/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include "read_write_file.h"
#include "function_declartion.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_InitialCommand_NS( TEMP *TP, int *c_G )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  char *T1, *T2, *T3, *T4, *T5, *T6, *T7, *T8;
  FILE *GP1, *GP2, *GP3, *GP4, *GP5, *GP6, *GP7;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  T1  =  MALLOC_1C( SIZE );
  T2  =  MALLOC_1C( SIZE );
  T3  =  MALLOC_1C( SIZE );
  T4  =  MALLOC_1C( SIZE );
  T5  =  MALLOC_1C( SIZE );
  T6  =  MALLOC_1C( SIZE );
  T7  =  MALLOC_1C( SIZE );
  T8  =  MALLOC_1C( SIZE );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  GP1  =  popen( "gnuplot -geometry 400x400+820+75 ", "w" );
  GP2  =  popen( "gnuplot -geometry 400x400+0+75   ", "w" );
  GP3  =  popen( "gnuplot -geometry 400x400+410+75 ", "w" );
  GP4  =  popen( "gnuplot -geometry 400x400+820+75 ", "w" );
  GP5  =  popen( "gnuplot -geometry 400x400+410+525", "w" );
  GP6  =  popen( "gnuplot -geometry 400x400+820+525", "w" );
  if( TP->EVS == 1 )   GP7  =  popen( "gnuplot -geometry 400x400+820+75 ", "w" );
  else                 GP7  =  popen( "gnuplot -geometry 400x400+820+525", "w" );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fprintf( GP1, "unset key\n" );
  fprintf( GP2, "unset key\n" );
  fprintf( GP3, "unset key\n" );
  fprintf( GP4, "unset key\n" );
  fprintf( GP5, "unset key\n" );
  fprintf( GP6, "unset key\n" );
  fprintf( GP7, "unset key\n" );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fprintf( GP1, "set xr[0.0:%lf]\n", TP->Lx );
  fprintf( GP2, "set xr[0.0:%lf]\n", TP->Lx );
  fprintf( GP3, "set xr[0.0:%lf]\n", TP->Lx );
/*  fprintf( GP6, "set yr[-10.0:10.0]\n"      );*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fprintf( GP4, "set grid\n" );
  fprintf( GP7, "set grid\n" );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  sprintf( T1 , "\"1 Initial Data\\n\""                                    );
  sprintf( T2 , "\"2 Solution\\n\""                                        );
  sprintf( T3 , "\"3 Solution (U)\\n\""                                    );
  sprintf( T4 , "\"4 CP - SoupNorm (U)\\n\""                               );
  sprintf( T5 , "\"5 Real Part Of Eigen Value(%d)\\n\"",(int)(N_OUTPUT_EV) );
  sprintf( T6 , "\"6 An Enlarged Picture For 5\\n\""                       );
  if     ( TP->SS == SS_1 )  sprintf( T7 , "\"7 CP - L2Norm\\n\""          );
  else if( TP->SS == SS_2 )  sprintf( T7 , "\"7 CP - Velocity\\n\""        );
  fprintf( GP1, "set title %s\n", T1 );
  fprintf( GP2, "set title %s\n", T2 );
  fprintf( GP3, "set title %s\n", T3 );
  fprintf( GP4, "set title %s\n", T4 );
  fprintf( GP5, "set title %s\n", T5 );
  fprintf( GP6, "set title %s\n", T6 );
  fprintf( GP7, "set title %s\n", T7 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( c_G[1] == 1 ){  Gnuplot_DrawCommand_NS( *TP, GP1, 1 );  fflush( GP1 );  }
  if( c_G[2] == 1 ){  Gnuplot_DrawCommand_NS( *TP, GP2, 2 );  fflush( GP2 );  }
  if( c_G[3] == 1 ){  Gnuplot_DrawCommand_NS( *TP, GP3, 3 );  fflush( GP3 );  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  TP->GP1  =  GP1;
  TP->GP2  =  GP2;
  TP->GP3  =  GP3;
  TP->GP4  =  GP4;
  TP->GP5  =  GP5;
  TP->GP6  =  GP6;
  TP->GP7  =  GP7;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1C( T1 );
  FREE_1C( T2 );
  FREE_1C( T3 );
  FREE_1C( T4 );
  FREE_1C( T5 );
  FREE_1C( T6 );
  FREE_1C( T7 );
  FREE_1C( T8 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_Draw_NS( TEMP TP, int *c_G )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( c_G[2] == 1 ){  Gnuplot_DrawCommand_NS( TP, TP.GP2, 2 );  fflush( TP.GP2 );  }
  if( c_G[3] == 1 ){  Gnuplot_DrawCommand_NS( TP, TP.GP3, 3 );  fflush( TP.GP3 );  }
  if( c_G[4] == 1 ){  Gnuplot_DrawCommand_NS( TP, TP.GP4, 4 );  fflush( TP.GP4 );  }
  if( TP.N_UEV  !=  -1 ){
    if( c_G[5] == 1 ){  Gnuplot_DrawCommand_NS( TP, TP.GP5, 5 );  fflush( TP.GP5 );  }
    if( c_G[6] == 1 ){  Gnuplot_DrawCommand_NS( TP, TP.GP6, 6 );  fflush( TP.GP6 );  }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  Gnuplot_Draw2_NS( TEMP TP, int *c_G )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if(   ! ( TP.KE != 1  &&  TP.SS == SS_1  &&  (TP.N_VAR <= 2 || (TP.N_VAR == 3 && TP.BCS != BCS_3)) )   ){
    if( c_G[2] == 1 ){  Gnuplot_DrawCommand_NS( TP, TP.GP2, 8 );  fflush( TP.GP2 );  }
    if( c_G[3] == 1 ){  Gnuplot_DrawCommand_NS( TP, TP.GP3, 9 );  fflush( TP.GP3 );  }
    if( c_G[7] == 1 ){  Gnuplot_DrawCommand_NS( TP, TP.GP7, 7 );  fflush( TP.GP7 );  }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_Close_NS( TEMP *TP )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  pclose( TP->GP1 );
  pclose( TP->GP2 );
  pclose( TP->GP3 );
  pclose( TP->GP4 );
  pclose( TP->GP5 );
  pclose( TP->GP6 );
  pclose( TP->GP7 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_DrawCommand_NS( TEMP TP, FILE *GP, int SELECT )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    ti, U1=0, U2=0;
  double PS1=0.0, PS2=0.0, PS3=0.0;
  char   *G1, *G2, *G3, *G4, *G5, *G6, *G7, *G8, *G9;
  FILE   *GP_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  G1  =  MALLOC_1C( SIZE );
  G2  =  MALLOC_1C( SIZE );
  G3  =  MALLOC_1C( SIZE );
  G4  =  MALLOC_1C( SIZE );
  G5  =  MALLOC_1C( SIZE );
  G6  =  MALLOC_1C( SIZE );
  G7  =  MALLOC_1C( SIZE );
  G8  =  MALLOC_1C( SIZE );
  G9  =  MALLOC_1C( SIZE );
  sprintf( G1, "%s", (char *)Gi_dx_STEP0SV                     );
  sprintf( G2, "%s", (char *)Gw_dx_STEPSV                      );
  sprintf( G3, "%s", (char *)Gi_S_CP_VT_NR_ASREV_ASIEV_NUEV    );
  sprintf( G4, "%s", (char *)Gw_S_CP_VT_NR_ASREV_ASIEV_NUEV    );
  sprintf( G5, "%s", (char *)Ga_S_CP_VT_NR_NZOREV_NZOIEV_NUEV  );
  sprintf( G6, "%s", (char *)WRITE_S_CP_VT_NR_ASREV_ASIEV_NUEV );
  sprintf( G7, "%s", (char *)WRITE_ITER_CP_VT_NR               );
  sprintf( G8, "%s", (char *)Ga_S_CP_VT_NR_HPEV_HPIEV_NUEV     );
  sprintf( G9, "%s", (char *)Gw_dt_dx_ITERALLSV_NR             );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( SELECT == 4  &&  TP.SS == SS_1 ){  U1  = 2;    U2  = 5;                }
  else if( SELECT == 4  &&  TP.SS == SS_2 ){  U1  = 2;    U2  = 5;                }
  if     ( SELECT == 7  &&  TP.SS == SS_1 ){  U1  = 2;    U2  = 5;                }
  else if( SELECT == 7  &&  TP.SS == SS_2 ){  U1  = 2;    U2  = 5;                }
  if     ( SELECT == 5                    ){  PS1 = 1.0;  PS2 = 1.0;  PS3 = 1.0;  }
  else if( SELECT == 6                    ){  PS1 = 1.5;  PS2 = 1.5;  PS3 = 1.5;  }
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  switch( SELECT ){
    case 1:    
      if     ( TP.N_VAR == 2 )   fprintf( GP, "plot '%s' u 1:2 w l lw 2.0 lt 1,\
                                                    ''   u 1:3 w l lw 2.0 lt 3 \n", G1 );
      else if( TP.N_VAR == 3 )   fprintf( GP, "plot '%s' u 1:2 w l lw 2.0 lt 1,\
                                                    ''   u 1:3 w l lw 2.0 lt 3,\
                                                    ''   u 1:4 w l lw 2.0 lt 2 \n", G1 );
      break;
    case 2:
      if     ( TP.N_VAR == 2 )   fprintf( GP, "plot '%s' u 1:2 w p ps 1.0 lt 3,\
                                                    ''   u 1:3 w p ps 1.0 lt 3,\
                                                    '%s' u 1:2 w l lw 2.0 lt 1,\
                                                    ''   u 1:3 w l lw 2.0 lt 1 \n", G1, G2 );
      else if( TP.N_VAR == 3 )   fprintf( GP, "plot '%s' u 1:2 w p ps 2.0 lt 3,\
                                                    ''   u 1:3 w p ps 1.0 lt 3,\
                                                    ''   u 1:4 w p ps 1.0 lt 3,\
                                                    '%s' u 1:2 w l lw 2.0 lt 1,\
                                                    ''   u 1:3 w l lw 2.0 lt 1,\
                                                    ''   u 1:4 w l lw 2.0 lt 1 \n", G1, G2 );
      break;
    case 3:
      fprintf( GP, "plot '%s' u 1:2 w p ps 1.0 lt 3,\
                         '%s' u 1:2 w l lw 3.0 lt 1 \n", G1, G2 );
      break;
    case 4:
      fprintf( GP, "plot '%s' u %d:%d pt 7 ps 2.0 lt 1,\
                         '%s' u %d:%d pt 7 ps 3.0 lt 2,\
                         '%s' u %d:%d pt 7 ps 4.0 lt 3\n", G5, U1, U2, G4, U1, U2, G3, U1, U2 );
      break;
    case 5:
    case 6:
      GP_R = fopen_mode( G8, 'r' );
      if( fscanf(GP_R,"%d\n",&ti)  !=  EOF )
        fprintf( GP, "plot 0 lt 6, '%s' u 1:8 pt 7 ps %lf lt 1,\
                                   '%s' u 1:8 pt 7 ps %lf lt 3,\
                                   '%s' u 1:8 pt 7 ps %lf lt 2\n", G6, PS1, G5, PS2, G8, PS3 );
      else
        fprintf( GP, "plot 0 lt 6, '%s' u 1:8 pt 7 ps %lf lt 1,\
                                   '%s' u 1:8 pt 7 ps %lf lt 3\n", G6, PS1, G5, PS2          );
      fclose( GP_R );
      break;
    case 7:
      fprintf( GP, "plot '%s' u %d:%d pt 7 ps 2.0 lt 1,\
                         '%s' u %d:%d pt 7 ps 3.0 lt 2,\
                         '%s' u %d:%d pt 7 ps 4.0 lt 3,\
                         '%s' u %d:%d pt 7 ps 2.0 lt 4\n", G5, U1, U2, G4, U1, U2, G3, U1, U2, G7, U1, U2 );
      break;
    case 8:
      if     ( TP.N_VAR == 2 )   fprintf( GP, "plot '%s' u 1:2 w p ps 1.0 lt 3,\
                                                    ''   u 1:3 w p ps 1.0 lt 3,\
                                                    '%s' u 1:2 w l lw 2.0 lt 2,\
                                                    ''   u 1:3 w l lw 2.0 lt 2,\
                                                    '%s' u 2:3 w p ps 1.0 lt 4,\
                                                    ''   u 2:4 w p ps 1.0 lt 4 \n", G1, G2, G9 );
      else if( TP.N_VAR == 3 )   fprintf( GP, "plot '%s' u 1:2 w p ps 2.0 lt 3,\
                                                    ''   u 1:3 w p ps 1.0 lt 3,\
                                                    ''   u 1:4 w p ps 1.0 lt 3,\
                                                    '%s' u 1:2 w l lw 2.0 lt 2,\
                                                    ''   u 1:3 w l lw 2.0 lt 2,\
                                                    ''   u 1:4 w l lw 2.0 lt 2,\
                                                    '%s' u 2:3 w p ps 1.0 lt 4,\
                                                    ''   u 2:3 w p ps 1.0 lt 4,\
                                                    ''   u 2:4 w p ps 1.0 lt 4 \n", G1, G2, G9 );
      break;
    case 9:
      fprintf( GP, "plot '%s' u 1:2 w d        lt 3,\
                         '%s' u 1:2 w l lw 3.0 lt 2,\
                         '%s' u 2:3 w p ps 1.0 lt 4 \n", G1, G2, G9 );
      break;
    default :
      printf( "\nGnuplot-Diagram Select-ArguMent Misstake !!\n" );
      exit(1);
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1C( G1 );
  FREE_1C( G2 );
  FREE_1C( G3 );
  FREE_1C( G4 );
  FREE_1C( G5 );
  FREE_1C( G6 );
  FREE_1C( G7 );
  FREE_1C( G8 );
  FREE_1C( G9 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
