/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include "read_write_file.h"
#include "function_declartion.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_InitialCommand_GP( TEMP *TP, int *c_G )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  char *T1, *T2, *T3, *T4, *T5, *T6, *T7, *T8, *T9;
  FILE *GP1, *GP2, *GP3, *GP4, *GP5, *GP6, *GP7, *GP8, *GP9;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  T1  =  MALLOC_1C( SIZE );
  T2  =  MALLOC_1C( SIZE );
  T3  =  MALLOC_1C( SIZE );
  T4  =  MALLOC_1C( SIZE );
  T5  =  MALLOC_1C( SIZE );
  T6  =  MALLOC_1C( SIZE );
  T7  =  MALLOC_1C( SIZE );
  T8  =  MALLOC_1C( SIZE );
  T9  =  MALLOC_1C( SIZE );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  GP1  =  popen( "gnuplot -geometry 310x310+30+335" , "w" );
  GP2  =  popen( "gnuplot -geometry 310x140+30+5"   , "w" );
  GP3  =  popen( "gnuplot -geometry 310x140+30+170" , "w" );
  GP4  =  popen( "gnuplot -geometry 430x430+820+515", "w" );
  GP5  =  popen( "gnuplot -geometry 310x310+30+670" , "w" );
  GP6  =  popen( "gnuplot -geometry 430x430+820+50" , "w" );
  GP7  =  popen( "gnuplot -geometry 430x430+366+515", "w" );
  GP8  =  popen( "gnuplot -geometry 430x430+366+50" , "w" );
  GP9  =  popen( "gnuplot -geometry 310x310+30+335" , "w" );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fprintf( GP1, "unset key\n" );
  fprintf( GP2, "unset key\n" );
  fprintf( GP3, "unset key\n" );
  fprintf( GP4, "unset key\n" );
  fprintf( GP5, "unset key\n" );
  fprintf( GP6, "unset key\n" );
  fprintf( GP7, "unset key\n" );
  fprintf( GP8, "unset key\n" );
  fprintf( GP9, "unset key\n" );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fprintf( GP2, "set xr[0.0:%lf]\n", TP->Lx );
  fprintf( GP3, "set xr[0.0:1.0]\n"         );
  fprintf( GP7, "set yr[0.9:1.1]\n"         );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fprintf( GP4, "set grid\n" );
  fprintf( GP5, "set grid\n" );
  fprintf( GP6, "set grid\n" );
  fprintf( GP7, "set grid\n" );
  fprintf( GP8, "set grid\n" );
  fprintf( GP9, "set grid\n" );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  sprintf( T1 , "\"1 STEP - N_UEV (ERR=%lf)\\n\""      ,(double)ERROR_BIF_LINE_P );
  sprintf( T2 , "\"2 Solution U\\n\""                                            );
  sprintf( T3 , "\"3 Solution U\\n\""                                            );
  sprintf( T4 , "\"4 CP - Norm\\n\""                                             );
  sprintf( T5 , "\"5 Real Part Of Eigen Value (%d)\\n\"",(int)(N_OUTPUT_EV)      );
  if     ( TP->SS  ==  SS_3 )  sprintf( T6 , "\"6 CP - Period\\n\""              );
  else if( TP->SS  ==  SS_4 )  sprintf( T6 , "\"6 CP - Velocity\\n\""            );
  sprintf( T7 , "\"7 An Enlarged Picture For 5\\n\""                             );
  sprintf( T8 , "\"8 STEP - CP\\n\""                                             );
  sprintf( T9 , "\"9 STEP - AS_IEV (%d)\\n\""           ,(int)(N_OUTPUT_EV)      );
  fprintf( GP1, "set title %s\n", T1 );
/*  fprintf( GP2, "set title %s\n", T2 );  */
/*  fprintf( GP3, "set title %s\n", T3 );  */
  fprintf( GP4, "set title %s\n", T4 );
  fprintf( GP5, "set title %s\n", T5 );
  fprintf( GP6, "set title %s\n", T6 );
  fprintf( GP7, "set title %s\n", T7 );
  fprintf( GP8, "set title %s\n", T8 );
  fprintf( GP9, "set title %s\n", T9 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  TP->GP1  =  GP1;
  TP->GP2  =  GP2;
  TP->GP3  =  GP3;
  TP->GP4  =  GP4;
  TP->GP5  =  GP5;
  TP->GP6  =  GP6;
  TP->GP7  =  GP5;
  TP->GP7  =  GP7;
  TP->GP8  =  GP8;
  TP->GP9  =  GP9;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1C( T1 );
  FREE_1C( T2 );
  FREE_1C( T3 );
  FREE_1C( T4 );
  FREE_1C( T5 );
  FREE_1C( T6 );
  FREE_1C( T7 );
  FREE_1C( T8 );
  FREE_1C( T9 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_Draw_GP( TEMP TP, int *c_G )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( c_G[2] == 1 ){  Gnuplot_DrawCommand_GP( TP, TP.GP2, 2 );  fflush( TP.GP2 );  }
  if( c_G[3] == 1 ){  if( TP.step == TP.MaxStep ){  Gnuplot_DrawCommand_GP( TP, TP.GP3, 3 );  fflush( TP.GP3 ); }  }
  if( c_G[4] == 1 ){  Gnuplot_DrawCommand_GP( TP, TP.GP4, 4 );  fflush( TP.GP4 );  }
  if( c_G[6] == 1 ){  Gnuplot_DrawCommand_GP( TP, TP.GP6, 6 );  fflush( TP.GP6 );  }
  if( c_G[8] == 1 ){  Gnuplot_DrawCommand_GP( TP, TP.GP8, 8 );  fflush( TP.GP8 );  }
  if( TP.N_UEV  !=  -1 ){
    if( c_G[5] == 1 ){  Gnuplot_DrawCommand_GP( TP, TP.GP5, 5 );  fflush( TP.GP5 );  }
    if( c_G[7] == 1 ){  Gnuplot_DrawCommand_GP( TP, TP.GP7, 7 );  fflush( TP.GP7 );  }
    if( c_G[9] == 1 ){  Gnuplot_DrawCommand_GP( TP, TP.GP9, 9 );  fflush( TP.GP9 );  }
    if( c_G[3] == 1 ){  if( TP.step == TP.MaxStep ){  Gnuplot_DrawCommand_GP( TP, TP.GP1, 1 );  fflush( TP.GP1 ); }  }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  Gnuplot_Draw2_GP( TEMP TP, int *c_G )
{
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_Close_GP( TEMP *TP )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  pclose( TP->GP1 );
  pclose( TP->GP2 );
  pclose( TP->GP3 );
  pclose( TP->GP4 );
  pclose( TP->GP5 );
  pclose( TP->GP6 );
  pclose( TP->GP7 );
  pclose( TP->GP8 );
  pclose( TP->GP9 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_DrawCommand_GP( TEMP TP, FILE *GP, int SELECT )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int  ti, U1=0, U2=0;
  char *G1, *G2, *G3, *G4, *G5, *G6, *G7, *G8, *G9, *G10, *G11;
  FILE *GP_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  G1   =  MALLOC_1C( SIZE );
  G2   =  MALLOC_1C( SIZE );
  G3   =  MALLOC_1C( SIZE );
  G4   =  MALLOC_1C( SIZE );
  G5   =  MALLOC_1C( SIZE );
  G6   =  MALLOC_1C( SIZE );
  G7   =  MALLOC_1C( SIZE );
  G8   =  MALLOC_1C( SIZE );
  G9   =  MALLOC_1C( SIZE );
  G10  =  MALLOC_1C( SIZE );
  G11  =  MALLOC_1C( SIZE );
  sprintf( G1 , "%s",    (char *)Gi_dt_dx_STEP0SV_NR                );
  sprintf( G2 , "%s",    (char *)Gw_dt_dx_ITERINISV_NR              );
  sprintf( G3 , "%s",    (char *)Gi_S_CP_VT_NR_ASREV_ASIEV_NUEV     );
  sprintf( G4 , "%s",    (char *)Gw_S_CP_VT_NR_ASREV_ASIEV_NUEV     );
  sprintf( G5 , "%s",    (char *)Ga_S_CP_VT_NR_NZOREV_NZOIEV_NUEV   );
  sprintf( G6 , "%s",    (char *)WRITE_S_CP_VT_NR_ASREV_ASIEV_NUEV  );
  sprintf( G7 , "%s",    (char *)WRITE_ITER_CP_VT_NR                );
  sprintf( G8 , "%s/%d", (char *)MKDIR_SOLUTION_VALUE, (TP.step-1)/TP.StepCut*TP.StepCut );
  sprintf( G9 , "%s",    (char *)Gw_dt_dx_ITERALLSV_NR              );
  sprintf( G10, "%s",    (char *)Ga_S_CP_VT_NR_HPEV_HPIEV_NUEV      );
  sprintf( G11, "%s",    (char *)WRITE_S_CP_VT_NR_ASREV_ASIEV_NUEV2 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( SELECT == 4                    ){  U1 = 2;  U2 = 5;  SELECT = 4;  }
  else if( SELECT == 6  &&  TP.SS == SS_3 ){  U1 = 2;  U2 = 3;  SELECT = 4;  }
  else if( SELECT == 6  &&  TP.SS == SS_4 ){  U1 = 2;  U2 = 4;  SELECT = 4;  }
  else if( SELECT == 8                    ){  U1 = 1;  U2 = 2;  SELECT = 4;  }
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  switch( SELECT ){
    case 1:    
      fprintf( GP, "plot '%s' u 1:11 pt 7 ps 2.0 lt 1\n", G6 );
      break;
    case 2:
      fprintf( GP, "plot '%s' u 2:3 w l lw 3.0 lt 5,\
                         '%s' u 2:3 w l lw 3.0 lt 2\n", G1, G2 );
      break;
    case 3:
      fprintf( GP, "plot '%s/0' u 1:6 ps 2.0 lt 5,\
                         '%s'   u 1:6 ps 2.0 lt 2 \n", MKDIR_SOLUTION_VALUE, G8 );
      break;
    case 4:
      if(   (GP_R = fopen( G11,"r")) != NULL   &&   fscanf(GP_R,"%d\n",&ti) != EOF   ){
        fprintf( GP, "plot '%s' u %d:%d w l  lw 2.0 lt 1,\
                           '%s' u %d:%d pt 7 ps 3.0 lt 2,\
                           '%s' u %d:%d pt 7 ps 4.0 lt 3,\
                           '%s' u %d:%d pt 7 ps 3.0 lt 0\n", G5, U1, U2, G4, U1, U2, G3, U1, U2, G11, U1, U2 );
        fprintf( GP, "rep  '%s' u %d:%d pt 7 ps 2.0 lt 3,\
                           '%s' u %d:%d pt 7 ps 3.0 lt 2,\
                           '%s' u %d:%d pt 7 ps 4.0 lt 5,\
                           '%s' u %d:%d pt 7 ps 3.0 lt 0\n", G5, U1, U2, G4, U1, U2, G3, U1, U2, G11, U1, U2 );
        fclose( GP_R );
      }else{
        fprintf( GP, "plot '%s' u %d:%d w l  lw 2.0 lt 1,\
                           '%s' u %d:%d pt 7 ps 3.0 lt 2,\
                           '%s' u %d:%d pt 7 ps 4.0 lt 3\n", G5, U1, U2, G4, U1, U2, G3, U1, U2 );
        fprintf( GP, "rep  '%s' u %d:%d pt 7 ps 2.0 lt 3,\
                           '%s' u %d:%d pt 7 ps 3.0 lt 2,\
                           '%s' u %d:%d pt 7 ps 4.0 lt 5\n", G5, U1, U2, G4, U1, U2, G3, U1, U2 );
      }
      break;
    case 5:
      GP_R  =  fopen_mode( G10, 'r' );
      if( fscanf(GP_R,"%d\n",&ti)  !=  EOF )
        fprintf( GP, "plot 1 lt 6, '%s' u 1:10 pt 7 ps 1.5 lt 1,\
                                   '%s' u 1:10 pt 7 ps 1.5 lt 3,\
                                   '%s' u 1:10 pt 7 ps 1.5 lt 2\n", G6, G5, G10 );
      else
        fprintf( GP, "plot 1 lt 6, '%s' u 1:10 pt 7 ps 1.5 lt 1,\
                                   '%s' u 1:10 pt 7 ps 1.5 lt 3\n", G6, G5 );
      fclose( GP_R );
      break;
    case 6:
      break;
    case 7:
      GP_R  =  fopen_mode( G10, 'r' );
      if( fscanf(GP_R,"%d\n",&ti)  !=  EOF )
        fprintf( GP, "plot 1 lt 6, '%s' u 1:10 pt 7 ps 1.0 lt 1,\
                                   '%s' u 1:10 pt 7 ps 1.0 lt 3,\
                                   '%s' u 1:10 pt 7 ps 1.0 lt 2\n", G6, G5, G10 );
      else
        fprintf( GP, "plot 1 lt 6  '%s' u 1:10 pt 7 ps 1.0 lt 1,\
                                   '%s' u 1:10 pt 7 ps 1.0 lt 3\n", G6, G5 );
      fclose( GP_R );
      break;
    case 8:
      break;
    case 9:
      fprintf( GP, "plot '%s' u 1:8 pt 7 ps 2.0 lt 1\n", G6 );
      break;
    default :
      printf( "\nGnuplot-Diagram Select-ArguMent Misstake !!\n" );
      exit(1);
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1C( G1  );
  FREE_1C( G2  );
  FREE_1C( G3  );
  FREE_1C( G4  );
  FREE_1C( G5  );
  FREE_1C( G6  );
  FREE_1C( G7  );
  FREE_1C( G8  );
  FREE_1C( G9  );
  FREE_1C( G10 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
