/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <mpi.h>
#include "function_declartion.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/





/*11111*/
/*-------------------------------------------------------------------------------*/
void  RS_P2( TEMP   *TP       , double *par      , double *BC   , \
             double *t__d_x   , double *t__p_x   , double *t__x , double *t__RS, \
             double **keep_p_x, double **keep_EEx, double **p_aa, double **RS2   )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_EP      =  TP->N_EP;
  int    N_VAR     =  TP->N_VAR;
  int    NM        =  TP->NM;
  int    NV        =  TP->NV;
  int    np        =  TP->np;
  int    nv        =  TP->nv;
  int    nk        =  TP->nk;
  int    na        =  TP->na;
  int    CP        =  TP->CP;
  int    CP2       =  TP->CP2;
  int    c_EES     =  TP->c_EES;
  int    c_memory  =  TP->c_memory;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_NM, iNM;
  double ptb_PCT;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    NMNV       =  NM*NV;
  int    NMNVna     =  NMNV+na;
  double delta_CP2  =  (double)DELTA_PTB_CP2;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    *point    =  malloc_1i( NM+1       );
  double *p_par    =  malloc_1d( N_EP+N_VAR );
  double *n_par    =  malloc_1d( N_EP+N_VAR );
  double *d_x      =  malloc_1d( NV+na      );
  double *p_x      =  malloc_1d( NV+na      );
  double *ptb_EEx  =  malloc_1d( NV+na      );
  double *tRS      =  malloc_1d( NMNVna     );
  double **aa      =  malloc_2d( 5, NV      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Round_Off( NM, TP->c_MP, *TP, point );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= NMNVna; i++ )
    RS2[1][i]  =  t__RS[i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= N_EP; i++ ){   p_par[i ] = par[i];             }
  if  ( nk == 0 )             {   p_par[CP] = par[CP] - TP->ds;   }
  else                        {   p_par[CP] = t__p_x[NMNVna];     }
  Diffusion( *TP, p_par );
  for( i = 1; i <= N_EP; i++ )   n_par[i  ]  = par[i];
                                 n_par[CP2] += delta_CP2;
  Diffusion( *TP, n_par );
  if(  c_EES == EES_D  ){
    for( i = 1; i <= NV; i++ ){   ptb_EEx[   i] = t__x[     i];   }
    for( i = 1; i <= na; i++ ){   ptb_EEx[NV+i] = t__x[NMNV+i];   }
    M_EETV( *TP, n_par, BC, ptb_EEx, aa );
    LU_Decomposition_EE( *TP, aa );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  tRS[NMNV+np]  =  0.0;
  for( i_NM = 1; i_NM <= NM; i_NM++ ){
    iNM  =  (i_NM-1)*NV;
    for( i = 1; i <= NV; i++ ){   p_x[   i] = t__p_x[iNM +i];  ptb_EEx[   i] = t__x[iNM +i];   }
    for( i = 1; i <= na; i++ ){   p_x[NV+i] = t__p_x[NMNV+i];  ptb_EEx[NV+i] = t__x[NMNV+i];   }
    if  ( TP->PF == 1 )   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, n_par, BC, aa, ptb_EEx );
    else                  Calculate_EE   ( c_memory, point[i_NM], point[i_NM+1], *TP, p_par, n_par, BC, p_x, keep_p_x, p_aa, aa, &ptb_PCT, ptb_EEx );
    for( i = 1; i <= NV; i++ ){   tRS[iNM+i  ]  = (ptb_EEx[i] - keep_EEx[i_NM][i    ]) / delta_CP2;   }
    if ( TP->PF != 1 )        {   tRS[NMNV+np] += (ptb_PCT    - keep_EEx[i_NM][NV+np]) / delta_CP2;   }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if(  c_EES == EES_D  ){
    for( i = 1; i <= NV; i++ ){   ptb_EEx[   i] = t__x[     i];   }
    for( i = 1; i <= na; i++ ){   ptb_EEx[NV+i] = t__x[NMNV+i];   }
    M_EETV( *TP, par, BC, ptb_EEx, aa );
    LU_Decomposition_EE( *TP, aa );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double **A = malloc_2d( NMNVna, NMNVna );
  double **tmp=NULL;
  for( i = 1; i <= NV; i++ ){   d_x[   i] = t__d_x[     i];  p_x[   i] = t__p_x[     i];  ptb_EEx[   i] = t__x[     i];   }
  for( i = 1; i <= na; i++ ){   d_x[NV+i] = t__d_x[NMNV+i];  p_x[NV+i] = t__p_x[NMNV+i];  ptb_EEx[NV+i] = t__x[NMNV+i];   }
  if( nv == 1 )
    if     (   c_EES == EES_D                           )   M_V    ( *TP, n_par, BC, p_x, ptb_EEx, A );
    else if(   c_EES == EES_S_E  ||  c_EES == EES_S_R   )   M_V_SFM( *TP, n_par,     p_x, ptb_EEx, A );
  if( nk == 1 )
    if     (   c_EES == EES_D                           )   M_K    ( *TP, n_par, BC, d_x, ptb_EEx, tmp, A );
    else if(   c_EES == EES_S_E  ||  c_EES == EES_S_R   )   M_K_SFM( *TP, n_par,     d_x, ptb_EEx, tmp, A );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i =    1; i <= NMNV+np; i++ )   RS2[2][     i] = tRS[i];
  for( i = np+1; i <= na     ; i++ )   RS2[2][NMNV+i] = A[NMNV+i][NMNVna];
  free_2d( A );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( point   );
  free_1d( p_par   );
  free_1d( n_par   );
  free_1d( d_x     );
  free_1d( p_x     );
  free_1d( ptb_EEx );
  free_1d( tRS     );
  free_2d( aa      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*22222*/
/*-------------------------------------------------------------------------------*/
void  M_CM2( int    c_EES     , TEMP   *TP       , double *par  , double *BC    , \
             double *t__d_x   , double *t__p_x   , double *t__x , double **t__RS, \
             double **keep_p_x, double **keep_EEx, double **p_aa, double **aa   , double **a, double **MM )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_EP, N_VAR, NM, NV, np, nv, nk, na, nR;
  N_EP   =  TP->N_EP;
  N_VAR  =  TP->N_VAR;
  NM     =  TP->NM;
  NV     =  TP->NV;
  np     =  TP->np;
  nv     =  TP->nv;
  nk     =  TP->nk;
  na     =  TP->na;
  nR     =  TP->nR;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, n, i_NM, c_LU, c_FIRST;
  int    *point;
  double delta, ptb_PCT=0.0;
  double *p_par, *ptb_EEx, *d_x, *p_x, *x;
  double **tmp=NULL;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  point    =  malloc_1i( NM+1       );
  p_par    =  malloc_1d( N_EP+N_VAR );
  d_x      =  malloc_1d( NV+na      );
  p_x      =  malloc_1d( NV+na      );
  x        =  malloc_1d( NV+na      );
  ptb_EEx  =  malloc_1d( NV+na      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  delta  =  (double)DELTA_PTB_X;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  c_LU     =  0;
  c_FIRST  =  0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Round_Off( NM, TP->c_MP, *TP, point );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    js, je;
  int    *len, *disp;
  double **t_a, **t_aa;
  len   =  malloc_1i( TP->PROCS+1 );
  disp  =  malloc_1i( TP->PROCS+1 );
  Partition_1dim( TP->PROCS, TP->RANK, NV+1, NV+na, &js, &je, len, disp );
  t_a   =  malloc_2d( je-js+1, NV+1 );
  t_aa  =  malloc_2d( NV+na  , NV+1 );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N_EP; i++ )
    p_par[i] =  par[i];
  if( TP->nk == 0 ){   p_par[TP->CP] =  par[TP->CP] - TP->ds;   }
  else             {   p_par[TP->CP] =  t__p_x[NM*NV+na];       }
  Diffusion( *TP, p_par );
  for( i = 1; i <= NV+na; i++ )  for( j = 1; j <= NV+na; j++ )  a[i][j] = 0.0;
  for( i = 1; i <= NV   ; i++ )                                 a[i][i] = 1.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= NV; i++ ){   d_x[   i] = t__d_x[      i];  p_x[   i] = t__p_x[      i];  x[   i] = t__x[      i];   }
  for( i = 1; i <= na; i++ ){   d_x[NV+i] = t__d_x[NM*NV+i];  p_x[NV+i] = t__p_x[NM*NV+i];  x[NV+i] = t__x[NM*NV+i];   }
  if( nv == 1 ){
    TP->NM = 1;
    if     (   c_EES == EES_D                           )   M_V    ( *TP, par, BC, p_x, x     , a );
    else if(   c_EES == EES_S_E  ||  c_EES == EES_S_R   )   M_V_SFM( *TP, par,     p_x, x     , a );
    TP->NM = NM;
  }
  if( nk == 1 ){
    TP->NM = 1;
    if     (   c_EES == EES_D                           )   M_K    ( *TP, par, BC, d_x, x, tmp, a );
    else if(   c_EES == EES_S_E  ||  c_EES == EES_S_R   )   M_K_SFM( *TP, par,     d_x, x, tmp, a );
    TP->NM = NM;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double sum;
  double *C, *D;
  double **RS, **BB, **M;
  RS   =  malloc_2d( nR, NV+na );
  BB   =  malloc_2d( NV, na    );
  C    =  malloc_1d( NV        );
  D    =  malloc_1d( na        );
  M    =  malloc_2d( NV, NV    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( n = 1; n <= nR; n++ ){
    for( i = 1; i <= NV; i++ )  RS[n][   i] = 0.0;
    for( i = 1; i <= na; i++ )  RS[n][NV+i] = t__RS[n][NM*NV+i];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i_NM = 1; i_NM <= NM; i_NM++ ){
    for( i = 1; i <= NV; i++ ){   p_x[   i] = t__p_x[(i_NM-1)*NV+i];  x[   i] = t__x[(i_NM-1)*NV+i];   }
    for( i = 1; i <= na; i++ ){   p_x[NV+i] = t__p_x[   NM   *NV+i];  x[NV+i] = t__x[   NM   *NV+i];   }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( j = js; j <= je; j++ ){
      for( i = 1; i <= NV+na; i++ )
        ptb_EEx[i]  =  x[i];
      ptb_EEx[j]  +=  delta;
      if( c_EES  ==  EES_D ){
        if( NV+1  <=  j ){
          if( j == NV+na  &&  nk == 1 ){   par[TP->CP] = ptb_EEx[NV+na];   Diffusion( *TP, par );   }
          M_EETV( *TP, par, BC, ptb_EEx, aa );   LU_Decomposition_EE( *TP, aa );
          if( TP->PF == 1 )   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx );
          else                Calculate_EE( c_FIRST, point[i_NM], point[i_NM+1], *TP, p_par, par, BC, p_x, keep_p_x, p_aa, aa, &ptb_PCT, ptb_EEx );
          if( j == NV+na  &&  nk == 1 ){   par[TP->CP] =       x[NV+na];   Diffusion( *TP, par );   }
          c_LU  =  1;
        }else{
          if( c_LU  ==  1 ){
            M_EETV( *TP, par, BC, x, aa );   LU_Decomposition_EE( *TP, aa );
            c_LU  =  0;
          }
          if( TP->PF == 1 )   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx );
          else                Calculate_EE( c_FIRST, point[i_NM], point[i_NM+1], *TP, p_par, par, BC, p_x, keep_p_x, p_aa, aa, &ptb_PCT, ptb_EEx );
        }
      }else{
        if( j == NV+na  &&  nk == 1 ){   par[TP->CP] = ptb_EEx[NV+na];   Diffusion( *TP, par );   }
        if( TP->PF == 1 )   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx );
        else                Calculate_EE( c_FIRST, point[i_NM], point[i_NM+1], *TP, p_par, par, BC, p_x, keep_p_x, p_aa, aa, &ptb_PCT, ptb_EEx );
        if( j == NV+na  &&  nk == 1 ){   par[TP->CP] =       x[NV+na];   Diffusion( *TP, par );   }
      }
      for( i = 1; i <= NV; i++ )   t_a[j-js+1][i]  =  ( ptb_EEx[i] - keep_EEx[i_NM][i] ) / delta;
      i = NV+1;                    t_a[j-js+1][i]  =  ( ptb_PCT    - keep_EEx[i_NM][i] ) / delta;
    }
    MPI_Allgatherv( &t_a[1][1], len[TP->RANK+1], MPI_DOUBLE, &t_aa[1][1], &len[1], &disp[1], MPI_DOUBLE, MPI_COMM_WORLD );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
                                for( i = 1; i <= NV; i++ )  for( j = 1; j <= NV; j++ )  MM[(i_NM-1)*NV+i][   j   ] = t_aa[   j][i];
                                for( i = 1; i <= NV; i++ )  for( j = 1; j <= na; j++ )  MM[(i_NM-1)*NV+i][NV+j   ] = t_aa[NV+j][i];
    for( n = 1; n <= nR; n++ )  for( i = 1; i <= NV; i++ )                              MM[(i_NM-1)*NV+i][NV+na+n] = t__RS[n][(i_NM-1)*NV+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( i = 1; i <= NV; i++ )  for( j = 1; j <= NV; j++ )  M [i][j] = t_aa[j][i];
    for( i = 1; i <= NV; i++ )  for( j = 1; j <= na; j++ )  BB[i][j] = a[i][NV+j];
    for( i = 1; i <= NV; i++ )  C[i] = t_aa[   i][NV+np];
    for( i = 1; i <= na; i++ )  D[i] = t_aa[NV+i][NV+np];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( j = 1; j <= NV; j++ ){
      sum  =  0.0;
      for( i = 1; i <= NV; i++ )
        sum  +=  C[i]*a[i][j];
      a[NV+np][j]  +=  sum;
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( j = 1; j <= na; j++ )
      a[NV+np][NV+j]  +=  D[j];
    if( i_NM  !=  1 ){
      for( j = 1; j <= na; j++ ){   sum = 0.0;   for( i = 1; i <= NV; i++ ) sum += C[i]*BB[i][j];   a [NV+np][NV+j ] += sum;   }
      for( n = 1; n <= nR; n++ ){   sum = 0.0;   for( i = 1; i <= NV; i++ ) sum += C[i]*RS[n][i];   RS[    n][NV+np] += sum;   }
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    MatrixProduct_22s_MPI( TP->PROCS, TP->RANK, NV, NV, M, NV, a, a );
    MatrixProduct    ( NV, NV, M, na, BB, t_aa );
    for( i = 1; i <= NV; i++ )  for( j = 1; j <= na; j++ )  a[i][NV+j] = t_aa[i][j] + t_aa[NV+j][i];
    for( n = 1; n <= nR; n++ ){
      MatrixProduct_21 ( NV, NV, M, RS[n], C );
      for( i = 1; i <= NV; i++ )  RS[n][i] = C[i] + t__RS[n][(i_NM-1)*NV+i];
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= NV; i++ )
    a[i][i]  -=  1.0;
  for( n = 1; n <= nR; n++ )
    for( i = 1; i <= NV+na; i++ )
      t__RS[n][i]  =  - RS[n][i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( c_EES  ==  EES_D ){
    M_EETV( *TP, par, BC, t__x, aa );   LU_Decomposition_EE( *TP, aa );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_2d( RS );
  free_2d( BB );
  free_1d( C  );
  free_1d( D  );
  free_2d( M  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( point   );
  free_1d( p_par   );
  free_1d( d_x     );
  free_1d( p_x     );
  free_1d( x       );
  free_1d( ptb_EEx );
  free_1i( len     );
  free_1i( disp    );
  free_2d( t_a     );
  free_2d( t_aa    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*33333*/
/*-------------------------------------------------------------------------------*/
void  RS_PD( TEMP *TP, double *x, double **a, double **a2, double *RS )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    NM   =  TP->NM;
  int    NV   =  TP->NV;
  int    na   =  TP->na;
  int    na2  =  TP->na2;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j;
  double tmp;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    NMNV     =  NM*NV;
  int    NMNVna   =  NMNV+na;
  int    NMNVna2  =  NMNV+na2;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= NMNV; i++ ) for( j = 1; j <= NMNV; j++ )  a2[i][j]   =  a[i][j];
  for( i = 1; i <= NMNV; i++ )                               a2[i][i]  +=  2.0;
  MatrixProduct_21( NMNV, NMNV, a2, &x[NMNVna], &RS[NMNVna] );
  MatrixProduct_11( NMNV, TP->bpev, &x[NMNVna], &tmp );
  RS[NMNVna+NMNVna2]  =  tmp - 1.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*44444*/
/*-------------------------------------------------------------------------------*/
void  M_CM_PD( TEMP *TP, double *par, double *BC , double *t__x    , double *RS , double *RS3, \
               double **keep_EEx    , double **aa, double **delta_x, double **a2  )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    NM   =  TP->NM;
  int    NV   =  TP->NV;
  int    np   =  TP->np;
  int    nv   =  TP->nv;
  int    nk   =  TP->nk;
  int    na   =  TP->na;
  int    na2  =  TP->na2;
  int    CP   =  TP->CP;
  int    CP2  =  TP->CP2;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, n, i_NM, c_LU, c_FIRST, n_ptb, n_ptb2, n_ptb3, n_ptb4, iNM, iNM2;
  int    *point;
  double delta_EV, keep_parCP1, keep_parCP2;
  double *ptb_EEx, *ptb_EEx2, *coeff, *ptb_EEx_base;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    NMNV     =  NM*NV;
  int    NMNVna   =  NMNV+na;
  int    NMNVna2  =  NMNV+na2;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  point         =  malloc_1i( NM+1  );
  ptb_EEx       =  malloc_1d( NV+na );
  ptb_EEx2      =  malloc_1d( NV+na );
  coeff         =  malloc_1d( NV+na );
  ptb_EEx_base  =  malloc_1d( NMNV  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*  n  =  1;      coeff[n++]  =  (double)DELTA_PTB_X11;*/
/*                coeff[n++]  =  (double)DELTA_PTB_T11;   n_ptb3 = n-1;*/
/*  if( nv == 1 ) coeff[n++]  =  (double)DELTA_PTB_V11;*/
/*  if( nk == 1 ) coeff[n++]  =  (double)DELTA_PTB_CP11;  n_ptb  = n-1;*/
/*                coeff[n++]  =  (double)DELTA_PTB_X12;*/
/*                coeff[n++]  =  (double)DELTA_PTB_T12;   n_ptb4 = n-1;*/
/*  if( nv == 1 ) coeff[n++]  =  (double)DELTA_PTB_V12;*/
/*  if( nk == 1 ) coeff[n++]  =  (double)DELTA_PTB_CP12;*/
/*                coeff[n++]  =  (double)DELTA_PTB_CP2;   n_ptb2 = n-1;*/
/*                delta_EV    =  (double)DELTA_PTB_EV;*/
  double max1, max2, max3;
  fabsmax_1d( NV, delta_x[1]   , &max1 );
  fabsmax_1d( NV, delta_x[2]   , &max2 );
  fabsmax_1d( NV, &t__x[NMNVna], &max3 );
  n  =  1;      coeff[n++]  =  1.0E-02/max1;
                coeff[n++]  =  1.0E-02/delta_x[1][NMNV+np   ];   n_ptb3 = n-1;
  if( nv == 1 ) coeff[n++]  =  1.0E-02/delta_x[1][NMNV+np+nv];
  if( nk == 1 ) coeff[n++]  =  1.0E-02/delta_x[1][NMNV+na   ];  n_ptb  = n-1;
                coeff[n++]  =  1.0E-02/max2;
                coeff[n++]  =  1.0E-02/delta_x[2][NMNV+np   ];   n_ptb4 = n-1;
  if( nv == 1 ) coeff[n++]  =  1.0E-02/delta_x[2][NMNV+np+nv];
  if( nk == 1 ) coeff[n++]  =  1.0E-02/delta_x[2][NMNV+na   ];
                coeff[n++]  =  1.0E-02;                          n_ptb2 = n-1;
                delta_EV    =  1.0E-02/max3;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double **delta  =  malloc_2d( n_ptb2, NV+na );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( n = 1; n <= n_ptb2; n++ )
    for( i = 1; i <= na; i++ )
      delta[n][NV+i]  =  0.0;
                   n=1;  for( i = 1; i <= NV; i++ ){  delta[n][i] = coeff[n]*delta_x[1][i];  }
                   n++;  for( i = 1; i <= NV; i++ ){  delta[n][i] = 0.0;                     }  delta[n][NV+np   ] = coeff[n]*delta_x[1][NMNV+np   ];
  if( nv == 1 ){   n++;  for( i = 1; i <= NV; i++ ){  delta[n][i] = 0.0;                     }  delta[n][NV+np+nv] = coeff[n]*delta_x[1][NMNV+np+nv];   }
  if( nk == 1 ){   n++;  for( i = 1; i <= NV; i++ ){  delta[n][i] = 0.0;                     }  delta[n][NV+na   ] = coeff[n]*delta_x[1][NMNV+na   ];   }
                   n++;  for( i = 1; i <= NV; i++ ){  delta[n][i] = coeff[n]*delta_x[2][i];  }
                   n++;  for( i = 1; i <= NV; i++ ){  delta[n][i] = 0.0;                     }  delta[n][NV+np   ] = coeff[n]*delta_x[2][NMNV+np   ];
  if( nv == 1 ){   n++;  for( i = 1; i <= NV; i++ ){  delta[n][i] = 0.0;                     }  delta[n][NV+np+nv] = coeff[n]*delta_x[2][NMNV+np+nv];   }
  if( nk == 1 ){   n++;  for( i = 1; i <= NV; i++ ){  delta[n][i] = 0.0;                     }  delta[n][NV+na   ] = coeff[n]*delta_x[2][NMNV+na   ];   }
                   n++;  for( i = 1; i <= NV; i++ ){  delta[n][i] = 0.0;                     }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  keep_parCP1  =  par[CP ];
  keep_parCP2  =  par[CP2];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Round_Off( NM, TP->c_MP, *TP, point );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i_NM = 1; i_NM <= NM; i_NM++ ){
    iNM   =  (i_NM-1)*NV;
    iNM2  =  (i_NM-1)*NV+NMNVna;
    for( i = 1; i <= NV; i++ ){   ptb_EEx[   i] = t__x[iNM+i] + delta_EV*t__x[iNM2+i];   }
    for( i = 1; i <= na; i++ ){   ptb_EEx[NV+i] = t__x[NMNV+i];                          }
    Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx );
    for( i = 1; i <= NV; i++ ){   ptb_EEx_base[i]  = keep_EEx[i_NM][i] - ptb_EEx[i];   }
  }
  double *MV=malloc_1d(NV);
  for(i=1;i<=NV;i++)MV[i]=ptb_EEx[i];
  for( i = 1; i <= NMNV; i++ )   RS3[i] = a2[i][NMNVna2] = 0.0;
  for( n = 1; n <= n_ptb2; n++ ){
    for( i_NM = 1; i_NM <= NM; i_NM++ ){
      iNM   =  (i_NM-1)*NV;
      iNM2  =  (i_NM-1)*NV+NMNVna;
      if(  n == n_ptb3  ||  n == n_ptb4  ){
        Reaction( *TP, par, MV         , ptb_EEx  );
        Reaction( *TP, par, keep_EEx[1], ptb_EEx2 );
        if  ( n <= n_ptb )   for( i = 1; i <= NV; i++ ){   RS3[iNM+i]          += (ptb_EEx[i]-ptb_EEx2[i])*delta[1][NMNV+np]/coeff[n];   }
        else                 for( i = 1; i <= NV; i++ ){   a2 [iNM+i][NMNVna2] += (ptb_EEx[i]-ptb_EEx2[i])*delta[2][NMNV+np]/coeff[n];   }
      }else{
         for( i = 1; i <= NV; i++ ){   ptb_EEx [   i] = t__x[iNM +i] + delta_EV*t__x[iNM2+i] + delta[n][   i];   }  /*delta[n][i_NM][i]????*/
         for( i = 1; i <= na; i++ ){   ptb_EEx [NV+i] = t__x[NMNV+i]                         + delta[n][NV+i];   }
         for( i = 1; i <= NV; i++ ){   ptb_EEx2[   i] = t__x[iNM +i]                         + delta[n][   i];   }  /*delta[n][i_NM][i]????*/
         for( i = 1; i <= na; i++ ){   ptb_EEx2[NV+i] = t__x[NMNV+i]                         + delta[n][NV+i];   }
         if( n  == n_ptb2 ){   par[CP2] += coeff[n];        Diffusion( *TP, par );   }
         if( nk == 1      ){   par[CP ]  = ptb_EEx [NV+na]; Diffusion( *TP, par );   }   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx  );
         if( nk == 1      ){   par[CP ]  = ptb_EEx2[NV+na]; Diffusion( *TP, par );   }   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx2 );
         if( nk == 1      ){   par[CP ]  = keep_parCP1;     Diffusion( *TP, par );   }
         if  ( n <= n_ptb )   for( i = 1; i <= NV; i++ ){   RS3[iNM+i]          += (ptb_EEx_base[i]+ptb_EEx[i]-ptb_EEx2[i])/delta_EV/coeff[n];   }
         else                 for( i = 1; i <= NV; i++ ){   a2 [iNM+i][NMNVna2] += (ptb_EEx_base[i]+ptb_EEx[i]-ptb_EEx2[i])/delta_EV/coeff[n];   }
      }
    }
  }
  free_1d(MV);
  par[CP ]  =  keep_parCP1;
  par[CP2]  =  keep_parCP2;
  Diffusion( *TP, par );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= NMNV   ; i++ )  RS3[i]                +=  RS[NMNVna+i];
       i = NMNVna2;                RS3[i]                 =  RS[NMNVna+i];
  for( i = 1; i <= NMNVna2; i++ )  RS3[i]                *=  -1.0;
  for( i = 1; i <= NMNV   ; i++ )  a2[NMNVna2][i      ]   =  TP->bpev[i];
                                   a2[NMNVna2][NMNVna2]   =  0.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( point        );
  free_1d( ptb_EEx      );
  free_1d( ptb_EEx2     );
  free_1d( coeff        );
  free_1d( ptb_EEx_base );
  free_2d( delta        );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
