/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "function_declartion.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_EETV( TEMP TP, double *par, double *BC, double *x, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N;
  N  =  TP.N;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  int    i_VAR;
  double T, VEL;
  double Rd, Rv;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  T  =  x[TP.NV+TP.np];
  if( TP.nv == 0 )   VEL  =  0.0;
  else               VEL  =  x[TP.NV+TP.np+TP.nv];
/*-------------------------------------------------------------------------------*/
/*                                                                               */
/*   a[1][1] a[3][1]                                       a[5][1  ]             */
/*   a[2][2] a[1][2] a[3][2]                                                     */
/*           a[2][3] a[1][3] a[3][3]                                             */
/*                                                                               */
/*                                                                               */
/*                           a[2][N-2] a[1][N-2] a[3][N-2]                       */
/*                                     a[2][N-1] a[1][N-1] a[3][N-1]             */
/*   a[4][1]                                     a[2][N  ] a[1][N  ]             */
/*                                                                               */
/*-------------------------------------------------------------------------------*/
  Rv  =  (VEL*T*TP.dt) / (2.0*TP.dx);
  for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
    Rd  =  (par[TP.N_EP+i_VAR]*T*TP.dt) / ( TP.dx*TP.dx );
    for( i = 1; i <= N; i++ ){
      a[1][i+(i_VAR-1)*N]  =  1.0 + 2.0 * Rd;              /*  Opposite  */
      a[2][i+(i_VAR-1)*N]  =        1.0 * ( - Rd + Rv );   /*  Left      */
      a[3][i+(i_VAR-1)*N]  =        1.0 * ( - Rd - Rv );   /*  Right     */
    }
    a[2][1+(i_VAR-1)*N]  =  0.0;
    a[3][N+(i_VAR-1)*N]  =  0.0;
    if( TP.BCS  ==  BCS_2 ){
      a[2][N+(i_VAR-1)*N]  +=  - Rd - Rv;
      a[3][1+(i_VAR-1)*N]  +=  - Rd + Rv;
    }else if( TP.BCS  ==  BCS_3 ){
      a[4][1+(i_VAR-1)*N]  =  - Rd - Rv;   /*  left  below  */
      a[5][1+(i_VAR-1)*N]  =  - Rd + Rv;   /*  upper right  */
    }else if( TP.BCS  ==  BCS_4 )
      a[2][N+(i_VAR-1)*N]  +=  - Rd - Rv;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RS_EEVT( TEMP TP, double *par, double *BC, double *x, double *F, double *RS_EE )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N;
  N  =  TP.N;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  int    i_VAR;
  double T, VEL;
  double Rd, Rv;
  double *BCX;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  BCX  =  malloc_1d( TP.N_VAR*2 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  T  =  x[TP.NV+TP.np];
  if( TP.nv == 0 )   VEL  =  0.0;
  else               VEL  =  x[TP.NV+TP.np+TP.nv];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Generate_BC_Space( TP, BC, x, BCX );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Rv  =  (VEL*T*TP.dt) / (2.0*TP.dx);
  for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
    for( i = 1; i <= N; i++ )
      RS_EE[(i_VAR-1)*N+i]  =  x[(i_VAR-1)*N+i] + TP.dt*T*F[(i_VAR-1)*N+i];
    Rd  =  (par[TP.N_EP+i_VAR]*T*TP.dt) / ( TP.dx*TP.dx );
    if( TP.BCS  ==  BCS_1 ){
      RS_EE[(i_VAR-1)*N+1]  +=  ( Rd - Rv ) * BCX[(i_VAR-1)*2+1];
      RS_EE[(i_VAR-1)*N+N]  +=  ( Rd + Rv ) * BCX[(i_VAR-1)*2+2];
    }else if( TP.BCS  ==  BCS_2 ){
      RS_EE[(i_VAR-1)*N+1]  +=  ( Rd - Rv ) * ( - 2.0 * BC[(i_VAR-1)*2+1] * TP.dx );
      RS_EE[(i_VAR-1)*N+N]  +=  ( Rd + Rv ) * (   2.0 * BC[(i_VAR-1)*2+2] * TP.dx );
    }else if( TP.BCS  ==  BCS_4 ){
      RS_EE[(i_VAR-1)*N+1]  +=  ( Rd - Rv ) * BCX[(i_VAR-1)*2+1];
      RS_EE[(i_VAR-1)*N+N]  +=  ( Rd + Rv ) * (   2.0 * BC[(i_VAR-1)*2+2] * TP.dx );
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( BCX );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
