/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  N_UnstableEigenValue( TEMP *TP, double *par, double *REV, double *IEV )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int NV;
  NV  =  TP->NV;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j;
  int    Check_Bif;
  int    BLS;
  double BIF_LINE;
  double EBL;
  double *AS_REV, *AS_IEV;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  AS_REV  =  malloc_1d( NV );
  AS_IEV  =  malloc_1d( NV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Check_Bif  =  0;
  BLS        =  (int)BIFURCATION_LINE_SELCT;
  if( TP->np == 0 )   EBL = (double)ERROR_BIF_LINE_S;
  else                EBL = (double)ERROR_BIF_LINE_P;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  TP->N_p_UEV  =  TP->N_UEV;
  TP->N_p_SEV  =  TP->N_SEV;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  BIF_LINE  =  0.0;
  if( BLS  ==  1 ){
    if( TP->np == 0 ){  BIF_LINE  =  fabs(REV[1]);
                        for( i = 2; i <= NV; i++ )   BIF_LINE  =  MIN( BIF_LINE, fabs(REV[i]) );   }
    else{               BIF_LINE  =  fabs(1.0-sqrt(REV[1]*REV[1]+IEV[1]*IEV[1]));
                        for( i = 2; i <= NV; i++ )   BIF_LINE  =  MIN( BIF_LINE, fabs(1.0-sqrt(REV[i]*REV[i]+IEV[i]*IEV[i])) );   }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= NV; i++ ){
    AS_REV[i]  =  REV[i];
    AS_IEV[i]  =  IEV[i];
  }
  if( TP->np == 0 )   Sort_AscendingSequence_REV ( NV, AS_REV, AS_IEV );
  else                Sort_AscendingSequence_RIEV( NV, AS_REV, AS_IEV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  TP->N_UEV  =  TP->N_SEV  =  0;
  if( TP->np  ==  0 ){
    for( i = 1; i <= NV; i++ )   if( AS_REV[i]-( fabs(BIF_LINE)+EBL) <= 0.0 )                                           break;   TP->N_UEV  =  i-1;
    for( j = i; j <= NV; j++ )   if( AS_REV[j]-(-fabs(BIF_LINE)-EBL) <  0.0 )                                           break;   TP->N_SEV  =  NV-(i-1+j-i);
  }else{
    for( i = 1; i <= NV; i++ )   if( sqrt(AS_REV[i]*AS_REV[i]+AS_IEV[i]*AS_IEV[i])-(1.0+fabs(BIF_LINE)+EBL) <= 0.0 )    break;   TP->N_UEV  =  i-1;
    for( j = i; j <= NV; j++ )   if( sqrt(AS_REV[j]*AS_REV[j]+AS_IEV[j]*AS_IEV[j])-(1.0-fabs(BIF_LINE)-EBL) <  0.0 )    break;   TP->N_SEV  =  NV-(i-1+j-i);
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP->N_p_UEV  !=  -1  ){
    if( TP->N_p_UEV  !=  TP->N_UEV ){
      if  ( TP->N_p_UEV+TP->N_p_SEV == TP->N_UEV+TP->N_SEV )   Check_Bif ++;
      else                                                     TP->N_UEV = TP->N_p_UEV;
    }else if( TP->N_p_SEV  !=  TP->N_SEV ){
      if  ( TP->N_p_UEV+TP->N_p_SEV == TP->N_UEV+TP->N_SEV )   Check_Bif ++;
      else                                                     TP->N_SEV = TP->N_p_SEV;
    }
  }
/*
FILE *fp;
if( TP->N_p_UEV == -1 )  fp = fopen_mode( "1.dat", 'w' );
else                     fp = fopen_mode( "1.dat", 'a' );
fprintf( fp, "step=%d U=%d S=%d BIF=%d i=%d j=%d NV=%d\n", TP->step, TP->N_UEV, TP->N_SEV, Check_Bif,i,j,NV );
fclose( fp );
printf("U=%d S=%d BIF=%d i=%d j=%d NV=%d\n",TP->N_UEV, TP->N_SEV, Check_Bif,i,j,NV );
printf("U=%d S=%d BIF=%d i=%d j=%d NV=%d\n",TP->N_UEV, TP->N_SEV, Check_Bif,i,j,NV );
printf("U=%d S=%d BIF=%d i=%d j=%d NV=%d\n",TP->N_UEV, TP->N_SEV, Check_Bif,i,j,NV );
printf("U=%d S=%d BIF=%d i=%d j=%d NV=%d\n",TP->N_UEV, TP->N_SEV, Check_Bif,i,j,NV );
*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*
  if( Check_Bif != 0  &&  TP->EVCS == 1 )
    Bifurcation_Point( &TP, par, BC, d_x, x, REV, IEV );
*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( AS_REV );
  free_1d( AS_IEV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
