/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mpi.h>
#include "function_declartion.h"
#include "constant.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define  SELECT_DISCRETE  2
#define  SELECT_MPEV      1
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_S_ILUCGS( int M1, int M2, int NV, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j;
  double **t_a;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  t_a  =  malloc_2d( NV, NV );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= NV; i++ )
    for( j = 1; j <= NV; j++ )
      t_a[i][j]  =  a[i][j];
  for( i = 1; i <= NV; i++ )
    for( j = 1; j <= 7; j++ )
      a[i][j]    =  0.0;
  for( i = 1; i <= NV-M2; i++ )
    a[i+M2][1]  =  t_a[i+M2][i];
  for( i = 1; i <= NV-M1; i++ )
    a[i+M1][2]  =  t_a[i+M1][i];
  for( i = 1; i <= NV-1; i++ ){
    a[i+1][3]  =  t_a[i+1][i  ];
    a[i  ][4]  =  t_a[i  ][i  ];
    a[i  ][5]  =  t_a[i  ][i+1];
  }
  i  =  NV;
  a[i][4]  =  t_a[i  ][i  ];
  for( i = 1; i <= NV-M1; i++ )
    a[i][6]  =  t_a[i][i+M1];
  for( i = 1; i <= NV-M2; i++ )
    a[i][7]  =  t_a[i][i+M2];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_2d( t_a );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_S( TEMP TP, double *par, double *x, double **PDF, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N, NV, np, nv, BCS;
  double dx;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NV     =  TP.NV;
  np     =  TP.np;
  nv     =  TP.nv;
  dx     =  TP.dx;
  BCS    =  TP.BCS;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, k, i_VAR;
  double *Rd;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Rd  =  malloc_1d( N_VAR );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= TP.N_VAR; i++ )
    Rd[i]  =  par[TP.N_EP+i] / ( dx*dx );
  for( i = 1; i <= NV; i++ )
    for( j = 1; j <= NV; j++ )
      a[i][j]  =  0.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#if   SELECT_DISCRETE == DISCRETE1
  double Rv;
  if( nv == 1 )  Rv  =  x[NV+np+nv] / ( 2.0*dx );
  else           Rv  =  0.0;
  for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
    for( i = (i_VAR-1)*N+1; i <= (i_VAR-1)*N+N-1; i++ ){
      a[i  ][i+1]  =          Rd[i_VAR] + Rv;
      a[i  ][i  ]  =  - 2.0 * Rd[i_VAR];
      a[i+1][i  ]  =          Rd[i_VAR] - Rv;
    }
    i = (i_VAR-1)*N+N;
    a[i  ][i  ]  =  - 2.0 * Rd[i_VAR];
    for( j = k = 1; k <= TP.N_VAR; k++ )
      for( i = 1; i <= TP.N; i++, j++ )
        a[(i_VAR-1)*N+i][j]  +=  PDF[i_VAR][j];
    if( BCS  ==  BCS_2 ){
      a[(i_VAR-1)*N+1][(i_VAR-1)*N+2  ]  +=  Rd[i_VAR] - Rv;
      a[(i_VAR-1)*N+N][(i_VAR-1)*N+N-1]  +=  Rd[i_VAR] + Rv;
    }else if( BCS  ==  BCS_3 ){
      a[(i_VAR-1)*N+1][(i_VAR-1)*N+N]  +=  Rd[i_VAR] - Rv;
      a[(i_VAR-1)*N+N][(i_VAR-1)*N+1]  +=  Rd[i_VAR] + Rv;
    }else if( BCS  ==  BCS_4 ){
      a[(i_VAR-1)*N+N][(i_VAR-1)*N+N-1]  +=  Rd[i_VAR] + Rv;
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#elif SELECT_DISCRETE == DISCRETE2
  double Rv1, Rv2;
  Rv1  =       x[NV+np+nv]  / (12.0*TP.dx);
  Rv2  =  fabs(x[NV+np+nv]) / (12.0*TP.dx);
  for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
    for( i = (i_VAR-1)*N+1; i <= (i_VAR-1)*N+N-2; i++ ){
      a[i  ][i+2]  =                  -     Rv1 +     Rv2;
      a[i  ][i+1]  =        Rd[i_VAR] + 8.0*Rv1 - 4.0*Rv2;
      a[i  ][i  ]  =  - 2.0*Rd[i_VAR]           + 6.0*Rv2;
      a[i+1][i  ]  =        Rd[i_VAR] - 8.0*Rv1 - 4.0*Rv2;
      a[i+2][i  ]  =                        Rv1 +     Rv2;
    }
    i = (i_VAR-1)*N+N-1;
      a[i  ][i+1]  =        Rd[i_VAR] + 8.0*Rv1 - 4.0*Rv2;
      a[i  ][i  ]  =  - 2.0*Rd[i_VAR]           + 6.0*Rv2;
      a[i+1][i  ]  =        Rd[i_VAR] - 8.0*Rv1 - 4.0*Rv2;
    i = (i_VAR-1)*N+N;
      a[i  ][i  ]  =  - 2.0*Rd[i_VAR]           + 6.0*Rv2;
    for( j = k = 1; k <= TP.N_VAR; k++ )
      for( i = 1; i <= TP.N; i++, j++ )
        a[(i_VAR-1)*N+i][j]  +=  PDF[i_VAR][j];
    if( BCS  ==  BCS_2 ){
      a[(i_VAR-1)*N+1  ][(i_VAR-1)*N+1  ]  +=                  Rv1 +     Rv2;
      a[(i_VAR-1)*N+1  ][(i_VAR-1)*N+2  ]  +=  Rd[i_VAR] - 8.0*Rv1 - 4.0*Rv2;
      a[(i_VAR-1)*N+2  ][(i_VAR-1)*N+2  ]  +=                  Rv1 +     Rv2;
      a[(i_VAR-1)*N+N-1][(i_VAR-1)*N+N-1]  +=            -     Rv1 +     Rv2;
      a[(i_VAR-1)*N+N  ][(i_VAR-1)*N+N-1]  +=  Rd[i_VAR] + 8.0*Rv1 - 4.0*Rv2;
      a[(i_VAR-1)*N+N  ][(i_VAR-1)*N+N  ]  +=            -     Rv1 +     Rv2;
    }else if( BCS  ==  BCS_3 ){
      a[(i_VAR-1)*N+1  ][(i_VAR-1)*N+N-1]  +=                  Rv1 +     Rv2;
      a[(i_VAR-1)*N+1  ][(i_VAR-1)*N+N  ]  +=  Rd[i_VAR] - 8.0*Rv1 - 4.0*Rv2;
      a[(i_VAR-1)*N+2  ][(i_VAR-1)*N+N  ]  +=                  Rv1 +     Rv2;
      a[(i_VAR-1)*N+N-1][(i_VAR-1)*N+1  ]  +=            -     Rv1 +     Rv2;
      a[(i_VAR-1)*N+N  ][(i_VAR-1)*N+1  ]  +=  Rd[i_VAR] + 8.0*Rv1 - 4.0*Rv2;
      a[(i_VAR-1)*N+N  ][(i_VAR-1)*N+2  ]  +=            -     Rv1 +     Rv2;
    }else if( BCS  ==  BCS_4 ){
      a[(i_VAR-1)*N+N][(i_VAR-1)*N+N-1]  +=  Rd[i_VAR];
    }
  }
#endif
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( Rd );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_S_SFM( TEMP TP, double *par, double *x, double **PDF, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_VAR, N, NV, np, nv;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NV     =  TP.NV;
  np     =  TP.np;
  nv     =  TP.nv;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, k, i_VAR, iV;
  double Rv;
  double *Rd;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Rd  =  malloc_1d( N_VAR );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= TP.N_VAR; i++ )
    Rd[i]  =  par[TP.N_EP+i];
  if  ( nv == 1 )   Rv = x[NV+np+nv];
  else              Rv = 0.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= NV; i++ )
    for( j = 1; j <= NV; j++ )
      a[i][j]  =  0.0;
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      for( j = 0; j <= i-1; j++ )
        a[iV+i+1][iV+j+1]  =    Rd[i_VAR]*cos(M_PI*(i-j))/(cos(2.0*M_PI*(i-j)/N)-1.0) \
                              + Rv*0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N);
      j  =  i;
        a[iV+i+1][iV+j+1]  =  - Rd[i_VAR]*(N*N+2.0)/12.0;
      for( j = i+1; j <= N-1; j++ )
        a[iV+i+1][iV+j+1]  =    Rd[i_VAR]*cos(M_PI*(i-j))/(cos(2.0*M_PI*(i-j)/N)-1.0) \
                              + Rv*0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N);
    }
  }
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ )
    for( j = k = 1; k <= N_VAR; k++ )
      for( i = 1; i <= N; i++, j++ )
        a[(i_VAR-1)*N+i][j]  +=  PDF[i_VAR][j];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( Rd );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_V( TEMP TP, double *par, double *BC, double *p_x, double *x, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N, NM, NV, np, nv, na;
  double dx;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NM     =  TP.NM;
  NV     =  TP.NV;
  np     =  TP.np;
  nv     =  TP.nv;
  na     =  TP.na;
  dx     =  TP.dx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  double *BCPX, *BCX;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  BCX   =  malloc_1d( N_VAR*2 );
  BCPX  =  malloc_1d( N_VAR*2 );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
#if SELECT_DISCRETE == DISCRETE1
  if( np  ==  0 ){
    Generate_BC_Space( TP, BC, x, BCX );
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      i  =  1;
        a[(i_VAR-1)*N+i][NV+np+nv]  =  ( x[(i_VAR-1)*N+i+1] - BCX[(i_VAR-1)*2+1] ) / ( 2.0*dx );
      for( i = 2; i <= N-1; i++ )
        a[(i_VAR-1)*N+i][NV+np+nv]  =  ( x[(i_VAR-1)*N+i+1] - x[(i_VAR-1)*N+i-1] ) / ( 2.0*dx );
      i  =  N;
        a[(i_VAR-1)*N+i][NV+np+nv]  =  ( BCX[(i_VAR-1)*2+2] - x[(i_VAR-1)*N+i-1] ) / ( 2.0*dx );
    }
  }
  Generate_BC_Space( TP, BC, p_x, BCPX );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    i  =  1;
      a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  p_x[(i_VAR-1)*N+i+1] - BCPX[(i_VAR-1)*2+1 ];
    for( i = 2; i <= N-1; i++ )
      a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  p_x[(i_VAR-1)*N+i+1] - p_x[(i_VAR-1)*N+i-1];
    i  =  N;
      a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  BCPX[(i_VAR-1)*2+2 ] - p_x[(i_VAR-1)*N+i-1];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*
  double *p_par, *p_F;
  p_par  =  malloc_1d( TP.N_EP );
  p_F    =  malloc_1d( NV      );
  Generate_BC_Space( TP, BC, p_x, BCPX );
  for( i = 1; i <= TP.N_EP; i++ )
    p_par[i]  =  par[i];
  if( TP.nk == 0 )   p_par[TP.CP]  =  par[TP.CP] - TP.ds;
  else               p_par[TP.CP]  =  p_x[NV+TP.na];
  Reaction( TP, p_par, p_x, p_F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    i  =  1;
      a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
        - (p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i+2]-p_x [(i_VAR-1)*N+i ])/(2.0*dx)+p_F[(i_VAR-1)*N+i+1]);
      a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
        - (p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i  ]-p_x[(i_VAR-1)*N+i-2])/(2.0*dx)+p_F[(i_VAR-1)*N+i-1]);
    i  =  2;
      a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
           p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i  ]-BCPX[(i_VAR-1)*2+1 ])/(2.0*dx)+p_F[(i_VAR-1)*N+i-1] \
        - (p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i+2]-p_x [(i_VAR-1)*N+i ])/(2.0*dx)+p_F[(i_VAR-1)*N+i+1]);
    for( i = 3; i <= N-2; i++ )
      a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
           p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i  ]-p_x[(i_VAR-1)*N+i-2])/(2.0*dx)+p_F[(i_VAR-1)*N+i-1] \
        - (p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i+2]-p_x[(i_VAR-1)*N+i  ])/(2.0*dx)+p_F[(i_VAR-1)*N+i+1]);
    i  =  N-1;
      a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
           p_x[NV+np+nv]*(p_x [(i_VAR-1)*N+i]-p_x[(i_VAR-1)*N+i-2])/(2.0*dx)+p_F[(i_VAR-1)*N+i-1] \
        - (p_x[NV+np+nv]*(BCPX[(i_VAR-1)*2+2]-p_x[(i_VAR-1)*N+i  ])/(2.0*dx)+p_F[(i_VAR-1)*N+i+1]);
    i  =  N;
      a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
           p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i  ]-p_x[(i_VAR-1)*N+i-2])/(2.0*dx)+p_F[(i_VAR-1)*N+i-1];
    if( TP.BCS  ==  BCS_2 ){
      i  =  0;
      a[NM*NV+np+nv][(i_VAR-1)*N+i+2]  +=  \
        - (p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i+2]-p_x[(i_VAR-1)*N+i  ])/(2.0*dx)+p_F[(i_VAR-1)*N+i+1]);
      i  =  N+1;
      a[NM*NV+np+nv][(i_VAR-1)*N+i-2]  +=  \
           p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i  ]-p_x[(i_VAR-1)*N+i-2])/(2.0*dx)+p_F[(i_VAR-1)*N+i-1];
    }else if( TP.BCS  ==  BCS_3 ){
      i  =  0;
      a[NM*NV+np+nv][(i_VAR-1)*N+i+N]  +=  \
        - (p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i+2]-p_x[(i_VAR-1)*N+i  ])/(2.0*dx)+p_F[(i_VAR-1)*N+i+1]);
      i  =  N+1;
      a[NM*NV+np+nv][(i_VAR-1)*N+i-N]  +=  \
           p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i  ]-p_x[(i_VAR-1)*N+i-2])/(2.0*dx)+p_F[(i_VAR-1)*N+i-1];
    }else if( TP.BCS  ==  BCS_4 ){
      i  =  N+1;
      a[NM*NV+np+nv][(i_VAR-1)*N+i-2]  +=  \
           p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i  ]-p_x[(i_VAR-1)*N+i-2])/(2.0*dx)+p_F[(i_VAR-1)*N+i-1];
    }
  }
  for( i = NV+1; i <= NM*NV+na; i++ )
    a[NM*NV+np+nv][i]  =  0.0;
  free_1d( p_par );
  free_1d( p_F   );
*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#elif SELECT_DISCRETE == DISCRETE2
  double s=1.0;
  if( x[NV+np+nv] < 0.0 ) s=-1.0;
  if( np  ==  0 ){
    Generate_BC_Space( TP, BC, x, BCX );
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      if( TP.BCS  ==  BCS_1 ){
        i  =  1;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (       -x[(i_VAR-1)*N+i+2] + 8.0*x[(i_VAR-1)*N+i+1]                        - 8.0*BCX[(i_VAR-1)*2+1] + BCX[(i_VAR-1)*2+1] \
              +  s*( x[(i_VAR-1)*N+i+2] - 4.0*x[(i_VAR-1)*N+i+1] + 6.0*x[(i_VAR-1)*N+i] - 4.0*BCX[(i_VAR-1)*2+1] + BCX[(i_VAR-1)*2+1])   ) / (12.0*dx);
        i  =  2;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (       -x[(i_VAR-1)*N+i+2] + 8.0*x[(i_VAR-1)*N+i+1]                        - 8.0*x[(i_VAR-1)*N+i-1] + BCX[(i_VAR-1)*2+1] \
              +  s*( x[(i_VAR-1)*N+i+2] - 4.0*x[(i_VAR-1)*N+i+1] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1] + BCX[(i_VAR-1)*2+1])   ) / (12.0*dx);
        for( i = 3; i <= N-2; i++ )
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (       -x[(i_VAR-1)*N+i+2] + 8.0*x[(i_VAR-1)*N+i+1]                        - 8.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2] \
              +  s*( x[(i_VAR-1)*N+i+2] - 4.0*x[(i_VAR-1)*N+i+1] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2])   ) / (12.0*dx);
        i  =  N-1;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (       -BCX[(i_VAR-1)*2+2] + 8.0*x[(i_VAR-1)*N+i+1]                        - 8.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2] \
              +  s*( BCX[(i_VAR-1)*2+2] - 4.0*x[(i_VAR-1)*N+i+1] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2])   ) / (12.0*dx);
        i  =  N;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (       -BCX[(i_VAR-1)*2+2] + 8.0*BCX[(i_VAR-1)*2+2]                        - 8.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2] \
              +  s*( BCX[(i_VAR-1)*2+2] - 4.0*BCX[(i_VAR-1)*2+2] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2])   ) / (12.0*dx);
      }else if( TP.BCS  ==  BCS_2 ){
        i  =  1;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (      -x[(i_VAR-1)*N+i+2  ] + 8.0*x[(i_VAR-1)*N+i+1  ]                        - 8.0*x[(i_VAR-1)*N+i-1+2] + x[(i_VAR-1)*N+i-2+2] \
              + s*( x[(i_VAR-1)*N+i+2  ] - 4.0*x[(i_VAR-1)*N+i+1  ] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1+2] + x[(i_VAR-1)*N+i-2+2])   ) / (12.0*dx);
        i  =  2;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (      -x[(i_VAR-1)*N+i+2  ] + 8.0*x[(i_VAR-1)*N+i+1  ]                        - 8.0*x[(i_VAR-1)*N+i-1  ] + x[(i_VAR-1)*N+i-2+2] \
              + s*( x[(i_VAR-1)*N+i+2  ] - 4.0*x[(i_VAR-1)*N+i+1  ] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1  ] + x[(i_VAR-1)*N+i-2+2])   ) / (12.0*dx);
        for( i = 3; i <= N-2; i++ )
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (      -x[(i_VAR-1)*N+i+2  ] + 8.0*x[(i_VAR-1)*N+i+1  ]                        - 8.0*x[(i_VAR-1)*N+i-1  ] + x[(i_VAR-1)*N+i-2  ] \
              + s*( x[(i_VAR-1)*N+i+2  ] - 4.0*x[(i_VAR-1)*N+i+1  ] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1  ] + x[(i_VAR-1)*N+i-2  ])   ) / (12.0*dx);
        i  =  N-1;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (      -x[(i_VAR-1)*N+i+2-2] + 8.0*x[(i_VAR-1)*N+i+1  ]                        - 8.0*x[(i_VAR-1)*N+i-1  ] + x[(i_VAR-1)*N+i-2  ] \
              + s*( x[(i_VAR-1)*N+i+2-2] - 4.0*x[(i_VAR-1)*N+i+1  ] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1  ] + x[(i_VAR-1)*N+i-2  ])   ) / (12.0*dx);
        i  =  N;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (      -x[(i_VAR-1)*N+i+2-2] + 8.0*x[(i_VAR-1)*N+i+1-2]                        - 8.0*x[(i_VAR-1)*N+i-1  ] + x[(i_VAR-1)*N+i-2  ] \
              + s*( x[(i_VAR-1)*N+i+2-2] - 4.0*x[(i_VAR-1)*N+i+1-2] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1  ] + x[(i_VAR-1)*N+i-2  ])   ) / (12.0*dx);
        if(TP.RANK==0)printf("M_V kyoukai mada!!\n" );
      }else if( TP.BCS  ==  BCS_3 ){
        i  =  1;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (       -x[(i_VAR-1)*N+i+2] + 8.0*x[(i_VAR-1)*N+i+1]                        - 8.0*x[(i_VAR-1)*N+i-1+N] + x[(i_VAR-1)*N+i-2+N] \
              +  s*( x[(i_VAR-1)*N+i+2] - 4.0*x[(i_VAR-1)*N+i+1] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1+N] + x[(i_VAR-1)*N+i-2+N])   ) / (12.0*dx);
        i  =  2;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (       -x[(i_VAR-1)*N+i+2] + 8.0*x[(i_VAR-1)*N+i+1]                        - 8.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2+N] \
              +  s*( x[(i_VAR-1)*N+i+2] - 4.0*x[(i_VAR-1)*N+i+1] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2+N])   ) / (12.0*dx);
        for( i = 3; i <= N-2; i++ )
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (       -x[(i_VAR-1)*N+i+2] + 8.0*x[(i_VAR-1)*N+i+1]                        - 8.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2] \
              +  s*( x[(i_VAR-1)*N+i+2] - 4.0*x[(i_VAR-1)*N+i+1] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2])   ) / (12.0*dx);
        i  =  N-1;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (       -x[(i_VAR-1)*N+i+2-N] + 8.0*x[(i_VAR-1)*N+i+1]                        - 8.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2] \
              +  s*( x[(i_VAR-1)*N+i+2-N] - 4.0*x[(i_VAR-1)*N+i+1] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2])   ) / (12.0*dx);
        i  =  N;
          a[(i_VAR-1)*N+i][NV+np+nv] = \
            (       -x[(i_VAR-1)*N+i+2-N] + 8.0*x[(i_VAR-1)*N+i+1-N]                        - 8.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2] \
              +  s*( x[(i_VAR-1)*N+i+2-N] - 4.0*x[(i_VAR-1)*N+i+1-N] + 6.0*x[(i_VAR-1)*N+i] - 4.0*x[(i_VAR-1)*N+i-1] + x[(i_VAR-1)*N+i-2])   ) / (12.0*dx);
      }else if( TP.BCS  ==  BCS_4 ){
        printf("M_V error");
        MPI_Barrier( MPI_COMM_WORLD );
        MPI_Finalize();
        exit(1);
      }
    }
  }
  Generate_BC_Space( TP, BC, p_x, BCPX );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    if( TP.BCS  ==  BCS_1 ){
      i  =  1;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =   -x[(i_VAR-1)*N+1]+p_x[(i_VAR-1)*N+1] + \
          0.5*(      -p_x[(i_VAR-1)*N+i+2  ] + 8.0*p_x[(i_VAR-1)*N+i+1  ]                          - 8.0*BCPX[(i_VAR-1)*2+1] + BCPX[(i_VAR-1)*2+1] \
                + s*( p_x[(i_VAR-1)*N+i+2  ] - 4.0*p_x[(i_VAR-1)*N+i+1  ] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*BCPX[(i_VAR-1)*2+1] + BCPX[(i_VAR-1)*2+1]) ) / 12.0;
      i  =  2;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
              (      -p_x[(i_VAR-1)*N+i+2  ] + 8.0*p_x[(i_VAR-1)*N+i+1  ]                          - 8.0*p_x[(i_VAR-1)*N+i-1  ] + BCPX[(i_VAR-1)*2+1] \
                + s*( p_x[(i_VAR-1)*N+i+2  ] - 4.0*p_x[(i_VAR-1)*N+i+1  ] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1  ] + BCPX[(i_VAR-1)*2+1]) ) / 12.0;
      for( i = 3; i <= N-2; i++ )
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
              (      -p_x[(i_VAR-1)*N+i+2  ] + 8.0*p_x[(i_VAR-1)*N+i+1  ]                          - 8.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ] \
                + s*( p_x[(i_VAR-1)*N+i+2  ] - 4.0*p_x[(i_VAR-1)*N+i+1  ] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ]) ) / 12.0;
      i  =  N-1;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
              (      -BCPX[(i_VAR-1)*2+2] + 8.0*p_x[(i_VAR-1)*N+i+1  ]                          - 8.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ] \
                + s*( BCPX[(i_VAR-1)*2+2] - 4.0*p_x[(i_VAR-1)*N+i+1  ] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ]) ) / 12.0;
      i  =  N;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  x[(i_VAR-1)*N+N]-p_x[(i_VAR-1)*N+N] + \
              (      -BCPX[(i_VAR-1)*2+2] + 8.0*BCPX[(i_VAR-1)*2+2]                          - 8.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ] \
                + s*( BCPX[(i_VAR-1)*2+2] - 4.0*BCPX[(i_VAR-1)*2+2] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ]) ) / 12.0;
    }else if( TP.BCS  ==  BCS_2 ){
      i  =  1;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =   -x[(i_VAR-1)*N+1]+p_x[(i_VAR-1)*N+1] + \
          0.5*(      -p_x[(i_VAR-1)*N+i+2  ] + 8.0*p_x[(i_VAR-1)*N+i+1  ]                          - 8.0*p_x[(i_VAR-1)*N+i-1+2] + p_x[(i_VAR-1)*N+i-2+2] \
                + s*( p_x[(i_VAR-1)*N+i+2  ] - 4.0*p_x[(i_VAR-1)*N+i+1  ] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1+2] + p_x[(i_VAR-1)*N+i-2+2]) ) / 12.0;
      i  =  2;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
              (      -p_x[(i_VAR-1)*N+i+2  ] + 8.0*p_x[(i_VAR-1)*N+i+1  ]                          - 8.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2+2] \
                + s*( p_x[(i_VAR-1)*N+i+2  ] - 4.0*p_x[(i_VAR-1)*N+i+1  ] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2+2]) ) / 12.0;
      for( i = 3; i <= N-2; i++ )
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
              (      -p_x[(i_VAR-1)*N+i+2  ] + 8.0*p_x[(i_VAR-1)*N+i+1  ]                          - 8.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ] \
                + s*( p_x[(i_VAR-1)*N+i+2  ] - 4.0*p_x[(i_VAR-1)*N+i+1  ] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ]) ) / 12.0;
      i  =  N-1;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  \
              (      -p_x[(i_VAR-1)*N+i+2-2] + 8.0*p_x[(i_VAR-1)*N+i+1  ]                          - 8.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ] \
                + s*( p_x[(i_VAR-1)*N+i+2-2] - 4.0*p_x[(i_VAR-1)*N+i+1  ] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ]) ) / 12.0;
      i  =  N;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =  x[(i_VAR-1)*N+N]-p_x[(i_VAR-1)*N+N] + \
              (      -p_x[(i_VAR-1)*N+i+2-2] + 8.0*p_x[(i_VAR-1)*N+i+1-2]                          - 8.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ] \
                + s*( p_x[(i_VAR-1)*N+i+2-2] - 4.0*p_x[(i_VAR-1)*N+i+1-2] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1  ] + p_x[(i_VAR-1)*N+i-2  ]) ) / 12.0;
    }else if( TP.BCS  ==  BCS_3 ){
      i  =  1;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1+N] + p_x[(i_VAR-1)*N+i-2+N] \
                                       +  s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1+N] + p_x[(i_VAR-1)*N+i-2+N]);
      i  =  2;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2+N] \
                                       +  s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2+N]);
      for( i = 3; i <= N-2; i++ )
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                                       +  s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2]);
      i  =  N-1;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =     -p_x[(i_VAR-1)*N+i+2-N] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                                       +  s*( p_x[(i_VAR-1)*N+i+2-N] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2]);
      i  =  N;
        a[NM*NV+np+nv][(i_VAR-1)*N+i]  =     -p_x[(i_VAR-1)*N+i+2-N] + 8.0*p_x[(i_VAR-1)*N+i+1-N]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                                       +  s*( p_x[(i_VAR-1)*N+i+2-N] - 4.0*p_x[(i_VAR-1)*N+i+1-N] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2]);
    }else if( TP.BCS  ==  BCS_4 ){
      printf("M_V error");
      MPI_Barrier( MPI_COMM_WORLD );
      MPI_Finalize();
      exit(1);
    }
  }
#endif
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = NV+1; i <= NM*NV+na; i++ )
    a[NM*NV+np+nv][i]  =  0.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( BCPX  );
  free_1d( BCX   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_V_SFM( TEMP TP, double *par, double *p_x, double *x, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_VAR, N, NM, NV, np, nv, na;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NM     =  TP.NM;
  NV     =  TP.NV;
  np     =  TP.np;
  nv     =  TP.nv;
  na     =  TP.na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_VAR;
  double sum;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( np  ==  0 ){
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      for( i = 0; i <= N-1; i++ ){
        sum  =  0.0;
        for( j = 0; j <= i-1; j++ )
          sum  +=  0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N)*x[(i_VAR-1)*N+j+1];
        for( j = i+1; j <= N-1; j++ )
          sum  +=  0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N)*x[(i_VAR-1)*N+j+1];
        a[(i_VAR-1)*N+i+1][NM*NV+np+nv]  =  sum;
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    for( i = 0; i <= N-1; i++ ){
      sum  =  0.0;
      for( j = 0; j <= i-1; j++ )
        sum  +=  0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N)*p_x[(i_VAR-1)*N+j+1];
      for( j = i+1; j <= N-1; j++ )
        sum  +=  0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N)*p_x[(i_VAR-1)*N+j+1];
      a[NM*NV+np+nv][(i_VAR-1)*N+i+1]  =  sum;
    }
  }
  for( i = NV+1; i <= NM*NV+na; i++ )
    a[NM*NV+np+nv][i]  =  0.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_K( TEMP TP, double *par, double *BC, double *d_x, double *x, double **PDF, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N, NM, NV, np, na;
  double dx;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NM     =  TP.NM;
  NV     =  TP.NV;
  np     =  TP.np;
  na     =  TP.na;
  dx     =  TP.dx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  double *BCX, *parD;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  BCX   =  malloc_1d( N_VAR*2 );
  parD  =  malloc_1d( N_VAR   );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  if( np  ==  0 ){
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ )
      for( i = 1; i <= N; i++ )
        a[(i_VAR-1)*N+i][NV+na]  =  PDF[i_VAR][NV+i];
/*
    if( TP.c_parCP  ==  1 ){
*/
      PartialDiff_Function_Di_AUTO( TP, par, parD );
      PartialDiff_Function_Di     ( TP, par, parD );
      Generate_BC_Space( TP, BC, x, BCX );
      for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
        i  =  1;
          a[(i_VAR-1)*N+i][NV+na]  +=  parD[i_VAR] * (BCX[(i_VAR-1)*2+1]-2.0*x[(i_VAR-1)*N+i]+x[(i_VAR-1)*N+i+1]) / (dx*dx);
        for( i = 2; i <= N-1; i++ )
          a[(i_VAR-1)*N+i][NV+na]  +=  parD[i_VAR] * (x[(i_VAR-1)*N+i-1]-2.0*x[(i_VAR-1)*N+i]+x[(i_VAR-1)*N+i+1]) / (dx*dx);
        i  =  N;
          a[(i_VAR-1)*N+i][NV+na]  +=  parD[i_VAR] * (x[(i_VAR-1)*N+i-1]-2.0*x[(i_VAR-1)*N+i]+BCX[(i_VAR-1)*2+2]) / (dx*dx);
      }
/*
    }
*/
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*
  for( i = 1; i <= NV; i++ )
    a[NM*NV+na][i]  =  d_x[i] * dx;
  for( i = NV+1; i <= NM*NV; i++ )
    a[NM*NV+na][i]  =  0.0;
  for( i = 1; i <= na; i++ )
    a[NM*NV+na][NM*NV+i]  =  d_x[NV+i];
******
  for( i = 1; i <= NM*NV; i++ )
    a[NM*NV+na][i]  =  d_x[i] * dx;
  for( i = NM*NV+1; i <= NM*NV+na; i++ )
    a[NM*NV+na][i]  =  d_x[i];
******
  for( i = 1; i <= NM*NV+na; i++ )
    a[NM*NV+na][i]  =  d_x[i];
******
*/
  for( i =    1; i <= NV   ; i++ )   a[NM*NV+na][      i]  =  d_x[i];
  for( i = NV+1; i <= NM*NV; i++ )   a[NM*NV+na][      i]  =  0.0;
  for( i =    1; i <= na   ; i++ )   a[NM*NV+na][NM*NV+i]  =  d_x[NV+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( BCX );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_K_SFM( TEMP TP, double *par, double *d_x, double *x, double **PDF, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N, NM, NV, np, na;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NM     =  TP.NM;
  NV     =  TP.NV;
  np     =  TP.np;
  na     =  TP.na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_VAR, iV;
  double *parD;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  parD  =  malloc_1d( N_VAR );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  if( np  ==  0 ){
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ )
      for( i = 1; i <= N; i++ )
        a[(i_VAR-1)*N+i][NV+na]  =  PDF[i_VAR][NV+i];
    PartialDiff_Function_Di_AUTO( TP, par, parD );
    PartialDiff_Function_Di     ( TP, par, parD );
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      iV  =  (i_VAR-1)*N;
      for( i = 0; i <= N-1; i++ ){
        for( j = 0; j <= i-1; j++ )
          a[(i_VAR-1)*N+i+1][NV+na] +=    parD[i_VAR]*cos(M_PI*(i-j))*x[iV+j+1]/(cos(2.0*M_PI*(i-j)/N)-1.0);
        j  =  i;
          a[(i_VAR-1)*N+i+1][NV+na] +=  - parD[i_VAR]*(N*N+2.0)*x[iV+j+1]/12.0;
        for( j = i+1; j <= N-1; j++ )
          a[(i_VAR-1)*N+i+1][NV+na] +=    parD[i_VAR]*cos(M_PI*(i-j))*x[iV+j+1]/(cos(2.0*M_PI*(i-j)/N)-1.0);
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i =    1; i <= NV   ; i++ )   a[NM*NV+na][      i]  =  d_x[i];
  for( i = NV+1; i <= NM*NV; i++ )   a[NM*NV+na][      i]  =  0.0;
  for( i =    1; i <= na   ; i++ )   a[NM*NV+na][NM*NV+i]  =  d_x[NV+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( parD );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_EV( TEMP TP, double *par, double *BC, double *t__x, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_VAR, N, NM, NV, np, nv, nk, na;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NM     =  TP.NM;
  NV     =  TP.NV;
  np     =  TP.np;
  nv     =  TP.nv;
  nk     =  TP.nk;
  na     =  TP.na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, c_EES;
  double *x, *F;
  double **PDF;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     (   TP.EES == EES_D    ||  TP.EES == EES_D_M     )    c_EES = EES_D;
  else if(   TP.EES == EES_S_E  ||  TP.EES == EES_S_E_M   )    c_EES = EES_S_E;
  else if(   TP.EES == EES_S_R  ||  TP.EES == EES_S_R_M   )    c_EES = EES_S_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x    =  malloc_1d( NM*NV+na    );
  F    =  malloc_1d( NV          );
  PDF  =  malloc_2d( N_VAR, NV+N );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= NM*NV; i++ )   x[i]            =  t__x[i];
  if( np  ==  1 )                 x[NM*NV+np]     =  t__x[NM*NV+1];
  if( nv  ==  1 )                 x[NM*NV+np+nv]  =  t__x[NM*NV+2];
  if( nk  ==  1 )                 x[NM*NV+na]     =  t__x[NM*NV+3];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( np  ==  0 ){
    Reaction( TP, par, x, F );
    PartialDiff_Function_FU_AUTO( TP, par, x, F, PDF );
    PartialDiff_Function( TP, par, x, PDF );
    if     (   c_EES == EES_D                           )   M_S    ( TP, par, x, PDF, a );
    else if(   c_EES == EES_S_E  ||  c_EES == EES_S_R   )   M_S_SFM( TP, par, x, PDF, a );
  }else
#if   SELECT_MPEV  ==  MPEV1
    M_P_EV( TP, par, BC, x, a );
#elif SELECT_MPEV  ==  MPEV2
    M_P_EV2( TP, par, BC, x, a );
#endif
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( x   );
  free_1d( F   );
  free_2d( PDF );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_P_EV( TEMP TP, double *par, double *BC, double *t__x, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int NM, NV, na;
  NM     =  TP.NM;
  NV     =  TP.NV;
  na     =  TP.na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, t, N_t, i_NM, N_Mono, c_EES;
  int    *point;
  double delta;
  double *EEx, *F, *RS_EE, *ptb_EEx;
  double **EEa, **a1, **a2;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( TP.EES == EES_D    ||  TP.EES == EES_D_M   )   c_EES = EES_D;
  else if( TP.EES == EES_S_E  ||  TP.EES == EES_S_E_M )   c_EES = EES_S_E;
  else if( TP.EES == EES_S_R  ||  TP.EES == EES_S_R_M )   c_EES = EES_S_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  point    =  malloc_1i( NM+1   );
  EEx      =  malloc_1d( NV+na  );
  if( c_EES  ==  EES_D )
  F        =  malloc_1d( NV     );
  if( c_EES  ==  EES_D )
  RS_EE    =  malloc_1d( NV     );
  ptb_EEx  =  malloc_1d( NV+na  );
  EEa      =  malloc_2d( 5 , NV );
  a1       =  malloc_2d( NV, NV );
  a2       =  malloc_2d( NV, NV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  delta  =  (double)DELTA_PTB_X;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Round_Off( NM, TP.c_MP, TP, point );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    js, je;
  int    *len, *disp;
  double **t_a, **t_aa;
  len   =  malloc_1i( TP.PROCS+1 );
  disp  =  malloc_1i( TP.PROCS+1 );
  Partition_1dim( TP.PROCS, TP.RANK, NV, NV, &js, &je, len, disp );
  t_a   =  malloc_2d( je-js+1, NV );
  t_aa  =  malloc_2d( NV     , NV );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( NM == 1 )   N_Mono = 1;
  else            N_Mono = NM;
  for( i_NM = 1; i_NM <= N_Mono; i_NM++ ){
    for( i = 1; i <= NV; i++ ){   EEx[   i] = t__x[(i_NM-1)*NV+i];   }
    for( i = 1; i <= na; i++ ){   EEx[NV+i] = t__x[   NM   *NV+i];   }
    if( c_EES == EES_D  &&  i_NM == 1 ){
      M_EETV( TP, par, BC, EEx, EEa );
      LU_Decomposition_EE( TP, EEa );
    }
    if( NM == 1 ){   N_t = (int)(1.0/TP.dt);   if( 1.0/TP.dt-N_t >= 0.5 )  N_t ++;   }
    else            N_t = point[i_NM+1] - point[i_NM];
    if( c_EES  ==  EES_D ){
      for( t = 2; t <= N_t+1; t++ ){
        Reaction( TP, par, EEx, F );
        RS_EEVT( TP, par, BC, EEx, F, RS_EE );
        Calculate_Solution_EE( TP, RS_EE, EEa, EEx );
      }
    }else if( c_EES  ==  EES_S_E ){
      for( t = 2; t <= N_t+1; t++ ){
        EM_SM( TP, par, EEx );
      }
    }else if( c_EES  ==  EES_S_R ){
      for( t = 2; t <= N_t+1; t++ ){
        RK4_SM( TP, par, EEx );
      }
    }
    for( j = js; j <= je; j++ ){
      for( i = 1; i <= NV; i++ ){   ptb_EEx[   i] = t__x[(i_NM-1)*NV+i];   }
      for( i = 1; i <= na; i++ ){   ptb_EEx[NV+i] = t__x[   NM   *NV+i];   }
      ptb_EEx[j]  +=  delta;
      if( c_EES  ==  EES_D ){
        for( t = 2; t <= N_t+1; t++ ){
          Reaction( TP, par, ptb_EEx, F );
          RS_EEVT( TP, par, BC, ptb_EEx, F, RS_EE );
          Calculate_Solution_EE( TP, RS_EE, EEa, ptb_EEx );
        }
      }else if( c_EES  ==  EES_S_E ){
        for( t = 2; t <= N_t+1; t++ ){
          EM_SM( TP, par, ptb_EEx );
        }
      }else if( c_EES  ==  EES_S_R ){
        for( t = 2; t <= N_t+1; t++ ){
          RK4_SM( TP, par, ptb_EEx );
        }
      }
      for( i = 1; i <= NV; i++ )   t_a[j-js+1][i]  =  ( ptb_EEx[i] - EEx[i] ) / delta;
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    MPI_Allgatherv( &t_a[1][1], len[TP.RANK+1], MPI_DOUBLE, &t_aa[1][1], &len[1], &disp[1], MPI_DOUBLE, MPI_COMM_WORLD );
    for( i = 1; i <= NV; i++ )
      for( j = 1; j <= NV; j++ )
        a[i][j]  =  t_aa[j][i];
    if( N_Mono  !=  1 ){
      if( i_NM  ==  1 ){
        for( i = 1; i <= NV; i++ )
          for( j = 1; j <= NV; j++ )
            a1[i][j]  =  a[i][j];
      }else{
        MatrixProduct_MPI1( TP.PROCS, TP.RANK, js, je, len, disp, t_a, NV, NV, a, NV, a1, a2 );
        if( i_NM == N_Mono )   for( i = 1; i <= NV; i++ )  for( j = 1; j <= NV; j++ )  a [i][j] = a2[i][j];
        else                   for( i = 1; i <= NV; i++ )  for( j = 1; j <= NV; j++ )  a1[i][j] = a2[i][j];
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( point   );
  free_1d( EEx     );
  if( c_EES  ==  EES_D )
  free_1d( F       );
  if( c_EES  ==  EES_D )
  free_1d( RS_EE   );
  free_1d( ptb_EEx );
  free_2d( EEa     );
  free_2d( a1      );
  free_2d( a2      );
  free_1i( len     );
  free_1i( disp    );
  free_2d( t_a     );
  free_2d( t_aa    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_P_EV2( TEMP TP, double *par, double *BC, double *t__x, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int NM, NV, na;
  NM     =  TP.NM;
  NV     =  TP.NV;
  na     =  TP.na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, t, N_t, i_NM, N_Mono, c_EES;
  int    *point;
  double delta;
  double *EEx, *F, *RS_EE, *ptb_EEx, *ptb_EEx2;
  double **EEa, **a1, **a2;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( TP.EES == EES_D    ||  TP.EES == EES_D_M   )   c_EES = EES_D;
  else if( TP.EES == EES_S_E  ||  TP.EES == EES_S_E_M )   c_EES = EES_S_E;
  else if( TP.EES == EES_S_R  ||  TP.EES == EES_S_R_M )   c_EES = EES_S_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  point    =  malloc_1i( NM+1   );
  if( c_EES  ==  EES_D )
  F        =  malloc_1d( NV     );
  if( c_EES  ==  EES_D )
  RS_EE     =  malloc_1d( NV     );
  ptb_EEx   =  malloc_1d( NV+na  );
  ptb_EEx2  =  malloc_1d( NV+na  );
  EEa       =  malloc_2d( 5 , NV );
  a1        =  malloc_2d( NV, NV );
  a2        =  malloc_2d( NV, NV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  delta  =  (double)DELTA_PTB_X2;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Round_Off( NM, TP.c_MP, TP, point );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    js, je;
  int    *len, *disp;
  double **t_a, **t_aa;
  len   =  malloc_1i( TP.PROCS+1 );
  disp  =  malloc_1i( TP.PROCS+1 );
  Partition_1dim( TP.PROCS, TP.RANK, NV, NV, &js, &je, len, disp );
  t_a   =  malloc_2d( je-js+1, NV );
  t_aa  =  malloc_2d( NV     , NV );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( NM == 1 )   N_Mono = 1;
  else            N_Mono = NM;
  for( i_NM = 1; i_NM <= N_Mono; i_NM++ ){
    for( i = 1; i <= NV; i++ ){   ptb_EEx[   i] = t__x[(i_NM-1)*NV+i];   }
    for( i = 1; i <= na; i++ ){   ptb_EEx[NV+i] = t__x[   NM   *NV+i];   }
    if( c_EES == EES_D  &&  i_NM == 1 ){
      M_EETV( TP, par, BC, ptb_EEx, EEa );
      LU_Decomposition_EE( TP, EEa );
    }
    if( NM == 1 ){   N_t = (int)(1.0/TP.dt);   if( 1.0/TP.dt-N_t >= 0.5 )  N_t ++;   }
    else             N_t = point[i_NM+1] - point[i_NM];
    for( j = js; j <= je; j++ ){
      for( i = 1; i <= NV; i++ ){   ptb_EEx [   i] = t__x[(i_NM-1)*NV+i];   }
      for( i = 1; i <= na; i++ ){   ptb_EEx [NV+i] = t__x[   NM   *NV+i];   }
      for( i = 1; i <= NV; i++ ){   ptb_EEx2[   i] = t__x[(i_NM-1)*NV+i];   }
      for( i = 1; i <= na; i++ ){   ptb_EEx2[NV+i] = t__x[   NM   *NV+i];   }
      ptb_EEx [j]  +=  delta;
      ptb_EEx2[j]  -=  delta;
      if( c_EES  ==  EES_D ){
        for( t = 2; t <= N_t+1; t++ ){
          Reaction( TP, par, ptb_EEx , F );   RS_EEVT( TP, par, BC, ptb_EEx , F, RS_EE );   Calculate_Solution_EE( TP, RS_EE, EEa, ptb_EEx  );
          Reaction( TP, par, ptb_EEx2, F );   RS_EEVT( TP, par, BC, ptb_EEx2, F, RS_EE );   Calculate_Solution_EE( TP, RS_EE, EEa, ptb_EEx2 );
        }
      }else if( c_EES  ==  EES_S_E ){
        for( t = 2; t <= N_t+1; t++ ){   EM_SM( TP, par, ptb_EEx  );   }
        for( t = 2; t <= N_t+1; t++ ){   EM_SM( TP, par, ptb_EEx2 );   }
      }else if( c_EES  ==  EES_S_R ){
        for( t = 2; t <= N_t+1; t++ ){   RK4_SM( TP, par, ptb_EEx  );   }
        for( t = 2; t <= N_t+1; t++ ){   RK4_SM( TP, par, ptb_EEx2 );   }
      }
      for( i = 1; i <= NV; i++ )   t_a[j-js+1][i]  =  (ptb_EEx[i]-ptb_EEx2[i]) / (2.0*delta);
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    MPI_Allgatherv( &t_a[1][1], len[TP.RANK+1], MPI_DOUBLE, &t_aa[1][1], &len[1], &disp[1], MPI_DOUBLE, MPI_COMM_WORLD );
    for( i = 1; i <= NV; i++ )
      for( j = 1; j <= NV; j++ )
        a[i][j]  =  t_aa[j][i];
    if( N_Mono  !=  1 ){
      if( i_NM  ==  1 ){
        for( i = 1; i <= NV; i++ )
          for( j = 1; j <= NV; j++ )
            a1[i][j]  =  a[i][j];
      }else{
        MatrixProduct_MPI1( TP.PROCS, TP.RANK, js, je, len, disp, t_a, NV, NV, a, NV, a1, a2 );
        if( i_NM == N_Mono )   for( i = 1; i <= NV; i++ )  for( j = 1; j <= NV; j++ )  a [i][j] = a2[i][j];
        else                   for( i = 1; i <= NV; i++ )  for( j = 1; j <= NV; j++ )  a1[i][j] = a2[i][j];
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( point   );
  if( c_EES  ==  EES_D )
  free_1d( F       );
  if( c_EES  ==  EES_D )
  free_1d( RS_EE   );
  free_1d( ptb_EEx );
  free_2d( EEa     );
  free_2d( a1      );
  free_2d( a2      );
  free_1i( len     );
  free_1i( disp    );
  free_2d( t_a     );
  free_2d( t_aa    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RS_S( TEMP TP, double *par, double *BC, double *x, double *F, double *RS )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N, NV, np, nv;
  double dx;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NV     =  TP.NV;
  np     =  TP.np;
  nv     =  TP.nv;
  dx     =  TP.dx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  double *BCX, *Rd;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  BCX  =  malloc_1d( N_VAR*2 );
  Rd   =  malloc_1d( N_VAR   );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Generate_BC_Space( TP, BC, x, BCX );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= TP.N_VAR; i++ )
    Rd[i]  =  par[TP.N_EP+i] / ( dx*dx );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#if   SELECT_DISCRETE == DISCRETE1
  double Rv;
  if( nv == 1 )  Rv  =  x[NV+np+nv] / ( 2.0*dx );
  else           Rv  =  0.0;
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    i  =  1;
      RS[(i_VAR-1)*N+i]  =      (Rd[i_VAR]-Rv)*BCX[(i_VAR-1)*2+1] \
                         -  2.0* Rd[i_VAR]    *x[(i_VAR-1)*N+i  ] \
                         +      (Rd[i_VAR]+Rv)*x[(i_VAR-1)*N+i+1] \
                         +  F[(i_VAR-1)*N+i];
    for( i = 2; i <= N-1; i++ )
      RS[(i_VAR-1)*N+i]  =      (Rd[i_VAR]-Rv)*x[(i_VAR-1)*N+i-1] \
                         -  2.0* Rd[i_VAR]    *x[(i_VAR-1)*N+i  ] \
                         +      (Rd[i_VAR]+Rv)*x[(i_VAR-1)*N+i+1] \
                         +  F[(i_VAR-1)*N+i];
    i  =  N;
      RS[(i_VAR-1)*N+i]  =      (Rd[i_VAR]-Rv)*x[(i_VAR-1)*N+i-1] \
                         -  2.0* Rd[i_VAR]    *x[(i_VAR-1)*N+i  ] \
                         +      (Rd[i_VAR]+Rv)*BCX[(i_VAR-1)*2+2] \
                         +  F[(i_VAR-1)*N+i];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#elif   SELECT_DISCRETE == DISCRETE2
  double Rv1, Rv2;
  Rv1  =       x[NV+np+nv]  / (12.0*TP.dx);
  Rv2  =  fabs(x[NV+np+nv]) / (12.0*TP.dx);
  if( TP.BCS  ==  BCS_1 ){
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      i  =  1;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*BCX[(i_VAR-1)*2+1  ] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*BCX[(i_VAR-1)*2+1  ] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*  x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*  x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*  x[(i_VAR-1)*N+i+2] \
                           +  F[(i_VAR-1)*N+i];
      i  =  2;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*BCX[(i_VAR-1)*2+1  ] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*  x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*  x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*  x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*  x[(i_VAR-1)*N+i+2] \
                           +  F[(i_VAR-1)*N+i];
      for( i = 3; i <= N-2; i++ )
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*x[(i_VAR-1)*N+i-2] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*x[(i_VAR-1)*N+i+2] \
                           +  F[(i_VAR-1)*N+i];
      i  =  N-1;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*  x[(i_VAR-1)*N+i-2] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*  x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*  x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*  x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*BCX[(i_VAR-1)*2+2  ] \
                           +  F[(i_VAR-1)*N+i];
      i  =  N;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*  x[(i_VAR-1)*N+i-2] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*  x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*  x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*BCX[(i_VAR-1)*2+2  ] \
                           +  (              -    Rv1+    Rv2)*BCX[(i_VAR-1)*2+2  ] \
                           +  F[(i_VAR-1)*N+i];
    }
  }else if( TP.BCS  ==  BCS_2 ){
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      i  =  1;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*x[(i_VAR-1)*N+i-2+2] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i-1+2] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*x[(i_VAR-1)*N+i+2] \
                           +  F[(i_VAR-1)*N+i];
      i  =  2;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*x[(i_VAR-1)*N+i-2+2] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*x[(i_VAR-1)*N+i+2] \
                           +  F[(i_VAR-1)*N+i];
      for( i = 3; i <= N-2; i++ )
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*x[(i_VAR-1)*N+i-2] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*x[(i_VAR-1)*N+i+2] \
                           +  F[(i_VAR-1)*N+i];
      i  =  N-1;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*x[(i_VAR-1)*N+i-2] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*x[(i_VAR-1)*N+i+2-2] \
                           +  F[(i_VAR-1)*N+i];
      i  =  N;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*x[(i_VAR-1)*N+i-2] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i+1-2] \
                           +  (              -    Rv1+    Rv2)*x[(i_VAR-1)*N+i+2-2] \
                           +  F[(i_VAR-1)*N+i];
    }
    if(TP.RANK==0)printf("RS_S kyoukaimada\n");
/*    MPI_Barrier( MPI_COMM_WORLD );*/
/*    MPI_Finalize();*/
/*    exit(1);*/
  }else if( TP.BCS  ==  BCS_3 ){
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      i  =  1;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*x[(i_VAR-1)*N+i-2+N] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i-1+N] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*x[(i_VAR-1)*N+i+2] \
                           +  F[(i_VAR-1)*N+i];
      i  =  2;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*x[(i_VAR-1)*N+i-2+N] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*x[(i_VAR-1)*N+i+2] \
                           +  F[(i_VAR-1)*N+i];
      for( i = 3; i <= N-2; i++ )
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*x[(i_VAR-1)*N+i-2] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*x[(i_VAR-1)*N+i+2] \
                           +  F[(i_VAR-1)*N+i];
      i  =  N-1;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*x[(i_VAR-1)*N+i-2] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i+1] \
                           +  (              -    Rv1+    Rv2)*x[(i_VAR-1)*N+i+2-N] \
                           +  F[(i_VAR-1)*N+i];
      i  =  N;
        RS[(i_VAR-1)*N+i]  =  (                   Rv1+    Rv2)*x[(i_VAR-1)*N+i-2] \
                           +  (     Rd[i_VAR]-8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i-1] \
                           +  (-2.0*Rd[i_VAR]        +6.0*Rv2)*x[(i_VAR-1)*N+i  ] \
                           +  (     Rd[i_VAR]+8.0*Rv1-4.0*Rv2)*x[(i_VAR-1)*N+i+1-N] \
                           +  (              -    Rv1+    Rv2)*x[(i_VAR-1)*N+i+2-N] \
                           +  F[(i_VAR-1)*N+i];
    }
  }
#endif
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( BCX );
  free_1d( Rd  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RS_S_SFM( TEMP TP, double *par, double *x, double *F, double *RS )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N, NV, np, nv;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NV     =  TP.NV;
  np     =  TP.np;
  nv     =  TP.nv;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_VAR, iV;
  double tmp, Rv;
  double *Rd;
  double **aa;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Rd  =  malloc_1d( N_VAR     );
  aa  =  malloc_2d( NV   , NV );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= TP.N_VAR; i++ )
    Rd[i]  =  par[TP.N_EP+i];
  if( nv == 1 )  Rv  =  x[NV+np+nv];
  else           Rv  =  0.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      for( j = 0; j <= i-1; j++ )
        aa[iV+i+1][iV+j+1]  =    Rd[i_VAR]*cos(M_PI*(i-j))/(cos(2.0*M_PI*(i-j)/N)-1.0);
      j  =  i;
        aa[iV+i+1][iV+j+1]  =  - Rd[i_VAR]*(2.0*(N-1)*(N-2)/24.0+N/4.0);
      for( j = i+1; j <= N-1; j++ )
        aa[iV+i+1][iV+j+1]  =    Rd[i_VAR]*cos(M_PI*(i-j))/(cos(2.0*M_PI*(i-j)/N)-1.0);
    }
  }
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV   =  (i_VAR-1)*N;
    for( i = 1; i <= N; i++ ){
      tmp  =  0.0;
      for( j = 1; j <= N; j++ )
        tmp  +=  aa[iV+i][iV+j]*x[iV+j];
      RS[iV+i]  =  tmp + F[iV+i];
    }
  }
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      for( j = 0; j <= i-1; j++ )
        aa[iV+i+1][iV+j+1]  =  Rv*0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N);
      j  =  i;
        aa[iV+i+1][iV+j+1]  =  0.0;
      for( j = i+1; j <= N-1; j++ )
        aa[iV+i+1][iV+j+1]  =  Rv*0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N);
    }
  }
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV   =  (i_VAR-1)*N;
    for( i = 1; i <= N; i++ ){
      tmp  =  0.0;
      for( j = 1; j <= N; j++ )
        tmp  +=  aa[iV+i][iV+j]*x[iV+j];
      RS[iV+i]  +=  tmp;
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( Rd );
  free_2d( aa );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RS_V( TEMP TP, double *par, double *BC, double *p_x, double *x, double *RS )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_VAR, N, NM, NV, np, nv;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NM     =  TP.NM;
  NV     =  TP.NV;
  np     =  TP.np;
  nv     =  TP.nv;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  double *BCPX;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  BCPX  =  malloc_1d( N_VAR*2 );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
#if   SELECT_DISCRETE == DISCRETE1
  Generate_BC_Space( TP, BC, p_x, BCPX );
  RS[NM*NV+np+nv]  =  0.0;
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    i  =  1;
      RS[NM*NV+np+nv]  +=  x[(i_VAR-1)*N+i] * ( p_x[(i_VAR-1)*N+i+1] - BCPX[(i_VAR-1)*2+1 ] );
    for( i = 2; i <= N-1; i++ )
      RS[NM*NV+np+nv]  +=  x[(i_VAR-1)*N+i] * ( p_x[(i_VAR-1)*N+i+1] - p_x[(i_VAR-1)*N+i-1] );
    i  =  N;
      RS[NM*NV+np+nv]  +=  x[(i_VAR-1)*N+i] * ( BCPX[(i_VAR-1)*2+2 ] - p_x[(i_VAR-1)*N+i-1] );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*
  double *BCX, *p_par, *p_F;
  BCX    =  malloc_1d( N_VAR*2 );
  p_par  =  malloc_1d( TP.N_EP );
  p_F    =  malloc_1d( NV      );
  Generate_BC_Space( TP, BC, p_x, BCPX );
  Generate_BC_Space( TP, BC,   x, BCX  );
  for( i = 1; i <= TP.N_EP; i++ )
    p_par[i]  =  par[i];
  if( TP.nk == 0 )   p_par[TP.CP]  =  par[TP.CP] - TP.ds;
  else               p_par[TP.CP]  =  p_x[NV+TP.na];
  Reaction( TP, p_par, p_x, p_F );
  RS[NM*NV+np+nv]  =  0.0;
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    i  =  1;
      RS[NM*NV+np+nv]  +=  \
          (p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i+1]-BCPX[(i_VAR-1)*2+1 ])/(2.0*TP.dx)+p_F[(i_VAR-1)*N+i]) \
        * (x[(i_VAR-1)*N+i+1]-BCX[(i_VAR-1)*2+1]);
    for( i = 2; i <= N-1; i++ )
      RS[NM*NV+np+nv]  +=  \
          (p_x[NV+np+nv]*(p_x[(i_VAR-1)*N+i+1]-p_x[(i_VAR-1)*N+i-1])/(2.0*TP.dx)+p_F[(i_VAR-1)*N+i]) \
        * (x[(i_VAR-1)*N+i+1]-x[(i_VAR-1)*N+i-1]);
    i  =  N;
      RS[NM*NV+np+nv]  +=  \
          (p_x[NV+np+nv]*(BCPX[(i_VAR-1)*2+2 ]-p_x[(i_VAR-1)*N+i-1])/(2.0*TP.dx)+p_F[(i_VAR-1)*N+i]) \
        * (BCX[(i_VAR-1)*2+2]-x[(i_VAR-1)*N+i-1]);
  }
  free_1d( BCX   );
  free_1d( p_par );
  free_1d( p_F   );
*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#elif   SELECT_DISCRETE == DISCRETE2
  double s = 1.0;
  if( x[NM*NV+np+nv] < 0.0 ) s = -1.0;
  RS[NM*NV+np+nv]  =  0.0;
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    if( TP.BCS  ==  BCS_1 ){
      RS[NM*NV+np+nv]  +=  0.5*(x[(i_VAR-1)*N+N]*x[(i_VAR-1)*N+N]-x[(i_VAR-1)*N+1]*x[(i_VAR-1)*N+1]) -x[(i_VAR-1)*N+N]*p_x[(i_VAR-1)*N+N]+x[(i_VAR-1)*N+1]*p_x[(i_VAR-1)*N+1];
      i  =  1;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*BCPX[(i_VAR-1)*2+1] + BCPX[(i_VAR-1)*2+1] \
                               +s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*BCPX[(i_VAR-1)*2+1] + BCPX[(i_VAR-1)*2+1])  ) / 12.0;
      i  =  2;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + BCPX[(i_VAR-1)*2+1] \
                               +s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + BCPX[(i_VAR-1)*2+1])  ) / 12.0;
      for( i = 3; i <= N-2; i++ )
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                               +s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2])  ) / 12.0;
      i  =  N-1;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -BCPX[(i_VAR-1)*2+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                               +s*( BCPX[(i_VAR-1)*2+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2])  ) / 12.0;
      i  =  N;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -BCPX[(i_VAR-1)*2+2] + 8.0*BCPX[(i_VAR-1)*2+2]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                               +s*( BCPX[(i_VAR-1)*2+2] - 4.0*BCPX[(i_VAR-1)*2+2] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2])  ) / 12.0;
    }else if( TP.BCS  ==  BCS_2 ){
      RS[NM*NV+np+nv]  +=  0.5*(x[(i_VAR-1)*N+N]*x[(i_VAR-1)*N+N]-x[(i_VAR-1)*N+1]*x[(i_VAR-1)*N+1]) -x[(i_VAR-1)*N+N]*p_x[(i_VAR-1)*N+N]+x[(i_VAR-1)*N+1]*p_x[(i_VAR-1)*N+1];
      i  =  1;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1+2] + p_x[(i_VAR-1)*N+i-2+2] \
                               +s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1+2] + p_x[(i_VAR-1)*N+i-2+2])  ) / 12.0;
      i  =  2;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2+2] \
                               +s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2+2])  ) / 12.0;
      for( i = 3; i <= N-2; i++ )
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                               +s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2])  ) / 12.0;
      i  =  N-1;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2-2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                               +s*( p_x[(i_VAR-1)*N+i+2-2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2])  ) / 12.0;
      i  =  N;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2-2] + 8.0*p_x[(i_VAR-1)*N+i+1-2]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                               +s*( p_x[(i_VAR-1)*N+i+2-2] - 4.0*p_x[(i_VAR-1)*N+i+1-2] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2])  ) / 12.0;
    }else if( TP.BCS  ==  BCS_3 ){
      i  =  1;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1+N] + p_x[(i_VAR-1)*N+i-2+N] \
                               +s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1+N] + p_x[(i_VAR-1)*N+i-2+N])  );
      i  =  2;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2+N] \
                               +s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2+N])  );
      for( i = 3; i <= N-2; i++ )
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                               +s*( p_x[(i_VAR-1)*N+i+2] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2])  );
      i  =  N-1;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2-N] + 8.0*p_x[(i_VAR-1)*N+i+1]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                               +s*( p_x[(i_VAR-1)*N+i+2-N] - 4.0*p_x[(i_VAR-1)*N+i+1] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2])  );
      i  =  N;
        RS[NM*NV+np+nv]  +=  \
          x[(i_VAR-1)*N+i] * (     -p_x[(i_VAR-1)*N+i+2-N] + 8.0*p_x[(i_VAR-1)*N+i+1-N]                          - 8.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2] \
                               +s*( p_x[(i_VAR-1)*N+i+2-N] - 4.0*p_x[(i_VAR-1)*N+i+1-N] + 6.0*p_x[(i_VAR-1)*N+i] - 4.0*p_x[(i_VAR-1)*N+i-1] + p_x[(i_VAR-1)*N+i-2])  );
    }else if( TP.BCS  ==  BCS_4 ){
    }
  }
#endif
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( BCPX );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RS_V_SFM( TEMP TP, double *par, double *p_x, double *x, double *RS )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_VAR, N, NM, NV, np, nv;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NM     =  TP.NM;
  NV     =  TP.NV;
  np     =  TP.np;
  nv     =  TP.nv;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_VAR;
  double sum = 0.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    for( i = 1; i <= N; i++ ){
      for( j = 1; j <= i-1; j++ )
        sum  +=  0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N)*p_x[(i_VAR-1)*N+j];
      for( j = i+1; j <= N; j++ )
        sum  +=  0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N)*p_x[(i_VAR-1)*N+j];
    }
    sum  *=  x[(i_VAR-1)*N+i];
  }
  RS[NM*NV+np+nv]  =  sum;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RS_K( TEMP TP, double *d_x, double *p_x, double *x, double *RS )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*  RS[TP.NM*TP.NV+TP.na]  =  0.0;*/
/*  for( i = 1; i <= TP.NV; i++ )*/
/*    RS[TP.NM*TP.NV+TP.na]  +=  ( x[i] - p_x[i] ) * d_x[i] * TP.dx;*/
/*  for( i = TP.NV+1; i <= TP.NV+TP.na; i++ )*/
/*    RS[TP.NM*TP.NV+TP.na]  +=  ( x[i] - p_x[i] ) * d_x[i];*/
/*  RS[TP.NM*TP.NV+TP.na]  -=  TP.ds;*/
    TP.WX=TP.WT=TP.WV=TP.WA=1.0;
                                                                RS[TP.NM*TP.NV+TP.na]  = 0.0;
    for( i = 1; i <= TP.NV; i++ )   {                           RS[TP.NM*TP.NV+TP.na] += TP.WX*(x[i]-p_x[i])*d_x[i];   }
    if ( TP.np == 1 && TP.npf != 1 ){   i = TP.NV+TP.np;        RS[TP.NM*TP.NV+TP.na] += TP.WT*(x[i]-p_x[i])*d_x[i];   }
    if ( TP.nv == 1                ){   i = TP.NV+TP.np+TP.nv;  RS[TP.NM*TP.NV+TP.na] += TP.WV*(x[i]-p_x[i])*d_x[i];   }
    i = TP.NV+TP.na;                                            RS[TP.NM*TP.NV+TP.na] += TP.WA*(x[i]-p_x[i])*d_x[i];
                                                                RS[TP.NM*TP.NV+TP.na] -= TP.ds;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RS_K_SFM( TEMP TP, double *d_x, double *p_x, double *x, double *RS )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*  RS[TP.NM*TP.NV+TP.na]  =  0.0;*/
/*  for( i = 1; i <= TP.NV; i++ )*/
/*    RS[TP.NM*TP.NV+TP.na]  +=  ( x[i] - p_x[i] ) * d_x[i] * TP.dx;*/
/*  for( i = TP.NV+1; i <= TP.NV+TP.na; i++ )*/
/*    RS[TP.NM*TP.NV+TP.na]  +=  ( x[i] - p_x[i] ) * d_x[i];*/
/*  RS[TP.NM*TP.NV+TP.na]  -=  TP.ds;*/
    TP.WX=TP.WT=TP.WV=TP.WA=1.0;
                                                                RS[TP.NM*TP.NV+TP.na]  = 0.0;
    for( i = 1; i <= TP.NV; i++ )   {                           RS[TP.NM*TP.NV+TP.na] += TP.WX*(x[i]-p_x[i])*d_x[i];   }
    if ( TP.np == 1 && TP.npf != 1 ){   i = TP.NV+TP.np;        RS[TP.NM*TP.NV+TP.na] += TP.WT*(x[i]-p_x[i])*d_x[i];   }
    if ( TP.nv == 1                ){   i = TP.NV+TP.np+TP.nv;  RS[TP.NM*TP.NV+TP.na] += TP.WV*(x[i]-p_x[i])*d_x[i];   }
    i = TP.NV+TP.na;                                            RS[TP.NM*TP.NV+TP.na] += TP.WA*(x[i]-p_x[i])*d_x[i];
                                                                RS[TP.NM*TP.NV+TP.na] -= TP.ds;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
