/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  NW_Gnuplot( int iteration, TEMP TP, int *c_G, double *par, double *BC, double *t__x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double period, velocity;
  double *x, *norm;
  FILE   *GP_W;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x     =  malloc_1d( TP.NM*TP.NV+TP.NA );
  norm  =  malloc_1d( N_NORM            );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP.np ==  0 )   period   = 0.0;   else   period   = t__x[TP.NM*TP.NV+TP.np      ];
  if( TP.nv ==  0 )   velocity = 0.0;   else   velocity = t__x[TP.NM*TP.NV+TP.np+TP.nv];
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= TP.NM*TP.NV; i++ )   x[            i    ]  =  t__x[            i];
  for( i = 1; i <= TP.NA-1    ; i++ )   x[TP.NM*TP.NV+i    ]  =  0.0;
                                        x[TP.NM*TP.NV+TP.NA]  =  par[TP.CP];
  for( i = 1; i <= TP.na      ; i++ )   x[TP.NM*TP.NV+i    ]  =  t__x[TP.NM*TP.NV+i];
  GP_W  =  fopen_mode( Gw_dt_dx_ITERALLSV_NR, 'w' );
  OP_SV_Norm( GP_W, TP, par, BC, x, norm );
  fclose( GP_W );
  if( iteration == 0 )  Output_Norm_Iter( iteration, period, velocity, TP, par, norm, 'w' );
  else                  Output_Norm_Iter( iteration, period, velocity, TP, par, norm, 'a' );
  if( c_G[0]  ==  1 ){
    if     ( TP.IS != IS_G  &&  TP.np == 0 ) Gnuplot_Draw2_NS( TP, c_G );
    else if( TP.IS != IS_G  &&  TP.np == 1 ) Gnuplot_Draw2_NP( TP, c_G );
    else if( TP.IS == IS_G  &&  TP.np == 0 ) Gnuplot_Draw2_GS( TP, c_G );
    else if( TP.IS == IS_G  &&  TP.np == 1 ) Gnuplot_Draw2_GP( TP, c_G );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( x    );
  free_1d( norm );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  NM_Norm( int iteration, TEMP *TP, double *par, double *RS, char *ErrC_SO, double *CC_Norm )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double MCC, NORM;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  MCC  =  (double)(MAXCONVERGENCECHECK);
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  if( TP->PF  ==  1 ){
    int DEL_ROW_A;
    DEL_ROW_A      =  TP->NM*TP->NV+1;
    RS[DEL_ROW_A]  =  0.0;
  }
  NORM  =  RS[1]*RS[1];
  if( TP->nv2  ==  0 )
    for( i = 2; i <= TP->n_NORM; i++ )
      NORM  =  MAX(NORM, RS[i]*RS[i]);
  else{
    for( i = 2; i <= TP->NM*TP->NV+TP->np; i++ )
      NORM  =  MAX(NORM, RS[i]*RS[i]);
    for( i = TP->NM*TP->NV+TP->np+2; i <= TP->n_NORM; i++ )
      NORM  =  MAX(NORM, RS[i]*RS[i]);
  }
  NORM  =  sqrt( NORM );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  *CC_Norm  =  NORM;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= TP->N_VAR; i++ ){
    if( par[TP->N_EP+i]  <  0.0 ){
      sprintf( ErrC_SO, "Diffusion is Negative !! (par[%d]=%lf)\n", TP->N_EP+i, par[TP->N_EP+i] );
      TP->CC  =  -3;
      return;
    }
  }
  if( TP->ME >=  NORM ){
    TP->CC  =  1;
  }else if( MCC  <=  NORM ){
    sprintf( ErrC_SO, "CC_Norm is not Converge !! (%20.15E)\n", NORM );
    TP->CC  =  -2;
  }else if( TP->MI  <=  iteration ){
    sprintf( ErrC_SO, "Iteration Over !! (%d)\n", iteration );
    TP->CC  =  -1;
/*  }else if( TP->SS == 2 && TP->v < 0.0 ){*/
/*    TP->CC  =  -1;*/
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  NM_Stdout( int iteration, TEMP TP, double CC_Norm, char *ErrC_SO, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*  printf( "                                  \n"                                                         );*/
/*  printf( "  Step  /  MaxStep     =   %d / %d\n"  , TP.step  , TP.MaxStep                                );*/
/*  printf( "  iter  /  MaxIter     =   %d / %d\n"  , iteration, TP.MI                                     );*/
/*  printf( "  Control Parameter    =  %20.15lf\n"  , par[TP.CP]                                           );*/
/*  if( TP.np  ==  1 )*/
/*  printf( "  Period               =  %20.15lf\n"  , x[TP.NM*TP.NV+TP.np]                                 );*/
/*  if( TP.nv  ==  1  &&  TP.nv2  ==  0 )*/
/*  printf( "  Velocity             =  %20.15lf\n"  , x[TP.NM*TP.NV+TP.np+TP.nv]                           );*/
/*  printf( "  MachineEps * (NV+%1d)  =  %20.15lf\n", TP.na-TP.nv2-TP.npf, TP.ME*(TP.n_NORM-TP.nv2-TP.npf) );*/
/*  printf( "  CC_Norm              =  %20.15lf\n"  , CC_Norm                                              );*/
  printf( "                                  \n"                                                           );
  printf( "  Step  /  MaxStep     =   %d / %d\n"  , TP.step  , TP.MaxStep                                  );
  printf( "  iter  /  MaxIter     =   %d / %d\n"  , iteration, TP.MI                                       );
  printf( "  Control Parameter    =  %20.15lf\n"  , par[TP.CP]                                             );
  if( TP.np  ==  1 )
  printf( "  Period               =  %20.15lf\n"  , x[TP.NM*TP.NV+TP.np]                                   );
  if( TP.nv  ==  1  &&  TP.nv2  ==  0 )
  printf( "  Velocity             =  %20.15lf\n"  , x[TP.NM*TP.NV+TP.np+TP.nv]                             );
/*  printf( "  MachineEps * (NV+%1d)  =  %20.15lf\n", TP.na-TP.nv2-TP.npf, TP.ME*(TP.n_NORM-TP.nv2-TP.npf) );*/
/*  printf( "  MachineEps * (NV+%1d)  =  %20.15lf\n", TP.na-TP.nv2-TP.npf, TP.ME*(TP.NV+TP.na-TP.nv2-TP.npf) );*/
  printf( "  MachineEps           =  %20.15lf\n", TP.ME );
  printf( "  CC_Norm              =  %20.15lf\n"  , CC_Norm                                                );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP.CC  ==  1 ){
    printf( "---------------------------------------------------------------\n" );
    printf( "                        Convergence  !!                        \n" );
    printf( "---------------------------------------------------------------\n" );
  }else if( TP.CC  !=  0 ){
    printf( "---------------------------------------------------------------\n" );
    printf( "                      Not Convergence  !!                      \n" );
    printf( "---------------------------------------------------------------\n" );
    END_PROGRAM( ErrC_SO, 5, 0 );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  Output_Norm_Iter( int iteration, double period, double velocity, TEMP TP, double *par, double *norm, int WriteMode )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int  i;
  FILE *FP_W;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FP_W  =  fopen_mode( WRITE_ITER_CP_VT_NR, WriteMode );
  if( iteration == 0  &&  TP.na == 0 ){
    fprintf( FP_W, "%7d %10.8lf %20.15E %20.15E ", iteration, par[TP.CP]-TP.ds, period, velocity );
    for( i = 1; i <= N_NORM-1; i++ )
      fprintf( FP_W, "%20.15E ", norm[i] );
    fprintf( FP_W, "%20.15E\n", norm[i] );
  }else{
    fprintf( FP_W, "%7d %10.8lf %20.15E %20.15E ", iteration, par[TP.CP]      , period, velocity );
    for( i = 1; i <= N_NORM-1; i++ )
      fprintf( FP_W, "%20.15E ", norm[i] );
    fprintf( FP_W, "%20.15E\n", norm[i] );
  }
  fclose( FP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Output_Sol_Iter( int NVna  , int iteration, int    *IP, \
                       double *RS, double *sol_x, double *x , int WriteMode )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int  i;
  FILE *FP_W1, *FP_W2;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FP_W1  =  fopen_mode( WRITE_ITER_I_RS_SX_X1, WriteMode );
  FP_W2  =  fopen_mode( WRITE_ITER_I_RS_SX_X2, WriteMode );
  for( i = 1; i <= NVna; i++ ){
    fprintf( FP_W1, "ITER = %d  i = %d  RS = %20.15E  sx = %20.15E  x = %20.15E\n", \
             iteration, i, RS[i], sol_x[IP[i]], x[i] );
    fprintf( FP_W2, "%d %d %20.15E %20.15E %20.15E\n", \
             iteration, i, RS[i], sol_x[IP[i]], x[i] );
  }
  fprintf( FP_W1,"\n" );
  fclose( FP_W1 );
  fclose( FP_W2 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
