/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/




/*-------------------------------------------------------------------------------*/
void  fwrite_iter_d( char *FILENAME, int iteration, double data )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int   i;
  FILE *fp;
  if  (  iteration == 1  ){   fp = fopen_w( FILENAME );   fprintf( fp, "%d %20.15lf\n", iteration, data );   }
  else                    {   fp = fopen_a( FILENAME );   fprintf( fp, "%d %20.15lf\n", iteration, data );   }
  fclose( fp );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/




/*-------------------------------------------------------------------------------*/
void  fwrite_iter_dd( char *FILENAME, int iteration, double data1, double data2 )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int   i;
  FILE *fp;
  if  (  iteration == 1  ){   fp = fopen_w( FILENAME );   fprintf( fp, "%d %20.15lf %20.15lf\n", iteration, data1, data2 );   }
  else                    {   fp = fopen_a( FILENAME );   fprintf( fp, "%d %20.15lf %20.15lf\n", iteration, data1, data2 );   }
  fclose( fp );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/




/*-------------------------------------------------------------------------------*/
void  fwrite_1d( char *FILENAME, int N, double *data )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int   i;
  FILE *fp = fopen_w( FILENAME );
  for( i = 1; i <= N; i++ )
    fprintf( fp, "%d %20.15lf\n", i, data[i] );
  fclose( fp );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  fwrite_2d( char *FILENAME, int N, int M, double **data )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int   i, j;
  FILE *fp = fopen_w( FILENAME );
  for( i = 1; i <= N; i++ )
    for( j = 1; j <= N; j++ )
      fprintf( fp, "%d %d %20.15lf\n", i, j, data[i][j] );
  fclose( fp );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  fwrite_1d1d( char *FILENAME, int N, double *data1, double *data2 )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int   i;
  FILE *fp = fopen_w( FILENAME );
  for( i = 1; i <= N; i++ )
    fprintf( fp, "%d %20.15lf %20.15lf\n", i, data1[i], data2[i] );
  fclose( fp );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  fwrite_1d1d1d( char *FILENAME, int N, double *data1, double *data2, double *data3 )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int   i;
  FILE *fp = fopen_w( FILENAME );
  for( i = 1; i <= N; i++ )
    fprintf( fp, "%d %20.15lf %20.15lf %20.15lf\n", i, data1[i], data2[i], data3[i] );
  fclose( fp );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  fwrite_1d1d1d1d( char *FILENAME, int N, double *data1, double *data2, double *data3, double *data4 )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int   i;
  FILE *fp = fopen_w( FILENAME );
  for( i = 1; i <= N; i++ )
    fprintf( fp, "%d %20.15lf %20.15lf %20.15lf %20.15lf\n", i, data1[i], data2[i], data3[i], data4[i] );
  fclose( fp );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  max_1d( int N, double *data, double *t__max )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double max;
  max  =  data[1];
  for( i = 2; i <= N; i++ )
    if(  max < data[i]  )
      max  =  data[i];
  *t__max  =  max;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  fabsmax_1d( int N, double *data, double *t__max )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double max;
  max  =  fabs(data[1]);
  for( i = 2; i <= N; i++ )
    if(  max < fabs(data[i])  )
      max  =  fabs(data[i]);
  *t__max  =  max;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  min_1d( int N, double *data, double *t__min )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double min;
  min  =  data[1];
  for( i = 2; i <= N; i++ )
    if(  min > data[i]  )
      min  =  data[i];
  *t__min  =  min;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  fabsmin_1d( int N, double *data, double *t__min )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double min;
  min  =  fabs(data[1]);
  for( i = 2; i <= N; i++ )
    if(  min > fabs(data[i])  )
      min  =  fabs(data[i]);
  *t__min  =  min;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  L2norm( int N, double *data, double *norm )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double tmp  =  0.0;
  for( i = 1; i <= N; i++ )
    tmp  +=  data[i]*data[i];
  *norm  =  sqrt( tmp );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  TransposedMatrix( int N, int M, double **A, double **B )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, j;
  for( i = 1; i <= N; i++ )
    for( j = 1; j <= M; j++ )
      B[j][i]  =  A[i][j];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
