/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define  SELECT_DISCRETE  2
#define  SELECT_PC        1
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Calculate_EE( int    c_FIRST, int    t_S    , int    t_E   , TEMP TP    , double *p_par, double *par, double *BC, \
                    double *t_p_x , double **k_p_x, double **p_aa, double **aa, double *PCT  , double *EEx  )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int NV, na;
  NV  =  TP.NV;
  na  =  TP.na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, t, N_t, c_EES;
  double p_PCT, t_PCT;
  double *p_x, *p_F, *F, *RS_EE;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( TP.EES == EES_D    ||  TP.EES == EES_D_M   )   c_EES = EES_D;
  else if( TP.EES == EES_S_E  ||  TP.EES == EES_S_E_M )   c_EES = EES_S_E;
  else if( TP.EES == EES_S_R  ||  TP.EES == EES_S_R_M )   c_EES = EES_S_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  p_x    =  malloc_1d( NV+na );
  p_F    =  malloc_1d( NV    );
  if( c_EES  ==  EES_D )
  F      =  malloc_1d( NV    );
  if( c_EES  ==  EES_D )
  RS_EE  =  malloc_1d( NV    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*  if  ( TP.NM == 1 )   N_t = (int)(1.0/TP.dt);*/
/*  else                 N_t = t_E - t_S;*/
  N_t  =  t_E - t_S;
  t_S --;
  *PCT  =  0.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= NV+na; i++ )
    p_x[i]  =  t_p_x[i];
  Reaction( TP, p_par, p_x, p_F );
#if   SELECT_PC == PC1
  PhaseCondition_T    ( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#elif SELECT_PC == PC2
  PhaseCondition_T_SFM( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#endif
  p_PCT  =  t_PCT;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( c_FIRST  ==  1 ){
    if( c_EES  ==  EES_D ){
      for( t = 2; t <= N_t+1; t++ ){
        RS_EEVT( TP, p_par, BC, p_x, p_F, RS_EE );
        Calculate_Solution_EE( TP, RS_EE, p_aa, p_x );
        for( i = 1; i <= NV; i++ )  k_p_x[t_S+t][i] = p_x[i];
        Reaction( TP, par, EEx, F );
        RS_EEVT( TP, par, BC, EEx, F, RS_EE );
        Calculate_Solution_EE( TP, RS_EE, aa, EEx );
        Reaction( TP, p_par, p_x, p_F );
        PhaseCondition_T( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
        *PCT   +=  p_PCT + t_PCT;
        p_PCT   =  t_PCT;
      }
    }else if( c_EES  ==  EES_S_E ){
      for( t = 2; t <= N_t+1; t++ ){
        EM_SM( TP, p_par, p_x );
        for( i = 1; i <= NV; i++ )  k_p_x[t_S+t][i] = p_x[i];
        EM_SM( TP, par  , EEx );
        Reaction( TP, p_par, p_x, p_F );
#if   SELECT_PC == PC1
        PhaseCondition_T( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#elif SELECT_PC == PC2
        PhaseCondition_T_SFM( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#endif
        *PCT   +=  p_PCT + t_PCT;
        p_PCT   =  t_PCT;
      }
    }else if( c_EES  ==  EES_S_R ){
      for( t = 2; t <= N_t+1; t++ ){
        RK4_SM( TP, p_par, p_x );
        for( i = 1; i <= NV; i++ )  k_p_x[t_S+t][i] = p_x[i];
        RK4_SM( TP, par  , EEx );
        Reaction( TP, p_par, p_x, p_F );
#if   SELECT_PC == PC1
        PhaseCondition_T( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#elif SELECT_PC == PC2
        PhaseCondition_T_SFM( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#endif
        *PCT   +=  p_PCT + t_PCT;
        p_PCT   =  t_PCT;
      }
    }
  }else{
    if( TP.EES  ==  EES_D ){
      for( t = 2; t <= N_t+1; t++ ){
        RS_EEVT( TP, p_par, BC, p_x, p_F, RS_EE );
        Calculate_Solution_EE( TP, RS_EE, p_aa, p_x );
        Reaction( TP, par, EEx, F );
        RS_EEVT( TP, par, BC, EEx, F, RS_EE );
        Calculate_Solution_EE( TP, RS_EE, aa, EEx );
        Reaction( TP, p_par, p_x, p_F );
        PhaseCondition_T( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
        *PCT   +=  p_PCT + t_PCT;
        p_PCT   =  t_PCT;
      }
    }else if( TP.EES  ==  EES_S_E ){
      for( t = 2; t <= N_t+1; t++ ){
        EM_SM( TP, p_par, p_x );
        EM_SM( TP, par  , EEx );
        Reaction( TP, p_par, p_x, p_F );
#if   SELECT_PC == PC1
        PhaseCondition_T( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#elif SELECT_PC == PC2
        PhaseCondition_T_SFM( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#endif
        *PCT   +=  p_PCT + t_PCT;
        p_PCT   =  t_PCT;
      }
    }else if( TP.EES  ==  EES_S_R ){
      for( t = 2; t <= N_t+1; t++ ){
        RK4_SM( TP, p_par, p_x );
        RK4_SM( TP, par  , EEx );
        Reaction( TP, p_par, p_x, p_F );
#if   SELECT_PC == PC1
        PhaseCondition_T( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#elif SELECT_PC == PC2
        PhaseCondition_T_SFM( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#endif
        *PCT   +=  p_PCT + t_PCT;
        p_PCT   =  t_PCT;
      }
    }else if( TP.EES  ==  EES_D_M ){
      for( t = 2; t <= N_t+1; t++ ){
        Reaction( TP, par, EEx, F );
        RS_EEVT( TP, par, BC, EEx, F, RS_EE );
        Calculate_Solution_EE( TP, RS_EE, aa, EEx );
        for( i = 1; i <= NV; i++ )   p_x[i] = k_p_x[t_S+t][i];
        Reaction( TP, p_par, p_x, p_F );
#if   SELECT_PC == PC1
        PhaseCondition_T( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#elif SELECT_PC == PC2
        PhaseCondition_T_SFM( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#endif
        *PCT   +=  p_PCT + t_PCT;
        p_PCT   =  t_PCT;
      }
    }else if( TP.EES  ==  EES_S_E_M ){
      for( t = 2; t <= N_t+1; t++ ){
        EM_SM( TP, par, EEx );
        for( i = 1; i <= NV; i++ )   p_x[i] = k_p_x[t_S+t][i];
        Reaction( TP, p_par, p_x, p_F );
#if   SELECT_PC == PC1
        PhaseCondition_T( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#elif SELECT_PC == PC2
        PhaseCondition_T_SFM( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#endif
        *PCT   +=  p_PCT + t_PCT;
        p_PCT   =  t_PCT;
      }
    }else if( TP.EES  ==  EES_S_R_M ){
      for( t = 2; t <= N_t+1; t++ ){
        RK4_SM( TP, par, EEx );
        for( i = 1; i <= NV; i++ )   p_x[i] = k_p_x[t_S+t][i];
        Reaction( TP, p_par, p_x, p_F );
#if   SELECT_PC == PC1
        PhaseCondition_T( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#elif SELECT_PC == PC2
        PhaseCondition_T_SFM( TP, p_par, BC, p_x, EEx, p_F, &t_PCT );
#endif
        *PCT   +=  p_PCT + t_PCT;
        p_PCT   =  t_PCT;
      }
    }
  }
  *PCT  *=  TP.dt / 2.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( p_x   );
  free_1d( p_F   );
  if( c_EES  ==  EES_D )
  free_1d( F     );
  if( c_EES  ==  EES_D )
  free_1d( RS_EE );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Calculate_EE_PF( int N_t, TEMP TP, double *par, double *BC, double **aa, double *EEx )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_EP, NV;
  N_EP  =  TP.N_EP;
  NV    =  TP.NV;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    t, c_EES;
  double *F, *RS_EE;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( TP.EES == EES_D    ||  TP.EES == EES_D_M   )   c_EES = EES_D;
  else if( TP.EES == EES_S_E  ||  TP.EES == EES_S_E_M )   c_EES = EES_S_E;
  else if( TP.EES == EES_S_R  ||  TP.EES == EES_S_R_M )   c_EES = EES_S_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  F      =  malloc_1d( NV );
  if( c_EES  ==  EES_D )
  RS_EE  =  malloc_1d( NV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*  if( TP.NM == 1 )   N_t = (int)(1.0/TP.dt);*/
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( c_EES  ==  EES_D ){
    for( t = 2; t <= N_t+1; t++ ){
      Reaction( TP, par, EEx, F );
      RS_EEVT( TP, par, BC, EEx, F, RS_EE );
      Calculate_Solution_EE( TP, RS_EE, aa, EEx );
    }
  }else if( c_EES  ==  EES_S_E ){
    for( t = 2; t <= N_t+1; t++ ){
      EM_SM( TP, par, EEx );
    }
  }else if( c_EES  ==  EES_S_R ){
    for( t = 2; t <= N_t+1; t++ ){
      RK4_SM( TP, par, EEx );
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( F     );
  if( c_EES  ==  EES_D )
  free_1d( RS_EE );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  PhaseCondition_T( TEMP TP, double *p_par, double *BC, double *p_x, double *x, double *p_F, double *t_PCT )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_EP, N_VAR, N, NV, np, nv;
  double dx;
  N_EP   =  TP.N_EP;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NV     =  TP.NV;
  np     =  TP.np;
  nv     =  TP.nv;
  dx     =  TP.dx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  double VEL;
  double *p_BCX, *PCF;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  p_BCX  =  malloc_1d( N_VAR*2 );
  PCF    =  malloc_1d( NV      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( nv == 0 )   VEL  =  0.0;
  else            VEL  =  x[NV+np+nv];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Generate_BC_Space( TP, BC, p_x, p_BCX );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
#if   SELECT_DISCRETE == DISCRETE1
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    i  =  1;
      PCF[(i_VAR-1)*N+i]  =  \
          p_par[N_EP+i_VAR]*(p_BCX[(i_VAR-1)*2+1]-2.0*p_x[(i_VAR-1)*N+i]+p_x[(i_VAR-1)*N+i+1]) / (dx*dx) \
        + VEL*(p_x[(i_VAR-1)*N+i+1]-p_BCX[(i_VAR-1)*2+1]) / (2.0*dx) \
        + p_F[(i_VAR-1)*N+i];
    for( i = 2; i <= N-1; i++ )
      PCF[(i_VAR-1)*N+i]  =  \
          p_par[N_EP+i_VAR]*(p_x[(i_VAR-1)*N+i-1]-2.0*p_x[(i_VAR-1)*N+i]+p_x[(i_VAR-1)*N+i+1]) / (dx*dx) \
        + VEL*(p_x[(i_VAR-1)*N+i+1]-p_x[(i_VAR-1)*N+i-1]) / (2.0*dx) \
        + p_F[(i_VAR-1)*N+i];
    i  =  N;
      PCF[(i_VAR-1)*N+i]  =  \
          p_par[N_EP+i_VAR]*(p_x[(i_VAR-1)*N+i-1]-2.0*p_x[(i_VAR-1)*N+i]+p_BCX[(i_VAR-1)*2+2]) / (dx*dx) \
        + VEL*(p_BCX[(i_VAR-1)*2+2]-p_x[(i_VAR-1)*N+i-1]) / (2.0*dx) \
        + p_F[(i_VAR-1)*N+i];
  }
#elif   SELECT_DISCRETE == DISCRETE2
  if( TP.BCS  ==  BCS_3 ){
    double Rv1  =  TP.dt *      VEL  / (12.0*TP.dx);
    double Rv2  =  TP.dt * fabs(VEL) / (12.0*TP.dx);
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      i  =  1;
        PCF[(i_VAR-1)*N+i]  =  \
             p_par[N_EP+i_VAR]*(p_x[(i_VAR-1)*N+i-1+N]-2.0*p_x[(i_VAR-1)*N+i]+p_x[(i_VAR-1)*N+i+1]) / (dx*dx) \
          +  Rv1*(-p_x[(i_VAR-1)*N+i+2]+8.0*p_x[(i_VAR-1)*N+i+1]                       -8.0*p_x[(i_VAR-1)*N+i-1+N]+p_x[(i_VAR-1)*N+i-2+N]) \
          +  Rv2*( p_x[(i_VAR-1)*N+i+2]-4.0*p_x[(i_VAR-1)*N+i+1]+6.0*p_x[(i_VAR-1)*N+i]-4.0*p_x[(i_VAR-1)*N+i-1+N]+p_x[(i_VAR-1)*N+i-2+N]) \
          + p_F[(i_VAR-1)*N+i];
      i  =  2;
        PCF[(i_VAR-1)*N+i]  =  \
            p_par[N_EP+i_VAR]*(p_x[(i_VAR-1)*N+i-1]-2.0*p_x[(i_VAR-1)*N+i]+p_x[(i_VAR-1)*N+i+1]) / (dx*dx) \
          + Rv1*(-p_x[(i_VAR-1)*N+i+2]+8.0*p_x[(i_VAR-1)*N+i+1]                       -8.0*p_x[(i_VAR-1)*N+i-1]+p_x[(i_VAR-1)*N+i-2+N]) \
          + Rv2*( p_x[(i_VAR-1)*N+i+2]-4.0*p_x[(i_VAR-1)*N+i+1]+6.0*p_x[(i_VAR-1)*N+i]-4.0*p_x[(i_VAR-1)*N+i-1]+p_x[(i_VAR-1)*N+i-2+N]) \
          + p_F[(i_VAR-1)*N+i];
      for( i = 3; i <= TP.N-2; i++ )
        PCF[(i_VAR-1)*N+i]  =  \
            p_par[N_EP+i_VAR]*(p_x[(i_VAR-1)*N+i-1]-2.0*p_x[(i_VAR-1)*N+i]+p_x[(i_VAR-1)*N+i+1]) / (dx*dx) \
          + Rv1*(-p_x[(i_VAR-1)*N+i+2]+8.0*p_x[(i_VAR-1)*N+i+1]                       -8.0*p_x[(i_VAR-1)*N+i-1]+p_x[(i_VAR-1)*N+i-2]) \
          + Rv2*( p_x[(i_VAR-1)*N+i+2]-4.0*p_x[(i_VAR-1)*N+i+1]+6.0*p_x[(i_VAR-1)*N+i]-4.0*p_x[(i_VAR-1)*N+i-1]+p_x[(i_VAR-1)*N+i-2]) \
          + p_F[(i_VAR-1)*N+i];
      i  =  TP.N-1;
        PCF[(i_VAR-1)*N+i]  =  \
             p_par[N_EP+i_VAR]*(p_x[(i_VAR-1)*N+i-1]-2.0*p_x[(i_VAR-1)*N+i]+p_x[(i_VAR-1)*N+i+1]) / (dx*dx) \
          +  Rv1*(-p_x[(i_VAR-1)*N+i+2-N]+8.0*p_x[(i_VAR-1)*N+i+1]                       -8.0*p_x[(i_VAR-1)*N+i-1]+p_x[(i_VAR-1)*N+i-2]) \
          +  Rv2*( p_x[(i_VAR-1)*N+i+2-N]-4.0*p_x[(i_VAR-1)*N+i+1]+6.0*p_x[(i_VAR-1)*N+i]-4.0*p_x[(i_VAR-1)*N+i-1]+p_x[(i_VAR-1)*N+i-2]) \
          + p_F[(i_VAR-1)*N+i];
      i  =  TP.N;
        PCF[(i_VAR-1)*N+i]  =  \
             p_par[N_EP+i_VAR]*(p_x[(i_VAR-1)*N+i-1]-2.0*p_x[(i_VAR-1)*N+i]+p_x[(i_VAR-1)*N+i+1-N]) / (dx*dx) \
          +  Rv1*(-p_x[(i_VAR-1)*N+i+2-N]+8.0*p_x[(i_VAR-1)*N+i+1-N]                       -8.0*p_x[(i_VAR-1)*N+i-1]+p_x[(i_VAR-1)*N+i-2]) \
          +  Rv2*( p_x[(i_VAR-1)*N+i+2-N]-4.0*p_x[(i_VAR-1)*N+i+1-N]+6.0*p_x[(i_VAR-1)*N+i]-4.0*p_x[(i_VAR-1)*N+i-1]+p_x[(i_VAR-1)*N+i-2]) \
          + p_F[(i_VAR-1)*N+i];
    }
  }else{
    printf("M_V error");
    MPI_EXIT(TP);
  }
#endif
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  *t_PCT  =  0.0;
  for( i = 1; i <= NV; i++ )
    *t_PCT  +=  x[i] * PCF[i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( p_BCX );
  free_1d( PCF   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  PhaseCondition_T_SFM( TEMP TP, double *p_par, double *BC, double *p_x, double *x, double *p_F, double *t_PCT )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_EP, N_VAR, N, NV, np, nv;
  N_EP   =  TP.N_EP;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NV     =  TP.NV;
  np     =  TP.np;
  nv     =  TP.nv;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_VAR, iV, i_min, i_max;
  double VEL, sum;
  double *p_BCX, *PCF;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  p_BCX  =  malloc_1d( N_VAR*2 );
  PCF    =  malloc_1d( NV      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( nv == 0 )   VEL  =  0.0;
  else            VEL  =  p_x[NV+np+nv];
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  i_min = 220;   i_max = 280;
  i_min = 180;   i_max = 320;
  i_min = 200;   i_max = 300;
  i_min = 150;   i_max = 350;
  i_min = 0;     i_max = N-1;
  i_min = N/2;   i_max = N/2;
  for( i_VAR = 1; i_VAR <= 1; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = i_min; i <= i_max; i++ ){
      sum  =  0.0;
      for( j = 0; j <= i-1; j++ )
        sum  +=  ( p_par[N_EP+i_VAR]*cos(M_PI*(i-j))/(cos(2.0*M_PI*(i-j)/N)-1.0) \
                 + VEL*0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N) ) * p_x[iV+j+1];
      j  =  i;
        sum  +=  ( - p_par[N_EP+i_VAR]*(N*N+2.0)/12.0 ) * p_x[iV+j+1];
      for( j = i+1; j <= N-1; j++ )
        sum  +=  ( p_par[N_EP+i_VAR]*cos(M_PI*(i-j))/(cos(2.0*M_PI*(i-j)/N)-1.0) \
                 + VEL*0.5*cos(M_PI*(i-j))*cos(M_PI*(i-j)/N)/sin(M_PI*(i-j)/N) ) * p_x[iV+j+1];
      PCF[iV+i+1]  =  sum + p_F[iV+i+1]; 
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  *t_PCT  =  0.0;
  for( i =i_min+1; i <= i_max+1; i++ )
    *t_PCT  +=  x[i] * PCF[i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( p_BCX );
  free_1d( PCF   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
