/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "function_declartion.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  GrammSchmidt( int N, int M, double **V, int *I_ERR )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, k;
  double inner_product;
  double *SUM, *jV;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SUM  =  malloc_1d( N );
  jV   =  malloc_1d( N );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= M; i++ ){
    for( j = 1; j <= N; j++ )
      SUM[j]  =  0.0;
    for( j = 2; j <= i; j++ ){
      inner_product  =  0.0;
      for( k = 1; k <= N; k++ )
        inner_product  +=  V[k][i] * V[k][j-1];
      for( k = 1; k <= N; k++ )
        SUM[k]  +=  inner_product * V[k][j-1];
    }
    for( j = 1; j <= N; j++ )
      jV[j]  =  V[j][i] - SUM[j];
    normalize_dot_x( N, jV, I_ERR );   if( *I_ERR == 1 ){   goto END;   }
    for( j = 1; j <= N; j++ )
      V[j][i]  =  jV[j];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  END:
  free_1d( SUM );
  free_1d( jV  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
