*
      SUBROUTINE ilucgs1(N,N1,N2,M1,M2,B,AA,XX,IER)
************************************************************************
*  INCOMPLETE LU DECOMPOSITION CONJUGATED GRADIENT SQUARED METHOD FOR  *
*      FINITE DIFFERENCE METHOD.                                       *
*                                                                      *
*  PARAMETERS: SAME AS ROUTINE ILUBCG.                                 *
*                                                                      *
*  COPYRIGHT	TSUTOMU OGUNI      SEP. 1 1991      VER. 1             *
************************************************************************
       IMPLICIT REAL*8(A-H,O-Z)
       DIMENSION A(N2:N1,7), B(N), X(N2:N+M2), W(N2:N+M2), P(N2:N+M2),
     *  Q(N2:N+M2), R(N2:N+M2), D(N2:N+M2), R0(N), E(N), H(N)
       DIMENSION AA(N*7), XX(N)
C
c-----------------------------------------------------------------------
      do i = N2, N1
        do j = 1, 7
          A(i,j)  =  0.D0
        end do
      end do
      do i = 1, N
        do j = 1, 7
          A(i,j)  =  AA(7*(i-1)+j)
        end do
      end do
      do i = N2, N+M2
        X(i)  =  0.D0
      end do
      do i = 1, N
        X(i)  =  XX(i)
      end do
c- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      EPS  =  1.0D-07
      ITR  =  10000
      S    =  0.D0
      IER  =  0
c-----------------------------------------------------------------------

      IF ((N1 .LT. N+M2) .OR. (M1 .LE. 1) .OR. (M1 .GE. M2) .OR.
     *    (M2 .GT. N) .OR. (N2 .GT. -M2) .OR. (S .LT. 0.0)) THEN
c      WRITE(*,*) '(SUBR. ILUCGS) INVALID ARGUMENT. ',N,N1,N2,M1,M2,S
       IER = 2
       RETURN
      ENDIF
C
      TH = 1.0D0
      IF (S .GT. 0.0 .AND. S .LT. 1.0) THEN
       TH = S
       S = 1.0D0
      ENDIF
      DO 10 I=1-M2,0
       D(I) = 0.0D0
       X(I) = 0.0D0
       P(I) = 0.0D0
       Q(I) = 0.0D0
       R(I) = 0.0D0
       W(I) = 0.0D0
       W(I+N+M2) = 0.0D0
       P(I+N+M2) = 0.0D0
       Q(I+N+M2) = 0.0D0
       R(I+N+M2) = 0.0D0
   10  X(I+N+M2) = 0.0D0
      DO 11 I=1,N
   11  D(I) = 0.0D0
C  INCOMPLETE CHOLESKY DECOMPOSITION
      IF (S .NE. 0.0) THEN
       DO 15 I=1,N
	SS=S*A(I,4)-A(I,3)*(A(I-1,5)+(A(I-1,6)+A(I-1,7))*TH)*D(I-1)
     *             -A(I,2)*(A(I-M1,6)+(A(I-M1,5)+A(I-M1,7))*TH)*D(I-M1) 
     *             -A(I,1)*(A(I-M2,7)+(A(I-M2,6)+A(I-M2,5))*TH)*D(I-M2)
   15	D(I) = 1.0D0 / SS
      ELSE
       DO 20 I=1,N
        SS = A(I,4) - A(I,3)*A(I-1,5)*D(I-1) - A(I,2)*A(I-M1,6)*D(I-M1)
     *              - A(I,1)*A(I-M2,7)*D(I-M2)
   20	D(I) = 1.0D0 / SS
      ENDIF
      DO 30 I=1,N
   30  Q(I) = A(I,1)*X(I-M2)+A(I,2)*X(I-M1)+A(I,3)*X(I-1)+A(I,4)*X(I)
     *        +A(I,5)*X(I+1)+A(I,6)*X(I+M1)+A(I,7)*X(I+M2)
      DO 40 I=1,N
   40  R(I) = B(I) - Q(I)
      DO 50 I=1,N
   50  R(I) = D(I)*(R(I)-A(I,3)*R(I-1)-A(I,2)*R(I-M1)-A(I,1)*R(I-M2))
      DO 60 I=N,1,-1
   60  R(I) = R(I)-D(I)*(A(I,5)*R(I+1)+A(I,6)*R(I+M1)+A(I,7)*R(I+M2))
      C1 = 0.0D0
      DO 70 I=1,N
       R0(I) = R(I)
       P(I) = R(I)
       E(I) = R(I)
   70  C1 = C1 + R(I) * R(I)
C  ITERATION PHASE
      DO 200 K=1,ITR
       DO 80 I=1,N
   80   Q(I) = A(I,1)*P(I-M2)+A(I,2)*P(I-M1)+A(I,3)*P(I-1)
     *         +A(I,4)*P(I)+A(I,5)*P(I+1)+A(I,6)*P(I+M1)
     *         +A(I,7)*P(I+M2)
       DO 90 I=1,N
   90   Q(I)=D(I)*(Q(I)-A(I,3)*Q(I-1)-A(I,2)*Q(I-M1)-A(I,1)*Q(I-M2))
       DO 100 I=N,1,-1
  100   Q(I)=Q(I)-D(I)*(A(I,5)*Q(I+1)+A(I,6)*Q(I+M1)+A(I,7)*Q(I+M2))
       C2 = 0.0D0
       DO 110 I=1,N
  110	C2 = C2 + Q(I) * R0(I)
       IF (C2 .EQ. 0.0) THEN
	IER = 5
	EPS = RES
	ITR = K
	RETURN
       ENDIF
       ALPHA = C1 / C2
       C3 = 0.0D0
       X1 = 0.0D0
       X2 = 0.0D0
       DO 120 I=1,N
        H(I) = E(I) - ALPHA * Q(I)
  120  CONTINUE
       DO 130 I=1,N
  130   W(I) = E(I) + H(I)
       DO 140 I=1,N
  140   Q(I) = A(I,1)*W(I-M2)+A(I,2)*W(I-M1)+A(I,3)*W(I-1)
     *         +A(I,4)*W(I)+A(I,5)*W(I+1)+A(I,6)*W(I+M1)
     *         +A(I,7)*W(I+M2)
       DO 150 I=1,N
  150   Q(I)=D(I)*(Q(I)-A(I,3)*Q(I-1)-A(I,2)*Q(I-M1)-A(I,1)*Q(I-M2))
       DO 160 I=N,1,-1
  160   Q(I)=Q(I)-D(I)*(A(I,5)*Q(I+1)+A(I,6)*Q(I+M1)+A(I,7)*Q(I+M2))
       DO 170 I=1,N
        Y = X(I)
        R(I) = R(I) - ALPHA * Q(I)
        X(I) = X(I) + ALPHA * W(I)
        C3 = C3 + R(I) * R0(I)
        X1 = X1 + Y * Y
  170   X2 = X2 + (X(I) - Y)**2
       IF (X1 .NE. 0.0) THEN
        RES = DSQRT(X2 / X1) 
        IF (RES .LE. EPS) THEN
         ITR = K
         IER = 0
         EPS = RES
         IF (TH .NE. 1.0D0) S = TH
c-----------------------------------------------------------------------
         do i = 1, N
           XX(i)  =  X(i)
         end do
c-----------------------------------------------------------------------
         RETURN
	ENDIF
       ENDIF 
       BETA = C3 / C1
       C1 = C3
       DO 180 I=1,N
        E(I) = R(I) + BETA * H(I)
        P(I) = E(I) + BETA * (H(I) + BETA * P(I))
  180  CONTINUE
C
  200 CONTINUE
      IER = 1
c     WRITE(*,*) '(SUBR. ILUCGS) NO CONVERGENCE. '
      EPS = RES
      IF (TH .NE. 1.0D0) S = TH
      RETURN
C  END OF ILUCGS
      END
