/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
#define  Malloc_Error_Check( x ){ \
  if( (x)  ==  NULL ){ \
    printf( "Malloc Failure!!\n" ); \
    exit(1); \
  } \
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
char  *malloc_1c( int N1 )
{
  char *x;
  x = (char *)malloc( sizeof(char)*N1 );   Malloc_Error_Check( x );   x -= 1;
  return x;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  free_1c( char *x )
{
  free( x+1 );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
char  **malloc_2c( int N1, int N2 )
{
  int  i;
  char *x, **xx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x  = (char * )malloc( sizeof(char  )*N1*N2 );   Malloc_Error_Check( x  );   x  -= 1;
  xx = (char **)malloc( sizeof(char *)*N1    );   Malloc_Error_Check( xx );   xx -= 1;
  for( i = 1; i <= N1; i++ )
    xx[i]  =  x + (i-1)*N2;
  return xx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  free_2c( char **xx )
{
  free( xx[1]+1 );
  free( xx+1    );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
char  ***malloc_3c( int N1, int N2, int N3 )
{
  int  i;
  char *x, **xx, ***xxx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x   = (char *  )malloc( sizeof(char   )*N1*N2*N3 );   Malloc_Error_Check( x   );  x   -= 1;
  xx  = (char ** )malloc( sizeof(char * )*N1*N2    );   Malloc_Error_Check( xx  );  xx  -= 1;
  xxx = (char ***)malloc( sizeof(char **)*N1       );   Malloc_Error_Check( xxx );  xxx -= 1;
  for( i = 1; i <= N1; i++ )
    xxx[i]  =  xx + (i-1)*N2;
  for( i = 1; i <= N1*N2; i++ )
    xx[i]  =  x + (i-1)*N3;
  return xxx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  free_3c( char ***xxx )
{
  free( xxx[1][1]+1 );
  free( xxx[1]+1    );
  free( xxx+1       );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
int  *malloc_1i( int N1 )
{
  int *x;
  x = (int *)malloc( sizeof(int)*N1 );   Malloc_Error_Check( x );   x -= 1;
  return x;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  free_1i( int *x )
{
  free( x+1 );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
int  **malloc_2i( int N1, int N2 )
{
  int i;
  int *x, **xx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x  = (int * )malloc( sizeof(int  )*N1*N2 );   Malloc_Error_Check( x  );   x  -= 1;
  xx = (int **)malloc( sizeof(int *)*N1    );   Malloc_Error_Check( xx );   xx -= 1;
  for( i = 1; i <= N1; i++ )
    xx[i]  =  x + (i-1)*N2;
  return xx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  free_2i( int **xx )
{
  free( xx[1]+1 );
  free( xx+1    );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
int  ***malloc_3i( int N1, int N2, int N3 )
{
  int i;
  int *x, **xx, ***xxx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x   = (int *  )malloc( sizeof(int   )*N1*N2*N3 );   Malloc_Error_Check( x   );  x   -= 1;
  xx  = (int ** )malloc( sizeof(int * )*N1*N2    );   Malloc_Error_Check( xx  );  xx  -= 1;
  xxx = (int ***)malloc( sizeof(int **)*N1       );   Malloc_Error_Check( xxx );  xxx -= 1;
  for( i = 1; i <= N1; i++ )
    xxx[i]  =  xx + (i-1)*N2;
  for( i = 1; i <= N1*N2; i++ )
    xx[i]  =  x + (i-1)*N3;
  return xxx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  free_3i( int ***xxx )
{
  free( xxx[1][1]+1 );
  free( xxx[1]+1    );
  free( xxx+1       );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
double  *malloc_1d( int N1 )
{
  double *x;
  x = (double *)malloc( sizeof(double)*N1 );   Malloc_Error_Check( x );   x -= 1;
  return x;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  free_1d( double *x )
{
  free( x+1 );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
double  **malloc_2d( int N1, int N2 )
{
  int    i;
  double *x, **xx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x  = (double * )malloc( sizeof(double  )*N1*N2 );   Malloc_Error_Check( x  );   x  -= 1;
  xx = (double **)malloc( sizeof(double *)*N1    );   Malloc_Error_Check( xx );   xx -= 1;
  for( i = 1; i <= N1; i++ )
    xx[i]  =  x + (i-1)*N2;
  return xx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  free_2d( double **xx )
{
  free( xx[1]+1 );
  free( xx+1    );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
double  ***malloc_3d( int N1, int N2, int N3 )
{
  int    i;
  double *x, **xx, ***xxx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x   = (double *  )malloc( sizeof(double   )*N1*N2*N3 );   Malloc_Error_Check( x   );  x   -= 1;
  xx  = (double ** )malloc( sizeof(double * )*N1*N2    );   Malloc_Error_Check( xx  );  xx  -= 1;
  xxx = (double ***)malloc( sizeof(double **)*N1       );   Malloc_Error_Check( xxx );  xxx -= 1;
  for( i = 1; i <= N1; i++ )
    xxx[i]  =  xx + (i-1)*N2;
  for( i = 1; i <= N1*N2; i++ )
    xx[i]  =  x + (i-1)*N3;
  return xxx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  free_3d( double ***xxx )
{
  free( xxx[1][1]+1 );
  free( xxx[1]+1    );
  free( xxx+1       );
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
char  *MALLOC_1C( int N1 )
{
  char *x;
  x = (char *)malloc( sizeof(char)*N1 );   Malloc_Error_Check( x );
  return x;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  FREE_1C( char *x )
{
  free( x );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
char  **MALLOC_2C( int N1, int N2 )
{
  int  i;
  char *x, **xx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x  = (char * )malloc( sizeof(char  )*N1*N2 );   Malloc_Error_Check( x  );
  xx = (char **)malloc( sizeof(char *)*N1    );   Malloc_Error_Check( xx );
  for( i = 0; i <= N1-1; i++ )
    xx[i]  =  x + i*N2;
  return xx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  FREE_2C( char **xx )
{
  free( xx[0] );
  free( xx    );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
char  ***MALLOC_3C( int N1, int N2, int N3 )
{
  int  i;
  char *x, **xx, ***xxx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x   = (char *  )malloc( sizeof(char   )*N1*N2*N3 );   Malloc_Error_Check( x   );
  xx  = (char ** )malloc( sizeof(char * )*N1*N2    );   Malloc_Error_Check( xx  );
  xxx = (char ***)malloc( sizeof(char **)*N1       );   Malloc_Error_Check( xxx );
  for( i = 0; i <= N1-1; i++ )
    xxx[i]  =  xx + i*N2;
  for( i = 0; i <= N1*N2-1; i++ )
    xx[i]  =  x + i*N3;
  return xxx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  FREE_3C( char ***xxx )
{
  free( xxx[0][0] );
  free( xxx[0]    );
  free( xxx       );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
long int  *MALLOC_1LI( long int N1 )
{
  long int *x;
  x = (long int *)malloc( sizeof(long int)*N1 );   Malloc_Error_Check( x );
  return x;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  FREE_1LI( long int *x )
{
  free( x );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
int  *MALLOC_1I( int N1 )
{
  int *x;
  x = (int *)malloc( sizeof(int)*N1 );   Malloc_Error_Check( x );
  return x;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  FREE_1I( int *x )
{
  free( x );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
int  **MALLOC_2I( int N1, int N2 )
{
  int i;
  int *x, **xx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x  = (int * )malloc( sizeof(int  )*N1*N2 );   Malloc_Error_Check( x  );
  xx = (int **)malloc( sizeof(int *)*N1    );   Malloc_Error_Check( xx );
  for( i = 0; i <= N1-1; i++ )
    xx[i]  =  x + i*N2;
  return xx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  FREE_2I( int **xx )
{
  free( xx[0] );
  free( xx    );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
int  ***MALLOC_3I( int N1, int N2, int N3 )
{
  int i;
  int *x, **xx, ***xxx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x   = (int *  )malloc( sizeof(int   )*N1*N2*N3 );   Malloc_Error_Check( x   );
  xx  = (int ** )malloc( sizeof(int * )*N1*N2    );   Malloc_Error_Check( xx  );
  xxx = (int ***)malloc( sizeof(int **)*N1       );   Malloc_Error_Check( xxx );
  for( i = 0; i <= N1-1; i++ )
    xxx[i]  =  xx + i*N2;
  for( i = 0; i <= N1*N2-1; i++ )
    xx[i]  =  x + i*N3;
  return xxx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  FREE_3I( int ***xxx )
{
  free( xxx[0][0] );
  free( xxx[0]    );
  free( xxx       );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
double  *MALLOC_1D( int N1 )
{
  double *x;
  x = (double *)malloc( sizeof(double)*N1 );   Malloc_Error_Check( x );
  return x;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  FREE_1D( double *x )
{
  free( x );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
double  **MALLOC_2D( int N1, int N2 )
{
  int    i;
  double *x, **xx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x  = (double * )malloc( sizeof(double  )*N1*N2 );   Malloc_Error_Check( x  );
  xx = (double **)malloc( sizeof(double *)*N1    );   Malloc_Error_Check( xx );
  for( i = 0; i <= N1-1; i++ )
    xx[i]  =  x + i*N2;
  return xx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  FREE_2D( double **xx )
{
  free( xx[0] );
  free( xx    );
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
double  ***MALLOC_3D( int N1, int N2, int N3 )
{
  int    i;
  double *x, **xx, ***xxx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x   = (double *  )malloc( sizeof(double   )*N1*N2*N3 );   Malloc_Error_Check( x   );
  xx  = (double ** )malloc( sizeof(double * )*N1*N2    );   Malloc_Error_Check( xx  );
  xxx = (double ***)malloc( sizeof(double **)*N1       );   Malloc_Error_Check( xxx );
  for( i = 0; i <= N1-1; i++ )
    xxx[i]  =  xx + i*N2;
  for( i = 0; i <= N1*N2-1; i++ )
    xx[i]  =  x + i*N3;
  return xxx;
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  FREE_3D( double ***xxx )
{
  free( xxx[0][0] );
  free( xxx[0]    );
  free( xxx       );
}
/*-------------------------------------------------------------------------------*/
