/*-------------------------------------------------------------------------------*/
#include <stdio.h>
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  comment_remove( char *INPUTPARAMETER, char *OUTPUTPARAMETER );
void  Remove_TempFile( char *TempFile );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  DataNum( char *READ_DATA, int *DataNum );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Read_OperationParameter( char *READ_OP, int N_OP, int *OP_int, double *OP_double );
void  Read_EquationParameter( char *READ_EP, int N_EP, double *par );
void  Read_BoundaryParameter( char *READ_EP, int N_EP, double *par );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
FILE  *fopen_mode( char *FILENAME, int ModeSet );
FILE  *fopen_r( char *FILENAME );
FILE  *fopen_w( char *FILENAME );
FILE  *fopen_a( char *FILENAME );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  END_PROGRAM( char *PRINTF, int N_REP, int c_END );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  GNUPLOT_DRAW_SELECT( int N_G, int GSD, int *c_G );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  PartialDiff_Function_FP( int N_EP, int N, int CP, double *par, double *x, double *PDF );
void  PartialDiff_Function_GP( int N_EP, int N, int CP, double *par, double *x, double *PDF );
void  PartialDiff_Function_FU( int N, int Nm, double *par, double *x, double *PDF );
void  PartialDiff_Function_FV( int N, int Nm, double *par, double *x, double *PDF );
void  PartialDiff_Function_GU( int N, int Nm, double *par, double *x, double *PDF );
void  PartialDiff_Function_GV( int N, int Nm, double *par, double *x, double *PDF );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  LU_Decomposition_0n3pDN( int N, double **a, double **L, double **U );
void  LU_Decomposition_0n3pC( int N, double **a, double **L, double **U );
void  LU_Decomposition_0nF( int N, double **a, double **L, double **U );
void  LU_Decomposition_1n3pDN( int N, double **a, double **L, double **U );
void  LU_Decomposition_1n3pC( int N, double **a, double **L, double **U );
void  LU_Decomposition_1n3pDNC( int N, int BCS, double **a, double **L, double **U );
void  LU_Decomposition_1nF( int N, double **a, double **L, double **U );
void  Calculate_Solution_0n3pDN( int N, double *RS, double **L, double **U, double *x );
void  Calculate_Solution_0n3pC( int N, double *RS, double **L, double **U, double *x );
void  Calculate_Solution_0nF( int N, double *RS, double **L, double **U, double *x );
void  Calculate_Solution_1n3pDN( int N, double *RS, double **L, double **U, double *x );
void  Calculate_Solution_1n3pC( int N, double *RS, double **L, double **U, double *x );
void  Calculate_Solution_1n3pDNC( int N, int BCS, double *RS, double **L, double **U, double *x );
void  Calculate_Solution_1nF( int N, double *RS, double **L, double **U, double *x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  initial_dot( int NM, int tNM, int NV, int NA, double *p_x, double *x, double *d_x );
void  normalize_dot_x( int N, double *d_x, int *I_ERR );
void  normalize( int N, double *x, int *I_ERR );
void  RightSide_Of_Dot( int N, double *dot_RS );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Sort_NearZeroEV( int Nm, double *REV, double *IEV );
void  Sort_NearOneEV( int Nm, double *REV, double *IEV );
void  Sort_AscendingSequence_REV( int Nm, double *REV, double *IEV );
void  Sort_AscendingSequence_RIEV( int Nm, double *REV, double *IEV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Arrange_SV( int N, int Nm , int nm, int NN, int NM, int BCS, \
                  double BC_00_U, double BC_N1_U, double BC_00_V , double BC_N1_V, \
                  double *x     , double *xx      );
void  Arrange_SV1( int N, int Nm, int nm, int NN, int NM, int BCS, double *xx, double *x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  MatrixProduct( int L, int M, double **A, int N, double **B, double **C );
void  MatrixProduct_11( int L, double *A, double *B, double *C );
void  MatrixProduct_22s( int L, int M, double **A, int N, double **B, double **C );
void  MatrixProduct_21( int L, int M, double **A, double *B, double *C );
void  MatrixProduct_21s( int L, int M, double **A, double *B, double *C );
void  MatrixProduct_22s_MPI( int PROCS, int RANK, int L, int M, double **A, int N, double **B, double **C );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  N_SPLIT( char *Split_Character, char *Split_Target, int *N_Split_Target );
void  SPLIT( int N_Split          , int NMax_Split    , \
             char *Split_Character, char *Split_Target, char **data );
void  SPLIT_READ_DATA( int N, FILE *fp, double *data );
void  SPLIT_WRITE_DATA( int N_Data       , FILE   *fp  , \
                        int *DeletingData, double *data, char **SubData );
void  SPLIT_WRITE_GNUPLOT
      ( FILE *fp      , int step      ,double data_DP, \
        char *EchoName, char *FileName, int N_SC12   , \
        char *C10     , char **C11    , char **C12   , char **C13, char **C14, \
        char *C2   );
void  SPLIT_WRITE_PRINT
      ( FILE *fp , char *FNData, char *FNLpr, char *lpr , char *PostScript, \
        int N_SC0, int N_SC12  , \
        char **C0, char *C10   , char **C11 , char **C12, char **C13, char **C14 );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
int     *alloc_1d_int(int n1);
void    free_1d_int(int *i);
double  *alloc_1d_double(int n1);
void    free_1d_double(double *d);
char    *alloc_1d_char(int n1);
void    free_1d_char(char *c);
int     **alloc_2d_int(int n1, int n2);
void    free_2d_int(int **ii);
double  **alloc_2d_double(int n1, int n2);
void    free_2d_double(double **dd);
char    **alloc_2d_char(int n1, int n2);
void    free_2d_char(char **cc);
int     ***alloc_3d_int(int n1, int n2, int n3);
void    free_3d_int(int ***iii);
double  ***alloc_3d_double(int n1, int n2, int n3);
void    free_3d_double(double ***ddd);
char    ***alloc_3d_char(int n1, int n2, int n3);
void    free_3d_char(char ***ccc);
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void rdft(int n, int isgn, double *a, int *ip, double *w);
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  CLCEGN( int NV, int N, double **a, double *REV, double *IEV );
void  BALANC( int Nm, int N, double **A, int *low, int *igh );
void  ELMHES( int Nm, int N, int *low, int *igh, double **a );
void  HQR( int Nm    , int N      , int *low   , int *igh, \
           double **a, double *REV, double *IEV, int *ERR  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  ilucgs1_( int *, int *, int *, int *, int *, double *, double *, double *, int * );
void  clcegn_( int *, int *, double *, double *, double * );
void  clcegnv_( int *, int *, int *, int *, double *, double *, double *, double *, double *, double *, double *, double *, int *, int *, double * );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  glu1_( int *, int *, double *, int * );
void  gslv1_( int *, int *, double *, double * );
void  glu2_( int *, int *, int *, double *, int * );
void  glu4_( int *, int *, int *, double *, int * );
void  gslv4_( int *, int *, int *, double *, double * );
void  glu11_( int *, int *, int *, double *, int * );
void  gslv11_( int *, int *, int *, double *, double * );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
char    *  malloc_1c( int N1                 );
char    ** malloc_2c( int N1, int N2         );
char    ***malloc_3c( int N1, int N2, int N3 );
int     *  malloc_1i( int N1                 );
int     ** malloc_2i( int N1, int N2         );
int     ***malloc_3i( int N1, int N2, int N3 );
double  *  malloc_1d( int N1                 );
double  ** malloc_2d( int N1, int N2         );
double  ***malloc_3d( int N1, int N2, int N3 );
void    free_1c( char   *x     );
void    free_2c( char   **xx   );
void    free_3c( char   ***xxx );
void    free_1i( int    *x     );
void    free_2i( int    **xx   );
void    free_3i( int    ***xxx );
void    free_1d( double *x     );
void    free_2d( double **xx   );
void    free_3d( double ***xxx );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
char      *  MALLOC_1C ( int N1                 );
char      ** MALLOC_2C ( int N1, int N2         );
char      ***MALLOC_3C ( int N1, int N2, int N3 );
int       *  MALLOC_1I ( int N1                 );
int       ** MALLOC_2I ( int N1, int N2         );
int       ***MALLOC_3I ( int N1, int N2, int N3 );
long int  *  MALLOC_1LI( long int N1            );
double    *  MALLOC_1D ( int N1                 );
double    ** MALLOC_2D ( int N1, int N2         );
double    ***MALLOC_3D ( int N1, int N2, int N3 );
void           FREE_1C ( char     *x     );
void           FREE_2C ( char     **xx   );
void           FREE_3C ( char     ***xxx );
void           FREE_1I ( int      *x     );
void           FREE_2I ( int      **xx   );
void           FREE_3I ( int      ***xxx );
void           FREE_1LI( long int *x     );
void           FREE_1D ( double   *x     );
void           FREE_2D ( double   **xx   );
void           FREE_3D ( double   ***xxx );
/*-------------------------------------------------------------------------------*/
