/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <mpi.h>
#include "function_declartion.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/





/*11111*/
/*-------------------------------------------------------------------------------*/
void  RS_P( int    c_EES     , TEMP   *TP       , double *par  , double *BC, \
            double *t__d_x   , double *t__p_x   , double *t__x , double *RS, \
            double **keep_p_x, double **keep_EEx, double **p_aa, double **aa )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_EP, N_VAR, NM, NV, np, nv, nk, na;
  N_EP   =  TP->N_EP;
  N_VAR  =  TP->N_VAR;
  NM     =  TP->NM;
  NV     =  TP->NV;
  np     =  TP->np;
  nv     =  TP->nv;
  nk     =  TP->nk;
  na     =  TP->na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int     i, i_NM, c_FIRST;
  int     *point;
  double  PCT;
  double  *p_par, *EEx, *d_x, *p_x;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     (   TP->EES == EES_D    ||  TP->EES == EES_D_M     )    c_EES = EES_D;
  else if(   TP->EES == EES_S_E  ||  TP->EES == EES_S_E_M   )    c_EES = EES_S_E;
  else if(   TP->EES == EES_S_R  ||  TP->EES == EES_S_R_M   )    c_EES = EES_S_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  point  =  malloc_1i( NM+1       );
  p_par  =  malloc_1d( N_EP+N_VAR );
  EEx    =  malloc_1d( NV+na      );
  d_x    =  malloc_1d( NV+na      );
  p_x    =  malloc_1d( NV+na      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if  ( TP->EES==EES_D_M  ||  TP->EES==EES_S_E_M  ||  TP->EES==EES_S_R_M )   c_FIRST = 1;
  else                                                                       c_FIRST = 0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Round_Off( NM, TP->c_MP, *TP, point );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= NV; i++ ){   p_x[   i] = t__p_x[      i];  EEx[   i] = t__x[      i];   }
  for( i = 1; i <= na; i++ ){   p_x[NV+i] = t__p_x[NM*NV+i];  EEx[NV+i] = t__x[NM*NV+i];   }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= N_EP; i++ )
    p_par[i] =  par[i];
  if( TP->nk == 0 ){   p_par[TP->CP] =  par[TP->CP] - TP->ds;   }
  else             {   p_par[TP->CP] =  t__p_x[NM*NV+na];       }
  Diffusion( *TP, p_par );
  if(  c_EES == EES_D  ){
    M_EETV( *TP, p_par, BC, p_x, p_aa );   LU_Decomposition_EE( *TP, p_aa );
    M_EETV( *TP,   par, BC, EEx,   aa );   LU_Decomposition_EE( *TP,   aa );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  RS[NM*NV+np] =  0.0;
  for( i_NM = 1; i_NM <= NM; i_NM++ ){
    for( i = 1; i <= NV; i++ ){   p_x[   i] = t__p_x[(i_NM-1)*NV+i];  EEx[   i] = t__x[(i_NM-1)*NV+i];   }
    for( i = 1; i <= na; i++ ){   p_x[NV+i] = t__p_x[   NM   *NV+i];  EEx[NV+i] = t__x[   NM   *NV+i];   }
    Calculate_EE( c_FIRST, point[i_NM], point[i_NM+1], *TP, p_par, par, BC, p_x, keep_p_x, p_aa, aa, &PCT, EEx );
    if  ( i_NM == NM ){   for( i = 1; i <= NV; i++ )  RS[(i_NM-1)*NV+i] = EEx[i] - t__x[        i];   }
    else              {   for( i = 1; i <= NV; i++ )  RS[(i_NM-1)*NV+i] = EEx[i] - t__x[i_NM*NV+i];   }
    RS[NM*NV+np]  +=  PCT;
    for( i = 1; i <= NV; i++ )
      keep_EEx[i_NM][i] =  EEx[i];
    keep_EEx[i_NM][NV+np] =  PCT;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= NV; i++ ){   d_x[   i] = t__d_x[      i];  p_x[   i] = t__p_x[      i];  EEx[   i] = t__x[      i];   }
  for( i = 1; i <= na; i++ ){   d_x[NV+i] = t__d_x[NM*NV+i];  p_x[NV+i] = t__p_x[NM*NV+i];  EEx[NV+i] = t__x[NM*NV+i];   }
  if( nv == 1 )
    if     (   c_EES == EES_D                           )   RS_V    ( *TP, par, BC, p_x, EEx, RS );
    else if(   c_EES == EES_S_E  ||  c_EES == EES_S_R   )   RS_V_SFM( *TP, par,     p_x, EEx, RS );
  if( nk == 1 )
    if     (   c_EES == EES_D                           )   RS_K    ( *TP, d_x,     p_x, EEx, RS );
    else if(   c_EES == EES_S_E  ||  c_EES == EES_S_R   )   RS_K_SFM( *TP, d_x,     p_x, EEx, RS );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( point );
  free_1d( p_par );
  free_1d( EEx   );
  free_1d( d_x   );
  free_1d( p_x   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*22222*/
/*-------------------------------------------------------------------------------*/
void  M_PF( int    c_EES     , TEMP   *TP       , double *par  , double *BC , \
            double *t__d_x   , double *t__p_x   , double *t__x , double *RS , \
            double **keep_p_x, double **keep_EEx, double **p_aa, double **aa, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_EP, N_VAR, NM, NV, np, nv, nk, na;
  N_EP   =  TP->N_EP;
  N_VAR  =  TP->N_VAR;
  NM     =  TP->NM;
  NV     =  TP->NV;
  np     =  TP->np;
  nv     =  TP->nv;
  nk     =  TP->nk;
  na     =  TP->na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_NM, c_LU, c_FIRST;
  int    *point;
  double delta, ptb_PCT=0.0;
  double *p_par, *ptb_EEx, *d_x, *p_x, *x;
  double **tmp=NULL;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  point    =  malloc_1i( NM+1       );
  p_par    =  malloc_1d( N_EP+N_VAR );
  d_x      =  malloc_1d( NV+na      );
  p_x      =  malloc_1d( NV+na      );
  x        =  malloc_1d( NV+na      );
  ptb_EEx  =  malloc_1d( NV+na      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  delta  =  (double)DELTA_PTB_X;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  c_LU     =  0;
  c_FIRST  =  0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Round_Off( NM, TP->c_MP, *TP, point );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    js, je;
  int    *len, *disp;
  double **t_a, **t_aa;
  len   =  malloc_1i( TP->PROCS+1 );
  disp  =  malloc_1i( TP->PROCS+1 );
  Partition_1dim( TP->PROCS, TP->RANK, NV+1, NV+na, &js, &je, len, disp );
  t_a   =  malloc_2d( je-js+1, NV+1 );
  t_aa  =  malloc_2d( NV+na  , NV+1 );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N_EP; i++ )
    p_par[i] =  par[i];
  if( TP->nk == 0 ){   p_par[TP->CP] =  par[TP->CP] - TP->ds;   }
  else             {   p_par[TP->CP] =  t__p_x[NM*NV+na];       }
  Diffusion( *TP, p_par );
  if( NM != 1 ){   for( i = 1; i <= NM*NV+na; i++ ) for( j = 1; j <= NM*NV+na; j++ ) a[i][j] = 0.0;   }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i_NM = 1; i_NM <= NM; i_NM++ ){
    for( i = 1; i <= NV; i++ ){   p_x[   i] = t__p_x[(i_NM-1)*NV+i];  x[   i] = t__x[(i_NM-1)*NV+i];   }
    for( i = 1; i <= na; i++ ){   p_x[NV+i] = t__p_x[   NM   *NV+i];  x[NV+i] = t__x[   NM   *NV+i];   }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( j = js; j <= je; j++ ){
      for( i = 1; i <= NV+na; i++ )
        ptb_EEx[i]  =  x[i];
      ptb_EEx[j]  +=  delta;
      if( c_EES  ==  EES_D ){
        if( NV+1  <=  j ){
          if( j == NV+na  &&  nk == 1 ){   par[TP->CP] = ptb_EEx[NV+na];   Diffusion( *TP, par );   }
          M_EETV( *TP, par, BC, ptb_EEx, aa );   LU_Decomposition_EE( *TP, aa );
          if( TP->PF == 1 )   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx );
          else                Calculate_EE( c_FIRST, point[i_NM], point[i_NM+1], *TP, p_par, par, BC, p_x, keep_p_x, p_aa, aa, &ptb_PCT, ptb_EEx );
          if( j == NV+na  &&  nk == 1 ){   par[TP->CP] =       x[NV+na];   Diffusion( *TP, par );   }
          c_LU  =  1;
        }else{
          if( c_LU  ==  1 ){
            M_EETV( *TP, par, BC, x, aa );   LU_Decomposition_EE( *TP, aa );
            c_LU  =  0;
          }
          if( TP->PF == 1 )   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx );
          else                Calculate_EE( c_FIRST, point[i_NM], point[i_NM+1], *TP, p_par, par, BC, p_x, keep_p_x, p_aa, aa, &ptb_PCT, ptb_EEx );
        }
      }else{
        if( j == NV+na  &&  nk == 1 ){   par[TP->CP] = ptb_EEx[NV+na];   Diffusion( *TP, par );   }
        if( TP->PF == 1 )   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx );
        else                Calculate_EE( c_FIRST, point[i_NM], point[i_NM+1], *TP, p_par, par, BC, p_x, keep_p_x, p_aa, aa, &ptb_PCT, ptb_EEx );
        if( j == NV+na  &&  nk == 1 ){   par[TP->CP] =       x[NV+na];   Diffusion( *TP, par );   }
      }
      for( i = 1; i <= NV; i++ )   t_a[j-js+1][i]  =  ( ptb_EEx[i] - keep_EEx[i_NM][i] ) / delta;
      i = NV+1;                    t_a[j-js+1][i]  =  ( ptb_PCT    - keep_EEx[i_NM][i] ) / delta;
    }
    MPI_Allgatherv( &t_a[1][1], len[TP->RANK+1], MPI_DOUBLE, &t_aa[1][1], &len[1], &disp[1], MPI_DOUBLE, MPI_COMM_WORLD );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    if( NM  ==  1 ){
      for( i = 1; i <= NV+1; i++ )
        for( j = 1; j <= NV+na; j++ )
          a[i][j]  =  t_aa[j][i];
      for( i = 1; i <= NV; i++ )
        a[i][i]  -=  1.0;
    }else{
      for( i = 1; i <= NV; i++ ){
        for( j = 1; j <= NV; j++ )
          a[(i_NM-1)*NV+i][(i_NM-1)*NV+j]  =  t_aa[j][i];
        a[(i_NM-1)*NV+i ][   NM   *NV+np  ]  =  t_aa[NV+np][i];
        a[   NM   *NV+np][(i_NM-1)*NV   +i]  =  t_aa[i][NV+np];
      }
      a[NM*NV+np][NM*NV+np]  +=  t_aa[NV+np][NV+1];
      if  ( i_NM != NM ){   for( i = 1; i <= NV; i++ ) a[(i_NM-1)*NV+i][(i_NM-1)*NV+NV+i ]  = -1.0;                   }
      else              {   for( i = 1; i <= NV; i++ ) a[(i_NM-1)*NV+i][               i ]  = -1.0;                   }
      if  ( nv == 1 )   {   for( i = 1; i <= NV; i++ ) a[(i_NM-1)*NV+i][   NM   *NV+np+nv]  = t_aa[NV+np+nv][i   ];
                                                       a[NM*NV+np     ][   NM   *NV+np+nv] += t_aa[NV+np+nv][NV+1];   }
      if  ( nk == 1 )   {   for( i = 1; i <= NV; i++ ) a[(i_NM-1)*NV+i][   NM   *NV+na   ]  = t_aa[NV+na   ][i   ];
                                                       a[NM*NV+np     ][   NM   *NV+na   ] += t_aa[NV+na   ][NV+1];   }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= NV; i++ ){   d_x[   i] = t__d_x[      i];  p_x[   i] = t__p_x[      i];  x[   i] = t__x[      i];   }
  for( i = 1; i <= na; i++ ){   d_x[NV+i] = t__d_x[NM*NV+i];  p_x[NV+i] = t__p_x[NM*NV+i];  x[NV+i] = t__x[NM*NV+i];   }
  if( nv == 1 )
    if     (   c_EES == EES_D                           )   M_V    ( *TP, par, BC, p_x, x     , a );
    else if(   c_EES == EES_S_E  ||  c_EES == EES_S_R   )   M_V_SFM( *TP, par,     p_x, x     , a );
  if( nk == 1 )
    if     (   c_EES == EES_D                           )   M_K    ( *TP, par, BC, d_x, x, tmp, a );
    else if(   c_EES == EES_S_E  ||  c_EES == EES_S_R   )   M_K_SFM( *TP, par,     d_x, x, tmp, a );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( point   );
  free_1d( p_par   );
  free_1d( d_x     );
  free_1d( p_x     );
  free_1d( x       );
  free_1d( ptb_EEx );
  free_1i( len     );
  free_1i( disp    );
  free_2d( t_a     );
  free_2d( t_aa    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*33333*/
/*-------------------------------------------------------------------------------*/
void  M_CM( int    c_EES     , TEMP   *TP       , double *par  , double *BC   , \
            double *t__d_x   , double *t__p_x   , double *t__x , double *t__RS, \
            double **keep_p_x, double **keep_EEx, double **p_aa, double **aa  , double **a, double **MM )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_EP, N_VAR, NM, NV, np, nv, nk, na;
  N_EP   =  TP->N_EP;
  N_VAR  =  TP->N_VAR;
  NM     =  TP->NM;
  NV     =  TP->NV;
  np     =  TP->np;
  nv     =  TP->nv;
  nk     =  TP->nk;
  na     =  TP->na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_NM, c_LU, c_FIRST;
  int    *point;
  double delta, ptb_PCT=0.0;
  double *p_par, *ptb_EEx, *d_x, *p_x, *x;
  double **tmp=NULL;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  point    =  malloc_1i( NM+1       );
  p_par    =  malloc_1d( N_EP+N_VAR );
  d_x      =  malloc_1d( NV+na      );
  p_x      =  malloc_1d( NV+na      );
  x        =  malloc_1d( NV+na      );
  ptb_EEx  =  malloc_1d( NV+na      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  delta  =  (double)DELTA_PTB_X;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  c_LU     =  0;
  c_FIRST  =  0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Round_Off( NM, TP->c_MP, *TP, point );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    js, je;
  int    *len, *disp;
  double **t_a, **t_aa;
  len   =  malloc_1i( TP->PROCS+1 );
  disp  =  malloc_1i( TP->PROCS+1 );
  Partition_1dim( TP->PROCS, TP->RANK, NV+1, NV+na, &js, &je, len, disp );
  t_a   =  malloc_2d( je-js+1, NV+1 );
  t_aa  =  malloc_2d( NV+na  , NV+1 );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N_EP; i++ )
    p_par[i] =  par[i];
  if( TP->nk == 0 ){   p_par[TP->CP] =  par[TP->CP] - TP->ds;   }
  else             {   p_par[TP->CP] =  t__p_x[NM*NV+na];       }
  Diffusion( *TP, p_par );
  for( i = 1; i <= NV+na; i++ )  for( j = 1; j <= NV+na; j++ )  a[i][j] = 0.0;
  for( i = 1; i <= NV   ; i++ )                                 a[i][i] = 1.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= NV; i++ ){   d_x[   i] = t__d_x[      i];  p_x[   i] = t__p_x[      i];  x[   i] = t__x[      i];   }
  for( i = 1; i <= na; i++ ){   d_x[NV+i] = t__d_x[NM*NV+i];  p_x[NV+i] = t__p_x[NM*NV+i];  x[NV+i] = t__x[NM*NV+i];   }
  if( nv == 1 ){
    TP->NM = 1;
    if     (   c_EES == EES_D                           )   M_V    ( *TP, par, BC, p_x, x     , a );
    else if(   c_EES == EES_S_E  ||  c_EES == EES_S_R   )   M_V_SFM( *TP, par,     p_x, x     , a );
    TP->NM = NM;
  }
  if( nk == 1 ){
    TP->NM = 1;
    if     (   c_EES == EES_D                           )   M_K    ( *TP, par, BC, d_x, x, tmp, a );
    else if(   c_EES == EES_S_E  ||  c_EES == EES_S_R   )   M_K_SFM( *TP, par,     d_x, x, tmp, a );
    TP->NM = NM;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double sum;
  double *RS, *C, *D;
  double **BB, **M;
  RS  =  malloc_1d( NV+na     );
  BB  =  malloc_2d( NV   , na );
  C   =  malloc_1d( NV        );
  D   =  malloc_1d( na        );
  M   =  malloc_2d( NV   , NV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= NV; i++ )  RS[   i] = 0.0;
  for( i = 1; i <= na; i++ )  RS[NV+i] = t__RS[NM*NV+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i_NM = 1; i_NM <= NM; i_NM++ ){
    for( i = 1; i <= NV; i++ ){   p_x[   i] = t__p_x[(i_NM-1)*NV+i];  x[   i] = t__x[(i_NM-1)*NV+i];   }
    for( i = 1; i <= na; i++ ){   p_x[NV+i] = t__p_x[   NM   *NV+i];  x[NV+i] = t__x[   NM   *NV+i];   }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( j = js; j <= je; j++ ){
      for( i = 1; i <= NV+na; i++ )
        ptb_EEx[i]  =  x[i];
      ptb_EEx[j]  +=  delta;
      if( c_EES  ==  EES_D ){
        if( NV+1  <=  j ){
          if( j == NV+na  &&  nk == 1 ){   par[TP->CP] = ptb_EEx[NV+na];   Diffusion( *TP, par );   }
          M_EETV( *TP, par, BC, ptb_EEx, aa );   LU_Decomposition_EE( *TP, aa );
          if( TP->PF == 1 )   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx );
          else                Calculate_EE( c_FIRST, point[i_NM], point[i_NM+1], *TP, p_par, par, BC, p_x, keep_p_x, p_aa, aa, &ptb_PCT, ptb_EEx );
          if( j == NV+na  &&  nk == 1 ){   par[TP->CP] =       x[NV+na];   Diffusion( *TP, par );   }
          c_LU  =  1;
        }else{
          if( c_LU  ==  1 ){
            M_EETV( *TP, par, BC, x, aa );   LU_Decomposition_EE( *TP, aa );
            c_LU  =  0;
          }
          if( TP->PF == 1 )   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx );
          else                Calculate_EE( c_FIRST, point[i_NM], point[i_NM+1], *TP, p_par, par, BC, p_x, keep_p_x, p_aa, aa, &ptb_PCT, ptb_EEx );
        }
      }else{
        if( j == NV+na  &&  nk == 1 ){   par[TP->CP] = ptb_EEx[NV+na];   Diffusion( *TP, par );   }
        if( TP->PF == 1 )   Calculate_EE_PF( point[i_NM+1]-point[i_NM], *TP, par, BC, aa, ptb_EEx );
        else                Calculate_EE( c_FIRST, point[i_NM], point[i_NM+1], *TP, p_par, par, BC, p_x, keep_p_x, p_aa, aa, &ptb_PCT, ptb_EEx );
        if( j == NV+na  &&  nk == 1 ){   par[TP->CP] =       x[NV+na];   Diffusion( *TP, par );   }
      }
      for( i = 1; i <= NV; i++ )   t_a[j-js+1][i]  =  ( ptb_EEx[i] - keep_EEx[i_NM][i] ) / delta;
      i = NV+1;                    t_a[j-js+1][i]  =  ( ptb_PCT    - keep_EEx[i_NM][i] ) / delta;
    }
    MPI_Allgatherv( &t_a[1][1], len[TP->RANK+1], MPI_DOUBLE, &t_aa[1][1], &len[1], &disp[1], MPI_DOUBLE, MPI_COMM_WORLD );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( i = 1; i <= NV; i++ )  for( j = 1; j <= NV; j++ )  MM[(i_NM-1)*NV+i][   j   ] = t_aa[   j][i];
    for( i = 1; i <= NV; i++ )  for( j = 1; j <= na; j++ )  MM[(i_NM-1)*NV+i][NV+j   ] = t_aa[NV+j][i];
    for( i = 1; i <= NV; i++ )                              MM[(i_NM-1)*NV+i][NV+na+1] = t__RS[(i_NM-1)*NV+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( i = 1; i <= NV; i++ )  for( j = 1; j <= NV; j++ )  M [i][j] = t_aa[j][i];
    for( i = 1; i <= NV; i++ )  for( j = 1; j <= na; j++ )  BB[i][j] = a[i][NV+j];
    for( i = 1; i <= NV; i++ )  C[i] = t_aa[   i][NV+np];
    for( i = 1; i <= na; i++ )  D[i] = t_aa[NV+i][NV+np];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( j = 1; j <= NV; j++ ){
      sum  =  0.0;
      for( i = 1; i <= NV; i++ )
        sum  +=  C[i]*a[i][j];
      a[NV+np][j]  +=  sum;
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( j = 1; j <= na; j++ )
      a[NV+np][NV+j]  +=  D[j];
    if( i_NM  !=  1 ){
      for( j = 1; j <= na; j++ ){   sum = 0.0;   for( i = 1; i <= NV; i++ ) sum += C[i]*BB[i][j];   a [NV+np][NV+j] += sum;   }
                                    sum = 0.0;   for( i = 1; i <= NV; i++ ) sum += C[i]*RS[i];      RS[NV+np]       += sum;
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    MatrixProduct_22s_MPI( TP->PROCS, TP->RANK, NV, NV, M, NV, a, a );
    MatrixProduct    ( NV, NV, M, na, BB, t_aa );
    for( i = 1; i <= NV; i++ )  for( j = 1; j <= na; j++ )  a[i][NV+j] = t_aa[i][j] + t_aa[NV+j][i];
    MatrixProduct_21 ( NV, NV, M, RS, C );
    for( i = 1; i <= NV; i++ )  RS[i] = C[i] + t__RS[(i_NM-1)*NV+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= NV; i++ )
    a[i][i]  -=  1.0;
  for( i = 1; i <= NV+na; i++ )
    t__RS[i]  =  -RS[i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( RS );
  free_2d( BB );
  free_1d( C  );
  free_1d( D  );
  free_2d( M  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( point   );
  free_1d( p_par   );
  free_1d( d_x     );
  free_1d( p_x     );
  free_1d( x       );
  free_1d( ptb_EEx );
  free_1i( len     );
  free_1i( disp    );
  free_2d( t_a     );
  free_2d( t_aa    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
