/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Output_MidleData  \
      ( TEMP TP, double *par, double *BC, double *d_x, double *x, char *FILENAME, int WriteMode )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double *SOP, *EP, *t_d_x, *t_x;
  FILE   *FP_W;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SOP    =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  EP     =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_d_x  =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_x    =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Generate_OPEP( TP, par, BC, SOP, EP );
  Generate_tSV( TP, BC, d_x, t_d_x );
  Generate_tSV( TP, BC, x  , t_x   );
  FP_W  =  fopen_mode( FILENAME, WriteMode );
  for( i = 1; i <= TP.NM*TP.N_VAR*TP.Ns+TP.NA; i++ )
    fprintf( FP_W, "%7d %20.15E %20.15E %20.15E %20.15E\n", \
             TP.step, SOP[i], EP[i], t_d_x[i], t_x[i] );
  fclose( FP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( SOP   );
  free_1d( EP    );
  free_1d( t_d_x );
  free_1d( t_x   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Output_MidleData_EV  \
      ( TEMP TP, double *par, double *BC, double *d_x, double *x, double *REV, double *IEV, char *FILENAME, int WriteMode )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double *SOP, *EP, *t_d_x, *t_x, *t_REV, *t_IEV;
  FILE   *FP_W;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SOP    =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  EP     =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_d_x  =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_x    =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_REV  =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_IEV  =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Generate_OPEP( TP, par, BC, SOP, EP );
  Generate_tSV( TP, BC, d_x, t_d_x );
  Generate_tSV( TP, BC, x  , t_x   );
  Generate_tSV( TP, BC, REV, t_REV );
  Generate_tSV( TP, BC, IEV, t_IEV );
  FP_W  =  fopen_mode( FILENAME, WriteMode );
  for( i = 1; i <= TP.NM*TP.N_VAR*TP.Ns+TP.NA; i++ )
    fprintf( FP_W, "%7d %20.15E %20.15E %20.15E %20.15E %20.15E %20.15E\n", \
             TP.step, SOP[i], EP[i], t_d_x[i], t_x[i], t_REV[i], t_IEV[i] );
  fclose( FP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( SOP   );
  free_1d( EP    );
  free_1d( t_d_x );
  free_1d( t_x   );
  free_1d( t_REV );
  free_1d( t_IEV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Output_MidleData_EVC  \
      ( TEMP TP    , double *par, double *BC   , double *d_x, double *x     , \
        double *REV, double *IEV, double *REVC, double *IEVC, char *FILENAME, int WriteMode )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double *SOP, *EP, *t_d_x, *t_x, *t_REV, *t_IEV, *t_REVC, *t_IEVC;
  FILE   *FP_W;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SOP     =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  EP      =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_d_x   =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_x     =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_REV   =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_IEV   =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_REVC  =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
  t_IEVC  =  malloc_1d( TP.NM*TP.N_VAR*TP.Ns+TP.NA );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Generate_OPEP( TP, par, BC, SOP, EP );
  Generate_tSV( TP, BC, d_x , t_d_x  );
  Generate_tSV( TP, BC, x   , t_x    );
  Generate_tSV( TP, BC, REV , t_REV  );
  Generate_tSV( TP, BC, IEV , t_IEV  );
  Generate_tSV( TP, BC, REVC, t_REVC );
  Generate_tSV( TP, BC, IEVC, t_IEVC );
  FP_W  =  fopen_mode( FILENAME, WriteMode );
  for( i = 1; i <= TP.NM*TP.N_VAR*TP.Ns+TP.NA; i++ )
    fprintf( FP_W, "%7d %20.15E %20.15E %20.15E %20.15E %20.15E %20.15E %20.15E %20.15E\n", \
             TP.step, SOP[i], EP[i], t_d_x[i], t_x[i], t_REV[i], t_IEV[i], t_REVC[i], t_IEVC[i] );
  fclose( FP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( SOP    );
  free_1d( EP     );
  free_1d( t_d_x  );
  free_1d( t_x    );
  free_1d( t_REV  );
  free_1d( t_IEV  );
  free_1d( t_REVC );
  free_1d( t_IEVC );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
