/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  RK4_SM( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_VAR, iV;
  int    *SCT;
  double T, VEL, d;
  double  DC11,  DC21,         DC31,         DC41,  DC42,  DC43,  DC44;
  double  DT11,  DT21,  DT22,  DT31,  DT32,  DT41,  DT42,  DT43,  DT44;
  double VDT11, VDT21, VDT22, VDT31, VDT32, VDT41, VDT42, VDT43, VDT44;
  double *F, *td, *wx, *wF, *wx1, *wF1, *wF2, *wF3, *wF4;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+(int)sqrt(N/2) );
  F    =  malloc_1d( NV               );
  td   =  MALLOC_1D( N/2              );
  wx   =  MALLOC_1D( N                );
  wF   =  MALLOC_1D( N                );
  wx1  =  MALLOC_1D( NV               );
  wF1  =  MALLOC_1D( NV               );
  wF2  =  MALLOC_1D( NV               );
  wF3  =  MALLOC_1D( NV               );
  wF4  =  MALLOC_1D( NV               );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
  T       =  x[TP.NV+TP.np];
  if  ( TP.nv == 0 )   VEL  =  0.0;
  else                 VEL  =  x[TP.NV+TP.np+TP.nv];
/*  T    =  TP.T;        VEL   = TP.VEL;*/
  DT11 =  T*dt/2.0;    VDT11 = VEL*DT11;
  DT21 =  T*dt/2.0;    VDT21 = VEL*DT21;
  DT22 =  DT21-DT11;   VDT22 = VEL*DT22;
  DT31 =  T*dt;        VDT31 = VEL*DT31;
  DT32 =  DT31-DT21;   VDT32 = VEL*DT32;
  DT41 =  T*dt;        VDT41 = VEL*DT41;
  DT42 =  DT41-DT11;   VDT42 = VEL*DT42;
  DT43 =  DT41-DT21;   VDT43 = VEL*DT43;
  DT44 =  DT41-DT31;   VDT44 = VEL*DT44;

  DC11 =  T    *dt/2.0;
  DC21 =  T    *dt/2.0;
  DC31 =  T    *dt    ;
  DC41 =  T    *dt/6.0;
  DC42 =  T*2.0*dt/6.0;
  DC43 =  T*2.0*dt/6.0;
  DC44 =  T    *dt/6.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ ){
      wx1[iV+i]  =  wx[i];
      wF1[iV+i]  =  wF[i];
    }
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i  ]*cos(i*VDT11)+wx1[iV+2*i+1]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i  ]*cos(i*VDT11)+wF1[iV+2*i+1]*sin(i*VDT11));
      wx[2*i+1]  =       exp(-d*j*j*DT11)*(wx1[iV+2*i+1]*cos(j*VDT11)-wx1[iV+2*i  ]*sin(i*VDT11)) \
                 +  DC11*exp(-d*j*j*DT11)*(wF1[iV+2*i+1]*cos(j*VDT11)-wF1[iV+2*i  ]*sin(i*VDT11));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i  ]*cos(i*VDT11)+wx1[iV+2*i+1]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i  ]*cos(i*VDT11)+wF1[iV+2*i+1]*sin(i*VDT11));
      wx[2*i+1]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i+1]*cos(i*VDT11)-wx1[iV+2*i  ]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i+1]*cos(i*VDT11)-wF1[iV+2*i  ]*sin(i*VDT11));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF2[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i  ]*cos(i*VDT21)+wx1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT22)*(wF2[iV+2*i  ]*cos(i*VDT22)+wF2[iV+2*i+1]*sin(i*VDT22));
      wx[2*i+1]  =       exp(-d*j*j*DT21)*(wx1[iV+2*i+1]*cos(j*VDT21)-wx1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC21*exp(-d*j*j*DT22)*(wF2[iV+2*i+1]*cos(j*VDT22)-wF2[iV+2*i  ]*sin(i*VDT22));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i  ]*cos(i*VDT21)+wx1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT22)*(wF2[iV+2*i  ]*cos(i*VDT22)+wF2[iV+2*i+1]*sin(i*VDT22));
      wx[2*i+1]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i+1]*cos(i*VDT21)-wx1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT22)*(wF2[iV+2*i+1]*cos(i*VDT22)-wF2[iV+2*i  ]*sin(i*VDT22));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF3[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i  ]*cos(i*VDT31)+wx1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT32)*(wF3[iV+2*i  ]*cos(i*VDT32)+wF3[iV+2*i+1]*sin(i*VDT32));
      wx[2*i+1]  =       exp(-d*j*j*DT31)*(wx1[iV+2*i+1]*cos(j*VDT31)-wx1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC31*exp(-d*j*j*DT32)*(wF3[iV+2*i+1]*cos(j*VDT32)-wF3[iV+2*i  ]*sin(i*VDT32));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i  ]*cos(i*VDT31)+wx1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT32)*(wF3[iV+2*i  ]*cos(i*VDT32)+wF3[iV+2*i+1]*sin(i*VDT32));
      wx[2*i+1]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i+1]*cos(i*VDT31)-wx1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT32)*(wF3[iV+2*i+1]*cos(i*VDT32)-wF3[iV+2*i  ]*sin(i*VDT32));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF4[iV+i]  =  wF[i];
    d   =  par[N_EP+i_VAR];
    i   =  0;
    j   =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i  ]*cos(i*VDT41)+wx1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i  ]*cos(i*VDT42)+wF2[iV+2*i+1]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i  ]*cos(i*VDT43)+wF3[iV+2*i+1]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i  ]*cos(i*VDT44)+wF4[iV+2*i+1]*sin(i*VDT44));
      wx[2*i+1]  =       exp(-d*j*j*DT41)*(wx1[iV+2*i+1]*cos(j*VDT41)-wx1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC41*exp(-d*j*j*DT41)*(wF1[iV+2*i+1]*cos(j*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC42*exp(-d*j*j*DT42)*(wF2[iV+2*i+1]*cos(j*VDT42)-wF2[iV+2*i  ]*sin(i*VDT42)) \
                 +  DC43*exp(-d*j*j*DT43)*(wF3[iV+2*i+1]*cos(j*VDT43)-wF3[iV+2*i  ]*sin(i*VDT43)) \
                 +  DC44*exp(-d*j*j*DT44)*(wF4[iV+2*i+1]*cos(j*VDT44)-wF4[iV+2*i  ]*sin(i*VDT44));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i  ]*cos(i*VDT41)+wx1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i  ]*cos(i*VDT42)+wF2[iV+2*i+1]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i  ]*cos(i*VDT43)+wF3[iV+2*i+1]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i  ]*cos(i*VDT44)+wF4[iV+2*i+1]*sin(i*VDT44));
      wx[2*i+1]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i+1]*cos(i*VDT41)-wx1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i+1]*cos(i*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i+1]*cos(i*VDT42)-wF2[iV+2*i  ]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i+1]*cos(i*VDT43)-wF3[iV+2*i  ]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i+1]*cos(i*VDT44)-wF4[iV+2*i  ]*sin(i*VDT44));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
  FREE_1D( wF1 );
  FREE_1D( wF2 );
  FREE_1D( wF3 );
  FREE_1D( wF4 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/







/*-------------------------------------------------------------------------------*/
void  EM_SM( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  int    *SCT;
  double T, VEL, d, DT1, VDT1;
  double *td, *wx, *wF, *F;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+(int)sqrt(N/2) );
  td   =  MALLOC_1D( N/2              );
  wx   =  MALLOC_1D( N                );
  wF   =  MALLOC_1D( N                );
  F    =  malloc_1d( NV               );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
  T       =  x[TP.NV+TP.np];
  if  ( TP.nv == 0 )   VEL  =  0.0;
  else                 VEL  =  x[TP.NV+TP.np+TP.nv];
/*  T   = TP.T;   VEL  = TP.VEL;*/
  DT1 = T*dt;   VDT1 = VEL*DT1;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[(i_VAR-1)*N+i+1];
      wF[i]  =  F[(i_VAR-1)*N+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =  exp(-d*i*i*DT1)*((wx[0    ]+DT1*wF[0    ])*cos(i*VDT1)                                      );
    i  =  NW/2;
      wx[1    ]  =  exp(-d*i*i*DT1)*((wx[1    ]+DT1*wF[1    ])*cos(i*VDT1)                                      );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =  exp(-d*i*i*DT1)*((wx[2*i  ]+DT1*wF[2*i  ])*cos(i*VDT1)+(wx[2*i+1]+DT1*wF[2*i+1])*sin(i*VDT1));
      wx[2*i+1]  =  exp(-d*i*i*DT1)*((wx[2*i+1]+DT1*wF[2*i+1])*cos(i*VDT1)-(wx[2*i  ]+DT1*wF[2*i  ])*sin(i*VDT1));
    }
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  FREE_1D( wx  );
  FREE_1D( wF  );
  free_1d( F   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  MEM_SM( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  int    *SCT;
  double T, VEL, d, DT1, DT2, VDT1, VDT2;
  double *td, *wx, *wF, *F, *wx1;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+(int)sqrt(N/2) );
  td   =  MALLOC_1D( N/2              );
  wx   =  MALLOC_1D( N                );
  wF   =  MALLOC_1D( N                );
  F    =  malloc_1d( NV               );
  wx1  =  MALLOC_1D( NV               );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
  T       =  x[TP.NV+TP.np];
  if  ( TP.nv == 0 )   VEL  =  0.0;
  else                 VEL  =  x[TP.NV+TP.np+TP.nv];
/*  T   = TP.T;        VEL  = TP.VEL;*/
  DT1 = T*    dt;    VDT1 = VEL*DT1;
  DT2 = T*0.5*dt;    VDT2 = VEL*DT2;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[(i_VAR-1)*N+i+1];
      wF[i]  =  F[(i_VAR-1)*N+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wx1[(i_VAR-1)*N+i]  =  wx[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =  exp(-d*i*i*DT2)*((wx[0    ]+DT2*wF[0    ])*cos(i*VDT2)                                      );
    i  =  NW/2;
      wx[1    ]  =  exp(-d*i*i*DT2)*((wx[1    ]+DT2*wF[1    ])*cos(i*VDT2)                                      );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =  exp(-d*i*i*DT2)*((wx[2*i  ]+DT2*wF[2*i  ])*cos(i*VDT2)+(wx[2*i+1]+DT2*wF[2*i+1])*sin(i*VDT2));
      wx[2*i+1]  =  exp(-d*i*i*DT2)*((wx[2*i+1]+DT2*wF[2*i+1])*cos(i*VDT2)-(wx[2*i  ]+DT2*wF[2*i  ])*sin(i*VDT2));
    }
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  wx1[(i_VAR-1)*N+i  ];
      wF[i]  =  F  [(i_VAR-1)*N+i+1];
    }
    RDFT( N, NW, SCT, td, wF );
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =      exp(-d*i*i*DT1)*(wx[0    ]*cos(i*VDT1)                      ) \
                 +  DT1*exp(-d*i*i*DT2)*(wF[0    ]*cos(i*VDT2)                      );
    i  =  NW/2;
      wx[1    ]  =      exp(-d*i*i*DT1)*(wx[1    ]*cos(i*VDT1)                      ) \
                 +  DT1*exp(-d*i*i*DT2)*(wF[1    ]*cos(i*VDT2)                      );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =      exp(-d*i*i*DT1)*(wx[2*i  ]*cos(i*VDT1)+wx[2*i+1]*sin(i*VDT1)) \
                 +  DT1*exp(-d*i*i*DT2)*(wF[2*i  ]*cos(i*VDT2)+wF[2*i+1]*sin(i*VDT2));
      wx[2*i+1]  =      exp(-d*i*i*DT1)*(wx[2*i+1]*cos(i*VDT1)-wx[2*i  ]*sin(i*VDT1)) \
                 +  DT1*exp(-d*i*i*DT2)*(wF[2*i+1]*cos(i*VDT2)-wF[2*i  ]*sin(i*VDT2));
    }
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
  free_1d( F   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  rRK4_SM( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR, iV;
  int    *SCT;
  double T, VEL, d, DT1, DT2, DT3, VDT1, VDT2;
  double *F, *td, *wx, *wF, *wx1, *wF1, *wF2, *wF3;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+(int)sqrt(N/2) );
  F    =  malloc_1d( NV               );
  td   =  MALLOC_1D( N/2              );
  wx   =  MALLOC_1D( N                );
  wF   =  MALLOC_1D( N                );
  wx1  =  MALLOC_1D( NV               );
  wF1  =  MALLOC_1D( NV               );
  wF2  =  MALLOC_1D( NV               );
  wF3  =  MALLOC_1D( NV               );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
  T       =  x[TP.NV+TP.np];
  if  ( TP.nv == 0 )   VEL  =  0.0;
  else                 VEL  =  x[TP.NV+TP.np+TP.nv];
/*  T   = TP.T;        VEL  = TP.VEL;*/
  DT1 = T*    dt;    VDT1 = VEL*DT1;
  DT2 = T*0.5*dt;    VDT2 = VEL*DT2;
  DT3 = T*dt/6.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ ){
      wx1[iV+i]  =  wx[i];
      wF1[iV+i]  =  wF[i];
    }
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =  exp(-d*i*i*DT2)*((wx[0    ]+DT2*wF[0    ])*cos(i*VDT2)                                      );
    i  =  NW/2;
      wx[1    ]  =  exp(-d*i*i*DT2)*((wx[1    ]+DT2*wF[1    ])*cos(i*VDT2)                                      );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =  exp(-d*i*i*DT2)*((wx[2*i  ]+DT2*wF[2*i  ])*cos(i*VDT2)+(wx[2*i+1]+DT2*wF[2*i+1])*sin(i*VDT2));
      wx[2*i+1]  =  exp(-d*i*i*DT2)*((wx[2*i+1]+DT2*wF[2*i+1])*cos(i*VDT2)-(wx[2*i  ]+DT2*wF[2*i  ])*sin(i*VDT2));
    }
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  wx1[iV+i  ];
      wF[i]  =  F  [iV+i+1];
    }
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF2[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =  exp(-d*i*i*DT2)*(wx[0    ]*cos(i*VDT2)                      )+DT2*wF[0    ];
    i  =  NW/2;
      wx[1    ]  =  exp(-d*i*i*DT2)*(wx[1    ]*cos(i*VDT2)                      )+DT2*wF[1    ];
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =  exp(-d*i*i*DT2)*(wx[2*i  ]*cos(i*VDT2)+wx[2*i+1]*sin(i*VDT2))+DT2*wF[2*i  ];
      wx[2*i+1]  =  exp(-d*i*i*DT2)*(wx[2*i+1]*cos(i*VDT2)-wx[2*i  ]*sin(i*VDT2))+DT2*wF[2*i+1];
    }
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  wx1[iV+i  ];
      wF[i]  =  F  [iV+i+1];
    }
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF3[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =      exp(-d*i*i*DT1)*(wx[0    ]*cos(i*VDT1)                      ) \
                 +  DT1*exp(-d*i*i*DT2)*(wF[0    ]*cos(i*VDT2)                      );
    i  =  NW/2;
      wx[1    ]  =      exp(-d*i*i*DT1)*(wx[1    ]*cos(i*VDT1)                      ) \
                 +  DT1*exp(-d*i*i*DT2)*(wF[1    ]*cos(i*VDT2)                      );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =      exp(-d*i*i*DT1)*(wx[2*i  ]*cos(i*VDT1)+wx[2*i+1]*sin(i*VDT1)) \
                 +  DT1*exp(-d*i*i*DT2)*(wF[2*i  ]*cos(i*VDT2)+wF[2*i+1]*sin(i*VDT2));
      wx[2*i+1]  =      exp(-d*i*i*DT1)*(wx[2*i+1]*cos(i*VDT1)-wx[2*i  ]*sin(i*VDT1)) \
                 +  DT1*exp(-d*i*i*DT2)*(wF[2*i+1]*cos(i*VDT2)-wF[2*i  ]*sin(i*VDT2));
    }
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  wx1[iV+i  ];
      wF[i]  =  F  [iV+i+1];
    }
    RDFT( N, NW, SCT, td, wF );
    d   =  par[N_EP+i_VAR];
    i   =  0;
      wx[0    ]  =        exp(-d*i*i*DT1)*((wx [   0    ]+DT3*wF1[iV+0    ])*cos(i*VDT1)                                              ) \
                 +  2*DT3*exp(-d*i*i*DT2)*((wF2[iV+0    ]+    wF3[iV+0    ])*cos(i*VDT2)                                              ) \
                 +    DT3*wF[0    ];
    i   =  NW/2;
      wx[1    ]  =        exp(-d*i*i*DT1)*((wx [   1    ]+DT3*wF1[iV+1    ])*cos(i*VDT1)                                              ) \
                 +  2*DT3*exp(-d*i*i*DT2)*((wF2[iV+1    ]+    wF3[iV+1    ])*cos(i*VDT2)                                              ) \
                 +    DT3*wF[1    ];
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =        exp(-d*i*i*DT1)*((wx [   2*i  ]+DT3*wF1[iV+2*i  ])*cos(i*VDT1)+(wx [   2*i+1]+DT3*wF1[iV+2*i+1])*sin(i*VDT1)) \
                 +  2*DT3*exp(-d*i*i*DT2)*((wF2[iV+2*i  ]+    wF3[iV+2*i  ])*cos(i*VDT2)+(wF2[iV+2*i+1]+    wF3[iV+2*i+1])*sin(i*VDT2)) \
                 +    DT3*wF[2*i  ];
      wx[2*i+1]  =        exp(-d*i*i*DT1)*((wx [   2*i+1]+DT3*wF1[iV+2*i+1])*cos(i*VDT1)-(wx [   2*i  ]+DT3*wF1[iV+2*i  ])*sin(i*VDT1)) \
                 +  2*DT3*exp(-d*i*i*DT2)*((wF2[iV+2*i+1]+    wF3[iV+2*i+1])*cos(i*VDT2)-(wF2[iV+2*i  ]+    wF3[iV+2*i  ])*sin(i*VDT2)) \
                 +    DT3*wF[2*i+1];
    }
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
  FREE_1D( wF1 );
  FREE_1D( wF2 );
  FREE_1D( wF3 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RDFT( int N, int NW, int *SCT, double *td, double *wx )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  rdft( N, 1, wx, SCT, td );
  if( N  !=  NW )
    wx[1]  =  0.0;
  for( i = NW/2; i <= N/2-1; i++ ){
    wx[2*i  ]  =  0.0;
    wx[2*i+1]  =  0.0;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  IRDFT( int i_VAR, int N, int *SCT, double *td, double *wx, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  rdft( N, -1, wx, SCT, td );
  for( i = 0; i <= N-1; i++ )
    x[(i_VAR-1)*N+i+1]  =  2.0 * wx[i] / N;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
