/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "function_declartion.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  TimeIntegration( int p, TEMP TP, int *point, double *par, double *BC, double *x, double *EEx, double **Ve, double **W )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int NV, na;
  NV  =  TP.NV;
  na  =  TP.na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, c_EES, c_i_NM;
  double delta;
  double *ptb_EEx;
  double **aa;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( TP.EES == EES_D    ||  TP.EES == EES_D_M   )   c_EES = EES_D;
  else if( TP.EES == EES_S_E  ||  TP.EES == EES_S_E_M )   c_EES = EES_S_E;
  else if( TP.EES == EES_S_R  ||  TP.EES == EES_S_R_M )   c_EES = EES_S_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  ptb_EEx  =  malloc_1d( NV     );
  aa       =  malloc_2d( 5, NV  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  delta  =  (double)DELTA_PTB_X;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( c_EES  ==  EES_D ){
    M_EETV( TP, par, BC, x, aa );   LU_Decomposition_EE( TP, aa );
  }
  c_i_NM  = 1;
  for( j = 1; j <= p; j++ ){
    for( i = 1; i <= NV+na; i++ )   ptb_EEx [i] = x[i] + delta * Ve[i][j];
    Calculate_EE_PF( point[c_i_NM+1]-point[c_i_NM], TP, par, BC, aa, ptb_EEx );
    for( i = 1; i <= NV; i++ )   W[i][j]  =  ( ptb_EEx[i] - EEx[i] ) / delta;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( ptb_EEx );
  free_2d( aa      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  TimeIntegration_T( int p, TEMP TP, double PCT, int *point, double *p_par, double *par, double *BC, \
                         double *p_x, double *x, double *EEx, double **p_aa, double **Ve, double **PM )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int NV, np, na;
  NV  =  TP.NV;
  np  =  TP.np;
  na  =  TP.na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, c_EES, c_i_NM, c_FIRST;
  double delta, ptb_PCT;
  double *ptb_EEx, **k_p_x;
  double **aa;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( TP.EES == EES_D    ||  TP.EES == EES_D_M   )   c_EES = EES_D;
  else if( TP.EES == EES_S_E  ||  TP.EES == EES_S_E_M )   c_EES = EES_S_E;
  else if( TP.EES == EES_S_R  ||  TP.EES == EES_S_R_M )   c_EES = EES_S_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  ptb_EEx  =  malloc_1d( NV                     );
  k_p_x    =  malloc_2d( (int)(1.0/TP.dt)+1, NV );
  if( c_EES  ==  EES_D )
  aa       =  malloc_2d( 5, NV                  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  delta  =  (double)DELTA_PTB_X;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( c_EES  ==  EES_D ){
    M_EETV( TP, par, BC, x, aa );   LU_Decomposition_EE( TP, aa );
  }
  c_i_NM   = 1;
  c_FIRST  = 1;
  for( j = 1; j <= p+np; j++ ){
    for( i = 1   ; i <= NV+1;  i++ )   ptb_EEx[i] = x[i] + delta * Ve[i][j];
    for( i = NV+2; i <= NV+na; i++ )   ptb_EEx[i] = x[i];
    if( j == p+np ){
      if( c_EES  ==  EES_D ){
        M_EETV( TP, par, BC, x, aa );   LU_Decomposition_EE( TP, aa );
      }
    }
    Calculate_EE( c_FIRST, point[c_i_NM], point[c_i_NM+1], TP, p_par, par, BC, p_x, k_p_x, p_aa, aa, &ptb_PCT, ptb_EEx );
    c_FIRST  = 2;
    PM[p+np][j]  =  ( ptb_PCT - PCT ) / delta;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( ptb_EEx );
  free_2d( k_p_x   );
  if( c_EES  ==  EES_D )
  free_2d( aa      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
