/*-------------------------------------------------------------------------------*/
#include "StructType_Definition.h"
#include "LIB/function_declartion.h"
/*-------------------------------------------------------------------------------*/

void  Newton_Method_BP( TEMP *TP, int *c_G, double *par, double *BC, double *t__d_x, double *t__p_x, double *t__x );
void  RS_P2( TEMP   *TP       , double *par      , double *BC   , \
             double *t__d_x   , double *t__p_x   , double *t__x , double *RS  , \
             double **keep_p_x, double **keep_EEx, double **p_aa, double **RS2  );
void  M_CM2( int    c_EES     , TEMP   *TP       , double *par  , double *BC    , \
             double *t__d_x   , double *t__p_x   , double *t__x , double **t__RS, \
             double **keep_p_x, double **keep_EEx, double **p_aa, double **aa   , double **a, double **MM );
void  RS_PD( TEMP *TP, double *x, double **a, double **a2, double *RS );
void  M_RS_PD( TEMP TP, double *x, double **a, double *RS );
void  M_CM_PD( TEMP *TP, double *par, double *BC , double *t__x    , double *RS , double *RS3, \
               double **keep_EEx    , double **aa, double **delta_x, double **a2  );
void  M_P_EV2( TEMP TP, double *par, double *BC, double *t__x, double **a );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  TimeIntegration( int p, TEMP TP, int *point, double *par, double *BC, double *x, double *EEx, double **Ve, double **W );
void  TimeIntegration_T( int p, TEMP TP, double PCT, int *point, double *p_par, double *par, double *BC, \
                         double *p_x, double *x, double *EEx, double **p_aa, double **Ve, double **PM );
void  subspace( TEMP *TP,  double *par, double *BC, double *x, double *EEx );
void  GrammSchmidt( int N, int M, double **V, int *I_ERR );
void  TransposedMatrix( int N, int M, double **A, double **B );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  fwrite_iter_dd( char *FILENAME, int iteration, double data1, double data2 );
void  fwrite_1d( char *FILENAME, int N, double *data );
void  fwrite_2d( char *FILENAME, int N, int M, double **data );
void  fwrite_1d1d( char *FILENAME, int N, double *data1, double *data2 );
void  fwrite_1d1d1d( char *FILENAME, int N, double *data1, double *data2, double *data3 );
void  fwrite_1d1d1d1d( char *FILENAME, int N, double *data1, double *data2, double *data3, double *data4 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  min_1d( int N, double *data, double *t__min );
void  max_1d( int N, double *data, double *t__max );
void  fabsmax_1d( int N, double *data, double *t__max );
void  fabsmin_1d( int N, double *data, double *t__min );
void  L2norm( int N, double *data, double *norm );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  initial_set1( TEMP *TP, int *I_ERR );
void  initial_set2( TEMP *TP      , double *par   , double *BC   , \
                    double *t__d_x, double *t__p_x, double *t__x , double *t__REV, double *t__IEV, int *I_ERR );
void  Initial_x( TEMP TP, double *par, double *BC, double *t_x, double *x );
void  Round_Off( int NM, int cMP, TEMP TP, int *point );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Parameter_OutPut( TEMP TP, double *par );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  output( TEMP TP    , double *par, double *BC , \
              double *d_x, double *x  , double *REV, double *IEV, int WriteMode );
void  OP_SV_Norm( FILE *FP_W, TEMP TP, double *par, double *BC, double *SV, double *t__norm );
void  Calculate_Norm( TEMP TP, double *t_x, double *norm );
void  output2( int i_EVC  , int N_EVC  , double minEV  , \
               TEMP *TP   , double *par, double *BC    , double *d_x   , double *x    , int *i_E, \
               double *REV, double *IEV, double **JREVC, double **JIEVC, int WriteMode );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Gnuplot_InitialCommand_NS( TEMP *TP, int *c_G );
void  Gnuplot_Draw_NS( TEMP TP, int *c_G );
void  Gnuplot_Draw2_NS( TEMP TP, int *c_G );
void  Gnuplot_DrawCommand_NS( TEMP TP, FILE *GP, int SELECT );
void  Gnuplot_Close_NS( TEMP *TP );
void  Gnuplot_InitialCommand_NP( TEMP *TP, int *c_G );
void  Gnuplot_Draw_NP( TEMP TP, int *c_G );
void  Gnuplot_Draw2_NP( TEMP TP, int *c_G );
void  Gnuplot_DrawCommand_NP( TEMP TP, FILE *GP, int SELECT );
void  Gnuplot_Close_NP( TEMP *TP );
void  Gnuplot_InitialCommand_GS( TEMP *TP, int *c_G );
void  Gnuplot_Draw_GS( TEMP TP, int *c_G );
void  Gnuplot_Draw2_GS( TEMP TP, int *c_G );
void  Gnuplot_DrawCommand_GS( TEMP TP, FILE *GP, int SELECT );
void  Gnuplot_Close_GS( TEMP *TP );
void  Gnuplot_InitialCommand_GP( TEMP *TP, int *c_G );
void  Gnuplot_Draw_GP( TEMP TP, int *c_G );
void  Gnuplot_Draw2_GP( TEMP TP, int *c_G );
void  Gnuplot_DrawCommand_GP( TEMP TP, FILE *GP, int SELECT );
void  Gnuplot_Close_GP( TEMP *TP );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Newton_Method_S_ILUCGS( TEMP *TP, int *c_G, double *par, double *BC, double *x );
void  Newton_Method( TEMP *TP, int *c_G, double *par, double *BC, double *t__d_x, double *t__p_x, double *t__x );
void  NW_Gnuplot( int iteration, TEMP TP, int *c_G, double *par, double *BC, double *t__x );
void  NM_Norm( int iteration, TEMP *TP, double *par, double *RS, char *ErrC_SO, double *CC_Norm );
void  NM_Stdout( int iteration, TEMP TP, double CC_Norm, char *ErrC_SO, double *par, double *x );
void  i_Diffusion( int *i_par );
void  Diffusion( TEMP TP, double *par );
void  Reaction( TEMP TP, double *par, double *x, double *F );
void  PartialDiff_Function( TEMP TP, double *par, double *x, double **PDF );
void  RS_S( TEMP TP, double *par, double *BC, double *x, double *F, double *RS );
void  RS_V( TEMP TP, double *par, double *BC, double *p_x, double *x, double *RS );
void  RS_K( TEMP TP, double *d_x, double *p_x, double *x, double *RS );
void  RS_S_SFM( TEMP TP, double *par, double *x, double *F, double *RS );
void  RS_V_SFM( TEMP TP, double *par, double *p_x, double *x, double *RS );
void  RS_K_SFM( TEMP TP, double *d_x, double *p_x, double *x, double *RS );
void  M_S_ILUCGS( int M1, int M2, int NV, double **a );
void  M_S( TEMP TP, double *par, double *x, double **PDF, double **a );
void  M_V( TEMP TP, double *par, double *BC, double *p_x, double *x, double **a );
void  M_K( TEMP TP, double *par, double *BC, double *d_x, double *x, double **PDF, double **a );
void  M_P_EV( TEMP TP, double *par, double *BC, double *x, double **a );
void  M_P( int    c_EES     , TEMP   *TP       , double *par  , double *BC , \
           double *t__d_x   , double *t__p_x   , double *t__x , double *RS , \
           double **keep_p_x, double **keep_EEx, double **p_aa, double **aa, double **a );
void  M_PF( int    c_EES     , TEMP   *TP       , double *par  , double *BC , \
            double *t__d_x   , double *t__p_x   , double *t__x , double *RS , \
            double **keep_p_x, double **keep_EEx, double **p_aa, double **aa, double **a );
void  M_CM( int    c_EES     , TEMP   *TP       , double *par  , double *BC   , \
            double *t__d_x   , double *t__p_x   , double *t__x , double *t__RS, \
            double **keep_p_x, double **keep_EEx, double **p_aa, double **aa  , double **a, double **MM );
void  RS_P( int    c_EES     , TEMP   *TP       , double *par  , double *BC, \
            double *t__d_x   , double *t__p_x   , double *t__x , double *RS, \
            double **keep_p_x, double **keep_EEx, double **p_aa, double **aa );
void  M_S_SFM( TEMP TP, double *par, double *x, double **PDF, double **a );
void  M_V_SFM( TEMP TP, double *par, double *p_x, double *x, double **a );
void  M_K_SFM( TEMP TP, double *par, double *d_x, double *x, double **PDF, double **a );
void  M_EETV( TEMP TP, double *par, double *BC, double *x, double **a );
void  PhaseCondition_T( TEMP TP, double *p_par, double *BC, double *p_x, double *x, double *p_F, double *t_PCT );
void  PhaseCondition_T_SFM( TEMP TP, double *p_par, double *BC, double *p_x, double *x, double *p_F, double *t_PCT );
void  Calculate_EE( int    c_FIRST, int    t_S    , int    t_E   , TEMP TP    , double *p_par, double *par, double *BC, \
                    double *t_p_x , double **t_p_F, double **p_aa, double **aa, double *PCT  , double *EEx  );
void  Calculate_EE_PF( int N_t, TEMP TP, double *par, double *BC, double **aa, double *EEx );
void  RS_EEVT( TEMP TP, double *par, double *BC, double *x, double *F, double *RS_EE );
void  Output_Norm_Iter( int iteration, double period, double velocity, TEMP TP, double *par, double *norm, int WriteMode );
void  Output_Sol_Iter( int NVna  , int iteration, int    *IP, \
                       double *RS, double *sol_x, double *x , int WriteMode );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  rRK4_SM( TEMP TP, double *par, double *x );
void  RK4_SM( TEMP TP, double *par, double *x );
void  Sub_RK4( TEMP TP, double *par, double *x, double *Wx, int *SCT, double *td, double *RK );
void  EM_SM( TEMP TP, double *par, double *x );
void  RDFT( int N, int NW, int *SCT, double *td, double *wx );
void  IRDFT( int i_VAR, int N, int *SCT, double *td, double *wx, double *x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Eigen_Value( TEMP *TP, double *par, double *BC, double *x, double *REV, double *IEV );
void  Eigen_Vector( TEMP *TP, double *par, double *BC, double *d_x, double *x, double *REV, double *IEV );
void  M_EV( TEMP TP, double *par, double *BC, double *t__x, double **a );
void  N_UnstableEigenValue( TEMP *TP, double *par, double *REV, double *IEV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Output_MidleData  \
      ( TEMP TP, double *par, double *BC, double *d_x, double *x, char *FILENAME, int WriteMode );
void  Output_MidleData_EV  \
      ( TEMP TP, double *par, double *BC, double *d_x, double *x, double *REV, double *IEV, char *FILENAME, int WriteMode );
void  Output_MidleData_EVC  \
      ( TEMP TP    , double *par, double *BC   , double *d_x  , double *x     , \
        double *REV, double *IEV, double *JREVC, double *JIEVC, char *FILENAME, int WriteMode );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  DataNum1( TEMP *TP, char *READ_DATA, int *DataNum );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Generate_OPEP( TEMP TP, double *par, double *BC, double *SOP, double *EP );
void  Generate_SV( TEMP TP, double *BC, double *xx, double *x );
void  Generate_tSV( TEMP TP, double *BC, double *x, double *xx );
void  Generate_BC_Space( TEMP TP, double *BC, double *x, double *BCX );
void  Generate_SV_tNM( TEMP TP, double *BC, double *xx, double *x );
void  Generate_tSV_tNM( TEMP TP, double *BC, double *x, double *xx );
void  Generate_SV_NM1( TEMP TP, double *BC, double *xx, double *x );
void  Generate_tSV_NM1( TEMP TP, double *BC, double *x, double *xx );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  PartialDiff_Function_FU_AUTO( TEMP TP, double *par, double *x, double *F, double **PDF );
void  PartialDiff_Function_FP_AUTO( TEMP TP, double *par, double *x, double *F, double **PDF );
void  PartialDiff_Function_Di_AUTO( TEMP TP, double *par, double *parD );
void  PartialDiff_Function_Di     ( TEMP TP, double *par, double *parD );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  LU_Decomposition_EE( TEMP TP, double **a );
void  LU_Decomposition_F( int N, double **a );
void  LU_Decomposition_F_PIVOT_MPI( int PROCS, int RANK, int N, int *IP, double **a );
void  LU_Decomposition_F_MPI( int PROCS, int RANK, int N, double **a );
void  Calculate_Solution_EE( TEMP TP, double *RS, double **a, double *x );
void  Calculate_Solution_F( int N, double **a, double *RS );
void  Calculate_Solution_F_PIVOT( int N, int *IP, double **a, double *RS );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Partition_1dim( int PROCS, int RANK, int Ni, int Nj, int *start, int *end, int *len, int *disp );
void  MatrixProduct_MPI( int PROCS, int RANK, int L, int M, double **A, int N, double **B, double **C );
void  MatrixProduct_MPI1( int PROCS, int RANK, int is    , int ie, int *len  , int *disp , double **t_C, \
                          int L    , int M   , double **A, int N , double **B, double **C );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  M_Delete( int DEL_ROW_A, int DEL_COL_A, int MAX_A, double *RS, double **a );
void  RS_Delete( int DEL_ROW_A, int MAX_A, double *RS );
void  IP_Delete( int DEL_ROW_A, int MAX_A, int *IP );
void  IP_Addition( int DEL_ROW_A, int MAX_A, int *IP );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  RANDOM( int N, double *p_x, double *x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  MPI_EXIT( TEMP TP );
void  MPI_EXIT2();
/*-------------------------------------------------------------------------------*/
