/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  initial_set2( TEMP *TP      , double *par   , double *BC   , \
                    double *t__d_x, double *t__p_x, double *t__x , double *t__REV, double *t__IEV, int *I_ERR )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_EP, N_VAR, N, NM, NV, NA, Ns, tNM, KE, CP, step, IS;
  N_EP   =  TP->N_EP;
  N_VAR  =  TP->N_VAR;
  N      =  TP->N;
  NM     =  TP->NM;
  NV     =  TP->NV;
  NA     =  TP->NA;
  Ns     =  TP->Ns;
  tNM    =  TP->tNM;    if( TP->IS == IS_EV  ||  TP->IS == IS_EVC  ||  TP->IS == IS_G )   tNM = TP->MAX_NM;
  KE     =  TP->KE;
  CP     =  TP->CP;
  step   =  TP->step;
  IS     =  TP->IS;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, ti;
  double td;
  double *SOP, *EP, *t_EP, *t_d_x, *tt_d_x, *t_p_x, *t_x, *t_REV, *t_IEV;
  double *d_x, *p_x, *x, *REV, *IEV;
  FILE   *FP_R=NULL;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SOP     =  malloc_1d( tNM*N_VAR*Ns+NA );
  EP      =  malloc_1d( tNM*N_VAR*Ns+NA );
  t_EP    =  malloc_1d( tNM*N_VAR*Ns+NA );
  t_d_x   =  malloc_1d( tNM*N_VAR*Ns+NA );
  tt_d_x  =  malloc_1d( tNM*N_VAR*Ns+NA );
  t_p_x   =  malloc_1d( tNM*N_VAR*Ns+NA );
  t_x     =  malloc_1d( tNM*N_VAR*Ns+NA );
  t_REV   =  malloc_1d( tNM*N_VAR*Ns+NA );
  t_IEV   =  malloc_1d( tNM*N_VAR*Ns+NA );
  d_x     =  malloc_1d( tNM*N_VAR*N +NA );
  p_x     =  malloc_1d( tNM*N_VAR*N +NA );
  x       =  malloc_1d( tNM*N_VAR*N +NA );
  REV     =  malloc_1d( tNM*N_VAR*N +NA );
  IEV     =  malloc_1d( tNM*N_VAR*N +NA );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( IS  ==  IS_1 ){
    FP_R  =  fopen_mode( READ_INITIALDATA, 'r' );
    for( i = 1; i <= tNM*N_VAR*Ns+NA; i++ ){
      if( feof(FP_R) ){
        char *PRINTF;
        PRINTF  =  MALLOC_1C( SIZE );
        sprintf( PRINTF, "Input FileData (IS=%d:N_S=%d) Mistake !! (%s)\n", IS, TP->N_S, READ_INITIALDATA );
        END_PROGRAM( PRINTF, 10, 0 );
        *I_ERR  =  1;
        goto  END;
      }
      fscanf( FP_R, "%d %lf %lf %lf %lf\n", \
              &ti, &SOP[i], &EP[i], &t_d_x[i], &t_p_x[i] );
    }
    t_p_x[tNM*N_VAR*Ns+NA]  =  EP[CP];
    Generate_SV_tNM( *TP, BC, t_d_x, d_x );
    Generate_SV_tNM( *TP, BC, t_p_x, p_x );
/*********************************************************************************/
/*    fclose(FP_R);*/
/*    FP_R  =  fopen_mode( "2", 'r' );*/
/*    for( i = 1; i <= N; i++ )*/
/*      fscanf( FP_R, "%lf %lf %lf %lf %lf %lf %lf\n", \*/
/*              &td, &p_x[i], &p_x[i+N], &p_x[i+2*N], &td, &td, &td );*/
/*********************************************************************************/
/*    int    i_VAR, i_max, i_center;*/
/*    double max_u;*/
/*    double *t_x;*/
/*    t_x  =  malloc_1d( NV );*/
/*    i_max  =  1;*/
/*    max_u  =  p_x[1];*/
/*    for( i = 2; i <= N; i++ ){*/
/*      if( max_u  <=  p_x[i] ){*/
/*        i_max  =  i;*/
/*        max_u  =  p_x[i];*/
/*      }*/
/*    }*/
/*    for( i = 1; i <= NV; i++ )*/
/*      t_x[i]  =  p_x[i];*/
/*    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ )  for( i = 1; i <= N; i++ )  p_x[(i_VAR-1)*N+i] = t_p_x[(i_VAR-1)*Ns+Ns];*/
/*    if( N % 2 == 0 )   i_center = N/2;*/
/*    else               i_center = N/2 + 1;*/
/*    if     ( i_max < i_center ){   for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ )*/
/*                                     for( i = 1; i <= 2*i_max-1    ; i++ )  p_x[(i_VAR-1)*N+i_center-i_max+i+1]   = t_x[(i_VAR-1)*N+i];               }*/
/*    else if( i_max > i_center ){   for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ )*/
/*                                     for( i = 1; i <= 2*(N-i_max)+1; i++ )  p_x[(i_VAR-1)*N+i_center-N+i_max+i-1] = t_x[(i_VAR-1)*N+2*i_max-N+i-1];   }*/
/*    else                       {   for( i = 1; i <= NV; i++ )  p_x[i] = t_x[i];   }*/
/*    free_1d( t_x );*/
/*********************************************************************************/
    for( i = 1; i <= tNM*NV+NA; i++ )
      x[i]  =  p_x[i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    if( KE  ==  1 ){
      if( ! feof(FP_R) ){
        for( i = 1; i <= tNM*N_VAR*Ns+NA; i++ ){
          if( feof(FP_R) ){
            char *PRINTF;
            PRINTF  =  MALLOC_1C( SIZE );
            sprintf( PRINTF, "Input FileData (IS=%d:N_S=%d) Mistake !! (%s)\n", IS, TP->N_S, READ_INITIALDATA );
            END_PROGRAM( PRINTF, 10, 0 );
            *I_ERR  =  1;
            goto  END;
          }
          fscanf( FP_R, "%d %lf %lf %lf %lf\n", \
                  &ti, &td, &t_EP[i], &tt_d_x[i], &t_x[i] );
        }
        t_x[tNM*N_VAR*Ns+NA]  =  t_EP[CP];
        for( i = 1; i <= tNM*N_VAR*Ns+NA; i++ )
          if( t_d_x[i]  !=  tt_d_x[i] )
            break;
        if( i  ==  tNM*N_VAR*Ns+NA+1 ){
          for( i = 1; i <= N_EP; i++ )
            EP[i]  =  t_EP[i];
          Generate_SV_tNM( *TP, BC, t_x, x );
          initial_dot( NM, tNM, NV, NA, p_x, x, d_x );
          normalize_dot_x( tNM*NV+NA, d_x, I_ERR );   if( *I_ERR == 1 ) goto END;
        }
      }else{
        for( i = 1; i <= tNM*NV+NA; i++ )
          if( d_x[i]  !=  0.0 )
            break;
        if( i  ==  tNM*NV+NA+1 ){
          RANDOM( tNM*NV+NA, p_x, x );
          initial_dot( NM, tNM, NV, NA, p_x, x, d_x );
          normalize_dot_x( tNM*NV+NA, d_x, I_ERR );   if( *I_ERR == 1 ) goto END;
        }
      }
    }
    fclose( FP_R );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  else if( IS  ==  IS_BC ){
    double EPS, VELOCITY_DELTA, PAR_DELTA, TIME, PERIOD_DELTA;
    double *t_REVC, *t_IEVC;
    double *REVC, *IEVC;
    comment_remove( READ_BRANCHCHANGEINITIALDATA, READ_WRITE_BRANCHCHANGEINITIALDATA );
    FP_R  =  fopen_mode( READ_WRITE_BRANCHCHANGEINITIALDATA, 'r' );
    fscanf( FP_R, "%lf %lf %lf %lf %lf\n", &EPS, &PERIOD_DELTA, &VELOCITY_DELTA, &PAR_DELTA, &TIME );
    fclose( FP_R );
    Remove_TempFile( READ_WRITE_BRANCHCHANGEINITIALDATA );
    t_REVC  =  malloc_1d( N_VAR*Ns+NA );
    t_IEVC  =  malloc_1d( N_VAR*Ns+NA );
    REVC    =  malloc_1d( NM*NV+NA    );
    IEVC    =  malloc_1d( NM*NV+NA    );
    FP_R  =  fopen_mode( READ_INITIALDATA, 'r' );
    for( i = 1; i <= N_VAR*Ns+NA; i++ ){
      if( feof(FP_R) ){
        char *PRINTF;
        PRINTF  =  MALLOC_1C( SIZE );
        sprintf( PRINTF, "Input FileData (IS=%d:N_S=%d) Mistake !! (%s)\n", IS, TP->N_S, READ_INITIALDATA );
        END_PROGRAM( PRINTF, 10, 0 );
        *I_ERR  =  1;
        goto  END;
      }
      fscanf( FP_R, "%d %lf %lf %lf %lf %lf %lf %lf %lf\n", \
              &ti, &SOP[i], &EP[i], &t_d_x[i], &t_p_x[i], &td, &td, &t_REVC[i], &t_IEVC[i] );
    }
    fclose( FP_R );
    EP[CP]              +=  PAR_DELTA;
    t_p_x[N_VAR*Ns+NA]   =  EP[CP];
    Generate_SV_tNM( *TP, BC, t_d_x , d_x  );
    Generate_SV_tNM( *TP, BC, t_p_x , p_x  );
    Generate_SV_tNM( *TP, BC, t_REVC, REVC );
    Generate_SV_tNM( *TP, BC, t_IEVC, IEVC );
/*********************************************************************************/
    for( i = 1; i <= NV; i++ )
      x[i]  =  p_x[i];
    if( TP->SS  ==  SS_2 )
      for( i = 1; i <= NV; i++ )
        p_x[i]  +=  EPS * REVC[i];
    else if( TP->SS == SS_3  ||  TP->SS == SS_4 )
      for( i = 1; i <= NV; i++ )
        p_x[i]  +=  EPS * ( sin(2.0*M_PI*TIME) * REVC[i] + cos(2.0*M_PI*TIME) * IEVC[i] );
    if( TP->np == 0 )  p_x[NV+1]   =  0.0;
    else               p_x[NV+1]   =  2.0*M_PI / fabs(SOP[L_REV_i_E]) + PERIOD_DELTA;
    if( TP->nv == 0 )  p_x[NV+2]   =  0.0;
    else               p_x[NV+2]  +=  VELOCITY_DELTA;
    if( TP->nk  ==  1 ){
      if( TP->SS  ==  SS_2 )
        for( i = 1; i <= NV; i++ )
          x[i]  +=  EPS * (REVC[i]+0.00001);
      else if( TP->SS == SS_3  ||  TP->SS == SS_4 )
        for( i = 1; i <= NV; i++ )
          x[i]  +=  EPS * ( sin(2.0*M_PI*(TIME+0.00001)) * REVC[i] + cos(2.0*M_PI*(TIME+0.00001)) * IEVC[i] );
        for( i = NV+1; i <= NV+NA; i++ )
          x[i]  =  p_x[i];
      initial_dot( NM, tNM, NV, NA, p_x, x, d_x );
      normalize_dot_x( tNM*NV+NA, d_x, I_ERR );   if( *I_ERR == 1 ) goto END;
    }else
      for( i = 1; i <= NV+NA; i++ )
        x[i]  =  p_x[i];
/*********************************************************************************/
/*    for( i = 1; i <= NV; i++ )*/
/*      x[i]  =  p_x[i];*/
/*      for( i = 1; i <= NV; i++ )*/
/*        p_x[i]  +=  EPS * REVC[i];*/
/*    p_x[NV+1]   =  2.0*p_x[NV+1];*/
/*    p_x[NV+2]  +=  VELOCITY_DELTA;*/
/*    if( TP->nk  ==  1 )*/
/*      for( i = 1; i <= NV; i++ )*/
/*        x[i]  +=  EPS * (REVC[i]+0.00001);*/
/*    for( i = 1; i <= NV+NA; i++ )*/
/*      x[i]  =  p_x[i];*/
/*********************************************************************************/
    free_1d( t_REVC );
    free_1d( t_IEVC );
    free_1d( REVC   );
    free_1d( IEVC   );
    TP->IS  =  IS_1;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  else if( IS == IS_EV  ||  IS == IS_EVC  ||  IS == IS_G ){
    if( step  ==  0 ){
      if     ( IS == IS_EV  ||  IS == IS_EVC )   FP_R = TP->FP_INIDATA = fopen_mode( READ_INITIALDATA, 'r' );
      else if( IS == IS_G                    )   FP_R = TP->FP_INIDATA = fopen_mode( READ_MIDLEDATA  , 'r' );
    }else
      FP_R  =  TP->FP_INIDATA;
    int N_READ     =  (int)L_SOP_NM;
    int MAX_L_SOP  =  MAX(MAX(MAX(L_SOP_dt,L_SOP_NM),L_SOP_EES),L_SOP_NW);
    if( TP->N_S  ==  N_S_SOL ){
      for( i = 1; i <= N_READ; i++ ){
        if( feof(FP_R) ){
          char *PRINTF;
          PRINTF  =  MALLOC_1C( SIZE );
          if( IS != IS_G )  sprintf( PRINTF, "Input FileData (IS=%d:N_S=%d) Mistake !! (%s)\n", IS, TP->N_S, READ_INITIALDATA );
          else              sprintf( PRINTF, "Input FileData (IS=%d:N_S=%d) Mistake !! (%s)\n", IS, TP->N_S, READ_MIDLEDATA   );
          END_PROGRAM( PRINTF, 10, 0 );
          *I_ERR  =  1;
          goto  END;
        }
        fscanf( FP_R, "%d %lf %lf %lf %lf\n", \
                &ti, &SOP[i], &EP[i], &t_d_x[i], &t_x[i] );
        if( i  <=  MAX_L_SOP ){
          if     ( i  ==  L_SOP_dt  ){   TP->dt   =       SOP[i];                                                    }
          else if( i  ==  L_SOP_NM  ){   TP->NM   =  TP->tNM = NM = tNM = (int)SOP[i];   N_READ = tNM*N_VAR*Ns+NA;   }
          else if( i  ==  L_SOP_EES ){   TP->EES  =  (int)SOP[i];                                                    }
          else if( i  ==  L_SOP_NW  ){   TP->NW   =  (int)SOP[i];                                                    }
        }
      }
    }else if( TP->N_S  ==  N_S_EV ){
      for( i = 1; i <= N_READ; i++ ){
        if( feof(FP_R) ){
          char *PRINTF;
          PRINTF  =  MALLOC_1C( SIZE );
          if( IS != IS_G )  sprintf( PRINTF, "Input FileData (IS=%d:N_S=%d) Mistake !! (%s)\n", IS, TP->N_S, READ_INITIALDATA );
          else              sprintf( PRINTF, "Input FileData (IS=%d:N_S=%d) Mistake !! (%s)\n", IS, TP->N_S, READ_MIDLEDATA   );
          END_PROGRAM( PRINTF, 10, 0 );
          *I_ERR  =  1;
          goto  END;
        }
        fscanf( FP_R, "%d %lf %lf %lf %lf %lf %lf\n", \
                &ti, &SOP[i], &EP[i], &t_d_x[i], &t_x[i], &t_REV[i], &t_IEV[i] );
        if( i  <=  MAX_L_SOP ){
          if     ( i  ==  L_SOP_dt  ){   TP->dt   =       SOP[i];                                                    }
          else if( i  ==  L_SOP_NM  ){   TP->NM   =  TP->tNM = NM = tNM = (int)SOP[i];   N_READ = tNM*N_VAR*Ns+NA;   }
          else if( i  ==  L_SOP_EES ){   TP->EES  =  (int)SOP[i];                                                    }
          else if( i  ==  L_SOP_NW  ){   TP->NW   =  (int)SOP[i];                                                    }
        }
      }
      Generate_SV_tNM( *TP, BC, t_REV, REV );
      Generate_SV_tNM( *TP, BC, t_IEV, IEV );
    }
    t_x[tNM*N_VAR*Ns+NA]  =  EP[CP];
    Generate_SV_tNM( *TP, BC, t_d_x, d_x );
    Generate_SV_tNM( *TP, BC, t_x  ,   x );
    if( TP->NM  !=  1 ){
      FILE *FP_W;
      FP_W  =  fopen_mode( READ_WRITE_MULTIPLEPOINTSDATA, 'w' );
      for( i = 1; i <= TP->NM; i++ )
        fprintf( FP_W, "%20.15E\n", SOP[i+L_SOP_N_VAR+N_VAR*2+1] );
      fflush( FP_W );
      fclose( FP_W );
      TP->Remove_MP  =  1;
    }
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( TP->nv2  ==  1 )
    p_x[NM*NV+2]  =  x[NM*NV+2]  =  0.0;
  for( i = 1; i <= N_EP; i++ )
    par[i]  =  EP[i];
  Diffusion( *TP, par );
  for( i = 1; i <= N_VAR*2; i++ )
    BC[i]  =  SOP[i+L_SOP_N_VAR];
  if( TP->IS == IS_1  &&  TP->np == 1  &&  ( NM != tNM  ||  TP->c_tMP == -1  ||  TP->c_tMP == -2  ||  TP->c_MP == 1  ||  TP->c_MP == 2 ) ){
    for( i =    1; i <=    NV; i++ )  t__d_x[      i]  =  d_x[       i];
    for( i = NV+1; i <= NM*NV; i++ )  t__d_x[      i]  =  0.0;
    for( i =    1; i <= NA   ; i++ )  t__d_x[NM*NV+i]  =  d_x[tNM*NV+i];
    Initial_x( *TP, par, BC, x, t__x );
    if( KE  ==  1 ){
      par[CP]  =  p_x[tNM*NV+NA];
      Initial_x( *TP, par, BC, p_x, t__p_x );
      par[CP]  =    x[tNM*NV+NA];
    }else
      for( i = 1; i <= NM*NV+NA; i++ )
        t__p_x[i]  =  t__x[i];
  }else{
    for( i = 1; i <= NM*NV+NA; i++ ){
      t__d_x[i]  =  d_x[i];
      t__p_x[i]  =  p_x[i];
        t__x[i]  =    x[i];
    }
    if( TP->N_S  ==  N_S_EV ){
      for( i = 1; i <= NM*NV+NA; i++ ){
        t__REV[i]  =  REV[i];
        t__IEV[i]  =  IEV[i];
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  *I_ERR  =  -1;
  END:
  free_1d( SOP    );
  free_1d( EP     );
  free_1d( t_EP   );
  free_1d( t_d_x  );
  free_1d( tt_d_x );
  free_1d( t_p_x  );
  free_1d( t_x    );
  free_1d( t_REV  );
  free_1d( t_IEV  );
  free_1d( d_x    );
  free_1d( p_x    );
  free_1d( x      );
  free_1d( REV    );
  free_1d( IEV    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Initial_x( TEMP TP, double *par, double *BC, double *t_x, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int NM, NV, NA, tNM;
  NM     =  TP.NM;
  NV     =  TP.NV;
  NA     =  TP.NA;
  tNM    =  TP.tNM;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, t, t1, t2, N_t, c_EES;
  int    *point1, *point2;
  double *EEx, *F, *RS_EE;
  double **EEa;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     (   TP.EES == EES_D    ||  TP.EES == EES_D_M     )    c_EES = EES_D;
  else if(   TP.EES == EES_S_E  ||  TP.EES == EES_S_E_M   )    c_EES = EES_S_E;
  else if(   TP.EES == EES_S_R  ||  TP.EES == EES_S_R_M   )    c_EES = EES_S_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  point1  =  malloc_1i( NM+1  );
  point2  =  malloc_1i( tNM+1 );
  EEx     =  malloc_1d( NV+NA );
  F       =  malloc_1d( NV    );
  RS_EE   =  malloc_1d( NV    );
  EEa     =  malloc_2d( 5, NV );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( NM  ==  1 ){
    for( i = 1; i <= NV; i++ ){   x[   i] = t_x[       i];   }
    for( i = 1; i <= NA; i++ ){   x[NV+i] = t_x[tNM*NV+i];   }
  }else{
/*    TP.dt  =  TP.pdt/t_x[tNM*NV+1];*/
    Round_Off( NM , TP.c_MP , TP, point1 );
    Round_Off( tNM, TP.c_tMP, TP, point2 );
    for( i = 1; i <= NV; i++ ){   x[      i] = EEx[   i] = t_x[       i];   }
    for( i = 1; i <= NA; i++ ){   x[NM*NV+i] = EEx[NV+i] = t_x[tNM*NV+i];   }
    if  ( NM == 1 )   N_t = 1;
    else              N_t = point1[NM];
    if(  c_EES == EES_D  ){
      M_EETV( TP, par, BC, EEx, EEa );
      LU_Decomposition_EE( TP, EEa );
      for( t = t1 = t2 = 2; t <= N_t; t++ ){
        if( t == point2[t2] ){   for( i = 1; i <= NV; i++ ) EEx[i] = t_x[(t2-1)*NV+i]; t2++;   }
        else{
          Reaction( TP, par, EEx, F );
          RS_EEVT( TP, par, BC, EEx, F, RS_EE );
          Calculate_Solution_EE( TP, RS_EE, EEa, EEx );
        }
        if( t == point1[t1] ){   for( i = 1; i <= NV; i++ ) x[(t1-1)*NV+i] = EEx[i];   t1++;   }
      }
    }else if( c_EES  ==  EES_S_E ){
      for( t = t1 = t2 = 2; t <= N_t; t++ ){
        if  ( t == point2[t2] ){   for( i = 1; i <= NV; i++ ) EEx[i] = t_x[(t2-1)*NV+i]; t2++;   }
        else                   {   EM_SM( TP, par, EEx );                                        }
        if  ( t == point1[t1] ){   for( i = 1; i <= NV; i++ ) x[(t1-1)*NV+i] = EEx[i];   t1++;   }
      }
        if  ( t == point1[t1] ){   for( i = 1; i <= NV; i++ ) x[(t1-1)*NV+i] = EEx[i];   t1++;   }
    }else if( c_EES  ==  EES_S_R ){
      for( t = t1 = t2 = 2; t <= N_t; t++ ){
        if  ( t == point2[t2] ){   for( i = 1; i <= NV; i++ ) EEx[i] = t_x[(t2-1)*NV+i]; t2++;   }
        else                   {   RK4_SM( TP, par, EEx );                                       }
        if  ( t == point1[t1] ){   for( i = 1; i <= NV; i++ ) x[(t1-1)*NV+i] = EEx[i];   t1++;   }
      }
        if  ( t == point1[t1] ){   for( i = 1; i <= NV; i++ ) x[(t1-1)*NV+i] = EEx[i];   t1++;   }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( point1 );
  free_1i( point2 );
  free_1d( EEx    );
  free_1d( F      );
  free_1d( RS_EE  );
  free_2d( EEa    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void Round_Off( int NM, int cMP, TEMP TP, int *point )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, ti, Nt;
  double td, t_point;
  FILE   *FP_R=NULL;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Nt  =  (int)(1.0/TP.dt);
  if( 1.0/TP.dt-Nt >= 0.5 )   Nt ++;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  point[1   ]  =  1;
  point[NM+1]  =  Nt+1;
  if( NM  !=  1 ){
    if( cMP < -2  ||  2 < cMP ){
      for( i = 2; i <= NM; i++ ){
        point[i]  =  1 + (i-1) * Nt / NM;
        if(   0.5  <=  ((i-1)*(double)Nt/(double)NM-(i-1)*Nt/NM)   )
          point[i] ++;
      }
    }else if( cMP  <  0 ){
      FP_R  =  fopen_mode( READ_INITIALDATA, 'r' );
      for( i = 1; i <= L_SOP_N_VAR+2*TP.N_VAR+2; i++ )
        fscanf( FP_R, "%d %lf %lf %lf %lf\n", &ti, &td     , &td, &td, &td );
      for( i = 2; i <= NM; i++ ){
        fscanf( FP_R, "%d %lf %lf %lf %lf\n", &ti, &t_point, &td, &td, &td );
        point[i]  =  (int)t_point;
      }
      fclose( FP_R );
    }else{
      if  ( TP.IS != IS_EV  &&  TP.IS != IS_EVC  &&  TP.IS != IS_G )   FP_R = fopen_mode( READ_MULTIPLEPOINTSDATA      , 'r' );
      else                                                             FP_R = fopen_mode( READ_WRITE_MULTIPLEPOINTSDATA, 'r' );
      fscanf( FP_R, "%lf\n", &t_point );
      for( i = 2; i <= NM; i++ ){
        fscanf( FP_R, "%lf\n", &t_point );
        if  ( cMP == 1 ){   point[i] =     (int)t_point;       }
        else            {   point[i] = 1 + (int)(t_point*Nt);  }
      }
      fclose( FP_R );
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  initial_set1( TEMP *TP, int *I_ERR )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double td, td1;
  double *SOP, *SOP2;
  char   *line;
  double *data;
  FILE   *FP_R=NULL;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SOP   =  malloc_1d( L_SOP_N_VAR );
  line  =  MALLOC_1C( LINESIZE    );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( TP->IS == IS_1  ||  TP->IS == IS_BC  ||  TP->IS == IS_EV  ||  TP->IS == IS_EVC )
    FP_R  =  fopen_mode( READ_INITIALDATA, 'r' );
  else if( TP->IS  ==  IS_G )
    FP_R  =  fopen_mode( READ_MIDLEDATA, 'r' );
  else{
    char *PRINTF;
    PRINTF  =  MALLOC_1C( SIZE );
    sprintf( PRINTF, "Initial Select Mistake !! (%d)\n", TP->IS );
    END_PROGRAM( PRINTF, 10, 0 );
    goto  END;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fgets( line, (int)LINESIZE, FP_R );
  N_SPLIT( " ", line, &(TP->N_S) );
  FREE_1C( line );
  fseek( FP_R, 0, SEEK_SET );
  data  =  malloc_1d( TP->N_S );
  for( i = 1; i <= (int)L_SOP_N_VAR; i++ ){
    SPLIT_READ_DATA( TP->N_S, FP_R, data );
    SOP[i]  =  data[2];
  }
  TP->N      =  (int)SOP[L_SOP_N];
  TP->N_EP   =  (int)SOP[L_SOP_N_EP];
  TP->Lx     =       SOP[L_SOP_Lx];
  if( TP->IS != IS_1  &&  TP->IS != IS_BC ){
    TP->dt   =       SOP[L_SOP_dt];
    TP->PF   =  (int)SOP[L_SOP_PF];
    TP->EES  =  (int)SOP[L_SOP_EES];
  }
  TP->tNM    =  (int)SOP[L_SOP_NM];
  TP->NW     =  (int)SOP[L_SOP_NW];
  TP->N_VAR  =  (int)SOP[L_SOP_N_VAR];
  TP->Ns     =  TP->N + 1;
  TP->dx     =  TP->Lx / TP->N;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP->tNM  !=  1 ){
    SOP2  =  malloc_1d( TP->N_VAR*2+1 );
    for( i = 1; i <= TP->N_VAR*2+1; i++ ){
      SPLIT_READ_DATA( TP->N_S, FP_R, data );
      SOP2[i]  =  data[2];
    }
    if     ( (int)SOP2[TP->N_VAR*2+1] == 1 )   TP->c_tMP  =  -1;
    else if( (int)SOP2[TP->N_VAR*2+1] == 2 )   TP->c_tMP  =  -2;
    else                                       TP->c_tMP  =  -9;
    free_1d( SOP2 );
  }else
    TP->c_tMP  =  0;
  fclose( FP_R );
  if( TP->NM != 1  &&  TP->IS != IS_EV  &&  TP->IS != IS_EVC  &&  TP->IS != IS_G ){
    FP_R  =  fopen_mode( READ_MULTIPLEPOINTSDATA, 'r' );
    fscanf( FP_R, "%lf\n", &td );
    if     ( (int)td == 0 )   TP->c_MP = 2;
    else if( (int)td == 1 )   TP->c_MP = 1;
    else                      TP->c_MP = 9;
    if( TP->c_MP == 1  ||  TP->c_MP == 2 ){
      td1     =  td;
      *I_ERR  =  -1;
      for( i = 1; i <= TP->NM-1; i++ ){
        if( ! feof(FP_R) ){
          fscanf( FP_R, "%lf\n", &td );
          if( td <= td1 ){   *I_ERR = 1;   }
          td1  =  td;
        }else
          *I_ERR  =  1;
      }
      int N_t  =  (int)(1.0/TP->dt);
      if( 1.0/TP->dt-N_t >= 0.5 )   N_t ++;
      if(   *I_ERR     == 1                          ||\
            ( TP->c_MP == 1  &&  (int)td != N_t+1 )  ||\
            ( TP->c_MP == 2  &&       td != 1.0   )       ){
        fclose( FP_R );
        char *PRINTF;
        PRINTF  =  MALLOC_1C( SIZE );
        sprintf( PRINTF, "Multiple Point Mistake !!\n" );
         END_PROGRAM( PRINTF, 10, 0 );
        *I_ERR  =  1;
        goto  END;
      }
    }
    fclose( FP_R );
  }else
    TP->c_MP  =  1;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( TP->BCS  ==  BCS_1 )  TP->N  =  TP->N-1;
  else if( TP->BCS  ==  BCS_2 )  TP->N  =  TP->N+1;
  else if( TP->BCS  ==  BCS_3 )  TP->N  =  TP->N;
  else if( TP->BCS  ==  BCS_4 )  TP->N  =  TP->N;
  else{
    char *PRINTF;
    PRINTF  =  MALLOC_1C( SIZE );
    sprintf( PRINTF, "Bounduary Condition Select Mistake !! (%d)\n", TP->BCS );
    END_PROGRAM( PRINTF, 10, 0 );
    goto  END;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if(   (TP->SS == SS_3 || TP->SS == SS_4)  &&  TP->PF == 1   ){   TP->npf = TP->KE = 1;    }
  else                                                         {   TP->npf = TP->PF = 0;    }
  if( TP->SS  ==  SS_1 ){
    if     ( TP->KE   !=  1     ){  TP->np = 0;   TP->nv = 0;   TP->nv2 = 0;   TP->nk = 0;  }
    else if( TP->BCS  ==  BCS_3 ){  TP->np = 0;   TP->nv = 1;   TP->nv2 = 1;   TP->nk = 1;  }
    else                         {  TP->np = 0;   TP->nv = 0;   TP->nv2 = 0;   TP->nk = 1;  }
  }else if( TP->SS  ==  SS_2 ){
    if     ( TP->KE   !=  1     ){  TP->np = 0;   TP->nv = 1;   TP->nv2 = 0;   TP->nk = 0;  }
    else                         {  TP->np = 0;   TP->nv = 1;   TP->nv2 = 0;   TP->nk = 1;  }
  }else if( TP->SS  ==  SS_3 ){
    if     ( TP->BCS  ==  BCS_3 ){  TP->np = 1;   TP->nv = 1;   TP->nv2 = 1;                }
    else                         {  TP->np = 1;   TP->nv = 0;   TP->nv2 = 0;                }
    if     ( TP->KE   !=  1     ){                                             TP->nk = 0;  }
    else                         {                                             TP->nk = 1;  }
  }else if( TP->SS  ==  SS_4 ){
    if     ( TP->KE   !=  1     ){  TP->np = 1;   TP->nv = 1;   TP->nv2 = 0;   TP->nk = 0;  }
    else                         {  TP->np = 1;   TP->nv = 1;   TP->nv2 = 0;   TP->nk = 1;  }
  }
  TP->na  =  TP->np + TP->nv + TP->nk;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP->np  ==  0 )
    TP->tNM  =  TP->NM  =  1;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  TP->n_NORM  =  TP->NM*TP->N_VAR*TP->N+TP->na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( TP->IS == IS_EV  ){  TP->EVS =  1;  TP->EVCS = -1;  }
  else if( TP->IS == IS_EVC ){  TP->EVS =  1;  TP->EVCS =  1;  }
  else if( TP->IS == IS_G   ){  TP->EVS = -1;  TP->EVCS = -1;  }
  if     ( TP->IS == IS_EV   &&  TP->N_S != N_S_SOL ){
    char *PRINTF;
    PRINTF  =  MALLOC_1C( SIZE );
    sprintf( PRINTF, "Initial Select and Eigen Vector Select Mistake !! (%d:%d)\n", TP->IS, TP->EVCS );
    END_PROGRAM( PRINTF, 10, 0 );
    goto  END;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP->IS == IS_EV  ||  TP->IS == IS_EVC  ||  TP->IS == IS_G ){
    TP->MAX_NM  =  1;
    int N_ReadData;
    if     (   (TP->IS == IS_EV || TP->IS == IS_EVC)  &&  TP->np == 0   )   DataNum (     READ_INITIALDATA, &N_ReadData );
    else if(   (TP->IS == IS_EV || TP->IS == IS_EVC)  &&  TP->np == 1   )   DataNum1( TP, READ_INITIALDATA, &N_ReadData );
    else if(    TP->IS == IS_G                        &&  TP->np == 0   )   DataNum (     READ_MIDLEDATA  , &N_ReadData );
    else if(    TP->IS == IS_G                        &&  TP->np == 1   )   DataNum1( TP, READ_MIDLEDATA  , &N_ReadData );
    TP->MaxStep  =  N_ReadData / (TP->N_VAR*TP->Ns+TP->NA);
    TP->DataCut  =  TP->StepCut;
    TP->StepCut  =  TP->StepCut  =  1;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  *I_ERR  =  -1;
  END:
  free_1d( SOP   );
  free_1d( data  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*
  int *i_par;
  i_par  =  malloc_1i( TP->N_EP );
  TP->c_parCP  =  0;
  for( i = 1; i <= TP->N_EP; i++ )
    i_par[i]  =  0;
  i_Diffusion( i_par );
  if( i_par[TP->CP]  ==  1 )
    TP->c_parCP  =  1;
  free_1i( i_par );
*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
