/*this program version 1.1(090629)*/
/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include <mpi.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define SELECT_NM 1
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
int  main( int argc, char *argv[] )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  TEMP TP;
  MPI_Init( &argc, &argv );
  MPI_Comm_size( MPI_COMM_WORLD, &TP.PROCS );
  MPI_Comm_rank( MPI_COMM_WORLD, &TP.RANK  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP.RANK  ==  0 )
    comment_remove( READ_OPERATIONPARAMETER, READ_WRITE_OPERATIONPARAMETER );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_OP;
  if( TP.RANK  ==  0 )
    DataNum( READ_WRITE_OPERATIONPARAMETER, &N_OP );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    *OP_i;
  double *OP_d;
  if( TP.RANK  ==  0 ){
    OP_i   =  malloc_1i( N_OP );
    OP_d   =  malloc_1d( N_OP );
    Read_OperationParameter( READ_WRITE_OPERATIONPARAMETER, N_OP, OP_i, OP_d );
  }
  MPI_Bcast( &N_OP, 1, MPI_INT, 0, MPI_COMM_WORLD );
  if( TP.RANK  !=  0 ){
    OP_i  =  malloc_1i( N_OP );
    OP_d  =  malloc_1d( N_OP );
  }
  MPI_Bcast( &OP_i[1], N_OP, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &OP_d[1], N_OP, MPI_DOUBLE, 0, MPI_COMM_WORLD );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int i=1;
  TP.ds         =  OP_d[i++];
  TP.PN         =  OP_d[i++];
  TP.KE         =  OP_i[i++];
  TP.MI         =  OP_i[i++];
  TP.pdt=TP.dt  =  OP_d[i++];
  TP.NM         =  OP_i[i++];
  TP.PF         =  OP_i[i++];
  TP.CP         =  OP_i[i++];
  TP.SS         =  OP_i[i++];
  TP.BCS        =  OP_i[i++];
  TP.EES        =  OP_i[i++];
  TP.EVS        =  OP_i[i++];
  TP.EVCS       =  OP_i[i++];
  TP.ME         =  OP_d[i++];
  TP.StepCut    =  OP_i[i++];
  TP.MaxStep    =  OP_i[i++];
  TP.GS         =  OP_d[i++];
  TP.IS         =  OP_i[i++];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  TP.ds_PF      =  TP.ds;
  TP.N_OP       =  N_OP;
  TP.NA         =  3;
  TP.step       =  0;
  TP.CC         =  0;
  TP.DataCut    =  1;
  TP.N_p_UEV    =  -1;
  TP.N_p_SEV    =  -1;
  TP.N_UEV      =  -1;
  TP.N_SEV      =  -1;
  TP.N_S        =  0;
  TP.BF_LABEL   =  1;
  TP.BF_TYPE    =  0;
  TP.REV_i_E    =  0.0;
  TP.Remove_MP  =  -1;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int    N_EP, N_VAR, N, NM, NV, NA, I_ERR;
  double *par, *BC;
  double *d_x, *p_x, *x;
  double *REV, *IEV;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP.RANK  ==  0 )
    initial_set1( &TP, &I_ERR );
  MPI_Bcast( &I_ERR     , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  if( I_ERR == 1 ){   MPI_Barrier( MPI_COMM_WORLD );  MPI_Finalize();  return 0;   }
  MPI_Bcast( &TP.N      , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.N_EP   , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.Lx     , 1, MPI_DOUBLE, 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.dt     , 1, MPI_DOUBLE, 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.tNM    , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.N_VAR  , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.Ns     , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.dx     , 1, MPI_DOUBLE, 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.c_tMP  , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.c_MP   , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.np     , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.nv     , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.nv2    , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.nk     , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.npf    , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.na     , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.NM     , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.PF     , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.EES    , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.NW     , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.KE     , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.EVS    , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.EVCS   , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.MaxStep, 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.DataCut, 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.StepCut, 1, MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &TP.n_NORM , 1, MPI_INT   , 0, MPI_COMM_WORLD );
/*
  StructType_Definition.h  main.c  initial_set1.c  Function.c  9M_RS_S.c
  MPI_Bcast( &TP.c_parCP, 1, MPI_INT   , 0, MPI_COMM_WORLD );
*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  N_EP   =  TP.N_EP;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NM     =  TP.NM;
  NV     =  TP.NV  =  N_VAR * N;
  NA     =  TP.NA;
  par  =  malloc_1d( N_EP+N_VAR );
  BC   =  malloc_1d( N_VAR*2    );
  d_x  =  malloc_1d( NM*NV+NA   );
  p_x  =  malloc_1d( NM*NV+NA   );
  x    =  malloc_1d( NM*NV+NA   );
  REV  =  malloc_1d( NM*NV+NA   );
  IEV  =  malloc_1d( NM*NV+NA   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= NM*NV+NA; i++ )
    REV[i]  =  IEV[i]  =  0.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP.RANK  ==  0 )
    initial_set2( &TP, par, BC, d_x, p_x, x, REV, IEV, &I_ERR );
  MPI_Bcast( &I_ERR, 1, MPI_INT, 0, MPI_COMM_WORLD );
  if( I_ERR == 1 ){   MPI_Barrier( MPI_COMM_WORLD );  MPI_Finalize();  return 0;   }
  if( TP.IS == IS_EV  ||  TP.IS == IS_EVC  ||  TP.IS == IS_G ){
    if( TP.RANK == 0 )   NM = TP.NM;
    MPI_Bcast( &TP.dt , 1, MPI_DOUBLE, 0, MPI_COMM_WORLD );
    MPI_Bcast( &NM    , 1, MPI_INT   , 0, MPI_COMM_WORLD );
    MPI_Bcast( &TP.NM , 1, MPI_INT   , 0, MPI_COMM_WORLD );
    MPI_Bcast( &TP.EES, 1, MPI_INT   , 0, MPI_COMM_WORLD );
    MPI_Bcast( &TP.NW , 1, MPI_INT   , 0, MPI_COMM_WORLD );
  }
  MPI_Bcast( &TP.IS , 1         , MPI_INT   , 0, MPI_COMM_WORLD );
  MPI_Bcast( &par[1], N_EP+N_VAR, MPI_DOUBLE, 0, MPI_COMM_WORLD );
  MPI_Bcast( &BC[1] , N_VAR*2   , MPI_DOUBLE, 0, MPI_COMM_WORLD );
  MPI_Bcast( &d_x[1], NM*NV+NA  , MPI_DOUBLE, 0, MPI_COMM_WORLD );
  MPI_Bcast( &p_x[1], NM*NV+NA  , MPI_DOUBLE, 0, MPI_COMM_WORLD );
  MPI_Bcast( &x[1]  , NM*NV+NA  , MPI_DOUBLE, 0, MPI_COMM_WORLD );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP.RANK  ==  0 ){
    Parameter_OutPut( TP, par );
    output( TP, par, BC, d_x, x, REV, IEV, 'w' );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_G  =  (int)N_GNUPLOT;
  int *c_G;
  c_G  =  MALLOC_1I( N_G+1 );
  if( TP.RANK  ==  0 ){
    if     ( TP.IS != IS_G  )   GNUPLOT_DRAW_SELECT( N_G, TP.GS, c_G );
    else if( 0     <= TP.GS )   for( i = 0; i <= N_G; i++ ) c_G[i] = 1;
  }
  MPI_Bcast( &c_G[0], N_G+1, MPI_INT, 0, MPI_COMM_WORLD );
/*-------------------------------------------------------------------------------*/
 
/*-------------------------------------------------------------------------------*/
  if( TP.RANK  ==  0 ){
    if( c_G[0]  ==  1 ){
      if     ( TP.IS != IS_G  &&  TP.np == 0 ) Gnuplot_InitialCommand_NS( &TP, c_G );
      else if( TP.IS != IS_G  &&  TP.np == 1 ) Gnuplot_InitialCommand_NP( &TP, c_G );
      else if( TP.IS == IS_G  &&  TP.np == 0 ) Gnuplot_InitialCommand_GS( &TP, c_G );
      else if( TP.IS == IS_G  &&  TP.np == 1 ) Gnuplot_InitialCommand_GP( &TP, c_G );
    }
  }
  if( TP.IS == IS_G )   if( TP.RANK != 0 )   TP.MaxStep = -1;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#if SELECT_NM  ==  NM2
  int    n_ds;
  double k_ds, m_ds;
  double *k_par, *k_d_x, *k_p_x, *k_x;
  k_par  =  malloc_1d( N_EP+N_VAR );
  k_d_x  =  malloc_1d( NM*NV+NA   );
  k_p_x  =  malloc_1d( NM*NV+NA   );
  k_x    =  malloc_1d( NM*NV+NA   );
  n_ds   =  1;
  k_ds   =  TP.ds;
  m_ds   =  0.00000001;
#endif
#if SELECT_NM  ==  NM3
  TP.bpev  =  malloc_1d( NM*NV );
  int    ti;
  double td;
  FILE   *FP_R;
  TP.CP2  =  2;
/*if(TP.RANK==0){*/
/*  FP_R  =  fopen_mode( "123", 'r' );*/
/*  for( i = 1; i <= NM*NV; i++ )*/
/*    fscanf( FP_R, "%d %lf %lf %lf %lf %lf %lf %lf %lf\n", \*/
/*            &ti, &td, &td, &td, &td, &td, &td, &TP.bpev[i], &td );*/
/*  fclose( FP_R );*/
/*  normalize( NM*NV, TP.bpev, &I_ERR );   if( I_ERR==1 ) MPI_EXIT(TP);*/
/*}*/
/*          MPI_Bcast( &TP.bpev[1], NM*NV, MPI_DOUBLE, 0, MPI_COMM_WORLD );*/
if(TP.RANK==0){
  FP_R  =  fopen_mode( "124", 'r' );
  for( i = 1; i <= NM*NV+TP.na; i++ )   fscanf( FP_R, "%d %d %lf %lf %lf\n", &ti, &ti, &td, &td, &x[i]        );
  for( i = 1; i <= NM*NV      ; i++ )   fscanf( FP_R, "%d %d %lf %lf %lf\n", &ti, &ti, &td, &td, &TP.bpev[i]  );
  for(      ; i <= NM*NV      ; i++ )   fscanf( FP_R, "%d %d %lf %lf %lf\n", &ti, &ti, &td, &td, &par[TP.CP2] );
  fclose( FP_R );
  normalize( NM*NV, TP.bpev, &I_ERR );   if( I_ERR==1 ) MPI_EXIT(TP);
}
  MPI_Bcast( &TP.bpev[1] , NM*NV      , MPI_DOUBLE, 0, MPI_COMM_WORLD );
  MPI_Bcast( &x[1]       , NM*NV+TP.na, MPI_DOUBLE, 0, MPI_COMM_WORLD );
  MPI_Bcast( &par[TP.CP2], 1          , MPI_DOUBLE, 0, MPI_COMM_WORLD );
#endif
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( TP.step = 1; TP.step <= TP.MaxStep; TP.step+=TP.DataCut ){
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    if( TP.IS == IS_1 ){
#if SELECT_NM  ==  NM2
      for( i = 1; i <= N_EP+N_VAR; i++ ){   k_par[i] = par[i];                                       }
      for( i = 1; i <= NM*NV+NA  ; i++ ){   k_d_x[i] = d_x[i];  k_p_x[i] = p_x[i];  k_x[i] = x[i];   }
#endif
      if(  TP.KE != 1  &&  TP.SS == SS_1  &&  (TP.EES == EES_D && TP.EES==EES_D_M)  &&  (N_VAR <= 2 || (N_VAR == 3 && TP.BCS != BCS_3))  )
        Newton_Method_S_ILUCGS( &TP, c_G, par, BC, x );
      else{
#if   SELECT_NM  ==  NM1
        Newton_Method( &TP, c_G, par, BC, d_x, p_x, x );
#elif SELECT_NM  ==  NM2
        while( 1 ){
          if(  fabs(TP.ds) <= m_ds  )   break;
          Newton_Method( &TP, c_G, par, BC, d_x, p_x, x );
          if(  TP.CC != 1  ){
            for( i = 1; i <= N_EP+N_VAR; i++ ){   par[i] = k_par[i];                                       }
            for( i = 1; i <= NM*NV+NA  ; i++ ){   d_x[i] = k_d_x[i];  p_x[i] = k_p_x[i];  x[i] = k_x[i];   }
            if  ( k_ds < 0 ){   TP.ds = k_ds + 0.1*(n_ds++);   }
            else            {   TP.ds = k_ds - 0.1*(n_ds++);   }
            TP.ds  =  k_ds / pow(2,n_ds++);
            if( TP.RANK == 0 ) printf( "ds / mds   =   |%.15lf| / %.15lf\n", TP.ds_PF, m_ds );
            TP.CC  =  0;
          }else
            break;
        }
#elif SELECT_NM  ==  NM3
        Newton_Method_BP( &TP, c_G, par, BC, d_x, p_x, x );
#endif
      }
      if( TP.CC  !=  1 )   break;
      else                 TP.CC = 0;
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    else if( TP.IS  ==  IS_EV )
      Eigen_Value( &TP, par, BC, x, REV, IEV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    else if( TP.IS  ==  IS_EVC )
      Eigen_Vector( &TP, par, BC, d_x, x, REV, IEV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    if( TP.step % TP.StepCut  ==  0 ){
      if( TP.IS == IS_1  &&  TP.EVS == 1 ){
        if( TP.EVCS != 1 )   Eigen_Value ( &TP, par, BC,      x, REV, IEV );
        else                 Eigen_Vector( &TP, par, BC, d_x, x, REV, IEV );  
      }else if( TP.IS == IS_G  &&  TP.N_S == N_S_EV )
        N_UnstableEigenValue( &TP, par, REV, IEV );
      if( TP.RANK  ==  0 ){
        if( TP.step  ==  TP.StepCut )  output( TP, par, BC, d_x, x, REV, IEV, 'w' );
        else                           output( TP, par, BC, d_x, x, REV, IEV, 'a' );
        if( c_G[0]  ==  1 ){
          if     ( TP.IS != IS_G  &&  TP.np == 0 ) Gnuplot_Draw_NS( TP, c_G );
          else if( TP.IS != IS_G  &&  TP.np == 1 ) Gnuplot_Draw_NP( TP, c_G );
/*
          else if( TP.IS == IS_G  &&  TP.np == 0 ) Gnuplot_Draw_GS( TP, c_G );
          else if( TP.IS == IS_G  &&  TP.np == 1 ) Gnuplot_Draw_GP( TP, c_G );
*/
        }
      }
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( i = 1; i <= NM*NV+NA; i++ )
      p_x[i]  =  x[i];
    if( TP.IS == IS_EV  ||  TP.IS == IS_EVC  ||  TP.IS == IS_G ){
      if( TP.step + TP.DataCut  <=  TP.MaxStep ){
        if( TP.RANK  ==  0 )
          for( i = 1; i <= TP.DataCut; i++ )
            initial_set2( &TP, par, BC, d_x, p_x, x, REV, IEV, &I_ERR );
        MPI_Bcast( &I_ERR, 1, MPI_INT, 0, MPI_COMM_WORLD );
        if( I_ERR == 1 ){   MPI_Barrier( MPI_COMM_WORLD );  MPI_Finalize();  return 0;   }
        if( TP.IS  !=  IS_G ){
          if( TP.RANK == 0 )   NM = TP.NM;
          MPI_Bcast( &TP.dt , 1         , MPI_DOUBLE, 0, MPI_COMM_WORLD );
          MPI_Bcast( &NM    , 1         , MPI_INT   , 0, MPI_COMM_WORLD );
          MPI_Bcast( &TP.NM , 1         , MPI_INT   , 0, MPI_COMM_WORLD );
          MPI_Bcast( &TP.EES, 1         , MPI_INT   , 0, MPI_COMM_WORLD );
          MPI_Bcast( &TP.NW , 1         , MPI_INT   , 0, MPI_COMM_WORLD );
          MPI_Bcast( &par[1], N_EP+N_VAR, MPI_DOUBLE, 0, MPI_COMM_WORLD );
          MPI_Bcast( &BC[1] , N_VAR*2   , MPI_DOUBLE, 0, MPI_COMM_WORLD );
          MPI_Bcast( &d_x[1], NM*NV+NA  , MPI_DOUBLE, 0, MPI_COMM_WORLD );
          MPI_Bcast( &p_x[1], NM*NV+NA  , MPI_DOUBLE, 0, MPI_COMM_WORLD );
          MPI_Bcast( &x[1]  , NM*NV+NA  , MPI_DOUBLE, 0, MPI_COMM_WORLD );
        }
      }else
        break;
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( TP.RANK  ==  0 ){
    if( TP.IS  ==  IS_G ){
      char *PRINTF;
      PRINTF  =  MALLOC_1C( SIZE );
      sprintf( PRINTF, "Please Hit Enter Key !!\n" );
      END_PROGRAM( PRINTF, 3, 0 );
      FREE_1C( PRINTF );
      getchar();
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP.RANK  ==  0 ){
    if( c_G[0]  ==  1 ){
      if     ( TP.IS != IS_G  &&  TP.np == 0 ) Gnuplot_Close_NS( &TP );
      else if( TP.IS != IS_G  &&  TP.np == 1 ) Gnuplot_Close_NP( &TP );
      else if( TP.IS == IS_G  &&  TP.np == 0 ) Gnuplot_Close_GS( &TP );
      else if( TP.IS == IS_G  &&  TP.np == 1 ) Gnuplot_Close_GP( &TP );
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*
  if( TP.RANK  ==  0 )
    Parameter_OutPut( TP, par );
*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP.RANK  ==  0 ){
    Remove_TempFile( READ_WRITE_OPERATIONPARAMETER    );
    if( TP.np  ==  0 ){
      Remove_TempFile( Gi_dx_STEP0SV                  );
      Remove_TempFile( Gw_dx_STEPSV                   );
    }else{
      Remove_TempFile( Gi_dt_dx_STEP0SV_NR            );
      Remove_TempFile( Gw_dt_dx_ITERINISV_NR          );
      Remove_TempFile( Gw_dt_dx_ITERALLSV_NR          );
    }
    Remove_TempFile( Gi_S_CP_VT_NR_ASREV_ASIEV_NUEV   );
    Remove_TempFile( Gw_S_CP_VT_NR_ASREV_ASIEV_NUEV   );
    Remove_TempFile( Ga_S_CP_VT_NR_NZOREV_NZOIEV_NUEV );
    Remove_TempFile( Ga_S_CP_VT_NR_HPEV_HPIEV_NUEV    );
    if( TP.Remove_MP  ==  1 )
      Remove_TempFile( READ_WRITE_MULTIPLEPOINTSDATA  );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( OP_i  );
  free_1d( OP_d  );
  free_1d( par   );
  free_1d( d_x   );
  free_1d( p_x   );
  free_1d( x     );
  free_1d( REV   );
  free_1d( IEV   );
  FREE_1I( c_G   );
#if SELECT_NM  ==  NM2
  free_1d( k_par );
  free_1d( k_d_x );
  free_1d( k_p_x );
  free_1d( k_x   );
#endif
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  MPI_Barrier( MPI_COMM_WORLD );
  MPI_Finalize();
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  return 0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
