/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  output( TEMP TP    , double *par, double *BC , \
              double *d_x, double *x  , double *REV, double *IEV, int WriteMode )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, NM, NV, Ns, NA, N_UEV, CP, step, MaxStep;
  double dx;
  N_VAR    =  TP.N_VAR;
  NM       =  TP.NM;
  NV       =  TP.NV;
  Ns       =  TP.Ns;
  NA       =  TP.NA;
  N_UEV    =  TP.N_UEV;
  CP       =  TP.CP;
  step     =  TP.step;
  MaxStep  =  TP.MaxStep;
  dx       =  TP.dx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_VAR;
  int    N_OPEV;
  double period, velocity;
  double *t_x;
  double *norm;
  double *NZO_REV, *NZO_IEV, *AS_REV, *AS_IEV;
  FILE   *FP_W;
  FILE   *GP_W;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  t_x      =  malloc_1d( N_VAR*Ns+NA );
  norm     =  malloc_1d( N_NORM      );
  AS_REV   =  malloc_1d( NM*NV       );
  AS_IEV   =  malloc_1d( NM*NV       );
  NZO_REV  =  malloc_1d( NM*NV       );
  NZO_IEV  =  malloc_1d( NM*NV       );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  period    =  x[NM*NV+1];
  velocity  =  x[NM*NV+2];
  N_OPEV    =  (int)(N_OUTPUT_EV);
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Generate_tSV_NM1( TP, BC, x, t_x );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  if( TP.np  ==  0 ){
    FP_W  =  fopen_mode( WRITE_SOLUTION_VALUE, WriteMode );
    for( i = 1; i <= Ns; i++ ){
      fprintf( FP_W, "%10.8lf %10.8lf ", par[CP], (double)(i-1)*dx );
      for( i_VAR = 1; i_VAR <= N_VAR-1; i_VAR++ )
        fprintf( FP_W, "%15.8E ", t_x[(i_VAR-1)*Ns+i] );
      fprintf( FP_W, "%15.8E\n", t_x[(i_VAR-1)*Ns+i] );
    }
    fclose( FP_W );
    Calculate_Norm( TP, t_x, norm );
  }else{
    char *MSV;
    char *SHELLCOMMAND;
    char *FNAME_SV;
    MSV           =  MALLOC_1C( SIZE );
    SHELLCOMMAND  =  MALLOC_1C( SIZE );
    FNAME_SV      =  MALLOC_1C( SIZE );
    sprintf( MSV, "%s", (char *)MKDIR_SOLUTION_VALUE );
    if( step  ==  0 ){
      if( mkdir(MSV, 0000755)  !=  0 ){
        sprintf( SHELLCOMMAND, "rm -rf %s", MSV );
        system( SHELLCOMMAND );
        mkdir(MSV, 0000755);
      }
    }
    sprintf( FNAME_SV, "%s/%d", MSV, step );
    FP_W  =  fopen_mode( FNAME_SV, 'w' );
    OP_SV_Norm( FP_W, TP, par, BC, x, norm );
    fclose( FP_W );
    FREE_1C( MSV          );
    FREE_1C( SHELLCOMMAND );
    FREE_1C( FNAME_SV     );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FP_W  =  fopen_mode( WRITE_CP_VT_NR, WriteMode );
  fprintf( FP_W, "%10.8lf %15.8E %15.8E ", par[CP], period, velocity );
  for( i = 1; i <= N_NORM-1; i++ )
    fprintf( FP_W, "%15.8E ", norm[i] );
  fprintf( FP_W, "%15.8E\n", norm[i] );
  fclose( FP_W );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= NV; i++ ){
    NZO_REV[i] = REV[i];  NZO_IEV[i] = IEV[i];
    AS_REV[i]  = REV[i];  AS_IEV[i]  = IEV[i];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( N_UEV  !=  -1 ){
    if( TP.np == 0 ){   Sort_NearZeroEV( NV, NZO_REV, NZO_IEV );   Sort_AscendingSequence_REV ( NV, AS_REV, AS_IEV );   }
    else            {   Sort_NearOneEV ( NV, NZO_REV, NZO_IEV );   Sort_AscendingSequence_RIEV( NV, AS_REV, AS_IEV );   }
    FP_W  =  fopen_mode( WRITE_S_CP_VT_NR_ASREV_ASIEV_NUEV, WriteMode );
    for( i = 1; i <= N_OPEV; i++ ){
      fprintf( FP_W, "%7d %10.8lf %15.8E %15.8E ", step, par[CP], period, velocity );
      for( j = 1; j <= N_NORM; j++ )
        fprintf( FP_W, "%15.8E ", norm[j] );
      fprintf( FP_W, "%15.8E %15.8E %15.8E %5d\n", AS_REV[i], AS_IEV[i], sqrt(AS_REV[i]*AS_REV[i]+AS_IEV[i]*AS_IEV[i]), N_UEV );
    }
    fclose( FP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    if( TP.N_p_UEV == -1 ){   FP_W = fopen_mode( WRITE_S_CP_VT_NR_ASREV_ASIEV_NUEV2, 'w' );  fclose( FP_W );   }
    else if( TP.N_p_UEV  !=  N_UEV ){
      FP_W = fopen_mode( WRITE_S_CP_VT_NR_ASREV_ASIEV_NUEV2, 'a' );
      for( i = 1; i <= N_OPEV; i++ ){
        fprintf( FP_W, "%7d %10.8lf %15.8E %15.8E ", step, par[CP], period, velocity );
        for( j = 1; j <= N_NORM; j++ )
          fprintf( FP_W, "%15.8E ", norm[j] );
        fprintf( FP_W, "%15.8E %15.8E %15.8E %5d\n", AS_REV[i], AS_IEV[i], sqrt(AS_REV[i]*AS_REV[i]+AS_IEV[i]*AS_IEV[i]), N_UEV );
      }
      fclose( FP_W );
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    printf( "                                                               \n" );
    printf( "-----------------------------------------------------------------------------\n" );
    printf( "  Step  /  MaxStep             =  %d / %d\n", step, MaxStep        );
    printf( "  Control Parameter            =  %15.12lf\n", par[CP]              );
    if( TP.np  ==  0 ){
      printf( "  Nearly Most Zero EigenValue  =  %15.12lf\n", NZO_REV[1]         );
/*      printf( "  Judgment Stability           =  %10.8lf\n", JUDG_STABILITY_S   );*/
    }else{
      printf( "  Nearly Most One EigenValue   =  %15.12lf\n", NZO_REV[1]         );
    }
    if( 1  <=  N_UEV ){
      printf( "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n" );
      for( i = 1; i <= N_UEV; i++ )
/*      printf( "  Judgment Stability           =  %10.8lf\n", JUDG_STABILITY_P   );*/
        printf( "  REV[%d] = %-15.12lf IEV[%d] = %-15.12lf  RI[%d] = %-15.12lf\n", i, AS_REV[i], i, AS_IEV[i], i, sqrt(AS_REV[i]*AS_REV[i]+AS_IEV[i]*AS_IEV[i]) );
    }
    printf( "-----------------------------------------------------------------------------\n" );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  }
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  if( TP.EVS  ==  1 ){
    Output_MidleData   ( TP, par, BC, d_x, x,           WRITE_MIDLEDATA_EV, WriteMode );
    Output_MidleData_EV( TP, par, BC, d_x, x, REV, IEV, WRITE_MIDLEDATA   , WriteMode );
  }else if( TP.IS  !=  IS_G ){
    Output_MidleData   ( TP, par, BC, d_x, x,           WRITE_MIDLEDATA   , WriteMode );
    Output_MidleData_EV( TP, par, BC, d_x, x, REV, IEV, WRITE_MIDLEDATA_EV, WriteMode );
  }else if( N_UEV  !=  -1 )
    Output_MidleData   ( TP, par, BC, d_x, x,           WRITE_MIDLEDATA_EV, WriteMode );
  Output_MidleData( TP, par, BC, d_x, x, WRITE_FINALDATA, 'w' );
  Output_MidleData   ( TP, par, BC, d_x, x,           "11" , WriteMode );
  Output_MidleData_EV( TP, par, BC, d_x, x, REV, IEV, "1", WriteMode );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  if( TP.np  ==  0 ){
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    if( step  ==  0 ){
      GP_W  =  fopen_mode( Gi_dx_STEP0SV, 'w' );
      for( i = 1; i <= Ns; i++ ){
        fprintf( GP_W, "%10.8lf ", (double)(i-1)*dx );
        for( i_VAR = 1; i_VAR <= N_VAR-1; i_VAR++ )
          fprintf( GP_W, "%15.8E ", t_x[(i_VAR-1)*Ns+i] );
        fprintf( GP_W, "%15.8E\n", t_x[(i_VAR-1)*Ns+i] );
      }
      fclose( GP_W );
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    GP_W  =  fopen_mode( Gw_dx_STEPSV, 'w' );
    for( i = 1; i <= Ns; i++ ){
      fprintf( GP_W, "%10.8lf ", (double)(i-1)*dx );
      for( i_VAR = 1; i_VAR <= N_VAR-1; i_VAR++ )
        fprintf( GP_W, "%15.8E ", t_x[(i_VAR-1)*Ns+i] );
      fprintf( GP_W, "%15.8E\n", t_x[(i_VAR-1)*Ns+i] );
    }
    fclose( GP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  }
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  if( step  ==  0 ){
    if( TP.IS  ==  IS_G )  step++;
    GP_W  =  fopen_mode( Gi_S_CP_VT_NR_ASREV_ASIEV_NUEV, 'w' );
    for( i = 1; i <= N_OPEV; i++ ){
      fprintf( GP_W, "%7d %10.8lf %15.8E %15.8E ", step, par[CP], period, velocity );
      for( j = 1; j <= N_NORM; j++ )
        fprintf( GP_W, "%15.8E ", norm[j] );
      fprintf( GP_W, "%15.8E %15.8E %15.8E %5d\n", AS_REV[i], AS_IEV[i], sqrt(AS_REV[i]*AS_REV[i]+AS_IEV[i]*AS_IEV[i]), N_UEV );
    }
    fclose( GP_W );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  GP_W  =  fopen_mode( Gw_S_CP_VT_NR_ASREV_ASIEV_NUEV, 'w' );
  for( i = 1; i <= N_OPEV; i++ ){
    fprintf( GP_W, "%7d %10.8lf %15.8E %15.8E ", step, par[CP], period, velocity );
    for( j = 1; j <= N_NORM; j++ )
      fprintf( GP_W, "%15.8E ", norm[j] );
    fprintf( GP_W, "%15.8E %15.8E %15.8E %5d\n", AS_REV[i], AS_IEV[i], sqrt(AS_REV[i]*AS_REV[i]+AS_IEV[i]*AS_IEV[i]), N_UEV );
  }
  fclose( GP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  GP_W  =  fopen_mode( Ga_S_CP_VT_NR_NZOREV_NZOIEV_NUEV, WriteMode );
  fprintf( GP_W, "%7d %10.8lf %15.8E %15.8E ", step, par[CP], period, velocity );
  i  =  1;
  for( j = 1; j <= N_NORM; j++ )
    fprintf( GP_W, "%15.8E ", norm[j] );
  fprintf( GP_W, "%15.8E %15.8E %15.8E %5d\n", NZO_REV[i], NZO_IEV[i], sqrt(NZO_REV[i]*NZO_REV[i]+NZO_IEV[i]*NZO_IEV[i]), N_UEV );
  fclose( GP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  GP_W  =  fopen_mode( Ga_S_CP_VT_NR_HPEV_HPIEV_NUEV, WriteMode );
  for( i = 1; i <= N_OPEV; i++ ){
    if( AS_IEV[i]  !=  0.0 ){
      fprintf( GP_W, "%7d %10.8lf %15.8E %15.8E ", step, par[CP], period, velocity );
      for( j = 1; j <= N_NORM; j++ )
        fprintf( GP_W, "%15.8E ", norm[j] );
      fprintf( GP_W, "%15.8E %15.8E %15.8E %5d\n", AS_REV[i], AS_IEV[i], sqrt(AS_REV[i]*AS_REV[i]+AS_IEV[i]*AS_IEV[i]), N_UEV );
    }
  }
  fclose( GP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( t_x     );
  free_1d( norm    );
  free_1d( NZO_REV );
  free_1d( NZO_IEV );
  free_1d( AS_REV  );
  free_1d( AS_IEV  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  OP_SV_Norm( FILE *FP_W, TEMP TP, double *par, double *BC, double *SV, double *t__norm )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, NM, NV, NA, Ns;
  double dt, dx;
  N_VAR  =  TP.N_VAR;
  NM     =  TP.NM;
  NV     =  TP.NV;
  NA     =  TP.NA;
  Ns     =  TP.Ns;
  dt     =  TP.dt;
  dx     =  TP.dx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, t, tt, N_t, i_VAR, SVCUT, c_EES;
  int    *point;
  double *x, *t_x, *norm, *p_norm, *F, *RS_EE;
  double **a;
  FILE   *GP_W;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( TP.EES == EES_D    ||  TP.EES == EES_D_M   )   c_EES = EES_D;
  else if( TP.EES == EES_S_E  ||  TP.EES == EES_S_E_M )   c_EES = EES_S_E;
  else if( TP.EES == EES_S_R  ||  TP.EES == EES_S_R_M )   c_EES = EES_S_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  point   =  malloc_1i( NM+1        );
  x       =  malloc_1d( NV+NA       );
  t_x     =  malloc_1d( N_VAR*Ns+NA );
  norm    =  malloc_1d( N_NORM      );
  p_norm  =  malloc_1d( N_NORM      );
  if( c_EES  ==  EES_D )
  F       =  malloc_1d( NV          );
  if( c_EES  ==  EES_D )
  RS_EE   =  malloc_1d( NV          );
  a       =  malloc_2d( 5, NV       );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*  dt     =  TP.pdt/SV[NM*NV+1];*/
  TP.dt  =  dt;
  N_t    =  (int)(1.0/dt);
  if( 1.0/dt-N_t >= 0.5 )   N_t ++;
  SVCUT  =  N_t / (int)OUTPUT_SV_CUT;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Round_Off( NM , TP.c_MP , TP, point );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= NV; i++ )   x[   i] = SV[      i];
  for( i = 1; i <= NA; i++ )   x[NV+i] = SV[NM*NV+i];
  for( i = 1; i <= N_NORM; i++ )
    t__norm[i]  =  0.0;
  Generate_tSV_NM1( TP, BC, x, t_x );
  Calculate_Norm( TP, t_x, norm );
  t  =  1;
  for( i = 1; i <= Ns; i++ ){
    fprintf( FP_W, "%10.8lf %10.8lf ", (t-1)*dt, (double)(i-1)*dx );
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ )
      fprintf( FP_W, "%15.8E ", t_x[(i_VAR-1)*Ns+i] );
    for( j = 1; j <= N_NORM-1; j++ )
      fprintf( FP_W, "%15.8E ", norm[j] );
    fprintf( FP_W, "%15.8E\n", norm[j] );
  }
  if( TP.np  == 0 ){   for( i = 1; i <= N_NORM; i++ ) t__norm[i] = norm[i];   goto END;   }
  for( i = 1; i <= N_NORM; i++ )
    p_norm[i]  =  norm[i];
  if( TP.step  ==  0 ){
    GP_W  =  fopen_mode( Gi_dt_dx_STEP0SV_NR, 'w' );
    for( i = 1; i <= Ns; i++ ){
      fprintf( GP_W, "%10.8lf %10.8lf ", (t-1)*dt, (double)(i-1)*dx );
      for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ )
        fprintf( GP_W, "%15.8E ", t_x[(i_VAR-1)*Ns+i] );
      for( j = 1; j <= N_NORM-1; j++ )
        fprintf( GP_W, "%15.8E ", norm[j] );
      fprintf( GP_W, "%15.8E\n", norm[j] );
    }
    fclose( GP_W );
  }
  GP_W  =  fopen_mode( Gw_dt_dx_ITERINISV_NR, 'w' );
  for( i = 1; i <= Ns; i++ ){
    fprintf( GP_W, "%10.8lf %10.8lf ", (t-1)*dt, (double)(i-1)*dx );
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ )
      fprintf( GP_W, "%15.8E ", t_x[(i_VAR-1)*Ns+i] );
    for( j = 1; j <= N_NORM-1; j++ )
      fprintf( GP_W, "%15.8E ", norm[j] );
    fprintf( GP_W, "%15.8E\n", norm[j] );
  }
  fclose( GP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( c_EES  ==  EES_D ){
    M_EETV( TP, par, BC, x, a );
    LU_Decomposition_EE( TP, a );
  }
  for( t = tt = 2; t <= N_t+1; t++ ){
    if(  t == point[tt] && tt != NM+1  ){   for( i = 1; i <= NV; i++ ) x[i] = SV[(tt-1)*NV+i]; tt++;   }
    else if( c_EES  ==  EES_D ){
      Reaction( TP, par, x, F );
      RS_EEVT( TP, par, BC, x, F, RS_EE );
      Calculate_Solution_EE( TP, RS_EE, a, x );
    }else if( c_EES  ==  EES_S_E ){
      EM_SM( TP, par, x );
    }else if( c_EES  ==  EES_S_R ){
      RK4_SM( TP, par, x );
    }
    Generate_tSV_NM1( TP, BC, x, t_x );
    Calculate_Norm( TP, t_x, norm );
    for( i = 1; i <= N_NORM; i++ ){
      t__norm[i]  +=  norm[i];
      p_norm[i]  +=  norm[i];
    }
    if( (t-1) % SVCUT  ==  0 ){
      for( i = 1; i <= Ns; i++ ){
        fprintf( FP_W, "%10.8lf %10.8lf ", (t-1)*dt, (double)(i-1)*dx );
        for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ )
          fprintf( FP_W, "%15.8E ", t_x[(i_VAR-1)*Ns+i] );
        for( j = 1; j <= N_NORM-1; j++ )
          fprintf( FP_W, "%15.8E ", norm[j] );
        fprintf( FP_W, "%15.8E\n", norm[j] );
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= N_NORM; i++ )
    t__norm[i]  /=  N_t;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  END:
  free_1i( point  );
  free_1d( x      );
  free_1d( t_x    );
  free_1d( norm   );
  free_1d( p_norm );
  if( c_EES  ==  EES_D )
  free_1d( F      );
  if( c_EES  ==  EES_D )
  free_1d( RS_EE  );
  free_2d( a      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Calculate_Norm( TEMP TP, double *t_x, double *norm )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, Ns;
  double dx;
  N_VAR  =  TP.N_VAR;
  Ns     =  TP.Ns;
  dx     =  TP.dx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  double p;
  double Soup_NR, L1_NR, L2_NR;
  double *EQ;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  EQ  =  malloc_1d( N_VAR+10 );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N_VAR+10; i++ )
    EQ[i]  =  0.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Soup_NR  =  fabs( t_x[1] );
  for( i = 2; i <= Ns; i++ )
    if( Soup_NR  <=  fabs( t_x[i] ) )
      Soup_NR  =  fabs( t_x[i] );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  p      =  1.0;
  L1_NR  =  0.0;
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    L1_NR  +=  (fabs(pow(t_x[(i_VAR-1)*Ns+1]-EQ[i_VAR],p))+fabs(pow(t_x[(i_VAR-1)*Ns+Ns]-EQ[i_VAR],p)))/2.0;
    for( i = 2; i <= Ns-1; i++ )
      L1_NR  +=  fabs(pow(t_x[(i_VAR-1)*Ns+i]-EQ[i_VAR],p));
  }
  L1_NR  =  pow( L1_NR*dx, 1.0/p );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  p      =  2.0;
  L2_NR  =  0.0;
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    L2_NR  +=  (fabs(pow(t_x[(i_VAR-1)*Ns+1]-EQ[i_VAR],p))+fabs(pow(t_x[(i_VAR-1)*Ns+Ns]-EQ[i_VAR],p)))/2.0;
    for( i = 2; i <= Ns-1; i++ )
      L2_NR  +=  fabs(pow(t_x[(i_VAR-1)*Ns+i]-EQ[i_VAR],p));
  }
  L2_NR  =  pow( L2_NR*dx, 1.0/p );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  norm[1]  =  Soup_NR;
  norm[2]  =  L1_NR;
  norm[3]  =  L2_NR;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( EQ );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
