/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
#include "constant.h"
#include "LIB/CLAPACK/blaswrap.h"
#include "LIB/CLAPACK/f2c.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
typedef logical (L_FP)( doublereal *, doublereal * );
logical SELECT( doublereal *WR, doublereal *WI );
logical SELECT( doublereal *WR, doublereal *WI ){   return( *WI == 0.0  ?  1 : 0 );    }
int dgees_(char *jobvs, char *sort, L_fp select, integer *n, 
           doublereal *a, integer *lda, integer *sdim, doublereal *wr, 
           doublereal *wi, doublereal *vs, integer *ldvs, doublereal *work, 
           integer *lwork, logical *bwork, integer *info);
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  subspace( TEMP *TP,  double *par, double *BC, double *x, double *EEx )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int           NM     =  TP->NM;
  int           NV     =  TP->NV;
  int           na     =  TP->na;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int           p      =  1;
  int           N_sub  =  10;
  double        ME_SI  =  1.0E-08;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int         * point  =  malloc_1i( NM+1      );
  double      **t_Ve   =  malloc_2d( NV   , p  );
  double      **t_W    =  malloc_2d( NV   , p  );
  double      **Ve     =  malloc_2d( NV+na, p  );
  double      **VeT    =  malloc_2d( p    , NV );
  double      **W      =  malloc_2d( NV   , p  );
  double      **S      =  malloc_2d( p    , p  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  L_FP          SELECT;
  integer       SDIM, INFO;
  char          JOBVS  =  'V';
  char          SORT   =  'S';
  integer       LN     =  (integer)p;
  integer       LDA    =  (integer)p;
  integer       LDVS   =  (integer)p;
  integer       LWORK  =  (integer)(3*p);
  logical     * BWORK  =  MALLOC_1LI( LN      );
  doublereal  * WR     =  MALLOC_1D ( LN      );
  doublereal  * WI     =  MALLOC_1D ( LN      );
  doublereal  * WORK   =  MALLOC_1D ( LWORK   );
  doublereal  * A      =  MALLOC_1D ( LDA*LN  );
  doublereal  * VS     =  MALLOC_1D ( LDVS*LN );
  double      **Y      =  malloc_2d ( LN, LN  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int           i, j, i_SI;
  double        diff_Ve_tVe;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Round_Off( TP->NM, TP->c_MP, *TP, point );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*fwrite_1d( "8b", NV, &x[NV+na]);*/
  for( i = 1; i <= NV; i++ )  W[i][p]  =  x[NV+na+i];
  for( i_SI = 1; i_SI <= N_sub; i_SI++ ){
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*printf("%d\n",i_SI);*/
/*    if( iteration == 0  &&  i_SI == 1 ){*/
/*      RANDOM2( NV, p, Ve );*/
/*    GrammSchmidt( NV, p, Ve, &i );*/
/*    }else{*/
      for( i = 1; i <= NV; i++ )
        for( j = 1; j <= p; j++ )
          Ve[i][j]  =  W[i][j];
/*    }*/
    for( j = 1; j <= p; j++ )
      for( i = NV+1; i <= NV+na; i++ )
        Ve[i][j]  =  0.0;
    GrammSchmidt( NV, p, Ve, &i );
    if( i == 1 ){   TP->CC = 9;  goto END;   }
    TimeIntegration( p, *TP, point, par, BC, x, EEx, Ve, W );
    TransposedMatrix( NV, p, Ve, VeT );
    MatrixProduct( p, NV, VeT, p, W, S );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( i = 1; i <= LN; i++ )
      for( j = 1; j <= LN; j++ )
        A[(j-1)*LN+i-1]  =  S[i][j];
/*    dgees_( &JOBVS, &SORT, SELECT, &LN, A, &LDA, &SDIM, WR, WI, VS, &LDVS, WORK, &LWORK, BWORK, &INFO ); */
    for( i = 1; i <= LN; i++ )  for( j = 1; j <= LN; j++ )  Y[i][j] = VS[(j-1)*LN+i-1];
    for( i = 1; i <= p ; i++ )  for( j = 1; j <= p ; j++ )  S[i][j] = A [(j-1)*p +i-1];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( i = 1; i <= NV; i++ ){
      for( j = 1; j <= p; j++ ){
       t_Ve[i][j]  =  Ve[i][j];
       t_W [i][j]  =  W [i][j];
      }
    }
    MatrixProduct( NV, p, t_Ve, p, Y, Ve );
    MatrixProduct( NV, p, t_W , p, Y, W  );
    diff_Ve_tVe  =  0.0;
    for( i = 1; i <= NV; i++ )
      for( j = 1; j <= p; j++ )
        diff_Ve_tVe  +=  fabs(Ve[i][j]-t_Ve[i][j]);
/*printf("%.15lf\n",diff_Ve_tVe);*/
/*    if( diff_Ve_tVe <= ME_SI )   break;*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  }
  GrammSchmidt( NV, p, W, &i );
  for( i = 1; i <= NV; i++ )   x[NV+na+i]  =  W[i][p];
/*  for( i = 1; i <= NV; i++ )   x[NV+na+i]  =  Ve[i][p];*/
/*double tmp;*/
/*L2norm( NV, &x[NV+na], &tmp );*/
/*printf("tmp==%.15lf\n",tmp);*/
/*fwrite_1d( "8a", NV, &x[NV+na]);*/
/*MPI_EXIT2();*/
  END:
  FREE_1LI( BWORK );
  FREE_1D ( WR    );
  FREE_1D ( WI    );
  FREE_1D ( WORK  );
  FREE_1D ( A     );
  FREE_1D ( VS    );
  free_2d ( Y     );
  free_2d ( t_Ve  );
  free_2d ( t_W   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( point );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
