/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"

/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Reaction( TEMP TP, double *par, double *x, double *F )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  int N = TP.N;
  for( i = 1; i <= N; i++ ){
    F[i  ]  =  (-par[4]*x[i]+x[i]*x[i]*x[i+N]) / par[3];
    F[i+N]  =  par[6]*(par[5]-x[i+N]) - x[i]*x[i]*x[i+N];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  PartialDiff_Function( TEMP TP, double *par, double *x, double **PDF )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  int N = TP.N;
  for( i = 1; i <= N; i++ ){
/*
    PDF[1][i  ]  =  (-par[4]+x[i+N]*exp(x[i]/(1.0+x[i]/par[5]))/((1.0+x[i]/par[5])*(1.0+x[i]/par[5])))/par[3];
    PDF[1][i+N]  =  exp(x[i]/(1.0+x[i]/par[5]))/par[3];
    PDF[2][i  ]  =  -x[i+N]*exp(x[i]/(1.0+x[i]/par[5]))/((1.0+x[i]/par[5])*(1.0+x[i]/par[5]));
    PDF[2][i+N]  =  -par[6]-exp(x[i]/(1.0+x[i]/par[5]));
*/
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  i_Diffusion( int *i_par )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*
  i_par[4 ]  =  1;
  i_par[13]  =  1;
*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Diffusion( TEMP TP, double *par )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  par[TP.N_EP+1]  =  (4.0*M_PI*M_PI*par[1]) / (par[7]*par[7]);
  par[TP.N_EP+2]  =  (4.0*M_PI*M_PI*par[2]) / (par[7]*par[7]);
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  PartialDiff_Function_Di( TEMP TP, double *par, double *parD )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*  if      ( TP.CP  ==  1 ){*/
/*    parD[1]  =  (4.0*M_PI*M_PI) / (       par[13]*par[13]);*/
/*    parD[2]  =  0.0;*/
/*    parD[3]  =  0.0;*/
/*  }else if( TP.CP  ==  2 ){*/
/*    parD[1]  =  0.0;*/
/*    parD[2]  =  (4.0*M_PI*M_PI) / (       par[13]*par[13]);*/
/*    parD[3]  =  0.0;*/
/*  }else if( TP.CP  ==  3 ){*/
/*    parD[1]  =  0.0;*/
/*    parD[2]  =  0.0;*/
/*    parD[3]  =  (4.0*M_PI*M_PI) / (par[4]*par[13]*par[13]);*/
/*  }else if( TP.CP  ==  4 ){*/
/*    parD[1]  =  0.0;*/
/*    parD[2]  =  0.0;*/
/*    parD[3]  =  - (4.0*M_PI*M_PI*par[3]) / (par[4]*par[4]*par[13]*par[13]);*/
/*  }else if( TP.CP  ==  13 ){*/
/*    parD[1]  =  - (8.0*M_PI*M_PI*par[1]) / (       par[13]*par[13]*par[13]);*/
/*    parD[2]  =  - (8.0*M_PI*M_PI*par[2]) / (       par[13]*par[13]*par[13]);*/
/*    parD[3]  =  - (8.0*M_PI*M_PI*par[3]) / (par[4]*par[13]*par[13]*par[13]);*/
/*  }*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
