/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include "read_write_file.h"
#include "function_declartion.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_InitialCommand( TEMP *TP, int *c_G )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  char *T1, *T2, *T3, *T4, *T5, *T6;
  FILE *GP1, *GP2, *GP3, *GP4, *GP5, *GP6;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  T1  =  MALLOC_1C( SIZE );
  T2  =  MALLOC_1C( SIZE );
  T3  =  MALLOC_1C( SIZE );
  T4  =  MALLOC_1C( SIZE );
  T5  =  MALLOC_1C( SIZE );
  T6  =  MALLOC_1C( SIZE );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  GP1  =  popen( "gnuplot -geometry 400x400+820+75  ", "w" );
  GP2  =  popen( "gnuplot -geometry 400x400+0+75    ", "w" );
  GP3  =  popen( "gnuplot -geometry 400x400+410+75  ", "w" );
  GP4  =  popen( "gnuplot -geometry 400x400+410+525 ", "w" );
  GP5  =  popen( "gnuplot -geometry 400x400+820+525 ", "w" );
  GP6  =  popen( "gnuplot -geometry 400x400+820+75  ", "w" );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fprintf( GP1, "unset key\n" );
  fprintf( GP2, "unset key\n" );
  fprintf( GP3, "unset key\n" );
  fprintf( GP4, "unset key\n" );
  fprintf( GP5, "unset key\n" );
  fprintf( GP6, "unset key\n" );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fprintf( GP1, "set xr[0.0:%lf]\n", TP->Lx );
  fprintf( GP2, "set xr[0.0:%lf]\n", TP->Lx );
  fprintf( GP3, "set xr[0.0:%lf]\n", TP->Lx );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fprintf( GP2, "set yr[-0.1:1.1]\n" );  
  fprintf( GP3, "set yr[-0.1:1.1]\n" );  
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  sprintf( T1 , "\"1 Initial Data\\n\"" );
  sprintf( T2 , "\"2 Solution U and V\\n\"" );
  sprintf( T3 , "\"3 Solution U\\n\"" );
  sprintf( T4 , "\"4 X : Time\\n Y : | F_dis - T_dis |\"" );
  sprintf( T5 , "\"5 X : Time\\n Y : velocity\"" );
  sprintf( T6 , "\"6 X : Time\\n Y\"" );
  fprintf( GP1, "set title %s\n", T1 );
  fprintf( GP2, "set title %s\n", T2 );
  fprintf( GP3, "set title %s\n", T3 );
  fprintf( GP4, "set title %s\n", T4 );
  fprintf( GP5, "set title %s\n", T5 );
  fprintf( GP6, "set title %s\n", T6 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( c_G[1]  ==  1 ){  Gnuplot_DrawCommand( *TP, GP1, 1 );  fflush( GP1 );  }
  if( c_G[2]  ==  1 ){  Gnuplot_DrawCommand( *TP, GP2, 2 );  fflush( GP2 );  }
  if( c_G[3]  ==  1 ){  Gnuplot_DrawCommand( *TP, GP3, 3 );  fflush( GP3 );  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  TP->GP1  =  GP1;
  TP->GP2  =  GP2;
  TP->GP3  =  GP3;
  TP->GP4  =  GP4;
  TP->GP5  =  GP5;
  TP->GP6  =  GP6;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1C( T1 );
  FREE_1C( T2 );
  FREE_1C( T3 );
  FREE_1C( T4 );
  FREE_1C( T5 );
  FREE_1C( T6 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_Draw( TEMP TP, int *c_G )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( c_G[2]  ==  1 ){  Gnuplot_DrawCommand( TP, TP.GP2, 2 );  fflush( TP.GP2 );  }
  if( c_G[3]  ==  1 ){  Gnuplot_DrawCommand( TP, TP.GP3, 3 );  fflush( TP.GP3 );  }
  if( c_G[6]  ==  1 ){  Gnuplot_DrawCommand( TP, TP.GP6, 6 );  fflush( TP.GP6 );  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( 3  <=  TP.N_Vel ){
    if( c_G[4]  ==  1 ){  Gnuplot_DrawCommand( TP, TP.GP4, 4 );  fflush( TP.GP4 );  }
    if( c_G[5]  ==  1 ){  Gnuplot_DrawCommand( TP, TP.GP5, 5 );  fflush( TP.GP5 );  }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_Close( TEMP *TP )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  pclose( TP->GP1 );
  pclose( TP->GP2 );
  pclose( TP->GP3 );
  pclose( TP->GP4 );
  pclose( TP->GP5 );
  pclose( TP->GP6 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Gnuplot_DrawCommand( TEMP TP, FILE *GP, int SELECT )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  char *G1, *G2, *G3, *G4;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  G1  =  MALLOC_1C( SIZE );
  G2  =  MALLOC_1C( SIZE );
  G3  =  MALLOC_1C( SIZE );
  G4  =  MALLOC_1C( SIZE );
  sprintf( G1, "%s", (char *)Gi_SOLUTION_VALUE                 );
  sprintf( G2, "%s", (char *)Gw_SOLUTION_VALUE                 );
  sprintf( G3, "%s", (char *)WRITE_STEP_TIME_DX_SVPU_SVPV      );
  sprintf( G4, "%s", (char *)WRITE_STEP_TIME_DIFF_DIS_VEL_AVEL );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  switch( SELECT ){
    case 1:
      if( TP.N_VAR  ==  2 )
        fprintf( GP, "plot '%s' u 1:2 w l lw 2.0 lt 1,\
                           ''   u 1:3 w l lw 2.0 lt 3\n", G1 );
      else if( TP.N_VAR  ==  3 )
        fprintf( GP, "plot '%s' u 1:2 w l lw 2.0 lt 1,\
                           ''   u 1:3 w l lw 2.0 lt 3,\
                           ''   u 1:4 w l lw 2.0 lt 2\n", G1 );
      break;
    case 2:
      if( TP.N_VAR  ==  2 )
        fprintf( GP, "plot '%s' u 1:2 w l lw 2.0 lt 1,\
                           ''   u 1:3 w l lw 2.0 lt 3\n", G2 );
      else if( TP.N_VAR  ==  3 )
        fprintf( GP, "plot '%s' u 1:2 w l lw 2.0 lt 1,\
                           ''   u 1:3 w l lw 2.0 lt 3,\
                           ''   u 1:4 w l lw 2.0 lt 2\n", G2 );
      break;
    case 3:
      fprintf( GP, "plot '%s' u 1:2 w l lw 2.0 lt 1\n", G2 );
      break;
    case 4:
      fprintf( GP, "plot '%s' u 2:3 pt 7 ps 2.0 lt 1\n", G4 );
      break;
    case 5:
      fprintf( GP, "plot '%s' u 1:5 pt 7 ps 2.0 lt 1,\
                         ''   u 1:6 pt 7 ps 2.0 lt 3\n", G4 );
      break;
    case 6:
      fprintf( GP, "plot '%s' u 2:3 pt 7 ps 2.0 lt 1\n", G3 );
      break;
    default :
      printf( "\nGnuplot-Diagram Select-ArguMent Misstake !!\n" );
      exit(1);
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1C( G1 );
  FREE_1C( G2 );
  FREE_1C( G3 );
  FREE_1C( G4 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
