/*-------------------------------------------------------------------------------*/
void  LU_Decomposition_1n3pC( int N, double **a, double **L, double **U )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  double sum;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  L[1][1]  =  a[1][1];
  U[1][1]  =  a[1][2] / L[1][1];
  U[2][1]  =  a[1][N] / L[1][1];
  for( i = 2; i <= N-2; i++ ){
    L[2][i]  =  a[i][i-1];
    L[1][i]  =  a[i][i] - U[1][i-1]*L[2][i];
    U[1][i]  =  a[i][i+1] / L[1][i];
    U[2][i]  =  - L[2][i] * U[2][i-1] / L[1][i];
  }
  i        =  N-1;
  L[2][i]  =  a[i][i-1];
  L[1][i]  =  a[i][i] - U[1][i-1]*L[2][i];
  U[2][i]  =  ( a[i][i+1]-L[2][i]*U[2][i-1] ) / L[1][i];
  L[3][1]  =  a[N][1];            
  for( i = 2; i <= N-2; i++ )
    L[3][i]  =  - U[1][i-1] * L[3][i-1];
  i = N-1;
  L[3][i] = a[i+1][i] - U[1][i-1] * L[3][i-1];   
  sum  =  0.0;
  for( i = 1; i <= N-1; i++ )
    sum  +=  L[3][i] * U[2][i];
  L[3][N]  =  a[N][N] - sum;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
