/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "function_declartion.h"
#include "constant.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#ifdef  DELTA_DX
#else
  #define  DELTA_DX 1.0E-08
#endif
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  PartialDiff_Function_FP( int N_EP, int N, int CP, double *par, double *x, double *PDF )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  double *par_del, *func, *func_del;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  par_del   =  alloc_1d_double( N_EP+1 );
  func      =  alloc_1d_double( N+1    );
  func_del  =  alloc_1d_double( N+1    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double delta=(double)DELTA_DX;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( CP == 1  ||  CP == 2 )
    for( i = 1; i <= N; i++ )
      PDF[i]  =  0.0;
  else{
    for( i = 1; i <= N_EP; i++ )
      par_del[i]  =  par[i];
    par_del[CP]  +=  delta;
    F_Function( N, par_del, x, func_del );
    F_Function( N, par    , x, func     );
    for( i = 1; i <= N; i++ )
      PDF[i]  =  ( func_del[i] - func[i] ) / delta;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_double( par_del  );
  free_1d_double( func_del );
  free_1d_double( func     );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  PartialDiff_Function_GP( int N_EP, int N, int CP, double *par, double *x, double *PDF )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  double *par_del, *func, *func_del;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  par_del   =  alloc_1d_double( N_EP+1 );
  func      =  alloc_1d_double( N+1    );
  func_del  =  alloc_1d_double( N+1    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double delta=(double)DELTA_DX;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( CP == 1  ||  CP == 2 )
    for( i = 1; i <= N; i++ )
      PDF[i]  =  0.0;
  else{
    for( i = 1; i <= N_EP; i++ )
      par_del[i]  =  par[i];
    par_del[CP]  +=  delta;
    G_Function( N, par_del, x, func_del );
    G_Function( N, par    , x, func     );
    for( i = 1; i <= N; i++ )
      PDF[i]  =  ( func_del[i] - func[i] ) / delta;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_double( par_del  );
  free_1d_double( func     );
  free_1d_double( func_del );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  PartialDiff_Function_FU( int N, int Nm, double *par, double *x, double *PDF )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  double *x_del, *func, *func_del;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x_del     =  alloc_1d_double( Nm+1 );
  func      =  alloc_1d_double( N+1  );
  func_del  =  alloc_1d_double( N+1  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double delta=(double)DELTA_DX;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N; i++ ){
    x_del[i  ]  =  x[i  ] + delta;
    x_del[i+N]  =  x[i+N];
  }
  F_Function( N, par, x_del, func_del );
  F_Function( N, par, x    , func     );
  for( i = 1; i <= N; i++ )
    PDF[i]  =  ( func_del[i] - func[i] ) / delta;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_double( x_del    );
  free_1d_double( func     );
  free_1d_double( func_del );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  PartialDiff_Function_FV( int N, int Nm, double *par, double *x, double *PDF )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  double *x_del, *func, *func_del;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x_del     =  alloc_1d_double( Nm+1 );
  func      =  alloc_1d_double( N+1  );
  func_del  =  alloc_1d_double( N+1  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double delta=(double)DELTA_DX;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N; i++ ){
    x_del[i  ]  =  x[i  ];
    x_del[i+N]  =  x[i+N] + delta;
  }
  F_Function( N, par, x_del, func_del );
  F_Function( N, par, x    , func     );
  for( i = 1; i <= N; i++ )
    PDF[i]  =  ( func_del[i] - func[i] ) / delta;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_double( x_del    );
  free_1d_double( func     );
  free_1d_double( func_del );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  PartialDiff_Function_GU( int N, int Nm, double *par, double *x, double *PDF )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  double *x_del, *func, *func_del;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x_del     =  alloc_1d_double( Nm+1 );
  func      =  alloc_1d_double( N+1  );
  func_del  =  alloc_1d_double( N+1  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double delta=(double)DELTA_DX;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N; i++ ){
    x_del[i  ]  =  x[i  ] + delta;
    x_del[i+N]  =  x[i+N];
  }
  G_Function( N, par, x_del, func_del );
  G_Function( N, par, x    , func     );
  for( i = 1; i <= N; i++ )
    PDF[i]  =  ( func_del[i] - func[i] ) / delta;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_double( x_del    );
  free_1d_double( func     );
  free_1d_double( func_del );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  PartialDiff_Function_GV( int N, int Nm, double *par, double *x, double *PDF )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  double *x_del, *func, *func_del;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x_del     =  alloc_1d_double( Nm+1 );
  func      =  alloc_1d_double( N+1  );
  func_del  =  alloc_1d_double( N+1  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double delta=(double)DELTA_DX;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N; i++ ){
    x_del[i  ]  =  x[i  ];
    x_del[i+N]  =  x[i+N] + delta;
  }
  G_Function( N, par, x_del, func_del );
  G_Function( N, par, x    , func     );
  for( i = 1; i <= N; i++ )
    PDF[i]  =  ( func_del[i] - func[i] ) / delta;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_double( x_del    );
  free_1d_double( func     );
  free_1d_double( func_del );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
