/*-------------------------------------------------------------------------------*/
#include <math.h>
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  Sort_NearZeroEV( int Nm, double *REV, double *IEV )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, j;
  double x1, x2;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= Nm; i++ ){
    for( j = i+1; j <= Nm; j++ ){
      if( fabs(REV[i])  >  fabs(REV[j]) ){
        x1      =  REV[j];
        x2      =  IEV[j];
        REV[j]  =  REV[i];
        IEV[j]  =  IEV[i];
        REV[i]  =  x1;
        IEV[i]  =  x2;
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  Sort_AscendingSequence( int Nm, double *REV, double *IEV )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, j;
  double x1, x2;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= Nm; i++ ){
    for( j = i+1; j <= Nm; j++ ){
      if( REV[i]  <  REV[j] ){
        x1      =  REV[j];
        x2      =  IEV[j];
        REV[j]  =  REV[i];
        IEV[j]  =  IEV[i];
        REV[i]  =  x1;
        IEV[i]  =  x2;
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  Sort_NearOneEV( int Nm, double *REV, double *IEV )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, j;
  double x1, x2;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= Nm; i++ ){
    for( j = i+1; j <= Nm; j++ ){
      if(  fabs(1.0-sqrt(REV[i]*REV[i]+IEV[i]*IEV[i]))  >  fabs(1.0-sqrt(REV[j]*REV[j]+IEV[j]*IEV[j]))  ){
        x1      =  REV[j];
        x2      =  IEV[j];
        REV[j]  =  REV[i];
        IEV[j]  =  IEV[i];
        REV[i]  =  x1;
        IEV[i]  =  x2;
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  Sort_AscendingSequence_RIEV( int Nm, double *REV, double *IEV )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, j;
  double x1, x2;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= Nm; i++ ){
    for( j = i+1; j <= Nm; j++ ){
      if(  sqrt(REV[i]*REV[i]+IEV[i]*IEV[i])  <  sqrt(REV[j]*REV[j]+IEV[j]*IEV[j])  ){
        x1      =  REV[j];
        x2      =  IEV[j];
        REV[j]  =  REV[i];
        IEV[j]  =  IEV[i];
        REV[i]  =  x1;
        IEV[i]  =  x2;
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
