/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  N_SPLIT( char *Split_Character, char *Split_Target, int *N_Split_Target )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  char *Split_Part;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  Split_Part  =  strtok(Split_Target,Split_Character);
  *N_Split_Target  =  0;
  while( Split_Part  !=  NULL ){
    Split_Part  =  strtok(NULL,Split_Character);
    (*N_Split_Target) ++;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  SPLIT( int N_Split          , int NMax_Split    , \
             char *Split_Character, char *Split_Target, char **data )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  if( N_Split  ==  0 ){
    for( i = 1; i <= NMax_Split; i++ )
      data[i]  =  "";
    return;
  }
  strcpy( data[1], strtok(Split_Target,Split_Character) );
  for( i = 2; i <= N_Split; i++ )
    strcpy( data[i], strtok(NULL,Split_Character) );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  SPLIT_READ_DATA( int N_Data, FILE *fp, double *data )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N_Data; i++ )
    fscanf( fp, "%lf", &data[i] );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  SPLIT_WRITE_DATA( int N_Data       , FILE   *fp  , \
                        int *DeletingData, double *data, char **SubData )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N_Data; i++ ){
    if( DeletingData[i]  ==  0 )
      fprintf( fp, "%20.15E%s", data[i], SubData[i] ); 
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  SPLIT_WRITE_GNUPLOT
      ( FILE *fp      , int step      ,double data_DP, \
        char *EchoName, char *FileName, int N_SC12   , \
        char *C10     , char **C11    , char **C12   , char **C13, char **C14, \
        char *C2   )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  fprintf( fp, "! echo -n '  %s  =  %d : %lf'\n", EchoName, step, data_DP );
  fprintf( fp, "%s ", C10 );
  for( i = 1; i <= N_SC12; i++ )
    fprintf( fp, "%s '%s' %s %s %s", C11[i], FileName, C12[i], C13[i], C14[i] );
  fprintf( fp, "%s", C2 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  SPLIT_WRITE_PRINT  
      ( FILE *fp , char *FNData, char *FNLpr, char *lpr , char *PostScript, \
        int N_SC0, int N_SC12  , \
        char **C0, char *C10   , char **C11 , char **C12, char **C13, char **C14 )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N_SC0; i++ )
    fprintf( fp, "%s\n", C0[i] );
  fprintf( fp, "%s ", C10 );
  for( i = 1; i <= N_SC12; i++ )
    fprintf( fp, "%s '%s' %s %s %s", C11[i], FNData, C12[i], C13[i], C14[i] );
/*  fprintf( fp, "pause -1 \"Hit Ritturn Key !!\"\n"                  );
*/
/*  fprintf( fp, "unset key                      \n"                  );*/
  fprintf( fp, "set term postscript %s %s      \n", lpr, PostScript );
  fprintf( fp, "set output '%s\\.eps'           \n", FNLpr           );
  fprintf( fp, "replot                         \n"                  );
  fprintf( fp, "set term x11                   \n"                  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
