/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "StructType_Definition.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  Generate_OPEP( TEMP TP, double *par, double *BC, double *SOP, double *EP )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= TP.NM*TP.N_VAR*TP.Ns+TP.NA; i++ ){
     SOP[i]  =  0.0;
     EP[i]   =  0.0;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SOP[L_SOP_N]      =  TP.Ns - 1;
  SOP[L_SOP_N_EP]   =  TP.N_EP;
  SOP[L_SOP_Lx]     =  TP.Lx;
  SOP[L_SOP_dt]     =  TP.dt;
  SOP[L_SOP_NM]     =  TP.NM;
  SOP[L_SOP_N_VAR]  =  TP.N_VAR;
  SOP[L_REV_i_E]    =  TP.REV_i_E;
  for( i = 1; i <= 2*TP.N_VAR; i++ )
    SOP[i+L_SOP_N_VAR]  =  BC[i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= TP.N_EP; i++ )
    EP[i]  =  par[i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  Generate_SV( TEMP TP, double *BC, double *xx, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, ii, i_NM, i_xx, i_VAR, NVx, NVxx;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i_NM = 1; i_NM <= TP.NM; i_NM++ ){
    NVx   =  (i_NM-1)*TP.NV;
    NVxx  =  (i_NM-1)*TP.N_VAR*TP.Ns;
    ii    =  1;
    if( TP.BCS  ==  BCS_1 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        ii++;
        for( i = (i_VAR-1)*TP.N+1; i <= i_VAR*TP.N; i++, ii++ )
          x[NVx+i]  =  xx[NVxx+ii];
        ii++;
      }
    }else if( TP.BCS  ==  BCS_2 ){
      for( i = 1; i <= TP.N_VAR*TP.N; i++ )
        x[i+NVx]  =  xx[i+NVxx];
    }else if( TP.BCS  ==  BCS_3 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        for( i = (i_VAR-1)*TP.N+1; i <= i_VAR*TP.N; i++, ii++ )
          x[NVx+i]  =  xx[NVxx+ii];
        ii++;
      }
    }else if( TP.BCS  ==  BCS_4 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        ii++;
        for( i = (i_VAR-1)*TP.N+1; i <= i_VAR*TP.N; i++, ii++ )
          x[NVx+i]  =  xx[NVxx+ii];
      }
    }
  }
  for( i = 1; i <= TP.NA; i++ )
    x[TP.NM*TP.NV+i]  =  xx[TP.NM*TP.N_VAR*TP.Ns+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------------*/
void  Generate_tSV( TEMP TP, double *BC, double *x, double *xx )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, ii, i_VAR, i_BC, i_NM, NVx, NVxx;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i_NM = 1; i_NM <= TP.NM; i_NM++ ){
    NVx   =  (i_NM-1)*TP.NV;
    NVxx  =  (i_NM-1)*TP.N_VAR*TP.Ns;
    i_BC  =  1;
    i     =  1;
    if( TP.BCS  ==  BCS_1 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        xx[NVxx+(i_VAR-1)*TP.Ns+1]  =  BC[i_BC++];
        for( ii = (i_VAR-1)*TP.Ns+2; ii <= i_VAR*TP.Ns-1; ii++, i++ )
          xx[NVxx+ii]  =  x[NVx+i];
        xx[NVxx+i_VAR*TP.Ns]  =  BC[i_BC++];
      }
    }else if( TP.BCS  ==  BCS_2 ){
      for( ii = 1; ii <= TP.N_VAR*TP.Ns; ii++ )
        xx[NVxx+ii]  =  x[NVx+ii];
    }else if( TP.BCS  ==  BCS_3 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        for( ii = (i_VAR-1)*TP.Ns+1; ii <= i_VAR*TP.Ns-1; ii++, i++ )
          xx[NVxx+ii]  =  x[NVx+i];
        xx[NVxx+i_VAR*TP.Ns]  =  x[NVx+i-TP.N];
      }
    }else if( TP.BCS  ==  BCS_4 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        xx[NVxx+(i_VAR-1)*TP.Ns+1]  =  BC[i_BC]; 
        i_BC  +=  2;
        for( ii = (i_VAR-1)*TP.Ns+2; ii <= i_VAR*TP.Ns; ii++, i++ )
          xx[NVxx+ii]  =  x[NVx+i];
      }
    }
  }
  for( ii = 1; ii <= TP.NA; ii++ )
    xx[TP.NM*TP.N_VAR*TP.Ns+ii]  =  x[TP.NM*TP.NV+ii];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Generate_BC_Space( TEMP TP, double *BC, double *x, double *BCX )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N, BCS;
  double dx;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  BCS    =  TP.BCS;
  dx     =  TP.dx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i_VAR;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  if( BCS  ==  BCS_1 ){
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      BCX[(i_VAR-1)*2+1]  =  BC[(i_VAR-1)*2+1];
      BCX[(i_VAR-1)*2+2]  =  BC[(i_VAR-1)*2+2];
    }
  }else if( BCS  ==  BCS_2 ){
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      BCX[(i_VAR-1)*2+1]  =  x[(i_VAR-1)*N+2  ] - 2.0 * BC[(i_VAR-1)*2+1] * dx;
      BCX[(i_VAR-1)*2+2]  =  x[(i_VAR-1)*N+N-1] + 2.0 * BC[(i_VAR-1)*2+2] * dx;
    }
  }else if( BCS  ==  BCS_3 ){
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      BCX[(i_VAR-1)*2+1]  =  x[(i_VAR-1)*N+N];
      BCX[(i_VAR-1)*2+2]  =  x[(i_VAR-1)*N+1];
    }
  }else if( BCS  ==  BCS_4 ){
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      BCX[(i_VAR-1)*2+1]  =  BC[(i_VAR-1)*2+1];
      BCX[(i_VAR-1)*2+2]  =  x[(i_VAR-1)*N+N-1] + 2.0 * BC[(i_VAR-1)*2+2] * dx;
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Generate_SV_tNM( TEMP TP, double *BC, double *xx, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, ii, i_NM, i_xx, i_VAR, NVx, NVxx;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i_NM = 1; i_NM <= TP.tNM; i_NM++ ){
    NVx   =  (i_NM-1)*TP.NV;
    NVxx  =  (i_NM-1)*TP.N_VAR*TP.Ns;
    ii    =  1;
    if( TP.BCS  ==  BCS_1 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        ii++;
        for( i = (i_VAR-1)*TP.N+1; i <= i_VAR*TP.N; i++, ii++ )
          x[NVx+i]  =  xx[NVxx+ii];
        ii++;
      }
    }else if( TP.BCS  ==  BCS_2 ){
      for( i = 1; i <= TP.N_VAR*TP.N; i++ )
        x[i+NVx]  =  xx[i+NVxx];
    }else if( TP.BCS  ==  BCS_3 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        for( i = (i_VAR-1)*TP.N+1; i <= i_VAR*TP.N; i++, ii++ )
          x[NVx+i]  =  xx[NVxx+ii];
        ii++;
      }
    }else if( TP.BCS  ==  BCS_4 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        ii++;
        for( i = (i_VAR-1)*TP.N+1; i <= i_VAR*TP.N; i++, ii++ )
          x[NVx+i]  =  xx[NVxx+ii];
      }
    }
  }
  for( i = 1; i <= TP.NA; i++ )
    x[TP.tNM*TP.NV+i]  =  xx[TP.tNM*TP.N_VAR*TP.Ns+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Generate_tSV_tNM( TEMP TP, double *BC, double *x, double *xx )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, ii, i_VAR, i_BC, i_NM, NVx, NVxx;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i_NM = 1; i_NM <= TP.tNM; i_NM++ ){
    NVx   =  (i_NM-1)*TP.NV;
    NVxx  =  (i_NM-1)*TP.N_VAR*TP.Ns;
    i_BC  =  1;
    i     =  1;
    if( TP.BCS  ==  BCS_1 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        xx[NVxx+(i_VAR-1)*TP.Ns+1]  =  BC[i_BC++];
        for( ii = (i_VAR-1)*TP.Ns+2; ii <= i_VAR*TP.Ns-1; ii++, i++ )
          xx[NVxx+ii]  =  x[NVx+i];
        xx[NVxx+i_VAR*TP.Ns]  =  BC[i_BC++];
      }
    }else if( TP.BCS  ==  BCS_2 ){
      for( ii = 1; ii <= TP.N_VAR*TP.Ns; ii++ )
        xx[NVxx+ii]  =  x[NVx+ii];
    }else if( TP.BCS  ==  BCS_3 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        for( ii = (i_VAR-1)*TP.Ns+1; ii <= i_VAR*TP.Ns-1; ii++, i++ )
          xx[NVxx+ii]  =  x[NVx+i];
        xx[NVxx+i_VAR*TP.Ns]  =  x[NVx+i-TP.N];
      }
    }else if( TP.BCS  ==  BCS_4 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        xx[NVxx+(i_VAR-1)*TP.Ns+1]  =  BC[i_BC]; 
        i_BC  +=  2;
        for( ii = (i_VAR-1)*TP.Ns+2; ii <= i_VAR*TP.Ns; ii++, i++ )
          xx[NVxx+ii]  =  x[NVx+i];
      }
    }
  }
  for( ii = 1; ii <= TP.NA; ii++ )
    xx[TP.tNM*TP.N_VAR*TP.Ns+ii]  =  x[TP.tNM*TP.NV+ii];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Generate_SV_NM1( TEMP TP, double *BC, double *xx, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, ii, i_NM, i_xx, i_VAR, NVx, NVxx;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i_NM = 1; i_NM <= 1; i_NM++ ){
    NVx   =  (i_NM-1)*TP.NV;
    NVxx  =  (i_NM-1)*TP.N_VAR*TP.Ns;
    ii    =  1;
    if( TP.BCS  ==  BCS_1 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        ii++;
        for( i = (i_VAR-1)*TP.N+1; i <= i_VAR*TP.N; i++, ii++ )
          x[NVx+i]  =  xx[NVxx+ii];
        ii++;
      }
    }else if( TP.BCS  ==  BCS_2 ){
      for( i = 1; i <= TP.N_VAR*TP.N; i++ )
        x[i+NVx]  =  xx[i+NVxx];
    }else if( TP.BCS  ==  BCS_3 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        for( i = (i_VAR-1)*TP.N+1; i <= i_VAR*TP.N; i++, ii++ )
          x[NVx+i]  =  xx[NVxx+ii];
        ii++;
      }
    }else if( TP.BCS  ==  BCS_4 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        ii++;
        for( i = (i_VAR-1)*TP.N+1; i <= i_VAR*TP.N; i++, ii++ )
          x[NVx+i]  =  xx[NVxx+ii];
      }
    }
  }
  for( i = 1; i <= TP.NA; i++ )
    x[TP.NV+i]  =  xx[TP.tNM*TP.N_VAR*TP.Ns+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Generate_tSV_NM1( TEMP TP, double *BC, double *x, double *xx )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, ii, i_VAR, i_BC, i_NM, NVx, NVxx;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i_NM = 1; i_NM <= 1; i_NM++ ){
    NVx   =  (i_NM-1)*TP.NV;
    NVxx  =  (i_NM-1)*TP.N_VAR*TP.Ns;
    i_BC  =  1;
    i     =  1;
    if( TP.BCS  ==  BCS_1 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        xx[NVxx+(i_VAR-1)*TP.Ns+1]  =  BC[i_BC++];
        for( ii = (i_VAR-1)*TP.Ns+2; ii <= i_VAR*TP.Ns-1; ii++, i++ )
          xx[NVxx+ii]  =  x[NVx+i];
        xx[NVxx+i_VAR*TP.Ns]  =  BC[i_BC++];
      }
    }else if( TP.BCS  ==  BCS_2 ){
      for( ii = 1; ii <= TP.N_VAR*TP.Ns; ii++ )
        xx[NVxx+ii]  =  x[NVx+ii];
    }else if( TP.BCS  ==  BCS_3 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        for( ii = (i_VAR-1)*TP.Ns+1; ii <= i_VAR*TP.Ns-1; ii++, i++ )
          xx[NVxx+ii]  =  x[NVx+i];
        xx[NVxx+i_VAR*TP.Ns]  =  x[NVx+i-TP.N];
      }
    }else if( TP.BCS  ==  BCS_4 ){
      for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
        xx[NVxx+(i_VAR-1)*TP.Ns+1]  =  BC[i_BC]; 
        i_BC  +=  2;
        for( ii = (i_VAR-1)*TP.Ns+2; ii <= i_VAR*TP.Ns; ii++, i++ )
          xx[NVxx+ii]  =  x[NVx+i];
      }
    }
  }
  for( ii = 1; ii <= TP.NA; ii++ )
    xx[TP.N_VAR*TP.Ns+ii]  =  x[TP.tNM*TP.NV+ii];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
