/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "StructType_Definition.h"
#include "function_declartion.h"
#include "constant.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Reaction( TEMP TP, double *par, double *x, double *F );
void  Diffusion( TEMP TP, double *par );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  PartialDiff_Function_FU_AUTO( TEMP TP, double *par, double *x, double *F, double **PDF )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR, ii_VAR;
  double *x_del, *F_del;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x_del  =  malloc_1d( TP.NV );
  F_del  =  malloc_1d( TP.NV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double delta=(double)DELTA_DX;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
    for( i = 1; i <= TP.NV; i++ )
      x_del[i]  =  x[i];
    for( i = 1; i <= TP.N; i++ )
      x_del[(i_VAR-1)*TP.N+i]  +=  delta;
    Reaction( TP, par, x_del, F_del );
    for( ii_VAR = 1; ii_VAR <= TP.N_VAR; ii_VAR++ )
      for( i = 1; i <= TP.N; i++ )
        PDF[ii_VAR][(i_VAR-1)*TP.N+i]  =  ( F_del[(ii_VAR-1)*TP.N+i] - F[(ii_VAR-1)*TP.N+i] ) / delta;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( x_del );
  free_1d( F_del );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  PartialDiff_Function_FP_AUTO( TEMP TP, double *par, double *x, double *F, double **PDF )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  double *par_del, *F_del;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  par_del  =  malloc_1d( TP.NV );
  F_del    =  malloc_1d( TP.NV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double delta=(double)DELTA_DX;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= TP.N_EP; i++ )
    par_del[i]  =  par[i];
  par_del[TP.CP]  +=  delta;
  Reaction( TP, par_del, x, F_del );
  for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ )
    for( i = 1; i <= TP.N; i++ )
      PDF[i_VAR][TP.NV+i]  =  ( F_del[(i_VAR-1)*TP.N+i] - F[(i_VAR-1)*TP.N+i] ) / delta;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( par_del );
  free_1d( F_del   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  PartialDiff_Function_Di_AUTO( TEMP TP, double *par, double *parD )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  double *par_del;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  par_del  =  malloc_1d( TP.N_EP+TP.N_VAR );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double delta=(double)DELTA_DX;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= TP.N_EP; i++ )
    par_del[i]  =  par[i];
  par_del[TP.CP]  +=  delta;
  Diffusion( TP, par_del );
  for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ )
    parD[i_VAR]  =  ( par_del[TP.N_EP+i_VAR] - par[TP.N_EP+i_VAR] ) / delta;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( par_del );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
