/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "StructType_Definition.h"
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  LU_Decomposition_EE( TEMP TP, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, Vi, i_VAR;
  double sum;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( TP.BCS == 1  ||  TP.BCS == 2  ||  TP.BCS == 4 ){
    for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
      Vi  =  (i_VAR-1)*TP.N;
      for( i = 1+Vi; i <= TP.N-1+Vi; i++ ){
        a[3][i  ]  =  a[3][i] / a[1][i];
        a[1][i+1]  =  a[1][i+1] - a[3][i] * a[2][i+1];
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  else if( TP.BCS  ==  3 ){
    for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
      Vi  =  (i_VAR-1)*TP.N;
      a[3][1+Vi]  =  a[3][1+Vi] / a[1][1+Vi];
      a[5][1+Vi]  =  a[5][1+Vi] / a[1][1+Vi];
      for( i = 2+Vi; i <= TP.N-2+Vi; i++ ){
        a[1][i]  =  a[1][i] - a[3][i-1]*a[2][i];
        a[3][i]  =  a[3][i] / a[1][i];
        a[5][i]  =  - a[2][i] * a[5][i-1] / a[1][i];
      }
      i        =  TP.N-1+Vi;
      a[1][i]  =  a[1][i] - a[3][i-1]*a[2][i];
      a[5][i]  =  ( a[3][i]-a[2][i]*a[5][i-1] ) / a[1][i];
      for( i = 2+Vi; i <= TP.N-2+Vi; i++ )
        a[4][i]  =  - a[3][i-1] * a[4][i-1];
      i = TP.N-1+Vi;
      a[4][i] = a[2][TP.N+Vi] - a[3][i-1] * a[4][i-1];   
      sum  =  0.0;
      for( i = 1+Vi; i <= TP.N-1+Vi; i++ )
        sum  +=  a[4][i] * a[5][i];
      a[4][TP.N+Vi]  =  a[1][TP.N+Vi] - sum;
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Calculate_Solution_EE( TEMP TP, double *RS, double **a, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, Vi, i_VAR;
  double sum;
  double *z;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  z  =  malloc_1d( TP.N );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( TP.BCS == 1  ||  TP.BCS == 2   ||  TP.BCS == 4 ){
    for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
      Vi  =  (i_VAR-1)*TP.N;
      z[1]  =  RS[1+Vi] / a[1][1+Vi];
      for( i = 2+Vi; i <= TP.N+Vi; i++ )
        z[i-Vi]  =  ( RS[i] - a[2][i] * z[i-1-Vi] ) / a[1][i];
      x[TP.N+Vi]  =  z[TP.N];
      for( i = TP.N-1+Vi; i >= 1+Vi; i-- )
        x[i]  =  z[i-Vi] - a[3][i] * x[i+1];
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  else if( TP.BCS  ==  3 ){
    for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
      Vi  =  (i_VAR-1)*TP.N;
      z[1]  =  RS[1+Vi] / a[1][1+Vi];
      for( i = 2+Vi; i <= TP.N-1+Vi; i++ )
        z[i-Vi]  =  ( RS[i]-a[2][i]*z[i-1-Vi] ) / a[1][i];
      sum  =  0.0;
      for( i = 1+Vi; i <= TP.N-1+Vi; i++ )
        sum  +=  a[4][i]*z[i-Vi];
      i        =  TP.N + Vi;
      z[i-Vi]  =  ( RS[i]-sum ) / a[4][i];
      x[i   ]  =  z[i-Vi];
      x[i-1 ]  =  z[i-1-Vi]-a[5][i-1]*x[i];
      for( i = TP.N-2+Vi; i >= 1+Vi; i-- )
        x[i]  =  z[i-Vi] - a[3][i] * x[i+1] - a[5][i] * x[TP.N+Vi];
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( z );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  LU_Decomposition_F( int N, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int     i, j, k;
  double  p, q;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( k = 1; k <= N-1; k++ ){
    p  =  a[k][k];
    for( j = k+1; j <= N; j++ )
      a[k][j]  /=  p;
    for( i = k+1; i <= N; i++ ){
      q  =  a[i][k];
      for( j = k+1; j <= N; j++ )
        a[i][j]  -=  q * a[k][j];
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Calculate_Solution_F( int N, double *RS, double **a, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, k;
  double s;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( k = 1; k <= N-1; k++ ){
    RS[k]  /=  a[k][k];
    for( i = k+1; i <= N; i++ )
      RS[i]  -=  a[i][k] * RS[k];
  }
  x[N]  =  RS[N] / a[N][N];
  for( k = N-1; k >= 1; k-- ){
    s  =  RS[k];
    for( j = k+1; j <= N; j++ )
      s  -=  a[k][j] * x[j];
    x[k]  =  s;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
