/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  EM_SM( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  int    *SCT;
  double T, VEL, d, DT1, VDT1;
  double *td, *wx, *wx1, *wF, *F;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wx1  =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  F    =  malloc_1d( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T   = TP.T;   VEL  = TP.VEL;
  DT1 = T*dt;   VDT1 = VEL*DT1;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    for( i = 0; i <= N-1; i++ ){
      wx1[i]  =  x[(i_VAR-1)*N+i+1];
      wF [i]  =  F[(i_VAR-1)*N+i+1];
    }
    RDFT( N, NW, SCT, td, wx1 );
    RDFT( N, NW, SCT, td, wF  );
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =  exp(-d*i*i*DT1)*((wx1[0    ]+DT1*wF[0    ])*cos(i*VDT1)                                       );
    i  =  NW/2;
      wx[1    ]  =  exp(-d*i*i*DT1)*((wx1[1    ]+DT1*wF[1    ])*cos(i*VDT1)                                       );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =  exp(-d*i*i*DT1)*((wx1[2*i  ]+DT1*wF[2*i  ])*cos(i*VDT1)+(wx1[2*i+1]+DT1*wF[2*i+1])*sin(i*VDT1));
      wx[2*i+1]  =  exp(-d*i*i*DT1)*((wx1[2*i+1]+DT1*wF[2*i+1])*cos(i*VDT1)-(wx1[2*i  ]+DT1*wF[2*i  ])*sin(i*VDT1));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  FREE_1D( wx  );
  FREE_1D( wx1 );
  FREE_1D( wF  );
  free_1d( F   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  MEM_SM( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR, iV;
  int    *SCT;
  double T, VEL, d, DT1, DT2, VDT1, VDT2;
  double *td, *wx, *wF, *F, *wx1;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  F    =  malloc_1d( NV          );
  wx1  =  MALLOC_1D( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T   = TP.T;        VEL  = TP.VEL;
  DT1 = T*    dt;    VDT1 = VEL*DT1;
  DT2 = T*0.5*dt;    VDT2 = VEL*DT2;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[(i_VAR-1)*N+i+1];
      wF[i]  =  F[(i_VAR-1)*N+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wx1[(i_VAR-1)*N+i]  =  wx[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =  exp(-d*i*i*DT2)*((wx1[iV+    0]+DT2*wF[    0])*cos(i*VDT2)                                          );
    i  =  NW/2;
      wx[1    ]  =  exp(-d*i*i*DT2)*((wx1[iV+    1]+DT2*wF[    1])*cos(i*VDT2)                                          );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =  exp(-d*i*i*DT2)*((wx1[iV+2*i  ]+DT2*wF[2*i  ])*cos(i*VDT2)+(wx1[iV+2*i+1]+DT2*wF[2*i+1])*sin(i*VDT2));
      wx[2*i+1]  =  exp(-d*i*i*DT2)*((wx1[iV+2*i+1]+DT2*wF[2*i+1])*cos(i*VDT2)-(wx1[iV+2*i  ]+DT2*wF[2*i  ])*sin(i*VDT2));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[(i_VAR-1)*N+i+1];
    RDFT( N, NW, SCT, td, wF );
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =      exp(-d*i*i*DT1)*(wx1[iV+    0]*cos(i*VDT1)                          ) \
                 +  DT1*exp(-d*i*i*DT2)*(wF [       0]*cos(i*VDT2)                          );
    i  =  NW/2;
      wx[1    ]  =      exp(-d*i*i*DT1)*(wx1[iV+    1]*cos(i*VDT1)                          ) \
                 +  DT1*exp(-d*i*i*DT2)*(wF [       1]*cos(i*VDT2)                          );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =      exp(-d*i*i*DT1)*(wx1[iV+2*i  ]*cos(i*VDT1)+wx1[iV+2*i+1]*sin(i*VDT1)) \
                 +  DT1*exp(-d*i*i*DT2)*(wF [   2*i  ]*cos(i*VDT2)+wF [   2*i+1]*sin(i*VDT2));
      wx[2*i+1]  =      exp(-d*i*i*DT1)*(wx1[iV+2*i+1]*cos(i*VDT1)-wx1[iV+2*i  ]*sin(i*VDT1)) \
                 +  DT1*exp(-d*i*i*DT2)*(wF [   2*i+1]*cos(i*VDT2)-wF [   2*i  ]*sin(i*VDT2));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
  free_1d( F   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RK4_SM( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR, iV;
  int    *SCT;
  double T, VEL, d, DT1, DT2, DT3, VDT1, VDT2;
  double *F, *td, *wx, *wF, *wx1, *wF1, *wF2, *wF3;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  F    =  malloc_1d( NV          );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  wx1  =  MALLOC_1D( NV          );
  wF1  =  MALLOC_1D( NV          );
  wF2  =  MALLOC_1D( NV          );
  wF3  =  MALLOC_1D( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T   = TP.T;        VEL  = TP.VEL;
  DT1 = T*    dt;    VDT1 = VEL*DT1;
  DT2 = T*0.5*dt;    VDT2 = VEL*DT2;
  DT3 = T*dt/6.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ ){
      wx1[iV+i]  =  wx[i];
      wF1[iV+i]  =  wF[i];
    }
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =  exp(-d*i*i*DT2)*((wx1[iV+0    ]+DT2*wF[0    ])*cos(i*VDT2)                                          );
    i  =  NW/2;
      wx[1    ]  =  exp(-d*i*i*DT2)*((wx1[iV+1    ]+DT2*wF[1    ])*cos(i*VDT2)                                          );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =  exp(-d*i*i*DT2)*((wx1[iV+2*i  ]+DT2*wF[2*i  ])*cos(i*VDT2)+(wx1[iV+2*i+1]+DT2*wF[2*i+1])*sin(i*VDT2));
      wx[2*i+1]  =  exp(-d*i*i*DT2)*((wx1[iV+2*i+1]+DT2*wF[2*i+1])*cos(i*VDT2)-(wx1[iV+2*i  ]+DT2*wF[2*i  ])*sin(i*VDT2));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF2[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =  exp(-d*i*i*DT2)*(wx1[iV+0    ]*cos(i*VDT2)                          )+DT2*wF[0    ];
    i  =  NW/2;
      wx[1    ]  =  exp(-d*i*i*DT2)*(wx1[iV+1    ]*cos(i*VDT2)                          )+DT2*wF[1    ];
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =  exp(-d*i*i*DT2)*(wx1[iV+2*i  ]*cos(i*VDT2)+wx1[iV+2*i+1]*sin(i*VDT2))+DT2*wF[2*i  ];
      wx[2*i+1]  =  exp(-d*i*i*DT2)*(wx1[iV+2*i+1]*cos(i*VDT2)-wx1[iV+2*i  ]*sin(i*VDT2))+DT2*wF[2*i+1];
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF3[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =      exp(-d*i*i*DT1)*(wx1[iV+0    ]*cos(i*VDT1)                          ) \
                 +  DT1*exp(-d*i*i*DT2)*(wF [   0    ]*cos(i*VDT2)                          );
    i  =  NW/2;
      wx[1    ]  =      exp(-d*i*i*DT1)*(wx1[iV+1    ]*cos(i*VDT1)                          ) \
                 +  DT1*exp(-d*i*i*DT2)*(wF[    1    ]*cos(i*VDT2)                          );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =      exp(-d*i*i*DT1)*(wx1[iV+2*i  ]*cos(i*VDT1)+wx1[iV+2*i+1]*sin(i*VDT1)) \
                 +  DT1*exp(-d*i*i*DT2)*(wF [   2*i  ]*cos(i*VDT2)+wF [   2*i+1]*sin(i*VDT2));
      wx[2*i+1]  =      exp(-d*i*i*DT1)*(wx1[iV+2*i+1]*cos(i*VDT1)-wx1[iV+2*i  ]*sin(i*VDT1)) \
                 +  DT1*exp(-d*i*i*DT2)*(wF [   2*i+1]*cos(i*VDT2)-wF [   2*i  ]*sin(i*VDT2));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    d   =  par[N_EP+i_VAR];
    i   =  0;
      wx[0    ]  =          exp(-d*i*i*DT1)*((wx1[iV+0    ]+DT3*wF1[iV+0    ])*cos(i*VDT1)                                              ) \
                 +  2.0*DT3*exp(-d*i*i*DT2)*((wF2[iV+0    ]+    wF3[iV+0    ])*cos(i*VDT2)                                              ) \
                 +      DT3*wF[0    ];
    i   =  NW/2;
      wx[1    ]  =          exp(-d*i*i*DT1)*((wx1[iV+1    ]+DT3*wF1[iV+1    ])*cos(i*VDT1)                                              ) \
                 +  2.0*DT3*exp(-d*i*i*DT2)*((wF2[iV+1    ]+    wF3[iV+1    ])*cos(i*VDT2)                                              ) \
                 +      DT3*wF[1    ];
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =          exp(-d*i*i*DT1)*((wx1[iV+2*i  ]+DT3*wF1[iV+2*i  ])*cos(i*VDT1)+(wx1[iV+2*i+1]+DT3*wF1[iV+2*i+1])*sin(i*VDT1)) \
                 +  2.0*DT3*exp(-d*i*i*DT2)*((wF2[iV+2*i  ]+    wF3[iV+2*i  ])*cos(i*VDT2)+(wF2[iV+2*i+1]+    wF3[iV+2*i+1])*sin(i*VDT2)) \
                 +      DT3*wF[2*i  ];
      wx[2*i+1]  =          exp(-d*i*i*DT1)*((wx1[iV+2*i+1]+DT3*wF1[iV+2*i+1])*cos(i*VDT1)-(wx1[iV+2*i  ]+DT3*wF1[iV+2*i  ])*sin(i*VDT1)) \
                 +  2.0*DT3*exp(-d*i*i*DT2)*((wF2[iV+2*i+1]+    wF3[iV+2*i+1])*cos(i*VDT2)-(wF2[iV+2*i  ]+    wF3[iV+2*i  ])*sin(i*VDT2)) \
                 +      DT3*wF[2*i+1];
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
  FREE_1D( wF1 );
  FREE_1D( wF2 );
  FREE_1D( wF3 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RK4_SM2( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR, iV;
  int    *SCT;
  double T, VEL, d, DT1, DT2, DT3, DT4, VDT1, VDT2, VDT3;
  double *F, *td, *wx, *wF, *wx1, *wF1, *wF2, *wF3;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  F    =  malloc_1d( NV          );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  wx1  =  MALLOC_1D( NV          );
  wF1  =  MALLOC_1D( NV          );
  wF2  =  MALLOC_1D( NV          );
  wF3  =  MALLOC_1D( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T   = TP.T;            VEL  = TP.VEL;
  DT1 = T*    dt;        VDT1 = VEL*DT1;
  DT2 = T*    dt/3.0;    VDT2 = VEL*DT2;
  DT3 = T*2.0*dt/3.0;    VDT3 = VEL*DT3;
  DT4 = T*    dt/8.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ ){
      wx1[iV+i]  =  wx[i];
      wF1[iV+i]  =  wF[i];
    }
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =  exp(-d*i*i*DT2)*((wx1[iV+0    ]+DT2*wF[0    ])*cos(i*VDT2)                                          );
    i  =  NW/2;
      wx[1    ]  =  exp(-d*i*i*DT2)*((wx1[iV+1    ]+DT2*wF[1    ])*cos(i*VDT2)                                          );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =  exp(-d*i*i*DT2)*((wx1[iV+2*i  ]+DT2*wF[2*i  ])*cos(i*VDT2)+(wx1[iV+2*i+1]+DT2*wF[2*i+1])*sin(i*VDT2));
      wx[2*i+1]  =  exp(-d*i*i*DT2)*((wx1[iV+2*i+1]+DT2*wF[2*i+1])*cos(i*VDT2)-(wx1[iV+2*i  ]+DT2*wF[2*i  ])*sin(i*VDT2));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF2[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =      exp(-d*i*i*DT3)*((wx1[iV+    0]-DT2*wF1[iV+    0])*cos(i*VDT3)                                              ) \
                 +  DT1*exp(-d*i*i*DT2)*(                   wF [       0] *cos(i*VDT2)                                              );
    i  =  NW/2;
      wx[1    ]  =      exp(-d*i*i*DT3)*((wx1[iV+    1]-DT2*wF1[iV+    1])*cos(i*VDT3)                                              ) \
                 +  DT1*exp(-d*i*i*DT2)*(                   wF [       1] *cos(i*VDT2)                                              );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =      exp(-d*i*i*DT3)*((wx1[iV+2*i  ]-DT2*wF1[iV+2*i  ])*cos(i*VDT3)+(wx1[iV+2*i+1]-DT2*wF1[iV+2*i+1])*sin(i*VDT3)) \
                 +  DT1*exp(-d*i*i*DT2)*(                   wF [   2*i  ] *cos(i*VDT2)+                   wF [   2*i+1] *sin(i*VDT2));
      wx[2*i+1]  =      exp(-d*i*i*DT3)*((wx1[iV+2*i+1]-DT2*wF1[iV+2*i+1])*cos(i*VDT3)-(wx1[iV+2*i  ]-DT2*wF1[iV+2*i  ])*sin(i*VDT3)) \
                 +  DT1*exp(-d*i*i*DT2)*(                   wF [   2*i+1] *cos(i*VDT2)-                   wF [   2*i  ] *sin(i*VDT2));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF3[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx[0    ]  =      exp(-d*i*i*DT1)*((wx1[iV+    0]-DT1*wF1[iV+    0])*cos(i*VDT1)                                              ) \
                 -  DT1*exp(-d*i*i*DT3)*(                   wF2[iV+    0] *cos(i*VDT3)                                              ) \
                 +  DT1*exp(-d*i*i*DT2)*(                   wF [       0] *cos(i*VDT2)                                              );
    i  =  NW/2;
      wx[1    ]  =      exp(-d*i*i*DT1)*((wx1[iV+    1]-DT1*wF1[iV+    1])*cos(i*VDT1)                                              ) \
                 -  DT1*exp(-d*i*i*DT3)*(                   wF2[iV+    1] *cos(i*VDT3)                                              ) \
                 +  DT1*exp(-d*i*i*DT2)*(                   wF [       1] *cos(i*VDT2)                                              );
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =      exp(-d*i*i*DT1)*((wx1[iV+2*i  ]+DT1*wF1[iV+2*i  ])*cos(i*VDT1)+(wx1[iV+2*i+1]+DT1*wF1[iV+2*i+1])*sin(i*VDT1)) \
                 -  DT1*exp(-d*i*i*DT3)*(                   wF2[iV+2*i  ] *cos(i*VDT3)+                   wF2[iV+2*i+1] *sin(i*VDT3)) \
                 +  DT1*exp(-d*i*i*DT2)*(                   wF [   2*i  ] *cos(i*VDT2)+                   wF [   2*i+1] *sin(i*VDT2));
      wx[2*i+1]  =      exp(-d*i*i*DT1)*((wx1[iV+2*i+1]+DT1*wF1[iV+2*i+1])*cos(i*VDT1)-(wx1[iV+2*i  ]+DT1*wF1[iV+2*i  ])*sin(i*VDT1)) \
                 -  DT1*exp(-d*i*i*DT3)*(                   wF2[iV+2*i+1] *cos(i*VDT3)-                   wF2[iV+2*i  ] *sin(i*VDT3)) \
                 +  DT1*exp(-d*i*i*DT2)*(                   wF [   2*i+1] *cos(i*VDT2)-                   wF [   2*i  ] *sin(i*VDT2));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    d   =  par[N_EP+i_VAR];
    i   =  0;
      wx[0    ]  =          exp(-d*i*i*DT1)*((wx1[iV+    0]+DT4*wF1[iV+    0])*cos(i*VDT1)                                              ) \
                 +  3.0*DT4*exp(-d*i*i*DT3)*(                   wF2[iV+    0] *cos(i*VDT3)                                              ) \
                 +  3.0*DT4*exp(-d*i*i*DT2)*(                   wF3[iV+    0] *cos(i*VDT2)                                              ) \
                 +      DT4*                                    wF [       0];
    i   =  NW/2;
      wx[1    ]  =          exp(-d*i*i*DT1)*((wx1[iV+    1]+DT4*wF1[iV+    1])*cos(i*VDT1)                                              ) \
                 +  3.0*DT4*exp(-d*i*i*DT3)*(                   wF2[iV+    1] *cos(i*VDT3)                                              ) \
                 +  3.0*DT4*exp(-d*i*i*DT2)*(                   wF3[iV+    1] *cos(i*VDT2)                                              ) \
                 +      DT4*                                    wF [       1];
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =          exp(-d*i*i*DT1)*((wx1[iV+2*i  ]+DT4*wF1[iV+2*i  ])*cos(i*VDT1)+(wx1[iV+2*i+1]+DT4*wF1[iV+2*i+1])*sin(i*VDT1)) \
                 +  3.0*DT4*exp(-d*i*i*DT3)*(                   wF2[iV+2*i  ] *cos(i*VDT3)+                   wF2[iV+2*i+1] *sin(i*VDT3)) \
                 +  3.0*DT4*exp(-d*i*i*DT2)*(                   wF3[iV+2*i  ] *cos(i*VDT2)+                   wF3[iV+2*i+1] *sin(i*VDT2)) \
                 +      DT4*                                    wF [   2*i  ];
      wx[2*i+1]  =          exp(-d*i*i*DT1)*((wx1[iV+2*i+1]+DT4*wF1[iV+2*i+1])*cos(i*VDT1)-(wx1[iV+2*i  ]+DT4*wF1[iV+2*i  ])*sin(i*VDT1)) \
                 +  3.0*DT4*exp(-d*i*i*DT3)*(                   wF2[iV+2*i+1] *cos(i*VDT3)-                   wF2[iV+2*i  ] *sin(i*VDT3)) \
                 +  3.0*DT4*exp(-d*i*i*DT2)*(                   wF3[iV+2*i+1] *cos(i*VDT2)-                   wF3[iV+2*i  ] *sin(i*VDT2)) \
                 +      DT4*                                    wF [   2*i+1];
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
  FREE_1D( wF1 );
  FREE_1D( wF2 );
  FREE_1D( wF3 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RK4_SM3( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_VAR, iV;
  int    *SCT;
  double T, VEL, d;
  double  DC11,  DC21,         DC31,         DC41,  DC42,  DC43,  DC44;
  double  DT11,  DT21,  DT22,  DT31,  DT32,  DT41,  DT42,  DT43,  DT44;
  double VDT11, VDT21, VDT22, VDT31, VDT32, VDT41, VDT42, VDT43, VDT44;
  double *F, *td, *wx, *wF, *wx1, *wF1, *wF2, *wF3, *wF4;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  F    =  malloc_1d( NV          );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  wx1  =  MALLOC_1D( NV          );
  wF1  =  MALLOC_1D( NV          );
  wF2  =  MALLOC_1D( NV          );
  wF3  =  MALLOC_1D( NV          );
  wF4  =  MALLOC_1D( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T    =  TP.T;        VEL   = TP.VEL;
  DT11 =  T*dt/2.0;    VDT11 = VEL*DT11;
  DT21 =  T*dt/2.0;    VDT21 = VEL*DT21;
  DT22 =  DT21-DT11;   VDT22 = VEL*DT22;
  DT31 =  T*dt;        VDT31 = VEL*DT31;
  DT32 =  DT31-DT21;   VDT32 = VEL*DT32;
  DT41 =  T*dt;        VDT41 = VEL*DT41;
  DT42 =  DT41-DT11;   VDT42 = VEL*DT42;
  DT43 =  DT41-DT21;   VDT43 = VEL*DT43;
  DT44 =  DT41-DT31;   VDT44 = VEL*DT44;

  DC11 =  T    *dt/2.0;
  DC21 =  T    *dt/2.0;
  DC31 =  T    *dt    ;
  DC41 =  T    *dt/6.0;
  DC42 =  T*2.0*dt/6.0;
  DC43 =  T*2.0*dt/6.0;
  DC44 =  T    *dt/6.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ ){
      wx1[iV+i]  =  wx[i];
      wF1[iV+i]  =  wF[i];
    }
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i  ]*cos(i*VDT11)+wx1[iV+2*i+1]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i  ]*cos(i*VDT11)+wF1[iV+2*i+1]*sin(i*VDT11));
      wx[2*i+1]  =       exp(-d*j*j*DT11)*(wx1[iV+2*i+1]*cos(j*VDT11)-wx1[iV+2*i  ]*sin(i*VDT11)) \
                 +  DC11*exp(-d*j*j*DT11)*(wF1[iV+2*i+1]*cos(j*VDT11)-wF1[iV+2*i  ]*sin(i*VDT11));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i  ]*cos(i*VDT11)+wx1[iV+2*i+1]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i  ]*cos(i*VDT11)+wF1[iV+2*i+1]*sin(i*VDT11));
      wx[2*i+1]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i+1]*cos(i*VDT11)-wx1[iV+2*i  ]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i+1]*cos(i*VDT11)-wF1[iV+2*i  ]*sin(i*VDT11));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF2[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i  ]*cos(i*VDT21)+wx1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT22)*(wF2[iV+2*i  ]*cos(i*VDT22)+wF2[iV+2*i+1]*sin(i*VDT22));
      wx[2*i+1]  =       exp(-d*j*j*DT21)*(wx1[iV+2*i+1]*cos(j*VDT21)-wx1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC21*exp(-d*j*j*DT22)*(wF2[iV+2*i+1]*cos(j*VDT22)-wF2[iV+2*i  ]*sin(i*VDT22));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i  ]*cos(i*VDT21)+wx1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT22)*(wF2[iV+2*i  ]*cos(i*VDT22)+wF2[iV+2*i+1]*sin(i*VDT22));
      wx[2*i+1]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i+1]*cos(i*VDT21)-wx1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT22)*(wF2[iV+2*i+1]*cos(i*VDT22)-wF2[iV+2*i  ]*sin(i*VDT22));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF3[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i  ]*cos(i*VDT31)+wx1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT32)*(wF3[iV+2*i  ]*cos(i*VDT32)+wF3[iV+2*i+1]*sin(i*VDT32));
      wx[2*i+1]  =       exp(-d*j*j*DT31)*(wx1[iV+2*i+1]*cos(j*VDT31)-wx1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC31*exp(-d*j*j*DT32)*(wF3[iV+2*i+1]*cos(j*VDT32)-wF3[iV+2*i  ]*sin(i*VDT32));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i  ]*cos(i*VDT31)+wx1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT32)*(wF3[iV+2*i  ]*cos(i*VDT32)+wF3[iV+2*i+1]*sin(i*VDT32));
      wx[2*i+1]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i+1]*cos(i*VDT31)-wx1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT32)*(wF3[iV+2*i+1]*cos(i*VDT32)-wF3[iV+2*i  ]*sin(i*VDT32));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF4[iV+i]  =  wF[i];
    d   =  par[N_EP+i_VAR];
    i   =  0;
    j   =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i  ]*cos(i*VDT41)+wx1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i  ]*cos(i*VDT42)+wF2[iV+2*i+1]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i  ]*cos(i*VDT43)+wF3[iV+2*i+1]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i  ]*cos(i*VDT44)+wF4[iV+2*i+1]*sin(i*VDT44));
      wx[2*i+1]  =       exp(-d*j*j*DT41)*(wx1[iV+2*i+1]*cos(j*VDT41)-wx1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC41*exp(-d*j*j*DT41)*(wF1[iV+2*i+1]*cos(j*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC42*exp(-d*j*j*DT42)*(wF2[iV+2*i+1]*cos(j*VDT42)-wF2[iV+2*i  ]*sin(i*VDT42)) \
                 +  DC43*exp(-d*j*j*DT43)*(wF3[iV+2*i+1]*cos(j*VDT43)-wF3[iV+2*i  ]*sin(i*VDT43)) \
                 +  DC44*exp(-d*j*j*DT44)*(wF4[iV+2*i+1]*cos(j*VDT44)-wF4[iV+2*i  ]*sin(i*VDT44));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i  ]*cos(i*VDT41)+wx1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i  ]*cos(i*VDT42)+wF2[iV+2*i+1]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i  ]*cos(i*VDT43)+wF3[iV+2*i+1]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i  ]*cos(i*VDT44)+wF4[iV+2*i+1]*sin(i*VDT44));
      wx[2*i+1]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i+1]*cos(i*VDT41)-wx1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i+1]*cos(i*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i+1]*cos(i*VDT42)-wF2[iV+2*i  ]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i+1]*cos(i*VDT43)-wF3[iV+2*i  ]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i+1]*cos(i*VDT44)-wF4[iV+2*i  ]*sin(i*VDT44));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
  FREE_1D( wF1 );
  FREE_1D( wF2 );
  FREE_1D( wF3 );
  FREE_1D( wF4 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RK4_SM4( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_VAR, iV;
  int    *SCT;
  double T, VEL, d;
  double  DC11,  DC21,  DC22,  DC31,  DC32,  DC33,  DC41,  DC42,  DC43,  DC44;
  double  DT11,  DT21,  DT22,  DT31,  DT32,  DT33,  DT41,  DT42,  DT43,  DT44;
  double VDT11, VDT21, VDT22, VDT31, VDT32, VDT33, VDT41, VDT42, VDT43, VDT44;
  double *F, *td, *wx, *wF, *wx1, *wF1, *wF2, *wF3, *wF4;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  F    =  malloc_1d( NV          );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  wx1  =  MALLOC_1D( NV          );
  wF1  =  MALLOC_1D( NV          );
  wF2  =  MALLOC_1D( NV          );
  wF3  =  MALLOC_1D( NV          );
  wF4  =  MALLOC_1D( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T    =  TP.T;            VEL   = TP.VEL;
  DT11 =  T    *dt/3.0;    VDT11 = VEL*DT11;
  DT21 =  T*2.0*dt/3.0;    VDT21 = VEL*DT21;
  DT22 =  DT21-DT11;       VDT22 = VEL*DT22;
  DT31 =  T*dt;            VDT31 = VEL*DT31;
  DT32 =  DT31-DT11;       VDT32 = VEL*DT32;
  DT33 =  DT31-DT21;       VDT33 = VEL*DT33;
  DT41 =  T*dt;            VDT41 = VEL*DT41;
  DT42 =  DT41-DT11;       VDT42 = VEL*DT42;
  DT43 =  DT41-DT21;       VDT43 = VEL*DT43;
  DT44 =  DT41-DT31;       VDT44 = VEL*DT44;

  DC11 =  T    *dt/3.0;
  DC21 =  T    *dt/3.0;
  DC22 =  T    *dt    ;
  DC31 =  T    *dt    ;
  DC32 =  T    *dt    ;
  DC33 =  T    *dt    ;
  DC41 =  T    *dt/8.0;
  DC42 =  T*3.0*dt/8.0;
  DC43 =  T*3.0*dt/8.0;
  DC44 =  T    *dt/8.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ ){
      wx1[iV+i]  =  wx[i];
      wF1[iV+i]  =  wF[i];
    }
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i  ]*cos(i*VDT11)+wx1[iV+2*i+1]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i  ]*cos(i*VDT11)+wF1[iV+2*i+1]*sin(i*VDT11));
      wx[2*i+1]  =       exp(-d*j*j*DT11)*(wx1[iV+2*i+1]*cos(j*VDT11)-wx1[iV+2*i  ]*sin(i*VDT11)) \
                 +  DC11*exp(-d*j*j*DT11)*(wF1[iV+2*i+1]*cos(j*VDT11)-wF1[iV+2*i  ]*sin(i*VDT11));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i  ]*cos(i*VDT11)+wx1[iV+2*i+1]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i  ]*cos(i*VDT11)+wF1[iV+2*i+1]*sin(i*VDT11));
      wx[2*i+1]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i+1]*cos(i*VDT11)-wx1[iV+2*i  ]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i+1]*cos(i*VDT11)-wF1[iV+2*i  ]*sin(i*VDT11));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF2[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i  ]*cos(i*VDT21)+wx1[iV+2*i+1]*sin(i*VDT21)) \
                 -  DC21*exp(-d*i*i*DT21)*(wF1[iV+2*i  ]*cos(i*VDT21)+wF1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC22*exp(-d*i*i*DT22)*(wF2[iV+2*i  ]*cos(i*VDT22)+wF2[iV+2*i+1]*sin(i*VDT22));
      wx[2*i+1]  =       exp(-d*j*j*DT21)*(wx1[iV+2*i+1]*cos(j*VDT21)-wx1[iV+2*i  ]*sin(i*VDT21)) \
                 -  DC21*exp(-d*j*j*DT21)*(wF1[iV+2*i+1]*cos(j*VDT21)-wF1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC22*exp(-d*j*j*DT22)*(wF2[iV+2*i+1]*cos(j*VDT22)-wF2[iV+2*i  ]*sin(i*VDT22));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i  ]*cos(i*VDT21)+wx1[iV+2*i+1]*sin(i*VDT21)) \
                 -  DC21*exp(-d*i*i*DT21)*(wF1[iV+2*i  ]*cos(i*VDT21)+wF1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC22*exp(-d*i*i*DT22)*(wF2[iV+2*i  ]*cos(i*VDT22)+wF2[iV+2*i+1]*sin(i*VDT22));
      wx[2*i+1]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i+1]*cos(i*VDT21)-wx1[iV+2*i  ]*sin(i*VDT21)) \
                 -  DC21*exp(-d*i*i*DT21)*(wF1[iV+2*i+1]*cos(i*VDT21)-wF1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC22*exp(-d*i*i*DT22)*(wF2[iV+2*i+1]*cos(i*VDT22)-wF2[iV+2*i  ]*sin(i*VDT22));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF3[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i  ]*cos(i*VDT31)+wx1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT31)*(wF1[iV+2*i  ]*cos(i*VDT31)+wF1[iV+2*i+1]*sin(i*VDT31)) \
                 -  DC32*exp(-d*i*i*DT32)*(wF2[iV+2*i  ]*cos(i*VDT32)+wF2[iV+2*i+1]*sin(i*VDT32)) \
                 +  DC33*exp(-d*i*i*DT33)*(wF3[iV+2*i  ]*cos(i*VDT33)+wF3[iV+2*i+1]*sin(i*VDT33));
      wx[2*i+1]  =       exp(-d*j*j*DT31)*(wx1[iV+2*i+1]*cos(j*VDT31)-wx1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC31*exp(-d*j*j*DT31)*(wF1[iV+2*i+1]*cos(j*VDT31)-wF1[iV+2*i  ]*sin(i*VDT31)) \
                 -  DC32*exp(-d*j*j*DT32)*(wF2[iV+2*i+1]*cos(j*VDT32)-wF2[iV+2*i  ]*sin(i*VDT32)) \
                 +  DC33*exp(-d*j*j*DT33)*(wF3[iV+2*i+1]*cos(j*VDT33)-wF3[iV+2*i  ]*sin(i*VDT33));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i  ]*cos(i*VDT31)+wx1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT31)*(wF1[iV+2*i  ]*cos(i*VDT31)+wF1[iV+2*i+1]*sin(i*VDT31)) \
                 -  DC32*exp(-d*i*i*DT32)*(wF2[iV+2*i  ]*cos(i*VDT32)+wF2[iV+2*i+1]*sin(i*VDT32)) \
                 +  DC33*exp(-d*i*i*DT33)*(wF3[iV+2*i  ]*cos(i*VDT33)+wF3[iV+2*i+1]*sin(i*VDT33));
      wx[2*i+1]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i+1]*cos(i*VDT31)-wx1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT31)*(wF1[iV+2*i+1]*cos(i*VDT31)-wF1[iV+2*i  ]*sin(i*VDT31)) \
                 -  DC32*exp(-d*i*i*DT32)*(wF2[iV+2*i+1]*cos(i*VDT32)-wF2[iV+2*i  ]*sin(i*VDT32)) \
                 +  DC33*exp(-d*i*i*DT33)*(wF3[iV+2*i+1]*cos(i*VDT33)-wF3[iV+2*i  ]*sin(i*VDT33));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF4[iV+i]  =  wF[i];
    d   =  par[N_EP+i_VAR];
    i   =  0;
    j   =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i  ]*cos(i*VDT41)+wx1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i  ]*cos(i*VDT42)+wF2[iV+2*i+1]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i  ]*cos(i*VDT43)+wF3[iV+2*i+1]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i  ]*cos(i*VDT44)+wF4[iV+2*i+1]*sin(i*VDT44));
      wx[2*i+1]  =       exp(-d*j*j*DT41)*(wx1[iV+2*i+1]*cos(j*VDT41)-wx1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC41*exp(-d*j*j*DT41)*(wF1[iV+2*i+1]*cos(j*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC42*exp(-d*j*j*DT42)*(wF2[iV+2*i+1]*cos(j*VDT42)-wF2[iV+2*i  ]*sin(i*VDT42)) \
                 +  DC43*exp(-d*j*j*DT43)*(wF3[iV+2*i+1]*cos(j*VDT43)-wF3[iV+2*i  ]*sin(i*VDT43)) \
                 +  DC44*exp(-d*j*j*DT44)*(wF4[iV+2*i+1]*cos(j*VDT44)-wF4[iV+2*i  ]*sin(i*VDT44));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i  ]*cos(i*VDT41)+wx1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i  ]*cos(i*VDT42)+wF2[iV+2*i+1]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i  ]*cos(i*VDT43)+wF3[iV+2*i+1]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i  ]*cos(i*VDT44)+wF4[iV+2*i+1]*sin(i*VDT44));
      wx[2*i+1]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i+1]*cos(i*VDT41)-wx1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i+1]*cos(i*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i+1]*cos(i*VDT42)-wF2[iV+2*i  ]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i+1]*cos(i*VDT43)-wF3[iV+2*i  ]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i+1]*cos(i*VDT44)-wF4[iV+2*i  ]*sin(i*VDT44));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
  FREE_1D( wF1 );
  FREE_1D( wF2 );
  FREE_1D( wF3 );
  FREE_1D( wF4 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RK45_SM( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_VAR, iV;
  int    *SCT;
  double T, VEL, d;
  double  DC11,  DC21,  DC22,  DC31,  DC32,  DC33,  DC41,  DC42,  DC43,  DC44,  DC51,  DC52,  DC53,  DC54,  DC55,  DC61,  DC63,  DC64,  DC65,  DC66;
  double  DT11,  DT21,  DT22,  DT31,  DT32,  DT33,  DT41,  DT42,  DT43,  DT44,  DT51,  DT52,  DT53,  DT54,  DT55,  DT61,  DT63,  DT64,  DT65,  DT66;
  double VDT11, VDT21, VDT22, VDT31, VDT32, VDT33, VDT41, VDT42, VDT43, VDT44, VDT51, VDT52, VDT53, VDT54, VDT55, VDT61, VDT63, VDT64, VDT65, VDT66;
  double *F, *td, *wx, *wF, *wx1, *wF1, *wF2, *wF3, *wF4, *wF5, *wF6;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  F    =  malloc_1d( NV          );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  wx1  =  MALLOC_1D( NV          );
  wF1  =  MALLOC_1D( NV          );
  wF2  =  MALLOC_1D( NV          );
  wF3  =  MALLOC_1D( NV          );
  wF4  =  MALLOC_1D( NV          );
  wF5  =  MALLOC_1D( NV          );
  wF6  =  MALLOC_1D( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T    =  TP.T;              VEL   = TP.VEL;
  DT11 =  T     *dt/4.0;     VDT11 = VEL*DT11;
  DT21 =  T*3.0 *dt/8.0;     VDT21 = VEL*DT21;
  DT22 =  DT21-DT11;         VDT22 = VEL*DT22;
  DT31 =  T*12.0*dt/13.0;    VDT31 = VEL*DT31;
  DT32 =  DT31-DT11;         VDT32 = VEL*DT32;
  DT33 =  DT31-DT21;         VDT33 = VEL*DT33;
  DT41 =  T     *dt;         VDT41 = VEL*DT41;
  DT42 =  DT41-DT11;         VDT42 = VEL*DT42;
  DT43 =  DT41-DT21;         VDT43 = VEL*DT43;
  DT44 =  DT41-DT31;         VDT44 = VEL*DT44;
  DT51 =  T     *dt/2.0;     VDT51 = VEL*DT51;
  DT52 =  DT51-DT11;         VDT52 = VEL*DT52;
  DT53 =  DT51-DT21;         VDT53 = VEL*DT53;
  DT54 =  DT51-DT31;         VDT54 = VEL*DT54;
  DT55 =  DT51-DT41;         VDT55 = VEL*DT55;
  DT61 =  T     *dt;         VDT61 = VEL*DT61;
  DT63 =  DT61-DT21;         VDT63 = VEL*DT63;
  DT64 =  DT61-DT31;         VDT64 = VEL*DT64;
  DT65 =  DT61-DT41;         VDT65 = VEL*DT65;
  DT66 =  DT61-DT51;         VDT66 = VEL*DT66;

  DC11 =  T*        dt/    4.0;
  DC21 =  T*    3.0*dt/   32.0;
  DC22 =  T*    9.0*dt/   32.0;
  DC31 =  T* 1932.0*dt/ 2197.0;
  DC32 =  T* 7200.0*dt/ 2197.0;
  DC33 =  T* 7296.0*dt/ 2197.0;
  DC41 =  T*  439.0*dt/  216.0;
  DC42 =  T*    8.0*dt        ;
  DC43 =  T* 3680.0*dt/  513.0;
  DC44 =  T*  845.0*dt/ 4104.0;
  DC51 =  T*    8.0*dt/   27.0;
  DC52 =  T*    2.0*dt        ;
  DC53 =  T* 3544.0*dt/ 2565.0;
  DC54 =  T* 1859.0*dt/ 4104.0;
  DC55 =  T*   11.0*dt/   40.0;
  DC61 =  T*   16.0*dt/  135.0;
  DC63 =  T* 6656.0*dt/12825.0;
  DC64 =  T*28561.0*dt/56430.0;
  DC65 =  T*    9.0*dt/   50.0;
  DC66 =  T*    2.0*dt/   55.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ ){
      wx1[iV+i]  =  wx[i];
      wF1[iV+i]  =  wF[i];
    }
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i  ]*cos(i*VDT11)+wx1[iV+2*i+1]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i  ]*cos(i*VDT11)+wF1[iV+2*i+1]*sin(i*VDT11));
      wx[2*i+1]  =       exp(-d*j*j*DT11)*(wx1[iV+2*i+1]*cos(j*VDT11)-wx1[iV+2*i  ]*sin(i*VDT11)) \
                 +  DC11*exp(-d*j*j*DT11)*(wF1[iV+2*i+1]*cos(j*VDT11)-wF1[iV+2*i  ]*sin(i*VDT11));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i  ]*cos(i*VDT11)+wx1[iV+2*i+1]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i  ]*cos(i*VDT11)+wF1[iV+2*i+1]*sin(i*VDT11));
      wx[2*i+1]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i+1]*cos(i*VDT11)-wx1[iV+2*i  ]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i+1]*cos(i*VDT11)-wF1[iV+2*i  ]*sin(i*VDT11));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF2[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i  ]*cos(i*VDT21)+wx1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT21)*(wF1[iV+2*i  ]*cos(i*VDT21)+wF1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC22*exp(-d*i*i*DT22)*(wF2[iV+2*i  ]*cos(i*VDT22)+wF2[iV+2*i+1]*sin(i*VDT22));
      wx[2*i+1]  =       exp(-d*j*j*DT21)*(wx1[iV+2*i+1]*cos(j*VDT21)-wx1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC21*exp(-d*j*j*DT21)*(wF1[iV+2*i+1]*cos(j*VDT21)-wF1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC22*exp(-d*j*j*DT22)*(wF2[iV+2*i+1]*cos(j*VDT22)-wF2[iV+2*i  ]*sin(i*VDT22));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i  ]*cos(i*VDT21)+wx1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT21)*(wF1[iV+2*i  ]*cos(i*VDT21)+wF1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC22*exp(-d*i*i*DT22)*(wF2[iV+2*i  ]*cos(i*VDT22)+wF2[iV+2*i+1]*sin(i*VDT22));
      wx[2*i+1]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i+1]*cos(i*VDT21)-wx1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT21)*(wF1[iV+2*i+1]*cos(i*VDT21)-wF1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC22*exp(-d*i*i*DT22)*(wF2[iV+2*i+1]*cos(i*VDT22)-wF2[iV+2*i  ]*sin(i*VDT22));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF3[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i  ]*cos(i*VDT31)+wx1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT31)*(wF1[iV+2*i  ]*cos(i*VDT31)+wF1[iV+2*i+1]*sin(i*VDT31)) \
                 -  DC32*exp(-d*i*i*DT32)*(wF2[iV+2*i  ]*cos(i*VDT32)+wF2[iV+2*i+1]*sin(i*VDT32)) \
                 +  DC33*exp(-d*i*i*DT33)*(wF3[iV+2*i  ]*cos(i*VDT33)+wF3[iV+2*i+1]*sin(i*VDT33));
      wx[2*i+1]  =       exp(-d*j*j*DT31)*(wx1[iV+2*i+1]*cos(j*VDT31)-wx1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC31*exp(-d*j*j*DT31)*(wF1[iV+2*i+1]*cos(j*VDT31)-wF1[iV+2*i  ]*sin(i*VDT31)) \
                 -  DC32*exp(-d*j*j*DT32)*(wF2[iV+2*i+1]*cos(j*VDT32)-wF2[iV+2*i  ]*sin(i*VDT32)) \
                 +  DC33*exp(-d*j*j*DT33)*(wF3[iV+2*i+1]*cos(j*VDT33)-wF3[iV+2*i  ]*sin(i*VDT33));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i  ]*cos(i*VDT31)+wx1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT31)*(wF1[iV+2*i  ]*cos(i*VDT31)+wF1[iV+2*i+1]*sin(i*VDT31)) \
                 -  DC32*exp(-d*i*i*DT32)*(wF2[iV+2*i  ]*cos(i*VDT32)+wF2[iV+2*i+1]*sin(i*VDT32)) \
                 +  DC33*exp(-d*i*i*DT33)*(wF3[iV+2*i  ]*cos(i*VDT33)+wF3[iV+2*i+1]*sin(i*VDT33));
      wx[2*i+1]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i+1]*cos(i*VDT31)-wx1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT31)*(wF1[iV+2*i+1]*cos(i*VDT31)-wF1[iV+2*i  ]*sin(i*VDT31)) \
                 -  DC32*exp(-d*i*i*DT32)*(wF2[iV+2*i+1]*cos(i*VDT32)-wF2[iV+2*i  ]*sin(i*VDT32)) \
                 +  DC33*exp(-d*i*i*DT33)*(wF3[iV+2*i+1]*cos(i*VDT33)-wF3[iV+2*i  ]*sin(i*VDT33));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF4[iV+i]  =  wF[i];
    d   =  par[N_EP+i_VAR];
    i   =  0;
    j   =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i  ]*cos(i*VDT41)+wx1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 -  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i  ]*cos(i*VDT42)+wF2[iV+2*i+1]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i  ]*cos(i*VDT43)+wF3[iV+2*i+1]*sin(i*VDT43)) \
                 -  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i  ]*cos(i*VDT44)+wF4[iV+2*i+1]*sin(i*VDT44));
      wx[2*i+1]  =       exp(-d*j*j*DT41)*(wx1[iV+2*i+1]*cos(j*VDT41)-wx1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC41*exp(-d*j*j*DT41)*(wF1[iV+2*i+1]*cos(j*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 -  DC42*exp(-d*j*j*DT42)*(wF2[iV+2*i+1]*cos(j*VDT42)-wF2[iV+2*i  ]*sin(i*VDT42)) \
                 +  DC43*exp(-d*j*j*DT43)*(wF3[iV+2*i+1]*cos(j*VDT43)-wF3[iV+2*i  ]*sin(i*VDT43)) \
                 -  DC44*exp(-d*j*j*DT44)*(wF4[iV+2*i+1]*cos(j*VDT44)-wF4[iV+2*i  ]*sin(i*VDT44));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i  ]*cos(i*VDT41)+wx1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 -  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i  ]*cos(i*VDT42)+wF2[iV+2*i+1]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i  ]*cos(i*VDT43)+wF3[iV+2*i+1]*sin(i*VDT43)) \
                 -  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i  ]*cos(i*VDT44)+wF4[iV+2*i+1]*sin(i*VDT44));
      wx[2*i+1]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i+1]*cos(i*VDT41)-wx1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i+1]*cos(i*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 -  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i+1]*cos(i*VDT42)-wF2[iV+2*i  ]*sin(i*VDT42)) \
                 +  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i+1]*cos(i*VDT43)-wF3[iV+2*i  ]*sin(i*VDT43)) \
                 -  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i+1]*cos(i*VDT44)-wF4[iV+2*i  ]*sin(i*VDT44));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF5[iV+i]  =  wF[i];
    d   =  par[N_EP+i_VAR];
    i   =  0;
    j   =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT51)*(wx1[iV+2*i  ]*cos(i*VDT51)+wx1[iV+2*i+1]*sin(i*VDT51)) \
                 -  DC51*exp(-d*i*i*DT51)*(wF1[iV+2*i  ]*cos(i*VDT51)+wF1[iV+2*i+1]*sin(i*VDT51)) \
                 +  DC52*exp(-d*i*i*DT52)*(wF2[iV+2*i  ]*cos(i*VDT52)+wF2[iV+2*i+1]*sin(i*VDT52)) \
                 -  DC53*exp(-d*i*i*DT53)*(wF3[iV+2*i  ]*cos(i*VDT53)+wF3[iV+2*i+1]*sin(i*VDT53)) \
                 +  DC54*exp(-d*i*i*DT54)*(wF4[iV+2*i  ]*cos(i*VDT54)+wF4[iV+2*i+1]*sin(i*VDT54)) \
                 -  DC55*exp(-d*i*i*DT55)*(wF5[iV+2*i  ]*cos(i*VDT55)+wF5[iV+2*i+1]*sin(i*VDT55));
      wx[2*i+1]  =       exp(-d*j*j*DT51)*(wx1[iV+2*i+1]*cos(j*VDT51)-wx1[iV+2*i  ]*sin(i*VDT51)) \
                 -  DC51*exp(-d*j*j*DT51)*(wF1[iV+2*i+1]*cos(j*VDT51)-wF1[iV+2*i  ]*sin(i*VDT51)) \
                 +  DC52*exp(-d*j*j*DT52)*(wF2[iV+2*i+1]*cos(j*VDT52)-wF2[iV+2*i  ]*sin(i*VDT52)) \
                 -  DC53*exp(-d*j*j*DT53)*(wF3[iV+2*i+1]*cos(j*VDT53)-wF3[iV+2*i  ]*sin(i*VDT53)) \
                 +  DC54*exp(-d*j*j*DT54)*(wF4[iV+2*i+1]*cos(j*VDT54)-wF4[iV+2*i  ]*sin(i*VDT54)) \
                 -  DC55*exp(-d*j*j*DT55)*(wF5[iV+2*i+1]*cos(j*VDT55)-wF5[iV+2*i  ]*sin(i*VDT55));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT51)*(wx1[iV+2*i  ]*cos(i*VDT51)+wx1[iV+2*i+1]*sin(i*VDT51)) \
                 -  DC51*exp(-d*i*i*DT51)*(wF1[iV+2*i  ]*cos(i*VDT51)+wF1[iV+2*i+1]*sin(i*VDT51)) \
                 +  DC52*exp(-d*i*i*DT52)*(wF2[iV+2*i  ]*cos(i*VDT52)+wF2[iV+2*i+1]*sin(i*VDT52)) \
                 -  DC53*exp(-d*i*i*DT53)*(wF3[iV+2*i  ]*cos(i*VDT53)+wF3[iV+2*i+1]*sin(i*VDT53)) \
                 +  DC54*exp(-d*i*i*DT54)*(wF4[iV+2*i  ]*cos(i*VDT54)+wF4[iV+2*i+1]*sin(i*VDT54)) \
                 -  DC55*exp(-d*i*i*DT55)*(wF5[iV+2*i  ]*cos(i*VDT55)+wF5[iV+2*i+1]*sin(i*VDT55));
      wx[2*i+1]  =       exp(-d*i*i*DT51)*(wx1[iV+2*i+1]*cos(i*VDT51)-wx1[iV+2*i  ]*sin(i*VDT51)) \
                 -  DC51*exp(-d*i*i*DT51)*(wF1[iV+2*i+1]*cos(i*VDT51)-wF1[iV+2*i  ]*sin(i*VDT51)) \
                 +  DC52*exp(-d*i*i*DT52)*(wF2[iV+2*i+1]*cos(i*VDT52)-wF2[iV+2*i  ]*sin(i*VDT52)) \
                 -  DC53*exp(-d*i*i*DT53)*(wF3[iV+2*i+1]*cos(i*VDT53)-wF3[iV+2*i  ]*sin(i*VDT53)) \
                 +  DC54*exp(-d*i*i*DT54)*(wF4[iV+2*i+1]*cos(i*VDT54)-wF4[iV+2*i  ]*sin(i*VDT54)) \
                 -  DC55*exp(-d*i*i*DT55)*(wF5[iV+2*i+1]*cos(i*VDT55)-wF5[iV+2*i  ]*sin(i*VDT55));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF6[iV+i]  =  wF[i];
    d   =  par[N_EP+i_VAR];
    i   =  0;
    j   =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT61)*(wx1[iV+2*i  ]*cos(i*VDT61)+wx1[iV+2*i+1]*sin(i*VDT61)) \
                 +  DC61*exp(-d*i*i*DT61)*(wF1[iV+2*i  ]*cos(i*VDT61)+wF1[iV+2*i+1]*sin(i*VDT61)) \
                 +  DC63*exp(-d*i*i*DT63)*(wF3[iV+2*i  ]*cos(i*VDT63)+wF3[iV+2*i+1]*sin(i*VDT63)) \
                 +  DC64*exp(-d*i*i*DT64)*(wF4[iV+2*i  ]*cos(i*VDT64)+wF4[iV+2*i+1]*sin(i*VDT64)) \
                 -  DC65*exp(-d*i*i*DT65)*(wF5[iV+2*i  ]*cos(i*VDT65)+wF5[iV+2*i+1]*sin(i*VDT65)) \
                 +  DC66*exp(-d*i*i*DT66)*(wF6[iV+2*i  ]*cos(i*VDT66)+wF6[iV+2*i+1]*sin(i*VDT66));
      wx[2*i+1]  =       exp(-d*j*j*DT61)*(wx1[iV+2*i+1]*cos(j*VDT61)-wx1[iV+2*i  ]*sin(i*VDT61)) \
                 +  DC61*exp(-d*j*j*DT61)*(wF1[iV+2*i+1]*cos(j*VDT61)-wF1[iV+2*i  ]*sin(i*VDT61)) \
                 +  DC63*exp(-d*j*j*DT63)*(wF3[iV+2*i+1]*cos(j*VDT63)-wF3[iV+2*i  ]*sin(i*VDT63)) \
                 +  DC64*exp(-d*j*j*DT64)*(wF4[iV+2*i+1]*cos(j*VDT64)-wF4[iV+2*i  ]*sin(i*VDT64)) \
                 -  DC65*exp(-d*j*j*DT65)*(wF5[iV+2*i+1]*cos(j*VDT65)-wF5[iV+2*i  ]*sin(i*VDT65)) \
                 +  DC66*exp(-d*j*j*DT66)*(wF6[iV+2*i+1]*cos(j*VDT66)-wF6[iV+2*i  ]*sin(i*VDT66));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT61)*(wx1[iV+2*i  ]*cos(i*VDT61)+wx1[iV+2*i+1]*sin(i*VDT61)) \
                 +  DC61*exp(-d*i*i*DT61)*(wF1[iV+2*i  ]*cos(i*VDT61)+wF1[iV+2*i+1]*sin(i*VDT61)) \
                 +  DC63*exp(-d*i*i*DT63)*(wF3[iV+2*i  ]*cos(i*VDT63)+wF3[iV+2*i+1]*sin(i*VDT63)) \
                 +  DC64*exp(-d*i*i*DT64)*(wF4[iV+2*i  ]*cos(i*VDT64)+wF4[iV+2*i+1]*sin(i*VDT64)) \
                 -  DC65*exp(-d*i*i*DT65)*(wF5[iV+2*i  ]*cos(i*VDT65)+wF5[iV+2*i+1]*sin(i*VDT65)) \
                 +  DC66*exp(-d*i*i*DT66)*(wF6[iV+2*i  ]*cos(i*VDT66)+wF6[iV+2*i+1]*sin(i*VDT66));
      wx[2*i+1]  =       exp(-d*i*i*DT61)*(wx1[iV+2*i+1]*cos(i*VDT61)-wx1[iV+2*i  ]*sin(i*VDT61)) \
                 +  DC61*exp(-d*i*i*DT61)*(wF1[iV+2*i+1]*cos(i*VDT61)-wF1[iV+2*i  ]*sin(i*VDT61)) \
                 +  DC63*exp(-d*i*i*DT63)*(wF3[iV+2*i+1]*cos(i*VDT63)-wF3[iV+2*i  ]*sin(i*VDT63)) \
                 +  DC64*exp(-d*i*i*DT64)*(wF4[iV+2*i+1]*cos(i*VDT64)-wF4[iV+2*i  ]*sin(i*VDT64)) \
                 -  DC65*exp(-d*i*i*DT65)*(wF5[iV+2*i+1]*cos(i*VDT65)-wF5[iV+2*i  ]*sin(i*VDT65)) \
                 +  DC66*exp(-d*i*i*DT66)*(wF6[iV+2*i+1]*cos(i*VDT66)-wF6[iV+2*i  ]*sin(i*VDT66));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
  FREE_1D( wF1 );
  FREE_1D( wF2 );
  FREE_1D( wF3 );
  FREE_1D( wF4 );
  FREE_1D( wF5 );
  FREE_1D( wF6 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RK5_SM( TEMP TP, double *par, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, j, i_VAR, iV;
  int    *SCT;
  double T, VEL, d, eps;
  double  DC11,  DC21,  DC22,  DC31,  DC32,  DC33,  DC41,  DC42,  DC43,  DC44,  DC51,  DC52,  DC53,  DC54,  DC55;
  double  DT11,  DT21,  DT22,  DT31,  DT32,  DT33,  DT41,  DT42,  DT43,  DT44,  DT51,  DT52,  DT53,  DT54,  DT55;
  double VDT11, VDT21, VDT22, VDT31, VDT32, VDT33, VDT41, VDT42, VDT43, VDT44, VDT51, VDT52, VDT53, VDT54, VDT55;
  double *F, *td, *wx, *wF, *wx1, *wF1, *wF2, *wF3, *wF4, *wF5;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  F    =  malloc_1d( NV          );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  wx1  =  MALLOC_1D( NV          );
  wF1  =  MALLOC_1D( NV          );
  wF2  =  MALLOC_1D( NV          );
  wF3  =  MALLOC_1D( NV          );
  wF4  =  MALLOC_1D( NV          );
  wF5  =  MALLOC_1D( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
  eps     =  pow(2,-22);
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T    =  TP.T;            VEL   = TP.VEL;
  DT11 =  T*eps*dt;        VDT11 = VEL*DT11;
  DT21 =  T    *dt/2.0;    VDT21 = VEL*DT21;
  DT22 =  DT21-DT11;       VDT22 = VEL*DT22;
  DT31 =  T*5.0*dt/9.0;    VDT31 = VEL*DT31;
  DT32 =  DT31-DT11;       VDT32 = VEL*DT32;
  DT33 =  DT31-DT21;       VDT33 = VEL*DT33;
  DT41 =  T    *dt;        VDT41 = VEL*DT41;
  DT42 =  DT41-DT11;       VDT42 = VEL*DT42;
  DT43 =  DT41-DT21;       VDT43 = VEL*DT43;
  DT44 =  DT41-DT31;       VDT44 = VEL*DT44;
  DT51 =  T    *dt;        VDT51 = VEL*DT51;
  DT52 =  DT51-DT11;       VDT52 = VEL*DT52;
  DT53 =  DT51-DT21;       VDT53 = VEL*DT53;
  DT54 =  DT51-DT31;       VDT54 = VEL*DT54;
  DT55 =  DT51-DT41;       VDT55 = VEL*DT55;

  DC11 =  T*eps   *dt;
  DC21 =  T       *dt/(   2.0        );
  DC22 =  T       *dt/(   8.0    *eps);
  DC31 =  T* 305.0*dt/( 729.0        );
  DC32 =  T* 125.0*dt/(1458.0*8.0*eps);
  DC33 =  T* 100.0*dt/( 729.0        );
  DC41 =  T* 359.0*dt/( 775.0        );
  DC42 =  T*   7.0*dt/( 310.0*8.0*eps);
  DC43 =  T* 100.0*dt/(  31.0        );
  DC44 =  T*2916.0*dt/( 775.0        );
  DC51 =  T* 233.0*dt/( 750.0        );
  DC52 =  T*   3.0*dt/( 100.0*8.0*eps);
  DC53 =  T*   8.0*dt/(  15.0        );
  DC54 =  T*2187.0*dt/(2000.0        );
  DC55 =  T*  31.0*dt/( 240.0        );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ ){
      wx1[iV+i]  =  wx[i];
      wF1[iV+i]  =  wF[i];
    }
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i  ]*cos(i*VDT11)+wx1[iV+2*i+1]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i  ]*cos(i*VDT11)+wF1[iV+2*i+1]*sin(i*VDT11));
      wx[2*i+1]  =       exp(-d*j*j*DT11)*(wx1[iV+2*i+1]*cos(j*VDT11)-wx1[iV+2*i  ]*sin(i*VDT11)) \
                 +  DC11*exp(-d*j*j*DT11)*(wF1[iV+2*i+1]*cos(j*VDT11)-wF1[iV+2*i  ]*sin(i*VDT11));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i  ]*cos(i*VDT11)+wx1[iV+2*i+1]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i  ]*cos(i*VDT11)+wF1[iV+2*i+1]*sin(i*VDT11));
      wx[2*i+1]  =       exp(-d*i*i*DT11)*(wx1[iV+2*i+1]*cos(i*VDT11)-wx1[iV+2*i  ]*sin(i*VDT11)) \
                 +  DC11*exp(-d*i*i*DT11)*(wF1[iV+2*i+1]*cos(i*VDT11)-wF1[iV+2*i  ]*sin(i*VDT11));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF2[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i  ]*cos(i*VDT21)+wx1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT21)*(wF1[iV+2*i  ]*cos(i*VDT21)+wF1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC22*exp(-d*i*i*DT22)*(wF2[iV+2*i  ]*cos(i*VDT22)+wF2[iV+2*i+1]*sin(i*VDT22)) \
                 -  DC22*exp(-d*i*i*DT21)*(wF1[iV+2*i  ]*cos(i*VDT21)+wF1[iV+2*i+1]*sin(i*VDT21));
      wx[2*i+1]  =       exp(-d*j*j*DT21)*(wx1[iV+2*i+1]*cos(j*VDT21)-wx1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC21*exp(-d*j*j*DT21)*(wF1[iV+2*i+1]*cos(j*VDT21)-wF1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC22*exp(-d*j*j*DT22)*(wF2[iV+2*i+1]*cos(j*VDT22)-wF2[iV+2*i  ]*sin(i*VDT22)) \
                 -  DC22*exp(-d*j*j*DT21)*(wF1[iV+2*i+1]*cos(j*VDT21)-wF1[iV+2*i  ]*sin(i*VDT21));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i  ]*cos(i*VDT21)+wx1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT21)*(wF1[iV+2*i  ]*cos(i*VDT21)+wF1[iV+2*i+1]*sin(i*VDT21)) \
                 +  DC22*exp(-d*i*i*DT22)*(wF2[iV+2*i  ]*cos(i*VDT22)+wF2[iV+2*i+1]*sin(i*VDT22)) \
                 -  DC22*exp(-d*i*i*DT21)*(wF1[iV+2*i  ]*cos(i*VDT21)+wF1[iV+2*i+1]*sin(i*VDT21));
      wx[2*i+1]  =       exp(-d*i*i*DT21)*(wx1[iV+2*i+1]*cos(i*VDT21)-wx1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC21*exp(-d*i*i*DT21)*(wF1[iV+2*i+1]*cos(i*VDT21)-wF1[iV+2*i  ]*sin(i*VDT21)) \
                 +  DC22*exp(-d*i*i*DT22)*(wF2[iV+2*i+1]*cos(i*VDT22)-wF2[iV+2*i  ]*sin(i*VDT22)) \
                 -  DC22*exp(-d*i*i*DT21)*(wF1[iV+2*i+1]*cos(i*VDT21)-wF1[iV+2*i  ]*sin(i*VDT21));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF3[iV+i]  =  wF[i];
    d  =  par[N_EP+i_VAR];
    i  =  0;
    j  =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i  ]*cos(i*VDT31)+wx1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT31)*(wF1[iV+2*i  ]*cos(i*VDT31)+wF1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC32*exp(-d*i*i*DT32)*(wF2[iV+2*i  ]*cos(i*VDT32)+wF2[iV+2*i+1]*sin(i*VDT32)) \
                 -  DC32*exp(-d*i*i*DT31)*(wF1[iV+2*i  ]*cos(i*VDT31)+wF1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC33*exp(-d*i*i*DT33)*(wF3[iV+2*i  ]*cos(i*VDT33)+wF3[iV+2*i+1]*sin(i*VDT33));
      wx[2*i+1]  =       exp(-d*j*j*DT31)*(wx1[iV+2*i+1]*cos(j*VDT31)-wx1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC31*exp(-d*j*j*DT31)*(wF1[iV+2*i+1]*cos(j*VDT31)-wF1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC32*exp(-d*j*j*DT32)*(wF2[iV+2*i+1]*cos(j*VDT32)-wF2[iV+2*i  ]*sin(i*VDT32)) \
                 -  DC32*exp(-d*j*j*DT31)*(wF1[iV+2*i+1]*cos(j*VDT31)-wF1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC33*exp(-d*j*j*DT33)*(wF3[iV+2*i+1]*cos(j*VDT33)-wF3[iV+2*i  ]*sin(i*VDT33));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i  ]*cos(i*VDT31)+wx1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT31)*(wF1[iV+2*i  ]*cos(i*VDT31)+wF1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC32*exp(-d*i*i*DT32)*(wF2[iV+2*i  ]*cos(i*VDT32)+wF2[iV+2*i+1]*sin(i*VDT32)) \
                 -  DC32*exp(-d*i*i*DT31)*(wF1[iV+2*i  ]*cos(i*VDT31)+wF1[iV+2*i+1]*sin(i*VDT31)) \
                 +  DC33*exp(-d*i*i*DT33)*(wF3[iV+2*i  ]*cos(i*VDT33)+wF3[iV+2*i+1]*sin(i*VDT33));
      wx[2*i+1]  =       exp(-d*i*i*DT31)*(wx1[iV+2*i+1]*cos(i*VDT31)-wx1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC31*exp(-d*i*i*DT31)*(wF1[iV+2*i+1]*cos(i*VDT31)-wF1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC32*exp(-d*i*i*DT32)*(wF2[iV+2*i+1]*cos(i*VDT32)-wF2[iV+2*i  ]*sin(i*VDT32)) \
                 -  DC32*exp(-d*i*i*DT31)*(wF1[iV+2*i+1]*cos(i*VDT31)-wF1[iV+2*i  ]*sin(i*VDT31)) \
                 +  DC33*exp(-d*i*i*DT33)*(wF3[iV+2*i+1]*cos(i*VDT33)-wF3[iV+2*i  ]*sin(i*VDT33));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF4[iV+i]  =  wF[i];
    d   =  par[N_EP+i_VAR];
    i   =  0;
    j   =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i  ]*cos(i*VDT41)+wx1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i  ]*cos(i*VDT42)+wF2[iV+2*i+1]*sin(i*VDT42)) \
                 -  DC42*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 -  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i  ]*cos(i*VDT43)+wF3[iV+2*i+1]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i  ]*cos(i*VDT44)+wF4[iV+2*i+1]*sin(i*VDT44));
      wx[2*i+1]  =       exp(-d*j*j*DT41)*(wx1[iV+2*i+1]*cos(j*VDT41)-wx1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC41*exp(-d*j*j*DT41)*(wF1[iV+2*i+1]*cos(j*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC42*exp(-d*j*j*DT42)*(wF2[iV+2*i+1]*cos(j*VDT42)-wF2[iV+2*i  ]*sin(i*VDT42)) \
                 -  DC42*exp(-d*j*j*DT41)*(wF1[iV+2*i+1]*cos(j*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 -  DC43*exp(-d*j*j*DT43)*(wF3[iV+2*i+1]*cos(j*VDT43)-wF3[iV+2*i  ]*sin(i*VDT43)) \
                 +  DC44*exp(-d*j*j*DT44)*(wF4[iV+2*i+1]*cos(j*VDT44)-wF4[iV+2*i  ]*sin(i*VDT44));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i  ]*cos(i*VDT41)+wx1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i  ]*cos(i*VDT42)+wF2[iV+2*i+1]*sin(i*VDT42)) \
                 -  DC42*exp(-d*i*i*DT41)*(wF1[iV+2*i  ]*cos(i*VDT41)+wF1[iV+2*i+1]*sin(i*VDT41)) \
                 -  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i  ]*cos(i*VDT43)+wF3[iV+2*i+1]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i  ]*cos(i*VDT44)+wF4[iV+2*i+1]*sin(i*VDT44));
      wx[2*i+1]  =       exp(-d*i*i*DT41)*(wx1[iV+2*i+1]*cos(i*VDT41)-wx1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC41*exp(-d*i*i*DT41)*(wF1[iV+2*i+1]*cos(i*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 +  DC42*exp(-d*i*i*DT42)*(wF2[iV+2*i+1]*cos(i*VDT42)-wF2[iV+2*i  ]*sin(i*VDT42)) \
                 -  DC42*exp(-d*i*i*DT41)*(wF1[iV+2*i+1]*cos(i*VDT41)-wF1[iV+2*i  ]*sin(i*VDT41)) \
                 -  DC43*exp(-d*i*i*DT43)*(wF3[iV+2*i+1]*cos(i*VDT43)-wF3[iV+2*i  ]*sin(i*VDT43)) \
                 +  DC44*exp(-d*i*i*DT44)*(wF4[iV+2*i+1]*cos(i*VDT44)-wF4[iV+2*i  ]*sin(i*VDT44));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ )
      wF[i]  =  F[iV+i+1];
    RDFT( N, NW, SCT, td, wF );
    for( i = 0; i <= N-1; i++ )
      wF5[iV+i]  =  wF[i];
    d   =  par[N_EP+i_VAR];
    i   =  0;
    j   =  NW/2;
      wx[2*i  ]  =       exp(-d*i*i*DT51)*(wx1[iV+2*i  ]*cos(i*VDT51)+wx1[iV+2*i+1]*sin(i*VDT51)) \
                 +  DC51*exp(-d*i*i*DT51)*(wF1[iV+2*i  ]*cos(i*VDT51)+wF1[iV+2*i+1]*sin(i*VDT51)) \
                 +  DC52*exp(-d*i*i*DT52)*(wF2[iV+2*i  ]*cos(i*VDT52)+wF2[iV+2*i+1]*sin(i*VDT52)) \
                 -  DC52*exp(-d*i*i*DT51)*(wF1[iV+2*i  ]*cos(i*VDT51)+wF1[iV+2*i+1]*sin(i*VDT51)) \
                 -  DC53*exp(-d*i*i*DT53)*(wF3[iV+2*i  ]*cos(i*VDT53)+wF3[iV+2*i+1]*sin(i*VDT53)) \
                 +  DC54*exp(-d*i*i*DT54)*(wF4[iV+2*i  ]*cos(i*VDT54)+wF4[iV+2*i+1]*sin(i*VDT54)) \
                 +  DC55*exp(-d*i*i*DT55)*(wF5[iV+2*i  ]*cos(i*VDT55)+wF5[iV+2*i+1]*sin(i*VDT55));
      wx[2*i+1]  =       exp(-d*j*j*DT51)*(wx1[iV+2*i+1]*cos(j*VDT51)-wx1[iV+2*i  ]*sin(i*VDT51)) \
                 +  DC51*exp(-d*j*j*DT51)*(wF1[iV+2*i+1]*cos(j*VDT51)-wF1[iV+2*i  ]*sin(i*VDT51)) \
                 +  DC52*exp(-d*j*j*DT52)*(wF2[iV+2*i+1]*cos(j*VDT52)-wF2[iV+2*i  ]*sin(i*VDT52)) \
                 -  DC52*exp(-d*j*j*DT51)*(wF1[iV+2*i+1]*cos(j*VDT51)-wF1[iV+2*i  ]*sin(i*VDT51)) \
                 -  DC53*exp(-d*j*j*DT53)*(wF3[iV+2*i+1]*cos(j*VDT53)-wF3[iV+2*i  ]*sin(i*VDT53)) \
                 +  DC54*exp(-d*j*j*DT54)*(wF4[iV+2*i+1]*cos(j*VDT54)-wF4[iV+2*i  ]*sin(i*VDT54)) \
                 +  DC55*exp(-d*j*j*DT55)*(wF5[iV+2*i+1]*cos(j*VDT55)-wF5[iV+2*i  ]*sin(i*VDT55));
    for( i = 1; i <= NW/2-1; i++ ){
      wx[2*i  ]  =       exp(-d*i*i*DT51)*(wx1[iV+2*i  ]*cos(i*VDT51)+wx1[iV+2*i+1]*sin(i*VDT51)) \
                 +  DC51*exp(-d*i*i*DT51)*(wF1[iV+2*i  ]*cos(i*VDT51)+wF1[iV+2*i+1]*sin(i*VDT51)) \
                 +  DC52*exp(-d*i*i*DT52)*(wF2[iV+2*i  ]*cos(i*VDT52)+wF2[iV+2*i+1]*sin(i*VDT52)) \
                 -  DC52*exp(-d*i*i*DT51)*(wF1[iV+2*i  ]*cos(i*VDT51)+wF1[iV+2*i+1]*sin(i*VDT51)) \
                 -  DC53*exp(-d*i*i*DT53)*(wF3[iV+2*i  ]*cos(i*VDT53)+wF3[iV+2*i+1]*sin(i*VDT53)) \
                 +  DC54*exp(-d*i*i*DT54)*(wF4[iV+2*i  ]*cos(i*VDT54)+wF4[iV+2*i+1]*sin(i*VDT54)) \
                 +  DC55*exp(-d*i*i*DT55)*(wF5[iV+2*i  ]*cos(i*VDT55)+wF5[iV+2*i+1]*sin(i*VDT55));
      wx[2*i+1]  =       exp(-d*i*i*DT51)*(wx1[iV+2*i+1]*cos(i*VDT51)-wx1[iV+2*i  ]*sin(i*VDT51)) \
                 +  DC51*exp(-d*i*i*DT51)*(wF1[iV+2*i+1]*cos(i*VDT51)-wF1[iV+2*i  ]*sin(i*VDT51)) \
                 +  DC52*exp(-d*i*i*DT52)*(wF2[iV+2*i+1]*cos(i*VDT52)-wF2[iV+2*i  ]*sin(i*VDT52)) \
                 -  DC52*exp(-d*i*i*DT51)*(wF1[iV+2*i+1]*cos(i*VDT51)-wF1[iV+2*i  ]*sin(i*VDT51)) \
                 -  DC53*exp(-d*i*i*DT53)*(wF3[iV+2*i+1]*cos(i*VDT53)-wF3[iV+2*i  ]*sin(i*VDT53)) \
                 +  DC54*exp(-d*i*i*DT54)*(wF4[iV+2*i+1]*cos(i*VDT54)-wF4[iV+2*i  ]*sin(i*VDT54)) \
                 +  DC55*exp(-d*i*i*DT55)*(wF5[iV+2*i+1]*cos(i*VDT55)-wF5[iV+2*i  ]*sin(i*VDT55));
    }
    for( i = NW; i <= N-1; i++ )
      wx[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx, x );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
  FREE_1D( wF1 );
  FREE_1D( wF2 );
  FREE_1D( wF3 );
  FREE_1D( wF4 );
  FREE_1D( wF5 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  AB_SM_INI( TEMP TP, double *par, double *pF, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int  N_VAR, N, NV, NW, NAB;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  NAB    =  TP.NAB;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int     i, i_VAR, iV, iVpx, i_NAB;
  int     *SCT;
  double  *td, *wF, *F;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  td   =  MALLOC_1D( N/2         );
  wF   =  MALLOC_1D( N           );
  F    =  malloc_1d( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
  i_NAB   =  1;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  do{
    Reaction( TP, par, x, F );
    iVpx  =  (i_NAB-1)*NV;
    for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
      iV  =  (i_VAR-1)*N;
      for( i = 0; i <= N-1; i++ )
        wF[i]  =  F[iV+i+1];
      RDFT( N, NW, SCT, td, wF );
      for( i = 0; i <= N-1; i++ )
        pF[iVpx+iV+i]  =  wF[i];
    }
    if( i_NAB == TP.NAB )  break;
    i_NAB ++;
    RK4_SM( TP, par, x );
  }while( 1 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  FREE_1D( wF  );
  free_1d( F   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  AB3_SM( TEMP TP, double *par, double *pF, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW, NAB;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  NAB    =  TP.NAB;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR, iV, i_AB, iAB1, iAB2;
  int    *SCT;
  double T, VEL, d, DT1, DT2, DT3, VDT1, VDT2, VDT3, DC1, DC2, DC3;
  double *F, *td, *wx, *wF, *wx1;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  F    =  malloc_1d( NV          );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  wx1  =  MALLOC_1D( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T   = TP.T;               VEL  = TP.VEL;
  DT1 =       T*dt;         VDT1 = VEL*DT1;
  DT2 =   2.0*T*dt;         VDT2 = VEL*DT2;
  DT3 =   3.0*T*dt;         VDT3 = VEL*DT3;
  DC1 =   5.0*T*dt/12.0;
  DC2 = -16.0*T*dt/12.0;
  DC3 =  23.0*T*dt/12.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx1[    0]  =      exp(-d*i*i*DT1)*(wx[          0]*cos(i*VDT1)                            ) \
                  +  DC1*exp(-d*i*i*DT3)*(pF[   iV+    0]*cos(i*VDT3)                            ) \
                  +  DC2*exp(-d*i*i*DT2)*(pF[NV+iV+    0]*cos(i*VDT2)                            ) \
                  +  DC3*exp(-d*i*i*DT1)*(wF[          0]*cos(i*VDT1)                            );
    i  =  NW/2;
      wx1[    1]  =      exp(-d*i*i*DT1)*(wx[          1]*cos(i*VDT1)                            ) \
                  +  DC1*exp(-d*i*i*DT3)*(pF[   iV+    1]*cos(i*VDT3)                            ) \
                  +  DC2*exp(-d*i*i*DT2)*(pF[NV+iV+    1]*cos(i*VDT2)                            ) \
                  +  DC3*exp(-d*i*i*DT1)*(wF[          1]*cos(i*VDT1)                            );
    for( i = 1; i <= NW/2-1; i++ ){
      wx1[2*i  ]  =      exp(-d*i*i*DT1)*(wx[      2*i  ]*cos(i*VDT1)+wx[      2*i+1]*sin(i*VDT1)) \
                  +  DC1*exp(-d*i*i*DT3)*(pF[   iV+2*i  ]*cos(i*VDT3)+pF[   iV+2*i+1]*sin(i*VDT3)) \
                  +  DC2*exp(-d*i*i*DT2)*(pF[NV+iV+2*i  ]*cos(i*VDT2)+pF[NV+iV+2*i+1]*sin(i*VDT2)) \
                  +  DC3*exp(-d*i*i*DT1)*(wF[      2*i  ]*cos(i*VDT1)+wF[      2*i+1]*sin(i*VDT1));
      wx1[2*i+1]  =      exp(-d*i*i*DT1)*(wx[      2*i+1]*cos(i*VDT1)-wx[      2*i  ]*sin(i*VDT1)) \
                  +  DC1*exp(-d*i*i*DT3)*(pF[   iV+2*i+1]*cos(i*VDT3)-pF[   iV+2*i  ]*sin(i*VDT3)) \
                  +  DC2*exp(-d*i*i*DT2)*(pF[NV+iV+2*i+1]*cos(i*VDT2)-pF[NV+iV+2*i  ]*sin(i*VDT2)) \
                  +  DC3*exp(-d*i*i*DT1)*(wF[      2*i+1]*cos(i*VDT1)-wF[      2*i  ]*sin(i*VDT1));
    }
    for( i = NW; i <= N-1; i++ )
      wx1[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx1, x );
    for( i_AB = 1; i_AB <= NAB-1; i_AB++ ){
      iAB1  =  (i_AB-1)*NV;
      iAB2  =   i_AB   *NV;
      for( i = 0; i <= N-1; i++ )
        pF[iAB1+iV+i]  =  pF[iAB2+iV+i];
    }
    iAB1  =  (NAB-1)*NV;
    for( i = 0; i <= N-1; i++ )
      pF[iAB1+iV+i]  =  wF[i];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/




/*-------------------------------------------------------------------------------*/
void  AB4_SM( TEMP TP, double *par, double *pF, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW, NAB;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  NAB    =  TP.NAB;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR, iV, i_AB, iAB1, iAB2;
  int    *SCT;
  double T, VEL, d, DT1, DT2, DT3, DT4, VDT1, VDT2, VDT3, VDT4, DC1, DC2, DC3, DC4;
  double *F, *td, *wx, *wF, *wx1;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  F    =  malloc_1d( NV          );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  wx1  =  MALLOC_1D( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T   = TP.T;               VEL  = TP.VEL;
  DT1 =       T*dt;         VDT1 = VEL*DT1;
  DT2 =   2.0*T*dt;         VDT2 = VEL*DT2;
  DT3 =   3.0*T*dt;         VDT3 = VEL*DT3;
  DT4 =   4.0*T*dt;         VDT4 = VEL*DT4;
  DC1 = - 9.0*T*dt/24.0;
  DC2 =  37.0*T*dt/24.0;
  DC3 = -59.0*T*dt/24.0;
  DC4 =  55.0*T*dt/24.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx1[    0]  =      exp(-d*i*i*DT1)*(wx[            0]*cos(i*VDT1)                              ) \
                  +  DC1*exp(-d*i*i*DT4)*(pF[     iV+    0]*cos(i*VDT4)                              ) \
                  +  DC2*exp(-d*i*i*DT3)*(pF[  NV+iV+    0]*cos(i*VDT3)                              ) \
                  +  DC3*exp(-d*i*i*DT2)*(pF[2*NV+iV+    0]*cos(i*VDT2)                              ) \
                  +  DC4*exp(-d*i*i*DT1)*(wF[            0]*cos(i*VDT1)                              );
    i  =  NW/2;
      wx1[    1]  =      exp(-d*i*i*DT1)*(wx[            1]*cos(i*VDT1)                              ) \
                  +  DC1*exp(-d*i*i*DT4)*(pF[     iV+    1]*cos(i*VDT4)                              ) \
                  +  DC2*exp(-d*i*i*DT3)*(pF[  NV+iV+    1]*cos(i*VDT3)                              ) \
                  +  DC3*exp(-d*i*i*DT2)*(pF[2*NV+iV+    1]*cos(i*VDT2)                              ) \
                  +  DC4*exp(-d*i*i*DT1)*(wF[            1]*cos(i*VDT1)                              );
    for( i = 1; i <= NW/2-1; i++ ){
      wx1[2*i  ]  =      exp(-d*i*i*DT1)*(wx[        2*i  ]*cos(i*VDT1)+wx[        2*i+1]*sin(i*VDT1)) \
                  +  DC1*exp(-d*i*i*DT4)*(pF[     iV+2*i  ]*cos(i*VDT4)+pF[     iV+2*i+1]*sin(i*VDT4)) \
                  +  DC2*exp(-d*i*i*DT3)*(pF[  NV+iV+2*i  ]*cos(i*VDT3)+pF[  NV+iV+2*i+1]*sin(i*VDT3)) \
                  +  DC3*exp(-d*i*i*DT2)*(pF[2*NV+iV+2*i  ]*cos(i*VDT2)+pF[2*NV+iV+2*i+1]*sin(i*VDT2)) \
                  +  DC4*exp(-d*i*i*DT1)*(wF[        2*i  ]*cos(i*VDT1)+wF[        2*i+1]*sin(i*VDT1));
      wx1[2*i+1]  =      exp(-d*i*i*DT1)*(wx[        2*i+1]*cos(i*VDT1)-wx[        2*i  ]*sin(i*VDT1)) \
                  +  DC1*exp(-d*i*i*DT4)*(pF[     iV+2*i+1]*cos(i*VDT4)-pF[     iV+2*i  ]*sin(i*VDT4)) \
                  +  DC2*exp(-d*i*i*DT3)*(pF[  NV+iV+2*i+1]*cos(i*VDT3)-pF[  NV+iV+2*i  ]*sin(i*VDT3)) \
                  +  DC3*exp(-d*i*i*DT2)*(pF[2*NV+iV+2*i+1]*cos(i*VDT2)-pF[2*NV+iV+2*i  ]*sin(i*VDT2)) \
                  +  DC4*exp(-d*i*i*DT1)*(wF[        2*i+1]*cos(i*VDT1)-wF[        2*i  ]*sin(i*VDT1));
    }
    for( i = NW; i <= N-1; i++ )
      wx1[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx1, x );
    for( i_AB = 1; i_AB <= NAB-1; i_AB++ ){
      iAB1  =  (i_AB-1)*NV;
      iAB2  =   i_AB   *NV;
      for( i = 0; i <= N-1; i++ )
        pF[iAB1+iV+i]  =  pF[iAB2+iV+i];
    }
    iAB1  =  (NAB-1)*NV;
    for( i = 0; i <= N-1; i++ )
      pF[iAB1+iV+i]  =  wF[i];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  AB5_SM( TEMP TP, double *par, double *pF, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW, NAB;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  NAB    =  TP.NAB;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR, iV, i_AB, iAB1, iAB2;
  int    *SCT;
  double T, VEL, d, DT1, DT2, DT3, DT4, DT5, VDT1, VDT2, VDT3, VDT4, VDT5, DC1, DC2, DC3, DC4, DC5;
  double *F, *td, *wx, *wF, *wx1;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  F    =  malloc_1d( NV          );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  wx1  =  MALLOC_1D( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T   = TP.T;                 VEL  = TP.VEL;
  DT1 =         T*dt;         VDT1 = VEL*DT1;
  DT2 =     2.0*T*dt;         VDT2 = VEL*DT2;
  DT3 =     3.0*T*dt;         VDT3 = VEL*DT3;
  DT4 =     4.0*T*dt;         VDT4 = VEL*DT4;
  DT5 =     5.0*T*dt;         VDT5 = VEL*DT5;
  DC1 =   251.0*T*dt/720.0;
  DC2 = -1274.0*T*dt/720.0;
  DC3 =  2616.0*T*dt/720.0;
  DC4 = -2774.0*T*dt/720.0;
  DC5 =  1901.0*T*dt/720.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx1[    0]  =      exp(-d*i*i*DT1)*(wx[            0]*cos(i*VDT1)                              ) \
                  +  DC1*exp(-d*i*i*DT5)*(pF[     iV+    0]*cos(i*VDT5)                              ) \
                  +  DC2*exp(-d*i*i*DT4)*(pF[  NV+iV+    0]*cos(i*VDT4)                              ) \
                  +  DC3*exp(-d*i*i*DT3)*(pF[2*NV+iV+    0]*cos(i*VDT3)                              ) \
                  +  DC4*exp(-d*i*i*DT2)*(pF[3*NV+iV+    0]*cos(i*VDT2)                              ) \
                  +  DC5*exp(-d*i*i*DT1)*(wF[            0]*cos(i*VDT1)                              );
    i  =  NW/2;
      wx1[    1]  =      exp(-d*i*i*DT1)*(wx[            1]*cos(i*VDT1)                              ) \
                  +  DC1*exp(-d*i*i*DT5)*(pF[     iV+    1]*cos(i*VDT5)                              ) \
                  +  DC2*exp(-d*i*i*DT4)*(pF[  NV+iV+    1]*cos(i*VDT4)                              ) \
                  +  DC3*exp(-d*i*i*DT3)*(pF[2*NV+iV+    1]*cos(i*VDT3)                              ) \
                  +  DC4*exp(-d*i*i*DT2)*(pF[3*NV+iV+    1]*cos(i*VDT2)                              ) \
                  +  DC5*exp(-d*i*i*DT1)*(wF[            1]*cos(i*VDT1)                              );
    for( i = 1; i <= NW/2-1; i++ ){
      wx1[2*i  ]  =      exp(-d*i*i*DT1)*(wx[        2*i  ]*cos(i*VDT1)+wx[        2*i+1]*sin(i*VDT1)) \
                  +  DC1*exp(-d*i*i*DT5)*(pF[     iV+2*i  ]*cos(i*VDT5)+pF[     iV+2*i+1]*sin(i*VDT5)) \
                  +  DC2*exp(-d*i*i*DT4)*(pF[  NV+iV+2*i  ]*cos(i*VDT4)+pF[  NV+iV+2*i+1]*sin(i*VDT4)) \
                  +  DC3*exp(-d*i*i*DT3)*(pF[2*NV+iV+2*i  ]*cos(i*VDT3)+pF[2*NV+iV+2*i+1]*sin(i*VDT3)) \
                  +  DC4*exp(-d*i*i*DT2)*(pF[3*NV+iV+2*i  ]*cos(i*VDT2)+pF[3*NV+iV+2*i+1]*sin(i*VDT2)) \
                  +  DC5*exp(-d*i*i*DT1)*(wF[        2*i  ]*cos(i*VDT1)+wF[        2*i+1]*sin(i*VDT1));
      wx1[2*i+1]  =      exp(-d*i*i*DT1)*(wx[        2*i+1]*cos(i*VDT1)-wx[        2*i  ]*sin(i*VDT1)) \
                  +  DC1*exp(-d*i*i*DT5)*(pF[     iV+2*i+1]*cos(i*VDT5)-pF[     iV+2*i  ]*sin(i*VDT5)) \
                  +  DC2*exp(-d*i*i*DT4)*(pF[  NV+iV+2*i+1]*cos(i*VDT4)-pF[  NV+iV+2*i  ]*sin(i*VDT4)) \
                  +  DC3*exp(-d*i*i*DT3)*(pF[2*NV+iV+2*i+1]*cos(i*VDT3)-pF[2*NV+iV+2*i  ]*sin(i*VDT3)) \
                  +  DC4*exp(-d*i*i*DT2)*(pF[3*NV+iV+2*i+1]*cos(i*VDT2)-pF[3*NV+iV+2*i  ]*sin(i*VDT2)) \
                  +  DC5*exp(-d*i*i*DT1)*(wF[        2*i+1]*cos(i*VDT1)-wF[        2*i  ]*sin(i*VDT1));
    }
    for( i = NW; i <= N-1; i++ )
      wx1[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx1, x );
    for( i_AB = 1; i_AB <= NAB-1; i_AB++ ){
      iAB1  =  (i_AB-1)*NV;
      iAB2  =   i_AB   *NV;
      for( i = 0; i <= N-1; i++ )
        pF[iAB1+iV+i]  =  pF[iAB2+iV+i];
    }
    iAB1  =  (NAB-1)*NV;
    for( i = 0; i <= N-1; i++ )
      pF[iAB1+iV+i]  =  wF[i];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  AB6_SM( TEMP TP, double *par, double *pF, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N_EP, N, NV, NW, NAB;
  double dt;
  N_VAR  =  TP.N_VAR;
  N_EP   =  TP.N_EP;
  N      =  TP.N;
  NV     =  TP.NV;
  NW     =  TP.NW;
  NAB    =  TP.NAB;
  dt     =  TP.dt;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR, iV, i_AB, iAB1, iAB2;
  int    *SCT;
  double T, VEL, d, DT1, DT2, DT3, DT4, DT5, DT6, VDT1, VDT2, VDT3, VDT4, VDT5, VDT6, DC1, DC2, DC3, DC4, DC5, DC6;
  double *F, *td, *wx, *wF, *wx1;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT  =  MALLOC_1I( 2+sqrt(N/2) );
  F    =  malloc_1d( NV          );
  td   =  MALLOC_1D( N/2         );
  wx   =  MALLOC_1D( N           );
  wF   =  MALLOC_1D( N           );
  wx1  =  MALLOC_1D( NV          );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SCT[0]  =  0; 
/*  T       =  x[TP.NV+TP.np];*/
/*  if  ( TP.nv == 0 )   VEL  =  0.0;*/
/*  else                 VEL  =  x[TP.NM*TP.NV+TP.np+TP.nv];*/
  T   = TP.T;                 VEL  = TP.VEL;
  DT1 =         T*dt;         VDT1 = VEL*DT1;
  DT2 =     2.0*T*dt;         VDT2 = VEL*DT2;
  DT3 =     3.0*T*dt;         VDT3 = VEL*DT3;
  DT4 =     4.0*T*dt;         VDT4 = VEL*DT4;
  DT5 =     5.0*T*dt;         VDT5 = VEL*DT5;
  DT6 =     6.0*T*dt;         VDT6 = VEL*DT6;
  DC1 = - 475.0*T*dt/1440.0;
  DC2 =  2877.0*T*dt/1440.0;
  DC3 = -7298.0*T*dt/1440.0;
  DC4 =  9982.0*T*dt/1440.0;
  DC5 = -7923.0*T*dt/1440.0;
  DC6 =  4277.0*T*dt/1440.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Reaction( TP, par, x, F );
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    iV  =  (i_VAR-1)*N;
    for( i = 0; i <= N-1; i++ ){
      wx[i]  =  x[iV+i+1];
      wF[i]  =  F[iV+i+1];
    }
    RDFT( N, NW, SCT, td, wx );
    RDFT( N, NW, SCT, td, wF );
    d  =  par[N_EP+i_VAR];
    i  =  0;
      wx1[    0]  =      exp(-d*i*i*DT1)*(wx[            0]*cos(i*VDT1)                              ) \
                  +  DC1*exp(-d*i*i*DT6)*(pF[     iV+    0]*cos(i*VDT6)                              ) \
                  +  DC2*exp(-d*i*i*DT5)*(pF[  NV+iV+    0]*cos(i*VDT5)                              ) \
                  +  DC3*exp(-d*i*i*DT4)*(pF[2*NV+iV+    0]*cos(i*VDT4)                              ) \
                  +  DC4*exp(-d*i*i*DT3)*(pF[3*NV+iV+    0]*cos(i*VDT3)                              ) \
                  +  DC5*exp(-d*i*i*DT2)*(pF[4*NV+iV+    0]*cos(i*VDT2)                              ) \
                  +  DC6*exp(-d*i*i*DT1)*(wF[            0]*cos(i*VDT1)                              );
    i  =  NW/2;
      wx1[    1]  =      exp(-d*i*i*DT1)*(wx[            1]*cos(i*VDT1)                              ) \
                  +  DC1*exp(-d*i*i*DT6)*(pF[     iV+    1]*cos(i*VDT6)                              ) \
                  +  DC2*exp(-d*i*i*DT5)*(pF[  NV+iV+    1]*cos(i*VDT5)                              ) \
                  +  DC3*exp(-d*i*i*DT4)*(pF[2*NV+iV+    1]*cos(i*VDT4)                              ) \
                  +  DC4*exp(-d*i*i*DT3)*(pF[3*NV+iV+    1]*cos(i*VDT3)                              ) \
                  +  DC5*exp(-d*i*i*DT2)*(pF[4*NV+iV+    1]*cos(i*VDT2)                              ) \
                  +  DC6*exp(-d*i*i*DT1)*(wF[            1]*cos(i*VDT1)                              );
    for( i = 1; i <= NW/2-1; i++ ){
      wx1[2*i  ]  =      exp(-d*i*i*DT1)*(wx[        2*i  ]*cos(i*VDT1)+wx[        2*i+1]*sin(i*VDT1)) \
                  +  DC1*exp(-d*i*i*DT6)*(pF[     iV+2*i  ]*cos(i*VDT6)+pF[     iV+2*i+1]*sin(i*VDT6)) \
                  +  DC2*exp(-d*i*i*DT5)*(pF[  NV+iV+2*i  ]*cos(i*VDT5)+pF[  NV+iV+2*i+1]*sin(i*VDT5)) \
                  +  DC3*exp(-d*i*i*DT4)*(pF[2*NV+iV+2*i  ]*cos(i*VDT4)+pF[2*NV+iV+2*i+1]*sin(i*VDT4)) \
                  +  DC4*exp(-d*i*i*DT3)*(pF[3*NV+iV+2*i  ]*cos(i*VDT3)+pF[3*NV+iV+2*i+1]*sin(i*VDT3)) \
                  +  DC5*exp(-d*i*i*DT2)*(pF[4*NV+iV+2*i  ]*cos(i*VDT2)+pF[4*NV+iV+2*i+1]*sin(i*VDT2)) \
                  +  DC6*exp(-d*i*i*DT1)*(wF[        2*i  ]*cos(i*VDT1)+wF[        2*i+1]*sin(i*VDT1));
      wx1[2*i+1]  =      exp(-d*i*i*DT1)*(wx[        2*i+1]*cos(i*VDT1)-wx[        2*i  ]*sin(i*VDT1)) \
                  +  DC1*exp(-d*i*i*DT6)*(pF[     iV+2*i+1]*cos(i*VDT6)-pF[     iV+2*i  ]*sin(i*VDT6)) \
                  +  DC2*exp(-d*i*i*DT5)*(pF[  NV+iV+2*i+1]*cos(i*VDT5)-pF[  NV+iV+2*i  ]*sin(i*VDT5)) \
                  +  DC3*exp(-d*i*i*DT4)*(pF[2*NV+iV+2*i+1]*cos(i*VDT4)-pF[2*NV+iV+2*i  ]*sin(i*VDT4)) \
                  +  DC4*exp(-d*i*i*DT3)*(pF[3*NV+iV+2*i+1]*cos(i*VDT3)-pF[3*NV+iV+2*i  ]*sin(i*VDT3)) \
                  +  DC5*exp(-d*i*i*DT2)*(pF[4*NV+iV+2*i+1]*cos(i*VDT2)-pF[4*NV+iV+2*i  ]*sin(i*VDT2)) \
                  +  DC6*exp(-d*i*i*DT1)*(wF[        2*i+1]*cos(i*VDT1)-wF[        2*i  ]*sin(i*VDT1));
    }
    for( i = NW; i <= N-1; i++ )
      wx1[i]  =  0.0;
    IRDFT( i_VAR, N, SCT, td, wx1, x );
    for( i_AB = 1; i_AB <= NAB-1; i_AB++ ){
      iAB1  =  (i_AB-1)*NV;
      iAB2  =   i_AB   *NV;
      for( i = 0; i <= N-1; i++ )
        pF[iAB1+iV+i]  =  pF[iAB2+iV+i];
    }
    iAB1  =  (NAB-1)*NV;
    for( i = 0; i <= N-1; i++ )
      pF[iAB1+iV+i]  =  wF[i];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1I( SCT );
  FREE_1D( td  );
  free_1d( F   );
  FREE_1D( wx  );
  FREE_1D( wF  );
  FREE_1D( wx1 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RDFT( int N, int NW, int *SCT, double *td, double *wx )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  rdft( N, 1, wx, SCT, td );
  if( N  !=  NW )
    wx[1]  =  0.0;
  for( i = NW/2; i <= N/2-1; i++ ){
    wx[2*i  ]  =  0.0;
    wx[2*i+1]  =  0.0;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  IRDFT( int i_VAR, int N, int *SCT, double *td, double *wx, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  rdft( N, -1, wx, SCT, td );
  for( i = 0; i <= N-1; i++ )
    x[(i_VAR-1)*N+i+1]  =  2.0 * wx[i] / N;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
