/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  Velocity_Measurement( TEMP *TP, double *BC, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N, Ns, N_Vel, BCS;
  double dx, dt, Lx, Vel_Site;
  N         =  TP->N;
  Ns        =  TP->Ns;
  N_Vel     =  TP->N_Vel;
  BCS       =  TP->BCS;
  dx        =  TP->dx;
  dt        =  TP->dt;
  Lx        =  TP->Lx;
  Vel_Site  =  TP->Vel_Site;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double diff_F_T;
  double pDis_Front, pVel_Front, SumVel_Front, AveVel_Front;
  double pDis_Tail, pVel_Tail, SumVel_Tail, AveVel_Tail;
  pDis_Front    =  TP->pDis_F;
  pVel_Front    =  TP->pVel_F;
  SumVel_Front  =  TP->SumVel_F;
  AveVel_Front  =  TP->AveVel_F;
  pDis_Tail     =  TP->pDis_T;
  pVel_Tail     =  TP->pVel_T;
  SumVel_Tail   =  TP->SumVel_T;
  AveVel_Tail   =  TP->AveVel_T;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double front_dis=0.0, tail_dis=0.0;
  double change_F_T;
  double distance, p_distance;
  double diff1, diff2;
  double Vel, p_Vel, Sum_Vel, Ave_Vel;
  double *u;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  u   =  malloc_1d( Ns );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 2; i <= Ns-1; i++ )
    u[i]  =  x[i];
  if( BCS  ==  1 ){
    u[1 ]  =  BC[1];
    u[Ns]  =  BC[2];
  }else if( BCS  ==  2 ){
    u[1 ]  =  x[1 ];
    u[Ns]  =  x[Ns];
  }else if( BCS  ==  3 ){
    u[1 ]  =  x[1];
    u[Ns]  =  x[1];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = Ns-1; i >= 1; i-- ){
    if( (Vel_Site <= u[i]  &&  Vel_Site >= u[i+1]) ||
        (Vel_Site >= u[i]  &&  Vel_Site <= u[i+1])    ){
      front_dis  =  dx * ( i + (Vel_Site-u[i+1])/(u[i+1]-u[i]) );
      break;
    }
  }
  for( i = 1; i <= Ns-1; i++ ){
    if( (Vel_Site <= u[i]  &&  Vel_Site >= u[i+1]) ||
        (Vel_Site >= u[i]  &&  Vel_Site <= u[i+1])    ){
      tail_dis  =  dx * ( i + (Vel_Site-u[i+1])/(u[i+1]-u[i]) );
      break;
    }
  }
  if( N_Vel  ==  0 )
    if( Lx-fabs(front_dis-tail_dis)  <  fabs(front_dis-tail_dis) )
      return;
  if( Lx-fabs(front_dis-tail_dis)  <  fabs(front_dis-tail_dis) ){
    if(  (!(pDis_Tail-front_dis  > 0.0  &&  pDis_Tail-tail_dis  > 0.0)) || \
         (!(front_dis-pDis_Front > 0.0  &&  tail_dis-pDis_Front > 0.0))    ){
      change_F_T  =  tail_dis;
      tail_dis    =  front_dis;
      front_dis   =  change_F_T;
    }
  }
  if( tail_dis <= front_dis )   diff_F_T  =       fabs(front_dis-tail_dis);
  else                          diff_F_T  =  Lx - fabs(front_dis-tail_dis);
  TP->diff_F_T  =  diff_F_T;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( N_Vel  ==  0 ){
    TP->pDis_F    =  front_dis;
    TP->pVel_F    =  0.0;
    TP->SumVel_F  =  0.0;
    TP->AveVel_F  =  0.0;
    TP->pDis_T    =  tail_dis;
    TP->pVel_T    =  0.0;
    TP->SumVel_T  =  0.0;
    TP->AveVel_T  =  0.0;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  else{
    for( i = 1; i <= 2; i++ ){
      if( i  ==  1 ){
        distance    =  front_dis;
        p_distance  =  pDis_Front;
        p_Vel       =  pVel_Front;
        Sum_Vel     =  SumVel_Front;
        Ave_Vel     =  AveVel_Front;
      }else{
        distance    =  tail_dis;
        p_distance  =  pDis_Tail;
        p_Vel       =  pVel_Tail;
        Sum_Vel     =  SumVel_Tail;
        Ave_Vel     =  AveVel_Tail;
      }
      diff1  =  fabs( distance-p_distance );
      diff2  =  Lx - diff1;
      if( diff1  <=  diff2 )
        Vel  =  (distance - p_distance) / dt;
      else if( p_distance  >=  distance )
        Vel  =    diff2 / dt;
      else
        Vel  =  - diff2 / dt;
      p_distance  =  distance;
      if( N_Vel  ==  1 ){
        p_Vel    =  Vel;
        Sum_Vel  =  Vel;
        Ave_Vel  =  Vel;
      }else{
        Sum_Vel  +=  0.5*( p_Vel+Vel );
        Ave_Vel   =  Sum_Vel / (N_Vel-1);
        p_Vel     =  Vel;
      }
      if( i  ==  1 ){
        TP->pDis_F    =  p_distance;
        TP->pVel_F    =  p_Vel;
        TP->SumVel_F  =  Sum_Vel;
        TP->AveVel_F  =  Ave_Vel;
      }else{
        TP->pDis_T    =  p_distance;
        TP->pVel_T    =  p_Vel;
        TP->SumVel_T  =  Sum_Vel;
        TP->AveVel_T  =  Ave_Vel;
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP->pDis_F  <=  TP->pDis_T ){
    TP->pDis_C  =  ( Lx+TP->pDis_F + TP->pDis_T ) / 2.0;
    if( Lx  <  TP->pDis_C )
      TP->pDis_C  -=  Lx;
  }else
    TP->pDis_C  =  ( TP->pDis_F + TP->pDis_T     ) / 2.0;
  TP->pVel_C    =  ( TP->pVel_F + TP->pVel_T     ) / 2.0;
  TP->AveVel_C  =  ( TP->AveVel_F + TP->AveVel_T ) / 2.0;
  TP->N_Vel ++;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( u );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
