/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
int  main()
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  comment_remove( READ_OPERATIONPARAMETER, READ_WRITE_OPERATIONPARAMETER );
  comment_remove( READ_EQUATIONPARAMETER , READ_WRITE_EQUATIONPARAMETER  );
  comment_remove( READ_BOUNDARYPARAMETER , READ_WRITE_BOUNDARYPARAMETER  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_OP, t_N_EP, t_N_BC;
  DataNum( READ_WRITE_OPERATIONPARAMETER, &N_OP   );
  DataNum( READ_WRITE_EQUATIONPARAMETER , &t_N_EP );
  DataNum( READ_WRITE_BOUNDARYPARAMETER , &t_N_BC );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    *OP_i;
  double *OP_d, *t_par, *t_BC;
  OP_i   =  malloc_1i( N_OP   );
  OP_d   =  malloc_1d( N_OP   );
  t_par  =  malloc_1d( t_N_EP );
  t_BC   =  malloc_1d( t_N_BC );
  Read_OperationParameter( READ_WRITE_OPERATIONPARAMETER, N_OP  , OP_i , OP_d );
  Read_EquationParameter ( READ_WRITE_EQUATIONPARAMETER , t_N_EP, t_par       );
  Read_BoundaryParameter ( READ_WRITE_BOUNDARYPARAMETER , t_N_BC, t_BC        );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  TEMP TP;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i=1;
  int    VMS, StepCut, MaxStep, IS;
  double GS;
              TP.N         =  OP_i[i++];
              TP.NW        =  OP_i[i++];
              TP.T         =  OP_d[i++];
              TP.VEL       =  OP_d[i++];
              TP.dt        =  OP_d[i++];
              TP.Lx        =  OP_d[i++];
              TP.GCNVD     =  OP_i[i++];
              TP.Vel_Site  =  OP_d[i++];
  VMS      =  TP.VMS       =  OP_i[i++];
              TP.BCS       =  OP_i[i++];
              TP.EES       =  OP_i[i++];
  StepCut  =  TP.StepCut   =  OP_i[i++];
  MaxStep  =  TP.MaxStep   =  OP_i[i++];
  GS       =  TP.GS        =  OP_d[i++];
  IS       =  TP.IS        =  OP_i[i++];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  TP.N_OP      =  N_OP;
  TP.N_EP      =  t_N_EP;
  TP.N_VAR     =  t_N_BC / 2;
  TP.NM        =  1;
  TP.NA        =  3;
/*  TP.np        =  1;*/
/*  TP.nv        =  1;*/
  TP.PF        =  0;
  TP.ME        =  0.0;
  TP.c_MP      =  9;
  TP.step      =  0;
  TP.N_Vel     =  0;
  TP.AveVel_C  =  0.0;
  TP.REV_i_E   =  0.0;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int    N_EP, N_VAR, N, NV, NA;
  double *par, *BC, *x;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  initial_set1( &TP );
  N_EP   =  TP.N_EP;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NV     =  TP.NV  =  N_VAR * N;
  NA     =  TP.NA;
  par    =  malloc_1d( N_EP+N_VAR );
  BC     =  malloc_1d( N_VAR*2    );
  x      =  malloc_1d( NV+NA      );
  for( i = 1; i <= t_N_EP; i++ )
    par[i]  =  t_par[i];
  for( i = 1; i <= t_N_BC; i++ )
    BC[i]  =  t_BC[i];
  free_1d( t_par );
  free_1d( t_BC  );
  initial_set2( &TP, par, BC, x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_G  =  (int)N_GNUPLOT;
  int *c_G;
  c_G  =  MALLOC_1I( N_G+1 );
  GNUPLOT_DRAW_SELECT( N_G, GS, c_G );
  if( IS  ==  9 )
    c_G[0]  =  1;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Parameter_OutPut( TP, par );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  output( TP, par, BC, x, 'w' );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  Diffusion( TP, par );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double **a;
  if( TP.EES  ==  EES_D ){
    a  =  malloc_2d( 5, N_VAR*N );
    M_1n1v3dDNC( TP, par, BC, a );
    LU_Decomposition_EE( TP, a );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double *F;
  double *RS;
  if( TP.EES  ==  EES_D ){
    F   =  malloc_1d( NV );
    RS  =  malloc_1d( NV );
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( c_G[0]  ==  1 )
    Gnuplot_InitialCommand( &TP, c_G );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*  TP.NAB  =  2;*/
/*  double *pF;*/
/*  pF  =  MALLOC_1D( TP.NAB*NV );*/
/*  AB_SM_INI( TP, par, pF, x );*/
/*  TP.step  =  TP.NAB;*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*  for( ; TP.step <= MaxStep; TP.step++ ){*/
  for( TP.step = 1; TP.step <= MaxStep; TP.step++ ){
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    if( TP.EES  ==  EES_D ){
      Reaction( TP, par, x, F );
      RS_1n1v3dDNC( TP, par, BC, x, F, RS );
      Calculate_Solution_EE( TP, RS, a, x );                  }
/*    else if( TP.NAB == 5 ){    AB6_SM( TP, par, pF, x );   }*/
/*    else if( TP.NAB == 4 ){    AB5_SM( TP, par, pF, x );   }*/
/*    else if( TP.NAB == 3 ){    AB4_SM( TP, par, pF, x );   }*/
/*    else if( TP.NAB == 2 ){    AB3_SM( TP, par, pF, x );   }*/
    else if( TP.EES  ==  EES_S_E ){    EM_SM( TP, par, x );   }
    else if( TP.EES  ==  EES_S_R ){   RK4_SM3( TP, par, x );   }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    if( TP.step % StepCut  ==  0 ){
      if( IS != 1  &&  TP.step == StepCut )   output( TP, par, BC, x, 'w' );
      else                                    output( TP, par, BC, x, 'a' );
      if( c_G[0]  ==  1 ){
        Gnuplot_Draw( TP, c_G );
        printf( "step / MaxStep    =  %d / %d\n", TP.step, MaxStep );
        printf( "Average Velocity  =  %10.8lf\n", TP.AveVel_C      );
        printf( "                            \n"                   );
      }
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    if( VMS  <=  TP.step ){
      Velocity_Measurement( &TP, BC, x );
      if( TP.N_Vel  ==  2 )        output2( TP, par, x, 'w' );
      else if( TP.N_Vel  >=  3 )   output2( TP, par, x, 'a' );
    }
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( c_G[0]  ==  1 )
    Gnuplot_Close( &TP );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Parameter_OutPut( TP, par );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  TP.step  =  MaxStep;
  Output_Final( TP, par, BC, x, WRITE_FINALDATA, 'w' );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Remove_TempFile( READ_WRITE_OPERATIONPARAMETER  );
  Remove_TempFile( READ_WRITE_EQUATIONPARAMETER   );
  Remove_TempFile( READ_WRITE_BOUNDARYPARAMETER   );
  Remove_TempFile( Gi_SOLUTION_VALUE              );
  Remove_TempFile( Gw_SOLUTION_VALUE              );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1i( OP_i  );
  free_1d( OP_d  );
  free_1d( par   );
  free_1d( BC    );
  free_1d( x     );
  if( TP.EES  ==  EES_D ){
    free_2d( a     );
    free_1d( F     );
    free_1d( RS    );
  }
  FREE_1I( c_G   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  return 0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
