/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  output( TEMP TP, double *par, double *BC, double *x, int WriteMode )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N, NA, Ns, step;
  double dt, dx;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  Ns     =  TP.Ns;
  NA     =  TP.NA;
  step   =  TP.step;
  dt     =  TP.dt;
  dx     =  TP.dx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  double time;
  double *t_x, *norm;
  FILE   *FP_W, *GP_W;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  t_x   =  malloc_1d( N_VAR*Ns+NA );
  norm  =  malloc_1d( N_NORM      );
  Generate_tSV( TP, BC, x, t_x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  time  =  (double)(step) * dt;
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  FP_W  =  fopen_mode( WRITE_SOLUTION_VALUE, WriteMode );
  for( i = 1; i <= Ns; i++ ){
    fprintf( FP_W, "%10.8lf %10.8lf ", time, (double)(i-1)*dx );
    for( i_VAR = 1; i_VAR < N_VAR; i_VAR++ )
      fprintf( FP_W, "%15.8E ", t_x[(i_VAR-1)*Ns+i] );
    fprintf( FP_W, "%15.8E\n", t_x[(i_VAR-1)*Ns+i] );
  }
  fclose( FP_W );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  Calculate_Norm( TP, t_x, norm );
  FP_W  =  fopen_mode( WRITE_STEP_TIME_DX_SVPU_SVPV, WriteMode );
  fprintf( FP_W, "%7d %10.8lf ", step, time );
  for( i = 1; i <= N_NORM-1; i++ )
    fprintf( FP_W, "%15.8E ", norm[i] );
  fprintf( FP_W, "%15.8E\n", norm[i] );
  fclose( FP_W );
  free_1d( norm );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  if( step  ==  0 ){
    GP_W  =  fopen_mode( Gi_SOLUTION_VALUE, 'w' );
    for( i = 1; i <= Ns; i++ ){
      fprintf( GP_W, "%10.8lf ", (double)(i-1)*dx );
      for( i_VAR = 1; i_VAR < N_VAR; i_VAR++ )
        fprintf( GP_W, "%15.8E ", t_x[(i_VAR-1)*Ns+i] );
      fprintf( GP_W, "%15.8E\n", t_x[(i_VAR-1)*Ns+i] );
    }
    fclose( GP_W );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  GP_W  =  fopen_mode( Gw_SOLUTION_VALUE, 'w' );
  for( i = 1; i <= Ns; i++ ){
    fprintf( GP_W, "%10.8lf ", (double)(i-1)*dx );
    for( i_VAR = 1; i_VAR < N_VAR; i_VAR++ )
      fprintf( GP_W, "%15.8E ", t_x[(i_VAR-1)*Ns+i] );
    fprintf( GP_W, "%15.8E\n", t_x[(i_VAR-1)*Ns+i] );
  }
  fclose( GP_W );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  free_1d( t_x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  output2( TEMP TP, double *par, double *x, int WriteMode )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int step, N_Vel, GCNVD;
  double dt, diff_F_T, p_distance, p_vel, AveVel;
  step        =  TP.step;
  N_Vel       =  TP.N_Vel;
  GCNVD       =  TP.GCNVD;
  dt          =  TP.dt;
  diff_F_T    =  TP.diff_F_T;
  p_distance  =  TP.pDis_C;
  p_vel       =  TP.pVel_C;
  AveVel      =  TP.AveVel_C;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FILE *FP_W;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  if( (N_Vel-2) % GCNVD  ==  0 ){
    FP_W  =  fopen_mode( WRITE_STEP_TIME_DIFF_DIS_VEL_AVEL, WriteMode );
    fprintf( FP_W, "%7d %10.8lf %15.12E %15.12E %15.12E %15.12E\n", \
             step, (double)step*dt, diff_F_T, p_distance, p_vel, AveVel );
    fclose( FP_W );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Calculate_Norm( TEMP TP, double *t_x, double *norm )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N, NV, Ns;
  double dx;
  N_VAR  =  TP.N_VAR;
  N      =  TP.N;
  NV     =  TP.NV;
  Ns     =  TP.Ns;
  dx     =  TP.dx;
  dx     =  30/1024.;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  double p;
  double Soup_NR, L1_NR, L2_NR;
  double *EQ;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  EQ  =  malloc_1d( N_VAR+10 );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N_VAR+10; i++ )
    EQ[i]  =  0.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  Soup_NR  =  fabs( t_x[1] );
  for( i = 2; i <= Ns; i++ )
    if( Soup_NR  <=  fabs( t_x[i] ) )
      Soup_NR  =  fabs( t_x[i] );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  p      =  1.0;
  L1_NR  =  0.0;
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    L1_NR  +=  (fabs(pow(t_x[(i_VAR-1)*Ns+1]-EQ[i_VAR],p))+fabs(pow(t_x[(i_VAR-1)*Ns+Ns]-EQ[i_VAR],p)))/2.0;
    for( i = 2; i <= Ns-1; i++ )
      L1_NR  +=  fabs(pow(t_x[(i_VAR-1)*Ns+i]-EQ[i_VAR],p));
  }
  L1_NR  =  pow( L1_NR*dx, 1.0/p );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  p      =  2.0;
  L2_NR  =  0.0;
  for( i_VAR = 1; i_VAR <= N_VAR; i_VAR++ ){
    L2_NR  +=  (fabs(pow(t_x[(i_VAR-1)*Ns+1]-EQ[i_VAR],p))+fabs(pow(t_x[(i_VAR-1)*Ns+Ns]-EQ[i_VAR],p)))/2.0;
    for( i = 2; i <= Ns-1; i++ )
      L2_NR  +=  fabs(pow(t_x[(i_VAR-1)*Ns+i]-EQ[i_VAR],p));
  }
  L2_NR  =  pow( L2_NR*dx, 1.0/p );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  norm[1]  =  Soup_NR;
  norm[2]  =  L1_NR;
  norm[3]  =  L2_NR;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( EQ );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
