/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include "/home/yadome/LIB/function_declartion.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define  LINESIZE      300
#define  COMMANDSIZE   50
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
int  main( int argc, char **argv )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int     i = 1;
  int     N      =  atoi( argv[i++] );   //  N_DISPERSION;
  double  Lx     =  atof( argv[i++] );
  int     BCS    =  atoi( argv[i++] );   //  SELECT_BC;
  int     dim    =  atoi( argv[i++] );   //  DIMENSION;
  int     nm     =  atoi( argv[i++] );
  int     i_N    =  atoi( argv[i++] );
  int     i_Lx   =  atoi( argv[i++] );
  int     j_OP   =  atoi( argv[i++] );
  int     j_D    =  atoi( argv[i++] );
  char    *RD    =        argv[i++]  ;   //  READ_DATA;
  char    *WD    =        argv[i++]  ;   //  WRITE_DATA;
  char    *TGD1  =        argv[i++]  ;   //  TEMP_GNUPLOT_DATA1;
  char    *TGD2  =        argv[i++]  ;   //  TEMP_GNUPLOT_DATA2;
  char    *TGD3  =        argv[i++]  ;   //  TEMP_GNUPLOT_DATA3;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int    N_S, N_D;
  double **R_data;
  char   *line;
  FILE   *FP_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  line  =  alloc_1d_char( LINESIZE );
  FP_R  =  fopen_mode( RD, 'r' );
  fgets( line, LINESIZE, FP_R );
  N_SPLIT( " ", line, &N_S );
  free_1d_char( line );
  fseek( FP_R, 0, SEEK_SET );
  DataNum( RD, &N_D );
  R_data  =  alloc_2d_double( N_D+1, N_S+1 );
  for( i = 1; i <= N_D; i++ )
    SPLIT_READ_DATA( N_S, FP_R, R_data[i] );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int    R_N, R_Nm, R_NN, R_NM;
  double R_Lx;
  double R_dx;
  int    Nm, NN, NM;
  double dx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  R_N   =  (int)R_data[i_N][j_OP];
  R_NN  =  R_N + 1;
  R_Lx  =  R_data[i_Lx][j_OP];
  R_dx  =  R_Lx / (double)R_N;
  if     ( BCS == 1 )  R_N  =  R_N-1;
  else if( BCS == 2 )  R_N  =  R_N+1;
  else if( BCS == 3 )  R_N  =  R_N;
  else{
    char *PRINTF;
    PRINTF  =  alloc_1d_char( COMMANDSIZE );
    sprintf( PRINTF, "Bounduary Condition Select Mistake !! (%d)\n", BCS );
    END_PROGRAM( PRINTF, 10, 1 );
  }
  R_Nm  =  dim * R_N;
  R_NM  =  dim * R_NN;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  NN  =  N + 1;
  dx  =  R_Lx / (double)N;
  if     ( BCS == 1 )  N  =  N-1;
  else if( BCS == 2 )  N  =  N+1;
  else if( BCS == 3 )  N  =  N;
  Nm  =  dim * N;
  NM  =  dim * NN;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double *R_x;
  R_x  =  alloc_1d_double( R_NM+nm+1 );
  for( i = 1; i <= R_NM+nm; i++ )
    R_x[i]  =  R_data[i][j_D];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    j, k;
  int    c_j;
  double *x;
  x   =  alloc_1d_double( NM+nm+1 );
  c_j =  1;
  for( i = 1; i <= NN; i++ ){
    for( j = c_j; j <= R_NN; j++ ){
      if( (double)(i-1)*dx  <  (double)(j-1)*R_dx ){
        for( k = 0; k <= dim-1; k++ )
          x[i+k*NN]  =  (R_x[j+k*R_NN]-R_x[j-1+k*R_NN]) * ((double)(i-1)*dx-(double)(j-1)*R_dx) / R_dx + R_x[j+k*R_NN];
        c_j   =  j;
        break;
      }else if( (double)(i-1)*dx  ==  (double)(j-1)*R_dx ){
        for( k = 0; k <= dim-1; k++ )
          x[i+k*NN]  =  R_x[j+k*R_NN];
        c_j   =  j;
        break;
      }
    }
  }
  for( i = 1; i <= nm; i++ )
    x[NM+i]  =  R_x[R_NM+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double **data;
  FILE   *FP_W;
  data  =  alloc_2d_double( NM+nm+1, N_S+1 );
  if( NM  <=  R_NM )
    for( i = 1; i <= NM+nm; i++ )
      for( j = 1; j <= N_S; j++ )
        data[i][j]  =  R_data[i][j];
  else{
    for( i = 1; i <= R_NM+nm; i++ )
      for( j = 1; j <= N_S; j++ )
        data[i][j]  =  R_data[i][j];
    for( i = R_NM+nm+1; i <= R_NM+nm; i++ )
      for( j = 1; j <= N_S; j++ )
        data[i][j]  =  0.0;
  }
  j  =  j_D;
  for( i = 1; i <= NM+nm; i++ )
    data[i][j]  =  x[i];
  data[i_N ][j_OP]  =  NN-1;
  data[i_Lx][j_OP]  =  Lx;
  FP_W  =  fopen_mode( WD, 'w' );
  for( i = 1; i <= NM+nm; i++ ){
    j  =  1;
      fprintf( FP_W, "%7d ", (int)data[i][j] );
    for( j = 2; j <= N_S-1; j++ )
      fprintf( FP_W, "%15.8E " ,  data[i][j] );
    j  =  N_S;
      fprintf( FP_W, "%15.8E\n",  data[i][j] );
  }
  fclose( FP_W );
  free_2d_double( R_data );
  free_2d_double( data   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FILE *GP_W;
  GP_W  =  fopen_mode( TGD1, 'w' );
  for( i = 1; i <= R_NN; i++ ){
    fprintf( GP_W, "%10.8lf ", (i-1)*R_dx );
    for( j = 0; j <= dim-2; j++ )
      fprintf( GP_W, "%15.8E ", R_x[i+j*R_N] );
    j = dim-1;
    fprintf( GP_W, "%15.8E\n", R_x[i+j*R_N] );
  }
  fclose( GP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  GP_W  =  fopen_mode( TGD2, 'w' );
  for( i = 1; i <= NN; i++ ){
    fprintf( GP_W, "%10.8lf ", (i-1)*dx );
    for( j = 0; j <= dim-2; j++ )
      fprintf( GP_W, "%15.8E ", x[i+j*N] );
    j = dim-1;
    fprintf( GP_W, "%15.8E\n", x[i+j*N] );
  }
  fclose( GP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  GP_W  =  fopen_mode( TGD3, 'w' );
//  fprintf( GP_W, "set term dumb\n" );
  fprintf( GP_W, "plot " );
  for( j = 1; j <= dim; j++ )
    fprintf( GP_W, "\"%s\" u 1:%d w p pt 5 ps 1.5 lt 3, ", TGD1, j+1 );
  for( j = 1; j <= dim-1; j++ )
    fprintf( GP_W, "\"%s\" u 1:%d w p pt 7 ps 1.0 lt 1, ", TGD2, j+1 );
  j  =  dim;
    fprintf( GP_W, "\"%s\" u 1:%d w p pt 7 ps 1.0 lt 1\n", TGD2, j+1 );
  fprintf( GP_W, "pause -1 \"Hit Ritturn Key !!\"\n" );
  fclose( GP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  char *COMMAND;
  COMMAND  =  alloc_1d_char( COMMANDSIZE );
  sprintf( COMMAND, "gnuplot %s", TGD3 );  system( COMMAND );
  sprintf( COMMAND, "rm -rf %s" , TGD1 );  system( COMMAND );
  sprintf( COMMAND, "rm -rf %s" , TGD2 );  system( COMMAND );
  sprintf( COMMAND, "rm -rf %s" , TGD3 );  system( COMMAND );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_double( R_x );
  free_1d_double( x   );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  return 0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
