/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../LIB/function_declartion.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define  LINESIZE     3000
#define  COMMANDSIZE  3000
#define  GCSIZE       3000
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
int  main( int argc, char **argv )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int  ICD;
  int  IPD;
  int  N_CMa, N_CMi;
  char *GC0, *GC;
  char *RD;
  char *W_LMaD, *W_LMaAvD;
  char *W_LMaP, *W_LMaAvP;
  char *W_LMiD, *W_LMiAvD;
  char *W_LMiP, *W_LMiAvP;
  char *W_T_G;
  char *MD;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  ICD       =  atoi( argv[1 ] );   //  Index_Comparison_Data
  IPD       =  atoi( argv[2 ] );   //  Index_Period
  N_CMa     =  atoi( argv[3 ] );   //  N_Comparison_Max
  N_CMi     =  atoi( argv[4 ] );   //  N_Comparison_Min
  GC0       =        argv[5 ]  ;   //  Gnuplot_Command0
  GC        =        argv[6 ]  ;   //  Gnuplot_Command
  RD        =        argv[7 ]  ;   //  Read_Data
  W_LMaD    =        argv[8 ]  ;   //  Write_LocalMaxData
  W_LMaP    =        argv[9 ]  ;   //  Write_LocalMinPeriod
  W_LMaAvD  =        argv[10]  ;   //  Write_LocalMaxAveData
  W_LMaAvP  =        argv[11]  ;   //  Write_LocalMaxAvePeriod
  W_LMiD    =        argv[12]  ;   //  Write_LocalMinData
  W_LMiP    =        argv[13]  ;   //  Write_LocalMinPeriod
  W_LMiAvD  =        argv[14]  ;   //  Write_LocalMinAveData
  W_LMiAvP  =        argv[15]  ;   //  Write_LocalMinAvePeriod
  W_T_G     =        argv[16]  ;   //  Write_T_Gnuplot
  MD        =        argv[17]  ;   //  Making_Directory
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  char *COMMAND;
  COMMAND  =  alloc_1d_char( COMMANDSIZE );
  if( mkdir(MD,0000755)  !=  0 ){
    sprintf( COMMAND, "rm -rf %s", MD );
    system( COMMAND );
    mkdir(MD,0000755);
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int i, j;
  int FL;   //  FinalLine
  int N_Split;
  double **data;
  char *SplitData;
  char **line;
  FILE *fp_RD;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  DataNum( RD, &FL );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  line   =  alloc_2d_char( FL+1, LINESIZE );
  fp_RD  =  fopen_mode( RD, 'r' );
  for( i = 1;  i <= FL; i ++ )
    fgets( line[i], LINESIZE, fp_RD );
  fclose( fp_RD );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SplitData  =  strtok( line[1], " " );
  N_Split  =  0;
  while( SplitData  !=  NULL ){
    SplitData  =  strtok( NULL, " " );
    N_Split ++;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  data   =  alloc_2d_double( FL+1, N_Split+1 );
  fp_RD  =  fopen_mode( RD, 'r' );
  for( i = 1; i <= FL; i++ ){
    for( j = 1; j <= N_Split; j++ )
      fscanf( fp_RD, "%lf", &data[i][j] );
  }
  fclose( fp_RD );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int N_LMaAv, N_LMiAv;
  int c_LMM;
  double Sum_LMaAvD, Sum_LMiAvD, LMaAvD=0.0, LMiAvD=0.0;
  double Sum_LMaAvP, Sum_LMiAvP, LMaAvP=0.0, LMiAvP=0.0;
  double t_LMM;
  double p_LMaPD=0.0, p_LMiPD=0.0, period;
  FILE *fp_LMaD, *fp_LMiD;
  FILE *fp_LMaP, *fp_LMiP;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fp_LMaD  =  fopen_mode( W_LMaD, 'w' );
  fp_LMiD  =  fopen_mode( W_LMiD, 'w' );
  fp_LMaP  =  fopen_mode( W_LMaP, 'w' );
  fp_LMiP  =  fopen_mode( W_LMiP, 'w' );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  N_LMaAv     =  0;
  N_LMiAv     =  0;
  Sum_LMaAvD  =  0.0;
  Sum_LMiAvD  =  0.0;
  Sum_LMaAvP  =  0.0;
  Sum_LMiAvP  =  0.0;
  for( i = N_CMa; i <= FL-N_CMa; i++ ){
    t_LMM  =  data[i][ICD];
    c_LMM  =  0;
    for( j = 1; j <= N_CMa; j++ ){
      if( t_LMM  >  data[i-j][ICD] &&  
          t_LMM  >  data[i+j][ICD]    ){
        if( c_LMM == 0  ||  c_LMM == 1 )
          c_LMM  =  1;
        else{
          c_LMM  =  -1;
          j      =  N_CMa;
        }
      }else if( t_LMM  <  data[i-j][ICD] &&  
                t_LMM  <  data[i+j][ICD]    ){
        if( c_LMM == 0  ||  c_LMM == 2 )
          c_LMM  =  2;
        else{
          c_LMM  =  -1;
          j      =  N_CMa;
        }
      }else{
        c_LMM  =  -1;
        j      =  N_CMa;
      }
    }
    if( c_LMM  ==  1 ){
      fprintf( fp_LMaD, "%s", line[i] );
      N_LMaAv ++;
      Sum_LMaAvD  +=  t_LMM;
      if( 2  <=  N_LMaAv ){
        period  =  data[i][IPD]  - p_LMaPD;
        fprintf( fp_LMaP                          , \
                 "%d %15.10lf %15.10lf %15.10lf\n", \
                 N_LMaAv-1, p_LMaPD, data[i][IPD], period );
        Sum_LMaAvP  +=  period;
      }
      p_LMaPD  =  data[i][IPD];
    }else if( c_LMM  ==  2 ){
      fprintf( fp_LMiD, "%s", line[i] );
      N_LMiAv++;
      Sum_LMiAvD  +=  t_LMM;
      if( 2  <=  N_LMiAv ){
        period  =  data[i][IPD]  - p_LMiPD;
        fprintf( fp_LMiP                          , \
                 "%d %15.10lf %15.10lf %15.10lf\n", \
                 N_LMiAv-1, p_LMiPD, data[i][IPD], period );
        Sum_LMiAvP  +=  period; 
      }
      p_LMiPD  =  data[i][IPD];
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fclose( fp_LMaD );
  fclose( fp_LMiD );
  fclose( fp_LMaP );
  fclose( fp_LMiP );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  FILE *fp_LMaAvD, *fp_LMiAvD;
  FILE *fp_LMaAvP, *fp_LMiAvP;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( 1  <=  N_LMaAv ){
    LMaAvD     =  Sum_LMaAvD  /  N_LMaAv;
    fp_LMaAvD  =  fopen_mode( W_LMaAvD, 'w' );
    fprintf( fp_LMaAvD, "%15.10lf\n", LMaAvD );
    fclose( fp_LMaAvD );
  }
  if( 1  <=  N_LMiAv ){
    LMiAvD     =  Sum_LMiAvD  /  N_LMiAv;
    fp_LMiAvD  =  fopen_mode( W_LMiAvD, 'w' );
    fprintf( fp_LMiAvD, "%15.10lf\n", LMiAvD );
    fclose( fp_LMiAvD );
  }
  if( 2  <=  N_LMaAv ){
    LMaAvP     =  Sum_LMaAvP  /  ( N_LMaAv - 1);
    fp_LMaAvP  =  fopen_mode( W_LMaAvP, 'w' );
    fprintf( fp_LMaAvP, "%15.10lf\n", LMaAvP );
    fclose( fp_LMaAvP );
  }
  if( 2  <=  N_LMiAv ){
    LMiAvP     =  Sum_LMiAvP  /  ( N_LMiAv - 1);
    fp_LMiAvP  =  fopen_mode( W_LMiAvP, 'w' );
    fprintf( fp_LMiAvP, "%15.10lf\n", LMiAvP );
    fclose( fp_LMiAvP );
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  printf( "                                                               \n" );
  printf( "---------------------------------------------------------------\n" );
  printf( "                      Local Maximum Data                       \n" );
  printf( "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n" );
  sprintf( COMMAND, "cat %s", W_LMaD );
  system( COMMAND );
  printf( "---------------------------------------------------------------\n" );
  printf( "                    Local Maximum Period Data                  \n" );
  printf( "           N_period  |  p_LMaPD  |  LMaPD  |  period           \n" );
  printf( "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n" );
  sprintf( COMMAND, "cat %s", W_LMaP );
  system( COMMAND );
  printf( "---------------------------------------------------------------\n" );
  if( 1  <=  N_LMaAv ){
    printf( " Local Maximum Average Data    =  %15.10lf\n", LMaAvD              );
    if( 2  <=  N_LMaAv )
      printf( " Local Maximum Average Period  =  %15.10lf\n", LMaAvP            );
    printf( "---------------------------------------------------------------\n" );
  }
  printf( "                                                               \n" );
  printf( "---------------------------------------------------------------\n" );
  printf( "                      Local Minimum Data                       \n" );
  printf( "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n" );
  sprintf( COMMAND, "cat %s", W_LMiD );
  system( COMMAND );
  printf( "---------------------------------------------------------------\n" );
  printf( "                    Local Minimum Period Data                  \n" );
  printf( "           N_period  |  p_LMiPD  |  LMiPD  |  period           \n" );
  printf( "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n" );
  sprintf( COMMAND, "cat %s", W_LMiP );
  system( COMMAND );
  printf( "---------------------------------------------------------------\n" );
  if( 1  <=  N_LMiAv ){
    printf( " Local Minimum Average Data    =  %15.10lf\n", LMiAvD              );
    if( 2  <=  N_LMiAv )
      printf( " Local Minimum Average Period  =  %15.10lf\n", LMiAvP            );
    printf( "---------------------------------------------------------------\n" );
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int N_GC_Split;
  char *t_GC;
  char *GC_Split;
  char **GC_data;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  t_GC  =  alloc_1d_char( GCSIZE );
  strcpy( t_GC, GC );
  N_GC_Split  =  0;
  GC_Split    =  strtok( t_GC, "," );
  while( GC_Split  !=  NULL ){
    GC_Split  =  strtok( NULL, "," );
    N_GC_Split ++;
  }
  GC_data  =  alloc_2d_char( N_GC_Split+1, GCSIZE );
  strcpy( GC_data[1], strtok( GC, "," ) );
  for( i = 2; i <= N_GC_Split; i++ )
    strcpy( GC_data[i], strtok( NULL, "," ) );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  sprintf( COMMAND, "plot " );
  for( i = 1; i <= N_GC_Split; i++ ){
    if( i  !=  N_GC_Split ){
      sprintf( COMMAND, "%s'%s' %s, ", COMMAND, RD    , GC_data[i] );
      sprintf( COMMAND, "%s'%s' %s, ", COMMAND, W_LMaD, GC_data[i] );
      sprintf( COMMAND, "%s'%s' %s, ", COMMAND, W_LMiD, GC_data[i] );
    }else{
      sprintf( COMMAND, "%s'%s' %s, ", COMMAND, RD    , GC_data[i] );
      sprintf( COMMAND, "%s'%s' %s, ", COMMAND, W_LMaD, GC_data[i] );
      sprintf( COMMAND, "%s'%s' %s\n", COMMAND, W_LMiD, GC_data[i] );
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FILE *fp_T_G;
  fp_T_G  =  fopen_mode( W_T_G, 'w' );
  fprintf( fp_T_G, "%s\n", GC0   );
  fprintf( fp_T_G, "%s", COMMAND );
  fprintf( fp_T_G, "pause -1 \"Hit Ritturn Key !!\"\n" );
  fclose( fp_T_G );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  printf( "                                                                \n" );
  printf( "----------------------------------------------------------------\n" );
  printf( "During a summons of gnuplot !!                                  \n" );
  printf( "Waiting ...                                                     \n" );
  printf( "----------------------------------------------------------------\n" );
  sprintf( COMMAND, "gnuplot %s", W_T_G );
  system( COMMAND );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  free_1d_char  ( COMMAND );
  free_2d_char  ( line    );
  free_2d_double( data    );
  free_1d_char  ( t_GC    );
  free_2d_char  ( GC_data );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  return 0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
